﻿var MAX_TIMESPAN_SHOW = 5; // 显示的最多记录条数
var holidaySchedules;
var alarmOutGrid;
var alarmInCount;
var tirggerXmlDoc = {};
var successRequest = 0;
var tirggerSaveResult = [];
var xmlDoc; //排程xml文档
var copyObj = {},copySensorObj={};

$(function() {
    window.top.showLoading();
    window.parent.setConfigMiniHeight(0);
    $(window.top).resize(function() {
        window.parent.setConfigMiniHeight(0);
    });
    initControl();
    initTab();
});

function getSensorInMode(value) {
    switch (value) {
        case "NC":
            return LangCtrl._L_("normallyClose");
        case "NO":
            return LangCtrl._L_("normallyOpen");
    }
}

function initTab() {
    $("#divParent>ul").empty();
    getDeviceInfo(function(result) {
        alarmInCount = $("config>deviceInfo>alarmInCount", result).text() * 1;
//        $("#Content",window.top.document).css({"min-width":930 + 150*alarmInCount + "px"});
        TriggerModule.isSupportSDCard = $("config>deviceInfo>supportSDCard", result).text() === "true";
        var arrMap = [];
        if(alarmInCount <= 1){
            for (var i = 1; i <= alarmInCount; i++) {
                $("<li id='liAlarmInputConfig_" + i + "'><a href='#'>" + LangCtrl._L_("alarmIn") + "</a></li>").appendTo("#divParent>ul");
                arrMap.push({ "tab": "liAlarmInputConfig_"+ i, "content": "divAlarmInputConfig",
                    init: function(target) {
                        initAlarmInputTrigger($(target).attr("id").replace("liAlarmInputConfig_", ""));
                        initAlarmInputSchedule($(target).attr("id").replace("liAlarmInputConfig_", ""));
                    }
                });
            }
        }else{
            $("#copyBtn").show();
            for (var i = 1; i <= alarmInCount; i++) {
                $("<li id='liAlarmInputConfig_" + i + "'><a href='#'>" + LangCtrl._L_("alarmIn") + i + "</a></li>").appendTo("#divParent>ul");
                arrMap.push({ "tab": "liAlarmInputConfig_" + i, "content": "divAlarmInputConfig",
                    init: function(target) {
                        initAlarmInputTrigger($(target).attr("id").replace("liAlarmInputConfig_", ""));
                        initAlarmInputSchedule($(target).attr("id").replace("liAlarmInputConfig_", ""));
                    }
                });
                $("<option value=" + i + ">" + LangCtrl._L_("alarmIn")  + i + "</option>").appendTo($("#senserAlarmNum"));
                $("#btnCopySchedule").unbind().click(function(){
                    copyObj = {"id":$("#senserAlarmNum").val(),"copyXmlDoc":ScheduleModule.getSaveData()};
                });
            }
        }

        $("#divParent").tab({
            map: arrMap
        });
//        for (var i = 1; i <= alarmInCount; i++) {
//            TriggerModule.createAlarmInCfgItem(i, i - 1);
//            TriggerModule.bindCtrlData(i);
//            TriggerModule.getEmailListData(i);
//            TriggerModule.getFTPListData(i);
//        }
        $("#divParent").tab("selectLastTab");
    });
}

function initAlarmInputTrigger(id) {
    $("<div style='height: 10px;'></div>").appendTo($("#divAlarmInputTrigger"));
    TriggerModule.createAlarmInCfgItem(id);
    if($("#senserAlarmNum").size() != 0){
        $("#senserAlarmNum").val(1);
    }

    TriggerModule.getEmailListData(id);
    TriggerModule.getFTPListData(id);
    TriggerModule.bindCtrlData(id);
    TriggerModule.getData(id);
}

function initAlarmInputSchedule(sensorId) {
    ScheduleModule.getData(sensorId);
}

var TriggerModule = {
    triggerFlag: false,
    toggle: function(enabled, id) {
        if (!enabled) {
            $("#tbTrigger_" + id + " .triggle").hide();
        } else {
            $("#tbTrigger_" + id + " .triggle:not(#trTriggerSnap_" + id + ")").show();
            var chkTriggerFTP = $("#chkTriggerFTP_" + id);
            var chkTriggerEmail = $("#chkTriggerEmail_" + id);
            TriggerModule.toggleFtpList(chkTriggerFTP.is(":checked"), chkTriggerFTP.attr("id").replace("chkTriggerFTP_", ""));
            TriggerModule.toggleEmailList(chkTriggerEmail.is(":checked"), chkTriggerEmail.attr("id").replace("chkTriggerEmail_", ""));
            if (TriggerModule.isSupportSDCard) {
                $("#trTriggerSnap_" + id).show();
            }
        }
    },
    toggleFtpList: function(enabled, id){
        if (!enabled) {
            $("#tbTrigger_" + id + " .triggleFtp").hide();
        } else {
            $("#tbTrigger_" + id + " .triggleFtp").show();
        }
    },
    toggleEmailList: function(enabled,id){
        if (!enabled) {
            $("#tbTrigger_" + id + " .triggleEmail").hide();
        } else {
            $("#tbTrigger_" + id + " .triggleEmail").show();
        }
    },
    ajustHeight: function() {
        var minHeight = $("#divAlarmInputTrigger").height()+$("#divAlarmInputSchedule").height() + 300;
        window.parent.setConfigMiniHeight(minHeight);
    },
    bindPageByXml: function(id) {
        var elem = $("config>sensor", tirggerXmlDoc["a_" + id]);
        $("#chkEnableAlarm_" + id).click(function() {
            TriggerModule.toggle($(this).is(":checked"), $(this).attr("id").replace("chkEnableAlarm_", ""));
            TriggerModule.ajustHeight();
        });

        var chkTriggerFTP = $("#chkTriggerFTP_"+ id +"");
        chkTriggerFTP.unbind().click(function() {
            TriggerModule.toggleFtpList($(this).is(":checked"), $(this).attr("id").replace("chkTriggerFTP_", ""));
            TriggerModule.ajustHeight();
        });

        $("#cboAlarmType_" + id).empty();
        $("config>types>alarmInVoltage>enum", tirggerXmlDoc["a_" + id]).each(function(i, ele) {
            $("<option value=" + $(ele).text() + ">" + getSensorInMode($(ele).text()) + "</option>").appendTo($("#cboAlarmType_" + id));
        });
        $("#cboAlarmType_" + id).val($(">voltage", elem).text());
        var holdTime = $(">alarmHoldTime", elem).text();
        $("#cboAlarmHoldingTime_" + id).selectInput("setData", { text: holdTime, value: holdTime });
        $("#txtSensorName_" + id).val($(">sensorName ", elem).text());
        var alarmSwitch = $(">switch", elem).text().toLowerCase() === "true";
        $("#chkEnableAlarm_" + id).attr("checked", alarmSwitch);
        TriggerModule.toggle(alarmSwitch, id);

        var divAlarmOut = $("#divAlarmOut_" + id);
        divAlarmOut.empty();
        var alarmOutList = $(">triggerAlarmOut>item", elem);
        if(alarmOutList.length <= 1){
            $(">triggerAlarmOut>item", elem).each(function(j, j_elem) {
                divAlarmOut.append($("<input id='chkAlarmOut_" + id + "_" + $(j_elem).attr("id") + "' type='checkbox' " + ($(j_elem).text().toLowerCase() === "true" ? "checked='checked'" : "") + " />"));
                divAlarmOut.append($("<label for='chkAlarmOut_" + id + "_" + $(j_elem).attr("id") + "'>" + LangCtrl._L_("alarmOut") +  "</label>"));
            });
        }else{
            $(">triggerAlarmOut>item", elem).each(function(j, j_elem) {
                divAlarmOut.append($("<input id='chkAlarmOut_" + id + "_" + $(j_elem).attr("id") + "' type='checkbox' " + ($(j_elem).text().toLowerCase() === "true" ? "checked='checked'" : "") + " />"));
                divAlarmOut.append($("<label for='chkAlarmOut_" + id + "_" + $(j_elem).attr("id") + "'>" + LangCtrl._L_("alarmOut") + " " + $(j_elem).attr("id") + "</label>"));
            });
        }

        $("#chkTriggerSnap_" + id).attr("checked", $(">savePicSwitch", elem).text().toLowerCase() === "true");
        $("#chkTriggerSDRec_" + id).attr("checked", $(">sdRecSwitch", elem).text().toLowerCase() === "true");

        var chkTriggerEmail = $("#chkTriggerEmail_" + id);
        chkTriggerEmail.attr("checked", $(">mail>switch", elem).text().toLowerCase() === "true");
        chkTriggerEmail.unbind().click(function(e) {
            TriggerModule.toggleEmailList(chkTriggerEmail.is(":checked"), chkTriggerEmail.attr("id").replace("chkTriggerEmail_", ""));
            TriggerModule.ajustHeight();
        });
        TriggerModule.toggleEmailList(chkTriggerEmail.attr("checked") == "checked"  && $("#chkEnableAlarm_" + id).attr("checked") == "checked", chkTriggerFTP.attr("id").replace("chkTriggerFTP_", ""));
        var emailChkList = $("#divEmail_" + id ).find(".emailServer");
        var emailChkPicList = $("#divEmail_"+id).find(".emailPic");
        $(">mail>item", elem).each(function(i,element){
            $(emailChkList[$(element).attr("id")-1]).attr("checked","checked");
            $(emailChkPicList[$(element).attr("id")-1]).removeAttr("disabled");
        });
        $(">mail>item", elem).each(function(i,element){
            if($(">sendPic",element).text() === "true"){
                $(emailChkPicList[$(element).attr("id")-1]).attr("checked","checked");
            }
        });

        var subject = $(">mail>subject", elem);
        var content = $(">mail>content", elem);
        $("#emailTheme_"+ id).attr("maxLength",subject.attr("maxLen"));
        $("#emailContent_"+ id).attr("maxLength",content.attr("maxLen"));
        $("#emailTheme_"+ id).val(subject.text());
        $("#emailContent_"+ id).val(content.text());

        $("#chkTriggerFTP_" + id).attr("checked", $(">ftp>switch", elem).text().toLowerCase() === "true");
        TriggerModule.toggleFtpList(chkTriggerFTP.is(":checked")  && $("#chkEnableAlarm_" + id).attr("checked") == "checked", chkTriggerFTP.attr("id").replace("chkTriggerFTP_", ""));

        var ftpChkList = $("#divFTP_" + id).find(".ftpServer");
        var ftpChkPicList = $("#divFTP_" + id).find(".FTPPic");
        var ftpChkRecList = $("#divFTP_" + id).find(".FTPRec");
        $("config>sensor>ftp>item", elem).each(function(i,element){
            $(ftpChkList[$(element).attr("id")-1]).attr("checked","checked");
            $(ftpChkPicList[$(element).attr("id")-1]).removeAttr("disabled");
        });

        $("config>sensor>ftp>item", elem).each(function(i,element){
            if($(">sendPic",element).text() === "true"){
                $(ftpChkPicList[$(element).attr("id")-1]).attr("checked","checked");
            }
            if($(">sendRec",element).text() === "true"){
                $(ftpChkRecList[$(element).attr("id")-1]).attr("checked","checked");
            }
        });

        TriggerModule.ajustHeight();
    },
    createAlarmInCfgItem: function(id, index) {
        $("#divAlarmInputTrigger").empty();
        $("<div id='sensorIndex_" + id + "' class='h1" + (index == 0 ? "" : " h2") + "'></div>" + "<div id='alarmCopy_" + id + "' class='alarmCopy'><span>"+LangCtrl._L_("copySTo")+"</span><select id='cboAlarmNum_" + id + "' class='alarmSelect'></select><input class='cfgCopy' type='button' id='btnSensorCopy_" + id + "' value='"+LangCtrl._L_("copyTo")+"'/></div>" +
            "<table id='tbTrigger_" + id + "' class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                "<tbody>" +
                    "<tr>" +
                        "<td style='width: 160px;'>" + LangCtrl._L_("alarmType") + "</td>" +
                        "<td><select id='cboAlarmType_" + id + "'></select></td>" +
                    "</tr>" +
                    "<tr class='alter'>" +
                        "<td>" + LangCtrl._L_("alarmHoldingTime") + "</td>" +
                        "<td><div id='cboAlarmHoldingTime_" + id + "' style='width: 130px;'></div></td>" +
                    "</tr>" +
                    "<tr>" +
                        "<td>" + LangCtrl._L_("sensorName") + "</td>" +
                        "<td><input type='text' id='txtSensorName_" + id + "' style='width: 150px;' /></td>" +
                    "</tr>" +
                    "<tr class='alter'>" +
                        "<td colspan='2'>" +
                            "<input id='chkEnableAlarm_" + id + "' type='checkbox' />" +
                            "<label for='chkEnableAlarm_" + id + "'>" + LangCtrl._L_("enableAlarm") + "</label>" +
                        "</td>" +
                    "</tr>" +
                    "<tr class='triggle alter'>" +
                        "<td colspan='2'>" +
                            "<div id='divAlarmOut_" + id + "' class='alarmOutList'></div>" +
                        "</td>" +
                    "</tr>" +
                    "<tr id='trTriggerSnap_" + id + "' class='triggle' style='display: none;'>" +
                        "<td colspan='2'>" +
                            "<input id='chkTriggerSnap_" + id + "' type='checkbox' />" +
                            "<label for='chkTriggerSnap_" + id + "' >" + LangCtrl._L_("triggerSnap") + "</label>" +
                        "</td>" +
                    "</tr>" +
                    "<tr id='trTriggerSDRec_" + id + "' class='triggle' style='display: none;'>" +
                        "<td colspan='2'>" +
                            "<input id='chkTriggerSDRec_" + id + "' type='checkbox' />" +
                            "<label for='chkTriggerSDRec_" + id + "' >" + LangCtrl._L_("triggerSDRec") + "</label>" +
                        "</td>" +
                    "</tr>" +
                    "<tr class='triggle alter'>" +
                        "<td colspan='2'>" +
                            "<input id='chkTriggerEmail_" + id + "' type='checkbox' />" +
                            "<label for='chkTriggerEmail_" + id + "'>" + LangCtrl._L_("triggerEmail") + "</label>" +
                        "</td>" +
                    "</tr>" +
                    "<tr class='triggle triggleEmail'>" +
                        "<td colspan='2'>" +
                            "<div id='divEmailTitle_" + id + "' class='motionEmailTitle'></div>" +
                            "<div id='divEmail_" + id + "' class='motionEmailList'><table id='divEmailTable_" + id + "' style='table-layout: fixed' width='100%'></table></div>" +
                            "<div id='divEmailTheme_" + id + "' class='motionEmailTheme'></div>" +
                        "</td>" +
                    "</tr>" +
                    "<tr class='triggle'>" +
                        "<td colspan='2'>" +
                            "<input id='chkTriggerFTP_" + id + "' type='checkbox' />" +
                            "<label for='chkTriggerFTP_" + id + "' >" + LangCtrl._L_("triggerFTP") + "</label>" +
                        "</td>" +
                    "</tr>" +
                    "<tr class='triggle triggleFtp'>" +
                        "<td colspan='2'>" +
                            "<div id='divFTPTitle_" + id + "' class='alarmOutFTPTitle'></div>" +
                            "<div id='divFTP_" + id + "' class='alarmOutFTPList'>" +
//                            "<table id='divFTP_" + id + "' class='alarmOutFTPList'></table>" +
                            "</div>" +
                        "</td>" +
                    "</tr>" +
                "</tbody>" +
            "</table>").appendTo($("#divAlarmInputTrigger"));


        if(alarmInCount <= 1){
            $("#alarmCopy_" + id).hide();
        }else{
            for (var i = 1; i <= alarmInCount; i++) {
                if(i !== id){
                    $("<option value=" + i + ">" + LangCtrl._L_("alarmIn")  + i + "</option>").appendTo($("#cboAlarmNum_" + id));
                }
            }
        }

        $("#btnSensorCopy_"+id).hover(function(){
            $(this).attr("title",LangCtrl._L_("copyTip"));
        }).click(function(){
            copySensorObj = {"id":$("#cboAlarmNum_"+id).val(),"copyXmlDoc":TriggerModule.getCopyData(id,$("#cboAlarmNum_"+id).val())};
        });
    },
    copyConfigToOther: function(id,xmlDocTri){
        var elem = $("config>sensor", xmlDocTri);
        $("#chkEnableAlarm_" + id).click(function() {
            TriggerModule.toggle($(this).is(":checked"), $(this).attr("id").replace("chkEnableAlarm_", ""));
            TriggerModule.ajustHeight();
        });

        var chkTriggerFTP = $("#chkTriggerFTP_"+ id +"");
        chkTriggerFTP.unbind().click(function() {
            TriggerModule.toggleFtpList($(this).is(":checked"), $(this).attr("id").replace("chkTriggerFTP_", ""));
            TriggerModule.ajustHeight();
        });

        $("#cboAlarmType_" + id).empty();
        $("config>types>alarmInVoltage>enum", xmlDocTri).each(function(i, ele) {
            $("<option value=" + $(ele).text() + ">" + getSensorInMode($(ele).text()) + "</option>").appendTo($("#cboAlarmType_" + id));
        });
        $("#cboAlarmType_" + id).val($(">voltage", elem).text());
        var holdTime = $(">alarmHoldTime", elem).text();
        $("#cboAlarmHoldingTime_" + id).selectInput("setData", { text: holdTime, value: holdTime });
        $("#txtSensorName_" + id).val($(">sensorName ", elem).text());
        var alarmSwitch = $(">switch", elem).text().toLowerCase() === "true";
        $("#chkEnableAlarm_" + id).attr("checked", alarmSwitch);
        TriggerModule.toggle(alarmSwitch, id);

        var divAlarmOut = $("#divAlarmOut_" + id);
        divAlarmOut.empty();
        var alarmOutList = $(">triggerAlarmOut>item", elem);
        if(alarmOutList.length <= 1){
            $(">triggerAlarmOut>item", elem).each(function(j, j_elem) {
                divAlarmOut.append($("<input id='chkAlarmOut_" + id + "_" + $(j_elem).attr("id") + "' type='checkbox' " + ($(j_elem).text().toLowerCase() === "true" ? "checked='checked'" : "") + " />"));
                divAlarmOut.append($("<label for='chkAlarmOut_" + id + "_" + $(j_elem).attr("id") + "'>" + LangCtrl._L_("alarmOut") +  "</label>"));
            });
        }else{
            $(">triggerAlarmOut>item", elem).each(function(j, j_elem) {
                divAlarmOut.append($("<input id='chkAlarmOut_" + id + "_" + $(j_elem).attr("id") + "' type='checkbox' " + ($(j_elem).text().toLowerCase() === "true" ? "checked='checked'" : "") + " />"));
                divAlarmOut.append($("<label for='chkAlarmOut_" + id + "_" + $(j_elem).attr("id") + "'>" + LangCtrl._L_("alarmOut") + " " + $(j_elem).attr("id") + "</label>"));
            });
        }

        $("#chkTriggerSnap_" + id).attr("checked", $(">savePicSwitch", elem).text().toLowerCase() === "true");
        $("#chkTriggerSDRec_" + id).attr("checked", $(">sdRecSwitch", elem).text().toLowerCase() === "true");

        var chkTriggerEmail = $("#chkTriggerEmail_" + id);
        chkTriggerEmail.attr("checked", $(">mail>switch", elem).text().toLowerCase() === "true");
        chkTriggerEmail.unbind().click(function(e) {
            TriggerModule.toggleEmailList(chkTriggerEmail.is(":checked"), chkTriggerEmail.attr("id").replace("chkTriggerEmail_", ""));
            TriggerModule.ajustHeight();
        });
        TriggerModule.toggleEmailList(chkTriggerEmail.attr("checked") == "checked"  && $("#chkEnableAlarm_" + id).attr("checked") == "checked", chkTriggerFTP.attr("id").replace("chkTriggerFTP_", ""));
        var emailChkList = $("#divEmail_" + id ).find(".emailServer");
        $(">mail>item", elem).each(function(i,element){
            $(emailChkList[$(element).attr("id")-1]).attr("checked","checked");
        });
        var emailChkPicList = $("#divEmail_"+id).find(".emailPic");
        $(">mail>item", elem).each(function(i,element){
            if($(">sendPic",element).text() === "true"){
                $(emailChkPicList[$(element).attr("id")-1]).attr("checked","checked");
            }
        });

        var subject = $(">mail>subject", elem);
        var content = $(">mail>content", elem);
        $("#emailTheme_"+ id).attr("maxLength",subject.attr("maxLen"));
        $("#emailContent_"+ id).attr("maxLength",content.attr("maxLen"));
        $("#emailTheme_"+ id).val(subject.text());
        $("#emailContent_"+ id).val(content.text());

        $("#chkTriggerFTP_" + id).attr("checked", $(">ftp>switch", elem).text().toLowerCase() === "true");
        TriggerModule.toggleFtpList(chkTriggerFTP.is(":checked")  && $("#chkEnableAlarm_" + id).attr("checked") == "checked", chkTriggerFTP.attr("id").replace("chkTriggerFTP_", ""));

        var ftpChkList = $("#divFTP_" + id).find(".ftpServer");
        $("config>sensor>ftp>item", elem).each(function(i,element){
            $(ftpChkList[$(element).attr("id")-1]).attr("checked","checked");
        });

        var ftpChkPicList = $("#divFTP_" + id).find(".FTPPic");
        $("config>sensor>ftp>item", elem).each(function(i,element){
            if($(">sendPic",element).text() === "true"){
                $(ftpChkPicList[$(element).attr("id")-1]).attr("checked","checked");
            }
        });

        TriggerModule.ajustHeight();
    },
    getEmailListData: function(id){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetMailConfig",
            type: "POST",
            async: false,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                var emailList = "";
                var d = document.getElementById('dvCompute');
                $("config>mail>recvMail>item",result).each(function(i,ele){
                    var emailName = $(ele).text();
                    d.innerHTML = emailName;
                    var  averageLen = d.offsetWidth / (emailName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (emailName.substr(0, indexStr) + "...") : emailName;
                    emailList = emailList +"<tr>" +
                        "<td style='word-break:keep-all;width: 268px;'>" + "<div title='"+ $(ele).text()+"'>"+"<input id='chkTriggerEmailAddr_"  + i + "' class='emailServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
                        "<td><input id='chkTriggerEmailPic_"  + id + i + "' class='emailPic' type='checkbox' disabled/><label for='chkTriggerEmailPic_"  + id + i +"' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>";
                });

                var alarmOutEmailList = $("#divEmailTable_" + id + "");
                var alarmOutEmailTitle = $("#divEmailTitle_"+ id + "");
                var motionEmailTheme = $("#divEmailTheme_"+ id + "");
                alarmOutEmailList.empty();
                alarmOutEmailTitle.empty();
                motionEmailTheme.empty();

                for(var i= 0,len =alarmOutEmailList.length; i < len; i++ ){
                    $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;' width='100%'>" +
                        "<tbody>" +
                        "<tr>" +
                        "<td style='width: 271px;'>" + LangCtrl._L_("emailServer") + "</td>" +
                        "<td><input id='chkTriggerEmailPic_"+ id + "'  type='checkbox' /><label for='chkTriggerEmailPic_"+  id + "'>" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>" +
                        "</tbody>" +
                        "</table>").appendTo(alarmOutEmailTitle);
                    $(emailList).appendTo(alarmOutEmailList);
                    $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                        "<tbody>" +
                        "<tr>" +
                        "<td style='width: 100px;'>" + LangCtrl._L_("emailTheme") + "</td>" +
                        "<td><input id='emailTheme_"+ id + "'  type='text' style='width: 300px;'/></td>" +
                        "</tr>" +
                        "<tr>" +
                        "<td style='width: 160px;'>" + LangCtrl._L_("emailContent") + "</td>" +
                        "<td><input id='emailContent_"+ id + "'  type='text' style='width: 300px;'/></td>" +
                        "</tr>" +
                        "</tbody>" +
                        "</table>").appendTo(motionEmailTheme);

                    $("#chkTriggerEmailPic_" + id + "").click(function(){
                        var emialPicList = $(this).parent().parent().parent().parent().parent().next().find(".emailPic");
                        if($(this).attr("checked")){
                            for(var m=0;m<emialPicList.length;m++){
                                var chkEmailPic = $(emialPicList[m]);
                                if(chkEmailPic.attr("disabled")){
                                    chkEmailPic.attr("checked",false);
                                }else{
                                    chkEmailPic.attr("checked","checked");
                                }
                            }
                        }else{
                            $(emialPicList).attr("checked",false);
                        }

//                        if($(this).attr("checked") === "checked"){
//                            $(emialPicList).attr("checked","checked");
//                        }else{
//                            $(emialPicList).attr("checked",false);
//                        }
                    });

                    $(".emailServer").click(function(){
                        var emailPic = $(this).parent().parent().parent().find(".emailPic");
                        if( $(this).attr("checked")){
                            emailPic.removeAttr("disabled");
                        }else{
                            emailPic.attr("disabled","disabled");
                            emailPic.attr("checked",false);
                        }
                    });
                }

            }
        });
    },
    getFTPListData: function(id){
        window.top.showLoading();
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetFtpConfig",
            type: "POST",
            async: false,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
                var ftpList = "";
                var d = document.getElementById('dvCompute');
                $("config>ftp>item",result).each(function(i,ele){
                    var ftpName = $(">serverAddr",ele).text();
                    d.innerHTML = ftpName;
                    var  averageLen = d.offsetWidth / (ftpName.length);
                    var indexStr = Math.floor(210 / averageLen);
                    var imageName =  d.offsetWidth > 210 ? (ftpName.substr(0, indexStr) + "...") : ftpName;
                    ftpList = ftpList +"<tr>" +
                        "<td style='word-break:keep-all;width: 271px;'>" + "<div title='"+ ftpName+"'>"+"<input id='chkTriggerFTPAddr_"  + id + i + "' class='ftpServer' type='checkbox' />"+imageName +"</div>"+ "</td>" +
//                        "<td><input id='chkTriggerFTPRec_" + id + i + "' class='FTPRec' type='checkbox' /><label for='chkTriggerFTPRec_"+ id + i+"' >" + LangCtrl._L_("recSend") + "</label></td>" +
                        "<td><input id='chkTriggerFTPPic_" + id + i + "' class='FTPPic' type='checkbox' disabled/><label for='chkTriggerFTPPic_"+  id + i +"' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>";
                });

                var alarmOutFTPList = $("#divFTP_" + id + "");
                alarmOutFTPList.empty();
                var alarmOutFTPTitle = $("#divFTPTitle_" + id + "");
                alarmOutFTPTitle.empty();
                for(var i= 0,len =alarmOutFTPList.length; i < len; i++ ){
                    $("<table  class='contentTable' cellpadding='0' cellspacing='0' style='table-layout: fixed;'>" +
                        "<tbody>" +
                        "<tr>" +
                        "<td style='width: 271px;'>" + LangCtrl._L_("FTPServer") + "</td>" +
                        "<td><input id='chkTriggerFTPPic_" + id + "'  type='checkbox' /><label for='chkTriggerFTPPic_"+  id + "' >" + LangCtrl._L_("pictureSend") + "</label></td>" +
                        "</tr>" +
                        "</tbody>" +
                        "</table>").appendTo(alarmOutFTPTitle);
                    $(ftpList).appendTo(alarmOutFTPList);

                    $("#chkTriggerFTPPic_" + id + "").click(function(){
                        var ftpPicList = $(this).parent().parent().parent().parent().parent().next().find(".FTPPic");
                        if($(this).attr("checked")){
                            for(var m=0;m<ftpPicList.length;m++){
                                var chkFtpPic = $(ftpPicList[m]);
                                if(chkFtpPic.attr("disabled")){
                                    chkFtpPic.attr("checked",false);
                                }else{
                                    chkFtpPic.attr("checked","checked");
                                }
                            }
                        }else{
                            $(ftpPicList).attr("checked",false);
                        }

//                        var ftpPicList = $(this).parent().parent().parent().parent().parent().next().find(".FTPPic");
//                        if($(this).attr("checked") === "checked"){
//                            $(ftpPicList).attr("checked","checked");
//                        }else{
//                            $(ftpPicList).attr("checked",false);
//                        }
                    });

                    $(".ftpServer").click(function(){
                        var chkFTPPic = $(this).parent().parent().parent().find(".FTPPic");
                        if( $(this).attr("checked")){
                            chkFTPPic.removeAttr("disabled");
                        }else{
                            chkFTPPic.attr("disabled","disabled");
                            chkFTPPic.attr("checked",false);
                        }
                    });

                    $(".FTPRec").click(function(){
                        var ftpRecList = $(this).parent().parent().parent().find(".FTPRec");
                        for(var m=0;m<ftpRecList.length;m++){
                            if($(ftpRecList[m]).attr("id") == $(this).attr("id")){
                                $(ftpRecList[m]).attr("checked","checked");
                            }else{
                                $(ftpRecList[m]).attr("checked",false);
                            }
                        }
                    });
                }
            }
        });
    },
    getData: function(id) {
        window.top.showLoading();
        successRequest = 0;
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetAlarmInConfig/" + id,
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    var id = this.url.substr(this.url.lastIndexOf("/") + 1);
                    tirggerXmlDoc["a_" + id] = result;
                    if(alarmInCount <= 1){
                        $("#sensorIndex_" + id).html(LangCtrl._L_("alarmIn"));
                    }else{
                        $("#sensorIndex_" + id).html(LangCtrl._L_("alarmIn") + " " + id);
                    }
                    TriggerModule.bindPageByXml(id);

                    if(copySensorObj.id != undefined && copySensorObj.id == id){

                        var xmlCopyXml = XMLStr2XMLDoc(copySensorObj.copyXmlDoc);
                        TriggerModule.copyConfigToOther(copySensorObj.id,xmlCopyXml);
                    }

                    successRequest++;
                    if (successRequest == alarmInCount) {
                        window.top.hideLoading();
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function(id) {
        $("#cboAlarmHoldingTime_" + id).selectInput({
            list: [
				{ text: LangCtrl._L_("seconds").format(5), value: 5 },
				{ text: LangCtrl._L_("seconds").format(10), value: 10 },
				{ text: LangCtrl._L_("seconds").format(20), value: 20 },
				{ text: LangCtrl._L_("seconds").format(30), value: 30 },
				{ text: LangCtrl._L_("seconds").format(60), value: 60 },
				{ text: LangCtrl._L_("minutes").format(2), value: 120 }
			],
            mapping: function(text) {
                var validReg = /^[1-9]\d*$/;
                var execResults = validReg.exec(text);
                if (execResults) {
                    return { text: execResults[0] % 60 == 0 ? LangCtrl._L_("minutes").format(execResults[0] / 60) : LangCtrl._L_("seconds").format(execResults[0]), value: execResults[0] };
                }

                validReg = new RegExp("^" + LangCtrl._L_("seconds").format("([1-9]\\d*)") + "$");
                execResults = validReg.exec(text);
                if (execResults) {
                    return { text: text, value: execResults[1] };
                }

                validReg = new RegExp("^" + LangCtrl._L_("minutes").format("([1-9]\\d*)") + "$");
                execResults = validReg.exec(text);
                if (execResults) {
                    return { text: text, value: execResults[1] * 60 };
                }
                return false;
            }
        });
    },
    setData: function() {
        window.top.showLoading();
        successRequest = 0;
		tirggerSaveResult = [];
        var num = $("config>sensor>id", xmlDoc).text();
        if (!TriggerModule.verification(num)) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetAlarmInConfig/" + num,
                type: "POST",
                async: true,
                data: TriggerModule.getSaveData(num),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        TriggerModule.triggerFlag = true;
                        ScheduleModule.setData();
                        window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("saveSuccess"), null);
                    }
                    else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("saveFailed"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    verification: function(id) {
        var txtSensorName = $("#txtSensorName_" + id);
        if(txtSensorName.val().getBytesLength() > 11){
            ShowFloatError(txtSensorName, LangCtrl._L_("nameTooLong"),{left:5,top:140});
            return false;
        }
        var elem = $("config>sensor", tirggerXmlDoc["a_" + id]);
        var subject = $(">mail>subject", elem);
        var content = $(">mail>content", elem);
        var emailTheme = $("#emailTheme_"+ id);
        var emailContent = $("#emailContent_"+ id);
        if((emailTheme.val()+"").getBytesLength() > subject.attr("maxLen")){
            ShowFloatError(emailTheme, LangCtrl._L_("emailMameTooLong"),{left:5,top:520});
            return false;
        }
        if((emailContent.val()+"").getBytesLength() > content.attr("maxLen")){
            ShowFloatError(emailContent, LangCtrl._L_("emailThemeTooLong"),{left:5,top:555});
            return false;
        }

        return true;
    },
    getSaveData: function(id) {
        var elem = tirggerXmlDoc["a_" + id];
        $("config>sensor>voltage", elem).text($("#cboAlarmType_" + id).val());
        $("config>sensor>switch", elem).text($("#chkEnableAlarm_" + id).is(":checked") ? "true" : "false");

        $("config>sensor>alarmHoldTime", elem).text($("#cboAlarmHoldingTime_" + id).selectInput("getValue"));
        $("config>sensor>sensorName", elem).empty().append(elem.createCDATASection( $.trim($("#txtSensorName_" + id).val())));
        var divAlarmOut = $("#divAlarmOut_" + id);
        $("config>sensor>triggerAlarmOut>item", elem).each(function(j, j_elem) {
            if ($("#chkAlarmOut_" + id + "_" + $(j_elem).attr("id")).is(":checked")) {
                $(j_elem).text("true");
            }
            else {
                $(j_elem).text("false");
            }
        });
        $("config>sensor>savePicSwitch", elem).text($("#chkTriggerSnap_" + id).is(":checked") ? "true" : "false");
        $("config>sensor>sdRecSwitch", elem).text($("#chkTriggerSDRec_" + id).is(":checked") ? "true" : "false");
        var divFtpList = $("#divFTP_" + id).find(".ftpServer");
        $("config>sensor>ftp>item", elem).remove();
        $("config>sensor>ftp>switch",elem).text($("#chkTriggerFTP_" + id).is(":checked") ? "true" : "false");
        var count = 0;
        for(var i= 0,len = divFtpList.length;i<len;i++){
            if($(divFtpList[i]).attr("checked") === "checked"){
                count++;
                $("config>sensor>ftp", elem).append(
                    $(elem.createElement("item")).attr("id",i+1).append(
                        $(elem.createElement("sendPic")).attr("type","boolean").append(
//                            $(divFtpList[i]).parent().parent().next().next().find("input").attr("checked") === "checked" ? "true" : "false"
                                $(divFtpList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
//                        .append(
//                        $(elem.createElement("sendRec")).attr("type","boolean").append(
//                                $(divFtpList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
//                        )
//                    )
                );
            }
        }
        $("config>sensor>ftp", elem).attr("count",count);

        var divEmailList = $("#divEmail_"+id).find(".emailServer");
        $("config>sensor>mail>item", elem).remove();
        $("config>sensor>mail>subject", elem).remove();
        $("config>sensor>mail>content", elem).remove();
        $("config>sensor>mail>switch",elem).text($("#chkTriggerEmail_" + id).is(":checked") ? "true" : "false");
        $("config>sensor>mail",elem).append(
            $(elem.createElement("subject")).attr("type","string").attr("maxLen","63").append(
                elem.createCDATASection($("#emailTheme_"+id).val())
            )
        );
        $("config>sensor>mail",elem).append(
            $(elem.createElement("content")).attr("type","string").attr("maxLen","255").append(
                elem.createCDATASection($("#emailContent_"+id).val())
            )
        );
        var countEmail = 0;
        for(var i= 0,len = divEmailList.length;i<len;i++){
            if($(divEmailList[i]).attr("checked") === "checked"){
                countEmail++;
                $("config>sensor>mail", elem).append(
                    $(elem.createElement("item")).attr("id",i+1).append(
                        $(elem.createElement("sendPic")).attr("type","boolean").append(
                                $(divEmailList[i]).parent().parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                );
            }
        }
        $("config>sensor>mail", elem).attr("count",countEmail);
        return XMLDoc2XMLStr(elem);
    },
    getCopyData: function(id,copyId) {
        var elem = tirggerXmlDoc["a_" + id];
        $("config>sensor>voltage", elem).text($("#cboAlarmType_" + id).val());
        $("config>sensor>switch", elem).text($("#chkEnableAlarm_" + id).is(":checked") ? "true" : "false");

        $("config>sensor>alarmHoldTime", elem).text($("#cboAlarmHoldingTime_" + id).selectInput("getValue"));
        $("config>sensor>sensorName", elem).empty().append(elem.createCDATASection( $.trim($("#txtSensorName_" + id).val())));
        var divAlarmOut = $("#divAlarmOut_" + id);
        $("config>sensor>triggerAlarmOut>item", elem).each(function(j, j_elem) {
            if ($("#chkAlarmOut_" + id + "_" + $(j_elem).attr("id")).is(":checked")) {
                $(j_elem).text("true");
            }
            else {
                $(j_elem).text("false");
            }
        });
        $("config>sensor>savePicSwitch", elem).text($("#chkTriggerSnap_" + id).is(":checked") ? "true" : "false");
        $("config>sensor>sdRecSwitch", elem).text($("#chkTriggerSDRec_" + id).is(":checked") ? "true" : "false");
//        $("config>sensor>mailSwitch", elem).text($("#chkTriggerEmail_" + id).is(":checked") ? "true" : "false");
        var divFtpList = $("#divFTP_" + id).find(".ftpServer");
        $("config>sensor>ftp>item", elem).remove();
        $("config>sensor>ftp>switch",elem).text($("#chkTriggerFTP_" + id).is(":checked") ? "true" : "false");
        var count = 0;
        for(var i= 0,len = divFtpList.length;i<len;i++){
            if($(divFtpList[i]).attr("checked") === "checked"){
                count++;
                $("config>sensor>ftp", elem).append(
                    $(elem.createElement("item")).attr("id",i+1).append(
                        $(elem.createElement("sendPic")).attr("type","boolean").append(
                                $(divFtpList[i]).parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                );
            }
        }
        $("config>sensor>ftp", elem).attr("count",count);

        var divEmailList = $("#divEmail_"+id).find(".emailServer");
        $("config>sensor>mail>item", elem).remove();
        $("config>sensor>mail>subject", elem).remove();
        $("config>sensor>mail>content", elem).remove();
        $("config>sensor>mail>switch",elem).text($("#chkTriggerEmail_" + id).is(":checked") ? "true" : "false");
        $("config>sensor>mail",elem).append(
            $(elem.createElement("subject")).attr("type","string").attr("maxLen","63").append(
                elem.createCDATASection($("#emailTheme_"+id).val())
            )
        );
        $("config>sensor>mail",elem).append(
            $(elem.createElement("content")).attr("type","string").attr("maxLen","255").append(
                elem.createCDATASection($("#emailContent_"+id).val())
            )
        );
        var countEmail = 0;
        for(var i= 0,len = divEmailList.length;i<len;i++){
            if($(divEmailList[i]).attr("checked") === "checked"){
                countEmail++;
                $("config>sensor>mail", elem).append(
                    $(elem.createElement("item")).attr("id",i+1).append(
                        $(elem.createElement("sendPic")).attr("type","boolean").append(
                                $(divEmailList[i]).parent().next().find("input").attr("checked") === "checked" ? "true" : "false"
                        )
                    )
                );
            }
        }
        $("config>sensor>mail", elem).attr("count",countEmail);
        $("config>sensor>id",elem).text(copyId);
        return XMLDoc2XMLStr(elem);
    }
};

var ScheduleModule = {
    scheduleFlag: false,
    initCtrl: function() {
        $("#dpHoliday").dateInput({
            format: "MM-dd",
            defaultValue: new Date().format("MM-dd")
        });

        $("#divDate").listbox({
            data: [],
            selectItem: function() {
                var itemData = $(this).data("itemData");
                var times = holidaySchedules[itemData.value];
                var timelineObj = $("#divHolidayTimeline");
                timelineObj.timeline("clearTimes");
                $.each(times, function(index, element) {
                    timelineObj.timeline("setTime", element);
                });
            },
            clickItem: function() {
                var itemData = $(this).data("itemData");
                var times = holidaySchedules[itemData.value];
                var timelineObj = $("#divHolidayTimeline");
                timelineObj.timeline("clearTimes");
                $.each(times, function(index, element) {
                    timelineObj.timeline("setTime", element);
                });
            },
            unSelectItem: function() {
            }
        });

        $("#btnHolidayAdd").click(function(event) {
            var dateStr = $("#dpHoliday").val();
            ClearFloatError();
            for (var key in holidaySchedules) {
                if (key == dateStr) {
                    ShowFloatError($("#divDate"), LangCtrl._L_("notUniqueDateTip"));
                    return;
                }
            }
            $("#divHolidayTimeline").timeline("setEnable", true);
            holidaySchedules[dateStr] = ["00:00-23:59"];
            $("#divDate").listbox("addItem", { id: dateStr, value: dateStr });
            var lastItem = $("#divDate").listbox("getAllItems").last();
            lastItem.click();
//            lastItem[0].scrollIntoView();
        });

        $("#btnHolidayDelete").click(function(event) {
            ClearFloatError();
            var id = $("#divDate").listbox("getSeletedItems").data("itemData").id;
            delete holidaySchedules[id];
            $("#divDate").listbox("delItem", id);
            var firstDate = $("#divDate").listbox("getAllItems").first();
            if (firstDate.length == 0) {
                $("#divHolidayTimeline").timeline("clearTimes");
                $("#divHolidayTimeline").timeline("setEnable", false);
            } else {
                firstDate.click();
                firstDate[0].scrollIntoView();
            }
        });

        $("[name=\"scheduleOpType\"]").click(function(event) {
            $("[controlType=\"timeline\"]").timeline("changeMode", event.target.value);
            $("#divHolidayTimeline").timeline("changeMode", event.target.value);
        });

        $("[controlType=\"timeline\"]").timeline({
            manualButtonText: LangCtrl._L_("manualInput"),
            okButtonText: LangCtrl._L_("ok"),
            paddingLeft: 0,
            paddingRight: 0,
            showSelectAllButton: false,
            showInverseButton: false,
            showClearButton: false,
            maxTimeShow: 4,
            oninvalidate: function(startTime, endTime, startInput, endInput) {
                ShowFloatError(startInput, LangCtrl._L_("startTimeGEEndTime"), { left: -startInput.outerWidth() - 6, top: startInput.outerHeight() + 5 });
            }
        });

        $("#divHolidayTimeline").timeline({
            enable: false,
            manualButtonText: LangCtrl._L_("manualInput"),
            okButtonText: LangCtrl._L_("ok"),
            paddingLeft: 0,
            paddingRight: 0,
            showSelectAllButton: false,
            showInverseButton: false,
            showClearButton: false,
            maxTimeShow: 4,
            onvaluechanged: function(control) {
                var itemData = $("#divDate").listbox("getSeletedItems").data("itemData");
                if (itemData && itemData.value) {
                    if(control.timeline("getTimes").length == 0){
                        holidaySchedules[itemData.value] = ["00:00-00:00"];
                    }else{
                        holidaySchedules[itemData.value] = control.timeline("getTimes");
                    }
                }
            },
            oninvalidate: function(startTime, endTime, startInput, endInput) {
                ShowFloatError(startInput, LangCtrl._L_("startTimeGEEndTime"), { left: -startInput.outerWidth() - 6, top: startInput.outerHeight() + 5 });
            }
        });
    },
    getData: function(id) {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetAlarmInScheduleConfig/" + id,
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    ScheduleModule.bindCtrlData();

                    // 周排程
                    $.each(["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"], function(index, element) {
                        var timelineObj = $("[controlType=\"timeline\"]:eq(" + index + ")");
                        timelineObj.timeline("clearTimes");
                        $("config>sensor>schedule>period[mode=\"weekly\"][day=\"" + element + "\"]", xmlDoc).each(function(index, element) {
                            timelineObj.timeline("setTime", $(this).attr("start") + "-" + $(this).attr("end"));
                        });
                    });

                    // 年排程
                    var firstDate = "";
                    holidaySchedules = {};
                    $("#divDate").listbox("clearData");
                    $("#divHolidayTimeline").timeline("setTime","00:00-23:59");
                    $("#divHolidayTimeline").timeline("setEnable", false);
                    $("config>sensor>schedule>period[mode=\"yearly\"]", xmlDoc).each(function(index, element) {
                        var dateStr = $(this).attr("date");
                        if (index == 0) {
                            $("#divHolidayTimeline").timeline("setEnable", true);
                            firstDate = dateStr;
                        }
                        if (!holidaySchedules[dateStr]) {
                            holidaySchedules[dateStr] = [];
                            $("#divDate").listbox("addItem", { id: dateStr, value: dateStr });
                        }
                        holidaySchedules[dateStr].push($(this).attr("start") + "-" + $(this).attr("end"));
                    });

                    if (firstDate) {
                        $("#divDate").listbox("getItemByID", firstDate).click();
                    }

                    if(copyObj.id != undefined && copyObj.id == id){
                        var xmlCopyXml = XMLStr2XMLDoc(copyObj.copyXmlDoc);
                        // 周排程
                        $.each(["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"], function(index, element) {
                            var timelineObj = $("[controlType=\"timeline\"]:eq(" + index + ")");
                            timelineObj.timeline("clearTimes");
                            $("config>sensor>schedule>period[mode=\"weekly\"][day=\"" + element + "\"]", xmlCopyXml).each(function(index, element) {
                                timelineObj.timeline("setTime", $(this).attr("start") + "-" + $(this).attr("end"));
                            });
                        });

                        // 年排程
                        var firstDate = "";
                        holidaySchedules = {};
                        $("#divDate").listbox("clearData");
                        $("#divHolidayTimeline").timeline("setTime","00:00-23:59");
                        $("#divHolidayTimeline").timeline("setEnable", false);
                        $("config>sensor>schedule>period[mode=\"yearly\"]", xmlCopyXml).each(function(index, element) {
                            var dateStr = $(this).attr("date");
                            if (index == 0) {
                                $("#divHolidayTimeline").timeline("setEnable", true);
                                firstDate = dateStr;
                            }
                            if (!holidaySchedules[dateStr]) {
                                holidaySchedules[dateStr] = [];
                                $("#divDate").listbox("addItem", { id: dateStr, value: dateStr });
                            }
                            holidaySchedules[dateStr].push($(this).attr("start") + "-" + $(this).attr("end"));
                        });

                        if (firstDate) {
                            $("#divDate").listbox("getItemByID", firstDate).click();
                        }
                    }


                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        ScheduleModule.timeSpanMaxCount = $("config>sensor>schedule", xmlDoc).attr("maxTimeSpan") * 1;
    },
    verification: function() {
		ClearFloatError();

		var count = 0;
        $("[controlType=\"timeline\"]").each(function(index, element) {
            var $this = $(this);
			count += $this.timeline("getTimes").length;
        });

        $.each($("#divDate").listbox("getAllItems"), function(index, element) {
            var dateStr = $(this).data("itemData").value;
			count += holidaySchedules[dateStr].length;
        });

		if (count > ScheduleModule.timeSpanMaxCount) {
			ShowFloatError($("#btnSave"), LangCtrl._L_("timeSpanMaxCount").format(ScheduleModule.timeSpanMaxCount), { left: -350, top: 1 });
			return false;
		}

        return true;
    },
    getSaveData: function() {
        var weeks = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];
        var scheduleNode = $("config>sensor>schedule", xmlDoc);
        scheduleNode.empty();

        // 周排程
        $("[controlType=\"timeline\"]").each(function(weekIndex, element) {
            var timeSpans = $(this).timeline("getTimes", $.TIMELINE_DATA_MODE_STRING);
            $.each(timeSpans, function(index, element) {
                scheduleNode.append($(xmlDoc.createElement("period")).attr("mode", "weekly").attr("start", element[0]).attr("end", element[1]).attr("day", weeks[weekIndex]));
            });
        });

        // 年排程
        $.each($("#divDate").listbox("getAllItems"), function(index, element) {
            var dateStr = $(this).data("itemData").value;
            $.each(holidaySchedules[dateStr], function(index, element) {
                var timeParts = element.split("-");
                scheduleNode.append($(xmlDoc.createElement("period")).attr("mode", "yearly").attr("start", timeParts[0]).attr("end", timeParts[1]).attr("date", dateStr));
            });
        });

        return XMLDoc2XMLStr(xmlDoc);
    },
    setData: function() {
        window.top.showLoading();
        if (!ScheduleModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetAlarmInScheduleConfig/" + $("config>sensor>id", xmlDoc).text(),
                type: "POST",
                async: true,
                data: ScheduleModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("saveSuccess"), null);
                    }
                    else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("saveFailed"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

function initControl() {
    ScheduleModule.initCtrl();
    $("#btnSave").click(function() {
        var curTab = $.cookie("tab");
        TriggerModule.setData();
    });
}