﻿var context;

var testEmailModule = {
    mapping: {
        txtFromEmail: "config>mail>srcMail",
        txtEmailUserName: "config>mail>userName",
//        txtEmailPassword: "config>mail>passwd",
        txtEmailServiceAddress: "config>mail>server",
        choSafeLink: "config>mail>securityMethod",
        txtSMTPPort: "config>mail>port"
    },
	initCtrl: function(c) {
		context = c;
		$("#btnOK", context).click(function() {

            if (!testEmailModule.verification()) {
                window.top.hideLoading();
                return false;
            }

            testEmailModule.addData();
		});
		$("#btnCancel", context).click(function() {
            testEmailModule.close();
		});
		LangCtrl.translate($("#tbContent_addRecEmail", context));
	},
	verification: function() {
		ClearFloatError();
        var $txtEmailName = $("#emailName",context);
        if ($.trim($txtEmailName.val()).length == 0) {
            ShowFloatError($txtEmailName, LangCtrl._L_("emailNotEmptyTip"));
            return false;
        }
        if (!CheckEmail($txtEmailName.val())) {
            ShowFloatError($txtEmailName, LangCtrl._L_("invalidEmailTip"));
            return;
        }
		return true;
	},
    getTestSaveData: function() {
        var testXmlDoc = XMLStr2XMLDoc(XMLDoc2XMLStr(xmlDoc));
        $("config>mail>sendPicSwitch", testXmlDoc).remove();
        $("config>mail>recvMail", testXmlDoc).remove();
        $("config>mail", testXmlDoc).append(
            $(testXmlDoc.createElement("testRecvMail")).attr("type","string").attr("maxLen","63").append(
                $(testXmlDoc.createCDATASection($("#emailName",context).val()))
            )
        );
//        XmlHttpClient.GetXmlByPage(EmailModule.mapping, xmlDoc);
        var pwd = $("#txtEmailPassword").val();
        var pwdNode = $("config>mail>passwd", testXmlDoc);
        if (pwd == "" || !EmailModule.modifyFlag) {
            pwdNode.remove();
        } else {
            if (pwdNode.size() == 0) {
                var selectorParts = /^((\w+>?)+)>(\w+)$/.exec("config>mail>passwd");
                if (selectorParts) {
                    pwdNode = $(testXmlDoc.createElement(selectorParts[3]));
                    $(selectorParts[1], testXmlDoc).append(pwdNode);
                }
            }
            pwdNode.empty().append($(testXmlDoc.createCDATASection(PrivEncrypt([pwd],23784501))));
        }
//        return XMLDoc2XMLStr(xmlDoc);
        return XmlHttpClient.GetXmlByPage(testEmailModule.mapping, testXmlDoc);
    },
    addData : function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/MailTest",
                type: "POST",
                async: true,
                data: testEmailModule.getTestSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("emailSetSuccess"), null);
                        testEmailModule.close();
                    }
                    else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("emailSetFailed"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
	close: function() {
        dialog_addTestReceive.CloseDialog();
	}
};