var context;

var AddCruiseForGroupModule = {
    itemId:0,
    initCtrl: function(c) {
        context = c;

        $("#btnCruiseForOK", context).click(function() {
            AddCruiseForGroupModule.setData(context);
            AddCruiseForGroupModule.close();
        });

        $("#btnCruiseForCancel", context).click(function() {
            AddCruiseForGroupModule.close();
        });

        LangCtrl.translate($("#tbCruise", context));

        AddCruiseForGroupModule.bindCtrlData();

    },
    bindCtrlData: function() {
        var cboPresetName = $("#cboCruiseName", context);
        cboPresetName.empty();
        $("<option value=\"0\">" + LangCtrl._L_("no") + "</option>").appendTo(cboPresetName);
        $("config>cruiseInfo>item", autoCruiseXmlDoc).each(function(index, element) {
            $("<option value=" + $(this).attr("id") + ">" + $(this).text() + "</option>").appendTo(cboPresetName);
        });
    },
    getSaveData:function(){
        var itemGId = AddCruiseForGroupModule.itemId;
        var cruiseGId = $("#cboCruiseName", context).val();
        var cruiseGName = $("#cboCruiseName>option:selected", context).text();

        return xmlHeader + "<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\">" +"<groupInfo>" + "<cruiseInfo type=\"list\" maxCount=\"8\">" +"<item id=\""+itemGId+ "\"><cruise id=\"" +cruiseGId+"\">"+"<![CDATA["+cruiseGName+"]]></cruise></item>"+"</cruiseInfo></groupInfo></config>";
    },
    setData: function(c) {
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzSetGroup",
                type: "POST",
                async: true,
                data: AddCruiseForGroupModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    ptzGroupModule.showTip(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    close: function() {
        dialogAddCruiseForGroup.CloseDialog();
    }
};