﻿$(function() {
    window.top.hideLoading();
    PtzRestoreSettingModule.initCtrl();
});

var PtzRestoreSettingModule = {
    initCtrl: function(){
        $("#MReset").click(function(){
            window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmMRest"), function (result) {
                if (result) {
                    PtzRestoreSettingModule.MReset();
                }
            }, 300, 200);
        });
        $("#MClear").click(function(){
            window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmMClear"), function (result) {
                if (result) {
                    PtzRestoreSettingModule.MClear();
                }
            }, 300, 200);
        });
    },
    MReset: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzReset",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        window.top.MsgBoxHelper.Show("ok", LangCtrl._L_("infoTip"), LangCtrl._L_("resetSuccess"), null);
                    } else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("resetFailed"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    MClear:function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzClear",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        window.top.MsgBoxHelper.Show("ok", LangCtrl._L_("infoTip"), LangCtrl._L_("clearSuccess"), null);
                    } else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("clearFailed"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }

};