﻿$(function () {
    window.top.hideLoading();
    $("#btnExportSetting").click(function () {
//        window.open(serverBase + "/ExportSetting");
        document.location.href = serverBase + "/ExportSetting";
    });

    $("#btnLoadDefault").click(function () {
        window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmLoadDefault"), function (result) {
            if (result) {

                var arrIp =  serverIp.split(".");
                if(arrIp[0] == "169" && arrIp[1] == "254"){
                    window.top.showLoading(LangCtrl._L_("loadingDefaultTip1"));
                    setTimeout("reBootConnect()", 10000);
                }else{
                    window.top.showLoading(LangCtrl._L_("loadingDefaultTip2"));
                }

                $(".loadingIndicator_tip",window.top.document).css({background:"#5A626B"});
                $(".msg_border>.msg",window.top.document).css({color:"white"});
                XmlHttpClient.SendHttpRequest({
                    url: serverBase + "/LoadDefault",
                    type: "POST",
                    async: true,
                    data: "",
                    beforeSend: XmlHttpClient.CommBeforeSend,
                    callback: function () {
                    }
                });
//                setTimeout("reBootConnect()", 20000);
            }
        }, 300, 200);
    });

    $("#btnImportSetting").click(importSetting);
    $("#Content",window.top.document).css({"min-width":"900px"});
});

function importSetting() {
    if ($("#fileImport").val() == "") {
        window.top.showLoading();
        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("needImportFile"), null);
        window.top.hideLoading();
        return;
    }
    window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmImport"), function (result) {
        if (result) {
            window.top.showLoading(LangCtrl._L_("importing"));
            setTimeout("$('#importForm').submit()", 1000);
        }
    }, 300, 200);
}

//检测重启
function reBootConnect() {
    XmlHttpClient.SendHttpRequest({
        url: serverBase + "/GetRebootStatus",
        type: "POST",
        async: true,
        data: "",
        timeout: 60000,
        beforeSend: XmlHttpClient.CommBeforeSend,
        callback: function(result) {
            if ($("rebootStatus", result).text() == "true") {
                window.top.hideLoading();
                window.top.location.href = serverBase + "/Pages/main.htm";
            }
            else {
                setTimeout("reBootConnect()", 5000);
            }

        },
        error: function() {
            setTimeout("reBootConnect()", 5000);
        }
    });
}