var xmlDoc;
var rtspPort; // RTSP端口
var NetLiveMonitor; // 视频控件

$(function() {

    bindEvent();
    operatioLogModel.initCtrl();
    operatioLogModel.doResize();
    $("#Content",window.top.document).css({"min-width":"1150px"});
});

function LogType(key, value, parentValue,text) {
    this._key = key;
    this._value = value;
    this._parentValue = parentValue;
    this._text = text
}




//var MainType = [new LogType('LOG_ALL_TYPE', 0, null),
//    new LogType('LOG_MAIN_ALARM', parseInt("0x010000", 16), null),
//    new LogType('LOG_MAIN_ABNORMAL', parseInt("0x020000", 16), null),
//    new LogType('LOG_MAIN_OPERATION', parseInt("0x030000", 16), null),
//    new LogType('LOG_MAIN_INFO', parseInt("0x040000", 16), null)];
var MainType = [];
var LOG_MAIN_ALARM=[], LOG_MAIN_ABNORMAL=[], LOG_MAIN_OPERATION=[] ,LOG_MAIN_INFO = [];
//var SubType = [LOG_MAIN_ALARM,LOG_MAIN_ABNORMAL,LOG_MAIN_OPERATION,LOG_MAIN_INFO];



//var LOG_MAIN_ALARM = [new LogType('LOG_ALARM_IN', parseInt("0x010001", 16), parseInt("0x010000", 16)),
//    new LogType('LOG_ALARM_OUT', parseInt("0x010002", 16), parseInt("0x010000", 16)),
//    new LogType('LOG_MOTION_START', parseInt("0x010003", 16), parseInt("0x010000", 16)),
//    new LogType('LOG_MOTION_STOP', parseInt("0x010004", 16), parseInt("0x010000", 16))];
//
//var LOG_MAIN_ABNORMAL = [new LogType('LOG_ACCESS_DENY', parseInt("0x020001", 16), parseInt("0x020000", 16)),
//    new LogType('LOG_DISCONNECTED', parseInt("0x020002", 16), parseInt("0x020000", 16)),
//    new LogType('LOG_LINK_DOWN', parseInt("0x020003", 16), parseInt("0x020000", 16)),
//    new LogType('LOG_IP_COLLISION', parseInt("0x020004", 16), parseInt("0x020000", 16))];
//
//var LOG_MAIN_OPERATION = [new LogType('LOG_SYSTEM_CONFIG', parseInt("0x030001", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_VIDEO_CONFIG', parseInt("0x030002", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_PTZ_CONFIG', parseInt("0x030003", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_MOTION_ALARM_CONFIG', parseInt("0x030004", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_SENSOR_ALARM_CONFIG', parseInt("0x030005", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_NET_CONFIG', parseInt("0x030006", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_USER_CONFIG', parseInt("0x030007", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_SECURE_CONFIG', parseInt("0x030008", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_RECOVER_DEFAULT_CONFIG', parseInt("0x030009", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_IMPORT_CONFIG', parseInt("0x03000A", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_SYSTME_REBOOT', parseInt("0x03000B", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_SUCCESS_LOGIN', parseInt("0x03000C", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_SUCCESS_LOGOUT', parseInt("0x03000D", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_UPGRADE_START', parseInt("0x03000E", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_UPGRADE_SUCCESSFULLY', parseInt("0x03000F", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_UPGRADE_FAILED', parseInt("0x030010", 16), parseInt("0x030000", 16)),
//    new LogType('LOG_UPGRADE_STOP', parseInt("0x030011", 16), parseInt("0x030000", 16))];
//
//var LOG_MAIN_INFO = [new LogType('LOG_SYSTEM_START', parseInt("0x040001", 16), parseInt("0x040000", 16)),
//    new LogType('LOG_DHCP_START', parseInt("0x040002", 16), parseInt("0x040000", 16)),
//    new LogType('LOG_DHCP_SUCCESS', parseInt("0x040003", 16), parseInt("0x040000", 16)),
//    new LogType('LOG_DHCP_STOP', parseInt("0x040004", 16), parseInt("0x040000", 16)),
//    new LogType('LOG_PPPOE_START', parseInt("0x040005", 16), parseInt("0x040000", 16)),
//    new LogType('LOG_PPPOE_SUCCESS', parseInt("0x040006", 16), parseInt("0x040000", 16)),
//    new LogType('LOG_PPPOE_STOP', parseInt("0x040007", 16), parseInt("0x040000", 16)),
//    new LogType('LOG_INSERT_SD_CARD', parseInt("0x040008", 16), parseInt("0x040000", 16)),
//    new LogType('LOG_PULL_OUT_SD_CARD', parseInt("0x040009", 16), parseInt("0x040000", 16)),
//    new LogType('LOG_POPUP_SD_CARD', parseInt("0x04000A", 16), parseInt("0x040000", 16))];

function bindMainType() {
    var $drpMainType = $("#drpMainType");
    $drpMainType.empty();
    for (var i in MainType) {
        $("<option value=" + MainType[i]._value + ">" + MainType[i]._text + "</option>").appendTo($drpMainType);
    }
    $drpMainType.change(function() {
        bindSubType($drpMainType.val());
    });
}

function bindSubType(mainValue) {
    var $drpSubType = $("#drpSubType");
    $drpSubType.empty();
    $("<option value='0' title='" + MainType[0]._text + "'>" + MainType[0]._text + "</option>").appendTo($drpSubType);
    if (mainValue == "0") {
        for (var i in LOG_MAIN_ALARM) {
            $("<option value='" + LOG_MAIN_ALARM[i]._value + "' title='" + LOG_MAIN_ALARM[i]._text + "'>" + LOG_MAIN_ALARM[i]._text + "</option>").appendTo($drpSubType);
        }
        for (var i in LOG_MAIN_ABNORMAL) {
            $("<option value='" + LOG_MAIN_ABNORMAL[i]._value + "' title='" + LOG_MAIN_ABNORMAL[i]._text + "'>" + LOG_MAIN_ABNORMAL[i]._text + "</option>").appendTo($drpSubType);
        }
        for (var i in LOG_MAIN_OPERATION) {
            $("<option value='" + LOG_MAIN_OPERATION[i]._value + "' title='" + LOG_MAIN_OPERATION[i]._text + "'>" + LOG_MAIN_OPERATION[i]._text + "</option>").appendTo($drpSubType);
        }
        for (var i in LOG_MAIN_INFO) {
            $("<option value='" + LOG_MAIN_INFO[i]._value + "' title='" + LOG_MAIN_INFO[i]._text + "'>" + LOG_MAIN_INFO[i]._text + "</option>").appendTo($drpSubType);
        }
    }
    else {
        switch (mainValue*1) {
            case parseInt("0x010000", 16):
                for (var i in LOG_MAIN_ALARM) {
                    $("<option value='" + LOG_MAIN_ALARM[i]._value + "' title='" + LOG_MAIN_ALARM[i]._text + "'>" + LOG_MAIN_ALARM[i]._text + "</option>").appendTo($drpSubType);
                }
                break;
            case parseInt("0x020000", 16):
                for (var i in LOG_MAIN_ABNORMAL) {
                    $("<option value='" + LOG_MAIN_ABNORMAL[i]._value + "' title='" + LOG_MAIN_ABNORMAL[i]._text + "'>" + LOG_MAIN_ABNORMAL[i]._text + "</option>").appendTo($drpSubType);
                }
                break;
            case parseInt("0x030000", 16):
                for (var i in LOG_MAIN_OPERATION) {
                    $("<option value='" + LOG_MAIN_OPERATION[i]._value + "' title='" + LOG_MAIN_OPERATION[i]._text + "'>" + LOG_MAIN_OPERATION[i]._text + "</option>").appendTo($drpSubType);
                }
                break;
            case parseInt("0x040000", 16):
                for (var i in LOG_MAIN_INFO) {
                    $("<option value='" + LOG_MAIN_INFO[i]._value + "' title='" + LOG_MAIN_INFO[i]._text + "'>" + LOG_MAIN_INFO[i]._text + "</option>").appendTo($drpSubType);
                }
                break;
        }
    }
}

function GetLogType(){
    var langType = $.cookie('lang_type');
    var condition = xmlHeader+"<config>";
    condition += "  <language type=\"string\">" + langType + "</language>";
    condition += "</config>";

    window.top.showLoading();
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetLogType",
            type: "POST",
            async: true,
            data: condition,
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
                window.top.hideLoading();

                $("config > item",result).each(function(index,element){
                    var mainType = $(">mainType",element).attr("id");
                    var value = "0x0"+(index)+"0000";
                    var text =  $(">mainType",element).text();
                    MainType.push(new LogType(mainType, parseInt(value, 16), null, text));

                    $(">subType>item",element).each(function(i,ele){
                        var subType = $(ele).attr("id");
                        var subValue = "0x0"+(index)+"00";
                        var n = (i+1);
                        if(n < 10){
                            subValue += "0"+n;
                        }else{
                            var str  =   (n == 10) ? "0A" : (n == 11) ? "0B" : (n == 12) ? "0C" : (n == 13)  ? "0D" : n == 14 ? "0E" : n == 15 ? "0F" : n == 16 ? "10" : "11";
                            subValue += str;
                        }
                        var text =  $(ele).text();
                        if(index == 1){
                            LOG_MAIN_ALARM.push( new LogType(subType, parseInt(subValue, 16), parseInt(value, 16),text));
                        }else if( index == 2 ){
                            LOG_MAIN_ABNORMAL.push( new LogType(subType, parseInt(subValue, 16), parseInt(value, 16),text));
                        }else if(index == 3 ){
                            LOG_MAIN_OPERATION.push( new LogType(subType, parseInt(subValue, 16), parseInt(value, 16),text));
                        }else if(index == 4){
                            LOG_MAIN_INFO.push( new LogType(subType, parseInt(subValue, 16), parseInt(value, 16),text));
                        }
                    });

                });

                bindMainType();
                bindSubType("0");

            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}


function bindEvent() {
    GetLogType();

    var startTime = new Date();
    startTime.setHours(0, 0, 0, 0);
    var endTime = new Date();
    endTime.setHours(23, 59, 59, 0);

    var dpStartTime = $("#dpStartTime");
    dpStartTime.wbDatePicker({
        lang: LangCtrl.getLang(),
        showTime: true,
        defaultDate: startTime,
        dateFormat: "yyyy-MM-dd HH:mm:ss"
    });

    var dpEndTime = $("#dpEndTime");
    dpEndTime.wbDatePicker({
        lang: LangCtrl.getLang(),
        showTime: true,
        defaultDate: endTime,
        dateFormat: "yyyy-MM-dd HH:mm:ss"
    });

    $("#btnQuery").click(function(){
        if ($("#dpEndTime").wbDatePicker("get", $.DATEPICKER_TIME) - $("#dpStartTime").wbDatePicker("get", $.DATEPICKER_TIME) <= 0)
        {
            window.top.showLoading();
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("timeIllegalTip"), null);
            window.top.hideLoading();
        }else{
            operatioLogModel.query( $("#divEventLogPage").wbPager("getPageIndex"), $("#divEventLogPage").wbPager("getPageDataCount"));
        }
    });
    $("#btnExport").click(function(){
        operatioLogModel.exportLog();
    });
}

var operatioLogModel ={
    doResize: function(){
        var height1 = $("#config_content", window.parent.document).height();
        var height2 = $("#logTable").height();

        $("#eventLogGrid").wbGrid("setHeight", height1 - height2 - 160);
        $(window.top).resize(function () {
            $("#eventLogGrid").wbGrid("setHeight", height1 - height2 - 160);
        });
    },
    initCtrl: function() {
        $("#eventLogGrid").wbGrid({
            data: {
                colNames: [LangCtrl._L_("time"), LangCtrl._L_("mainType1"), LangCtrl._L_("subType1")
                    , LangCtrl._L_("userName"),LangCtrl._L_("loginIP")],
                colModel: [
                    { name: 'recordTime', index: 'recordTime',width: 80, align: "center", sortable: false },
                    { name: 'firstType', index: 'firstType',width: 80, align: "center", sortable: false },
                    { name: 'secondType', index: 'secondType',width: 80, align: "center", sortable: false },
                    { name: 'userName', index: 'userName',width: 80, align: "center", sortable: false },
                    { name: 'loginIP', index: 'loginIP',width: 80, align: "center", sortable: false }
                ],
                rowList: []
            },
            view: {
                selectRow : true,
                rownumbers: true,
                lang: LangCtrl.getLang()
            }
        });
        $("#divEventLogPage").wbPager({
            pageIndex: 1,
            pageDataCount: 20,
            dataCount: 0,
            lang: LangCtrl.getLang(),
            pageDataCountItems: [10, 20, 30,50,100],
            onPage: function (pagerId, pageIndex, pageDataCount) {
                operatioLogModel.isPaging = true;
                operatioLogModel.query(pageIndex, pageDataCount);
            }
        });
        window.top.hideLoading();
//        operatioLogModel.query(1, $("#divEventLogPage").wbPager("getPageDataCount"));
    },
    getCondition: function(pageIndex, pageSize){
        var langType = $.cookie('lang_type');
        var logType = $("#drpSubType").val() == "0" ? $("#drpMainType").val() : $("#drpSubType").val();
        var condition = xmlHeader+"<queryCondition>";
        condition += "  <startTime type=\"string\">" + $("#dpStartTime").val() + "</startTime>";
        condition += "  <endTime type=\"string\">" + $("#dpEndTime").val() + "</endTime>";
        condition += "  <type type=\"uint32\">" + logType + "</type>";
        condition += "  <index type=\"uint32\">" + (pageIndex-1) * pageSize + "</index>";
        condition += "  <count type=\"uint32\">" + pageSize + "</count>";
        condition += "</queryCondition>";
        return condition;
    },
    query: function(pageIndex, pageSize){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetEventLog",
                type: "POST",
                async: true,
                data: operatioLogModel.getCondition(pageIndex, pageSize),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    xmlDoc = result;

                    var rowData = xml2json(xmlDoc, "eventLog>item")["item"];
                    if (!rowData)
                        rowData = [];
                    if (!(rowData instanceof Array)) {
                        rowData = [rowData];
                    }
                    $.each( rowData, function(i, n){
                        n['firstType'] = $("#drpMainType>option[value='" + n['firstType'] + "']").text();
                        n['secondType'] = $("#drpSubType>option[value='" + n['secondType'] + "']").text();
                    });

                    $("#eventLogGrid").wbGrid("load", rowData);
                    $("#divEventLogPage").wbPager("setDataCount", $("eventLog", xmlDoc).attr("total") * 1, false);

                    if (rowData.length >= 1) {
                        $("#btnExport").removeAttr("disabled").removeClass("disabled");
                    }else if(rowData.length == 0){
                        $("#btnExport").addClass("disabled").attr("disabled","disabled");
                    }


                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    exportLog: function(){
        var langType = $.cookie('lang_type');
        var logType = $("#drpSubType").val() == "0" ? $("#drpMainType").val() : $("#drpSubType").val();
        var startTime = $("#dpStartTime").val();
        var aStartTime = startTime.split(" ")[0].split("-").join("");
        var bStartTime = startTime.split(" ")[1].split(":").join("");
        var endTime = $("#dpEndTime").val();
        var aEndTime = endTime.split(" ")[0].split("-").join("");
        var bEndTime = endTime.split(" ")[1].split(":").join("");

        var param = "";
        param += langType + "$" +logType + "$" + aStartTime + bStartTime +  "$" +  aEndTime + bEndTime + "\0";

        $("#log").attr("value",param);
        $("#downLog").attr("action",serverBase + "/ExportLog");
        $("#downLog").submit();

    }
}
