﻿var NetLiveMonitor;
var rtspPort,netPort; //RTSP端口
var netPortComplete = false;

$(function () {
    window.top.showLoading();
    getDeviceInfo(function (result) {
        if ($("config>deviceInfo>integratedPtz", result).text() == "true") {
            $(".ptzPl").show();
        }
        if ($("config>deviceInfo>upgradeProtocol", result).text() == "binary") {
            $("#upgradeByOcx").show();
            upgradeByOcx();
        }else{
            $("#upgradeHttp").show();
            upgradeHttp();
        }
        window.top.hideLoading();
    });
});

function upgradeHttp(){
    $("#btnUpgrade").click(upgrade);
    $("#btnUpgradePtz").click(upgradePtz);
    $("#Content",window.top.document).css({"min-width":"1080px"});
}

function upgradeByOcx(){
    getNetPort();
    $("input:text").bind("keydown",function(){
        return false;
    });
    NetLiveMonitor = LoadPlugin("divUpgradeByOCX","NetLiveMonitor");
    InitLiveOCX();
    closeStream();
    $("#Content",window.top.document).css({"min-width":"1080px"});
}

function upgrade() {
    if ($("#fileUpgrade").val() == "") {
        window.top.showLoading();
        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("needUpgradeFile"), null);
        window.top.hideLoading();
        return;
    }
    window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmUpgrade"), function (result) {
        if (result) {
            window.top.showLoading(window.top.LangCtrl._L_("upgradeTip"));
            setTimeout("$('#upgradeForm').submit()", 1000);
        }
    }, 300, 200);
}

function upgradePtz() {
    if ($("#fileUpgradePtz").val() == "") {
        window.top.showLoading();
        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("needUpgradeFile"), null);
        window.top.hideLoading();
        return;
    }
    window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmUpgrade"), function (result) {
        if (result) {
            window.top.showLoading(window.top.LangCtrl._L_("upgradeTip"));
            setTimeout("$('#upgradePtzForm').submit()", 1000);
        }
    }, 300, 200);
}

function InitLiveOCX() {
    //设置OCX模式
    try {
        var sendXML = OCX_XML_SetPreViewModel('Fixed');
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        $("#divUpgradeByOCX").width(0).height(0);
        bindEvent();
    }
    catch (ex) {
    }
}

function bindEvent() {
    $("#fileUpgradePath").click(function() {
        var sendXML = OCX_XML_OpenFileBrowser("FILE");
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var path = $.trim(OCX_XML_OpenFileBrowser_getpath(result));
        if (path != "") {
            $("#txtUpgradePath").val(path);
        }
    });
    $("#btnSave").click(upgrade2);
}

function upgrade2() {
    var userInfo = Decryption($.cookie('auInfo'));
    var userInfoArr = userInfo.split(':');

    //设置登录信息
    var username = userInfoArr[0];
    var password = userInfoArr[1];
    var id = "";
    var sendXML = OCX_XML_SetUpgradeLoginInfo(username, password, serverIp, netPort, id);
    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

    var upgradePath = $.trim($("#txtUpgradePath").val());
    window.top.showLoading();
    if(upgradePath == ""){
        window.top.hideLoading();
        window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("needUpgradeFile"), null);
        return false;
    }
    window.top.showLoading("0%");
    try {
        var sendXML = OCX_XML_SetUpgradePath(upgradePath);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }
    catch (e) {
        window.top.hideLoading();
        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("saveFailed"), null);

    }
}

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));
    var upgradeStatus = $("statenotify[type='upgradeStatus']",$xmlDoc);
    if (upgradeStatus.length > 0) {
        var status = $(">status", upgradeStatus).text();
        if(status === "25"){
            window.top.showLoading("25%");
        } if(status === "50"){
            window.top.showLoading("50%");
        } if(status === "75"){
            window.top.showLoading("75%");
        } if(status === "99"){
            window.top.showLoading("99%");
        }else if(status === "Success"){
            window.top.hideLoading();
            window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("Success"), null);
        }else if(status == "OpenFileError"){
            window.top.hideLoading();
            window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("OpenFileError"), null);
        }else if(status == "PackageError"){
            window.top.hideLoading();
            window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("PackageError"), null);
        }else if(status == "NetError"){
            window.top.hideLoading();
            window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("NetError"), null);
        }else if(status == "UserError"){
            window.top.hideLoading();
            window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("UserError"), null);
        }else if(status == "Failed"){
            window.top.hideLoading();
            window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("Failed"), null);
        }
    }
    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), null);
        }
    }
}

// 获取私有协议数据端口
function getNetPort() {
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetPortConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
                netPort = $("config>port>netPort", result).text() * 1;
                netPortComplete = true;
                if (netPortComplete) {
                    window.top.hideLoading();
                    if(!NetLiveMonitor){
                        NetLiveMonitor = LoadPlugin("divLiveOCX","NetLiveMonitor");
                        InitLiveOCX();
                    }
                }
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}