﻿var xmlDoc;

$(function() {
    BasicInfoModule.initCtrl();
	BasicInfoModule.getData();
});

var BasicInfoModule = {
    mapping: {
        txtSoftVersion: "config>deviceInfo>softwareVersion",
        txtSoftCreateDate: "config>deviceInfo>softwareBuildDate",
        txtCoreVersion: "config>deviceInfo>kernelVersion",
        txtHardVersion: "config>deviceInfo>hardwareVersion",
        txtMac: "config>deviceInfo>mac",
        txtDeviceVersion: "config>deviceInfo>model",
        txtDeviceBrand: "config>deviceInfo>brand",
        txtOnvifVersion: "config>deviceInfo>onvifVer"
    },
    initCtrl: function() {
        $(":text").keydown(function(event) { return false; });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetDeviceInfo",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    XmlHttpClient.BindPageByXml(BasicInfoModule.mapping, xmlDoc);
                    $("#txtOcxVersion").val($.cookie("ocxVersion").split(",").join("."));
                    if($("config>deviceInfo>ptzVersion",xmlDoc).size() >= 1){
                        $("#ptzVersion").show();
                    }
                    if($("config>deviceInfo>cameraType",xmlDoc).size() >= 1){
                        $("#cameraType").show();
                    }
                    $("#txtPtzVersion").val( $("config>deviceInfo>ptzVersion",xmlDoc).text());
                    $("#txtCameraType").val( $("config>deviceInfo>cameraType",xmlDoc).text());
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};