﻿var NetLiveMonitor;
var rtspPort; //RTSP端口

$(function() {
    window.top.hideLoading();
    $("input:text").bind("keydown",function(){
        return false;
    });
    NetLiveMonitor = LoadPlugin("divLocalCfgOCX","NetLiveMonitor");
    InitLiveOCX();
    LoadLocalCfg();
    closeStream();
    $("#Content",window.top.document).css({"min-width":"1080px"});
});

function InitLiveOCX() {
    //设置OCX模式
    try {
        var sendXML = OCX_XML_SetPreViewModel('Fixed');
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        bindEvent();
    }
    catch (ex) {
    }
}

function bindEvent() {
    $("#fileLiveSnapSavePath").click(function() {
        var sendXML = OCX_XML_OpenFileBrowser("FOLDER");
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var path = $.trim(OCX_XML_OpenFileBrowser_getpath(result));
        if (path != "") {
            $("#txtLiveSnapSavePath").val(path);
        }
    });
    $("#fileRecSavePath").click(function() {
        var sendXML = OCX_XML_OpenFileBrowser("FOLDER");
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var path = $.trim(OCX_XML_OpenFileBrowser_getpath(result));
        if (path != "") {
            $("#txtRecSavePath").val(path);
        }
    });
    $("#btnSave").click(GetLocalPathLimit);
}

function LoadLocalCfg() {
    try {
        var sendXML = OCX_XML_GetLocalCfg();
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var $xmlDoc = $(XMLStr2XMLDoc(result));
        $("[name='livePerformance'][value='" + $("response>livePerformance", $xmlDoc).text() + "']").attr("checked", "checked");
        $("#txtLiveSnapSavePath").val($("response>liveSnapSavePath", $xmlDoc).text());
        $("#txtRecSavePath").val($("response>recSavePath", $xmlDoc).text());

        var recVolume = $("response>recVolume", $xmlDoc).text();
        $(":radio[name=\"recVolume\"]").each(function(index, element) {
            if (recVolume == $(this).val()) {
                $(this).attr("checked", true);
                return false;
            }
        });

        $("#divLocalCfgOCX").width(0).height(0);
    }
    catch (e) {
        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("queryFailed"), null);
    }
}

function GetLocalPathLimit() {
    try {
        var liveSnapSavePath = $.trim($("#txtLiveSnapSavePath").val());
        var recSavePath = $.trim($("#txtRecSavePath").val());
        var sendXML = OCX_XML_GetLocalPathLimit(liveSnapSavePath,recSavePath);
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var $xmlDoc = $(XMLStr2XMLDoc(result));
        if($("response>status", $xmlDoc).text() === "success"){
            SaveLocalCfg();
        }else{
            $("response>errorCode", $xmlDoc).text() === "liveSnapSavePath" ? window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("liveSnapSavePathError"), null) :window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("recSavePathError"), null);
        }

    }
    catch (e) {
        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("queryFailed"), null);
    }
}

function SaveLocalCfg() {
    window.top.showLoading();
    try {
        var livePerformance = $("[name='livePerformance']:checked").attr("value");
        var liveSnapSavePath = $.trim($("#txtLiveSnapSavePath").val());
        var recSavePath = $.trim($("#txtRecSavePath").val());
        var recVolume = $(":radio[name=\"recVolume\"]:checked").val();

        var sendXML = OCX_XML_SetLocalCfg(livePerformance, recVolume, liveSnapSavePath, recSavePath);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        window.top.hideLoading();
        window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("saveSuccess"), null);
    }
    catch (e) {
        window.top.hideLoading();
        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("saveFailed"), null);

    }
}

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));
}