﻿var xmlDoc;
var rtspPort,netPort; //RTSP端口,数据端口
var NetLiveMonitor; //视频控件
var xmlDocReset,customized,aa;
$(function(){

    getDeviceInfo(function(result) {
        //定制需求
        customized = $("config>deviceInfo>Customized", result).text();
//        if(customized == "HU03"){
//            $("#trShutter").empty();
//            $("#trIris").empty();
//        }


    });

    ptzCameraSettingsModule.initCameraPtzSettingsCtrl();
});

var ptzCameraSettingsModule = {
    pnMode:"",
    mapping: {
        chkPtzSharpness: "config>ptzCameraSetting>ptzSharpness>switch",
        chkZoomDisplay: "config>ptzCameraSetting>zoomDisplay>switch",
        chkLightInhibit: "config>ptzCameraSetting>lightInhibit>switch",
        chkThroughFog: "config>ptzCameraSetting>throughFog>switch",
        cboWhiteBalance: "config>ptzCameraSetting>whiteBalance>mode",
        cboAutoExposureMode: "config>ptzCameraSetting>autoExposureMode>mode",
        cboDayNight: "config>ptzCameraSetting>IRCutMode>mode",
        coInfraMode: "config>ptzCameraSetting>infraSensitivity>infraMode"
    },
    ajustHeight: function() {
        //var minHeight = $("#divCameraTrigger").height() + 80;
        var minHeight = parseInt($("#leftParam").css("top")) + $("#leftParam").height() + 120;
        window.parent.setConfigMiniHeight(minHeight);
    },
    toggleZoomDisplay: function(enabled) {
        $("#valueZoomDisplay").attr("disabled", !enabled);
        $("#sliderZoomDisplay").slider("setProperty", "enable", enabled);
        if (!enabled) {
            var zoomDisplayNode = $("config>ptzCameraSetting>zoomDisplay>value", xmlDoc);
            $("#sliderZoomDisplay").slider("setValue", zoomDisplayNode.text() ? zoomDisplayNode.text() : zoomDisplayNode.attr("default"));
        }
    },
    toggleLightInhibit: function(enabled) {
        $("#valueLightInhibit").attr("disabled", !enabled);
        $("#sliderLightInhibit").slider("setProperty", "enable", enabled);
        if (!enabled) {
            var lightInhibiNtode = $("config>ptzCameraSetting>lightInhibit>value", xmlDoc);
            $("#sliderLightInhibit").slider("setValue", lightInhibiNtode.text() ? lightInhibiNtode.text() : lightInhibiNtode.attr("default"));
        }
    },
    toggleThroughFog: function(enabled) {
        $("#valueThroughFog").attr("disabled", !enabled);
        $("#sliderThroughFog").slider("setProperty", "enable", enabled);
        if (!enabled) {
            var throughFogNode = $("config>ptzCameraSetting>throughFog>value", xmlDoc);
            $("#sliderThroughFog").slider("setValue", throughFogNode.text() ? throughFogNode.text() : throughFogNode.attr("default"));
        }
    },
    togglePtzSharpness: function(enabled) {
        $("#valuePtzSharpness").attr("disabled", !enabled);
        $("#sliderPtzSharpness").slider("setProperty", "enable", enabled);
        if (!enabled) {
            var ptzSharpnessNode = $("config>ptzCameraSetting>ptzSharpness>value", xmlDoc);
            $("#sliderPtzSharpness").slider("setValue", ptzSharpnessNode.text() ? ptzSharpnessNode.text() : ptzSharpnessNode.attr("default"));
        }
    },
    toggleWhiteBalance: function(enabled) {
        $("#trBalanceRed")[enabled ? "show" : "hide"]();
        $("#trBalanceBlue")[enabled ? "show" : "hide"]();
    },
    toggleInfra: function(enabled) {
        $("#trInfraOnOff")[enabled ? "show" : "hide"]();
    },
    toggleManualExposureMode: function(type){
        $("#valueAutomaticGain").attr("disabled", type === "manual");
        $("#sliderAutomaticGain").slider("setProperty", "enable", type !== "manual");
    },
    toggleAutoExposureMode: function(one,two,three,four) {
        $("#trBrightness")[one ? "show" : "hide"]();
        $("#trShutter")[two ? "show" : "hide"]();
        $("#trIris")[three ? "show" : "hide"]();
        $("#trAutoGain")[four ? "show" : "hide"]();
//        $("#sliderBrightness").slider("setProperty","maxValue",$("config>ptzCameraSetting>autoExposureMode>autoBrightness",xmlDoc).attr("max"));
//        $("#sliderShutter").slider("setProperty","maxValue",$("config>ptzCameraSetting>autoExposureMode>autoShutter",xmlDoc).attr("max"));
//        $("#sliderAperture").slider("setProperty","maxValue",$("config>ptzCameraSetting>autoExposureMode>autoIris",xmlDoc).attr("max"));
    },
    toggleDayNight: function(enabled) {
        $("#trDayToNight")[enabled ? "show" : "hide"]();
        $("#trNightToDay")[enabled ? "show" : "hide"]();
    },
    initCameraPtzSettingsCtrl: function(){
        $("#Content", window.top.document).css({ "min-width": "1200px" });
        $("#sliderLightInhibit").slider({
            enable: false,
            minValue: 0,
            maxValue: 20,
            maxWidth: 124,
            thumbCss: "slider_thumb_1",
            valueChangeEvent: function(value) {
                $("#valueLightInhibit").val(value);
            },
            setValueCompleteEvent: function(value) {
                ptzCameraSettingsModule.setData({ lightInhibit: { "switch": $("#chkLightInhibit").attr("checked") ? "true" : "false", value: value } });
            }
        });
        $("#valueLightInhibit").bind("blur", function() {
            $("#sliderLightInhibit").slider("setValueWithEvent", $("#valueLightInhibit").val());
        }).keydown(function(ev) {
            ev = ev || event;
            if (isEnter(ev))
                $("#sliderLightInhibit").slider("setValueWithEvent", $("#valueLightInhibit").val());
        });
        $("#chkLightInhibit").click(function() {
            ptzCameraSettingsModule.toggleLightInhibit($(this).attr("checked"));
            ptzCameraSettingsModule.setData({ lightInhibit: { "switch": $(this).attr("checked") ? "true" : "false", value: $("#sliderLightInhibit").slider("getValue") } });
        });

        $("#sliderThroughFog").slider({
            enable: false,
            minValue: 1,
            maxValue: 4,
            maxWidth: 124,
            thumbCss: "slider_thumb_1",
            valueChangeEvent: function(value) {
                $("#valueThroughFog").val(value);
            },
            setValueCompleteEvent: function(value) {
                ptzCameraSettingsModule.setData({ throughFog: { "switch": $("#chkThroughFog").attr("checked") ? "true" : "false", value: value } });
            }
        });
        $("#valueThroughFog").bind("blur", function() {
            $("#sliderThroughFog").slider("setValueWithEvent", $("#valueThroughFog").val());
        }).keydown(function(ev) {
            ev = ev || event;
            if (isEnter(ev))
                $("#sliderThroughFog").slider("setValueWithEvent", $("#valueThroughFog").val());
        });
        $("#chkThroughFog").click(function() {
            ptzCameraSettingsModule.toggleThroughFog($(this).attr("checked"));
            ptzCameraSettingsModule.setData({ throughFog: { "switch": $(this).attr("checked") ? "true" : "false", value: $("#sliderThroughFog").slider("getValue") } });
            if($(this).attr("checked") !="checked"){
                $("#sliderThroughFog").slider("setValue", $("config>ptzCameraSetting>throughFog>value", xmlDoc).attr("default"));
            }
        });

        $("#sliderColorLevel").slider({
            minValue: 0,
            maxValue: 20,
            maxWidth: 124,
            thumbCss: "slider_thumb_1",
            valueChangeEvent: function(value) {
                $("#valueColorLevel").val(value);
            },
            setValueCompleteEvent: function(value) {
                ptzCameraSettingsModule.setData({ colorLevel: value });
            }
        });

        $("#valueColorLevel").bind("blur", function() {
            $("#sliderColorLevel").slider("setValueWithEvent", $("#valueColorLevel").val());
        }).keydown(function(ev) {
            ev = ev || event;
            if (isEnter(ev))
                $("#sliderColorLevel").slider("setValueWithEvent", $("#valueColorLevel").val());
        });

        $("#sliderPtzSharpness").slider({
            enable: false,
            minValue: 0,
            maxValue: 20,
            maxWidth: 124,
            thumbCss: "slider_thumb_1",
            valueChangeEvent: function(value) {
                $("#valuePtzSharpness").val(value);
            },
            setValueCompleteEvent: function(value) {
                ptzCameraSettingsModule.setData({ ptzSharpness: { "switch": $("#chkPtzSharpness").attr("checked") ? "true" : "false", value: value } });
            }
        });
        $("#valuePtzSharpness").bind("blur", function() {
            $("#sliderPtzSharpness").slider("setValueWithEvent", $("#valuePtzSharpness").val());
        }).keydown(function(ev) {
            ev = ev || event;
            if (isEnter(ev))
                $("#sliderPtzSharpness").slider("setValueWithEvent", $("#valuePtzSharpness").val());
        });
        $("#chkPtzSharpness").click(function() {
            ptzCameraSettingsModule.togglePtzSharpness($(this).attr("checked"));
            ptzCameraSettingsModule.setData({ ptzSharpness: { "switch": $(this).attr("checked") ? "true" : "false", value: $("#sliderPtzSharpness").slider("getValue") } });
        });

        $("#sliderBrightness").slider({
            minValue: 0,
            maxValue: 20,
            maxWidth: 124,
            thumbCss: "slider_thumb_1",
            valueChangeEvent: function(value) {
                $("#valueBrightness").val(value);
            },
            setValueCompleteEvent: function(value) {
                ptzCameraSettingsModule.setData({ autoExposureMode: { mode: $("#autoExposureMode").val(), autoBrightness: value} });
            }
        });

        $("#valueBrightness").bind("blur", function() {
            $("#sliderBrightness").slider("setValueWithEvent", $("#valueBrightness").val());
        }).keydown(function(ev) {
            ev = ev || event;
            if (isEnter(ev))
                $("#sliderBrightness").slider("setValueWithEvent", $("#valueBrightness").val());
        });

        $("#valueDayToNight,#valueNightToDay").timeInput({format: "hh:mm"});

        if(customized == "HU03"){
            var trShutter = $($("#trShutter").children("td")[1]).empty();
            $("<select id='cobShutter' style='width: 175px;'></select>").appendTo(trShutter);

            var trIris = $($("#trIris").children("td")[1]).empty();
            $("<select id='cobAperture' style='width: 175px;'></select>").appendTo(trIris);
        }else {
            $("#sliderShutter").slider({
                minValue: 0,
                maxValue: 20,
                maxWidth: 124,
                thumbCss: "slider_thumb_1",
                valueChangeEvent: function (value) {
                    $("#valueShutter").val(value);
                },
                setValueCompleteEvent: function (value) {
                    ptzCameraSettingsModule.setData({ autoExposureMode: { mode: $("#autoExposureMode").val(), autoShutter: value} });
                }
            });

            $("#valueShutter").bind("blur", function () {
                $("#sliderShutter").slider("setValueWithEvent", $("#valueShutter").val());
            }).keydown(function (ev) {
                ev = ev || event;
                if (isEnter(ev))
                    $("#sliderShutter").slider("setValueWithEvent", $("#valueShutter").val());
            });

            $("#sliderAperture").slider({
                minValue: 0,
                maxValue: 20,
                maxWidth: 124,
                thumbCss: "slider_thumb_1",
                valueChangeEvent: function (value) {
                    $("#valueAperture").val(value);
                },
                setValueCompleteEvent: function (value) {
                    ptzCameraSettingsModule.setData({ autoExposureMode: { mode: $("#autoExposureMode").val(), autoIris: value} });
                }
            });
            $("#valueAperture").bind("blur", function () {
                $("#sliderAperture").slider("setValueWithEvent", $("#valueAperture").val());
            }).keydown(function (ev) {
                ev = ev || event;
                if (isEnter(ev))
                    $("#sliderAperture").slider("setValueWithEvent", $("#valueAperture").val());
            });

            $("#sliderAutoGain").slider({
                minValue: 0,
                maxValue: 20,
                maxWidth: 124,
                thumbCss: "slider_thumb_1",
                valueChangeEvent: function (value) {
                    $("#valueAutoGain").val(value);
                },
                setValueCompleteEvent: function (value) {
                    ptzCameraSettingsModule.setData({ autoExposureMode: { mode: $("#autoExposureMode").val(), autoGain: value} });
                }
            });

            $("#valueAutoGain").bind("blur", function () {
                $("#sliderAutoGain").slider("setValueWithEvent", $("#valueAutoGain").val());
            }).keydown(function (ev) {
                ev = ev || event;
                if (isEnter(ev))
                    $("#sliderAutoGain").slider("setValueWithEvent", $("#valueAutoGain").val());
            });

            $("#sliderWhiteBalanceRed").slider({
                minValue: 0,
                maxValue: 20,
                maxWidth: 124,
                thumbCss: "slider_thumb_1",
                valueChangeEvent: function (value) {
                    $("#valueWhiteBalanceRed").val(value);
                },
                setValueCompleteEvent: function (value) {
                    ptzCameraSettingsModule.setData({ whiteBalance: { mode: $("#whiteBalance").val(), red: value, blue: $("#sliderWhiteBalanceBlue").slider("getValue") } });
                }
            });

            $("#valueWhiteBalanceRed").bind("blur", function () {
                $("#sliderWhiteBalanceRed").slider("setValueWithEvent", $("#valueWhiteBalanceRed").val());
            }).keydown(function (ev) {
                ev = ev || event;
                if (isEnter(ev))
                    $("#sliderWhiteBalanceRed").slider("setValueWithEvent", $("#valueWhiteBalanceRed").val());
            });

            $("#sliderWhiteBalanceBlue").slider({
                minValue: 0,
                maxValue: 20,
                maxWidth: 124,
                thumbCss: "slider_thumb_1",
                valueChangeEvent: function (value) {
                    $("#valueWhiteBalanceBlue").val(value);
                },
                setValueCompleteEvent: function (value) {
                    ptzCameraSettingsModule.setData({ whiteBalance: { mode: $("#whiteBalance").val(), red: $("#sliderWhiteBalanceRed").slider("getValue"), blue: value } });
                }
            });

            $("#valueWhiteBalanceBlue").bind("blur", function () {
                $("#sliderWhiteBalanceBlue").slider("setValueWithEvent", $("#valueWhiteBalanceBlue").val());
            }).keydown(function (ev) {
                ev = ev || event;
                if (isEnter(ev))
                    $("#sliderWhiteBalanceBlue").slider("setValueWithEvent", $("#valueWhiteBalanceBlue").val());
            });

            $("#sliderAutomaticGain").slider({
                minValue: 0,
                maxValue: 20,
                maxWidth: 124,
                thumbCss: "slider_thumb_1",
                valueChangeEvent: function (value) {
                    $("#valueAutomaticGain").val(value);
                },
                setValueCompleteEvent: function (value) {
                    ptzCameraSettingsModule.setData({ automaticGain: value });
                }
            });

            $("#valueAutomaticGain").bind("blur", function () {
                $("#sliderAutomaticGain").slider("setValueWithEvent", $("#valueAutomaticGain").val());
            }).keydown(function (ev) {
                ev = ev || event;
                if (isEnter(ev))
                    $("#sliderAutomaticGain").slider("setValueWithEvent", $("#valueAutomaticGain").val());
            });

            $("#sliderBrightness1").slider({
                minValue: 0,
                maxValue: 20,
                maxWidth: 124,
                thumbCss: "slider_thumb_1",
                valueChangeEvent: function (value) {
                    $("#valueBrightness1").val(value);
                },
                setValueCompleteEvent: function (value) {
                    ptzCameraSettingsModule.setData({ brightness: value });
                }
            });

            $("#valueBrightness1").bind("blur", function () {
                $("#sliderBrightness1").slider("setValueWithEvent", $("#valueBrightness1").val());
            }).keydown(function (ev) {
                ev = ev || event;
                if (isEnter(ev))
                    $("#sliderBrightness1").slider("setValueWithEvent", $("#valueBrightness1").val());
            });

            $("#sliderZoomDisplay").slider({
                minValue: 1,
                maxValue: 8,
                maxWidth: 124,
                thumbCss: "slider_thumb_1",
                valueChangeEvent: function (value) {
                    $("#valueZoomDisplay").val(value);
                },
                setValueCompleteEvent: function (value) {
                    ptzCameraSettingsModule.setData({ zoomDisplay: { "switch": $("#chkZoomDisplay").attr("checked") ? "true" : "false", value: value } });
                }
            });
            $("#valueZoomDisplay").bind("blur", function () {
                $("#sliderZoomDisplay").slider("setValueWithEvent", $("#valueZoomDisplay").val());
            }).keydown(function (ev) {
                ev = ev || event;
                if (isEnter(ev))
                    $("#sliderZoomDisplay").slider("setValueWithEvent", $("#valueZoomDisplay").val());
            });
            $("#chkZoomDisplay").click(function () {
//            ptzCameraSettingsModule.toggleZoomDisplay($(this).attr("checked"));
                ptzCameraSettingsModule.setData({ zoomDisplay: { "switch": $(this).attr("checked") ? "true" : "false", value: $("#sliderZoomDisplay").slider("getValue") } });
            });

            $("#sliderScanSpeed").slider({
                minValue: 1,
                maxValue: 8,
                maxWidth: 124,
                thumbCss: "slider_thumb_1",
                valueChangeEvent: function (value) {
                    $("#valueScanSpeed").val(value);
                },
                setValueCompleteEvent: function (value) {
                    ptzCameraSettingsModule.setData({ scanSpeed: value });
                }
            });
            $("#valueScanSpeed").bind("blur", function () {
                $("#sliderScanSpeed").slider("setValueWithEvent", $("#valueScanSpeed").val());
            }).keydown(function (ev) {
                ev = ev || event;
                if (isEnter(ev))
                    $("#sliderScanSpeed").slider("setValueWithEvent", $("#valueScanSpeed").val());
            });

            $("#coInfraMode").change(function (event) {
                ptzCameraSettingsModule.toggleInfra($(this).val() == "user");
                ptzCameraSettingsModule.ajustHeight();
                ptzCameraSettingsModule.setData({ infraSensitivity: { infraMode: $(this).val() }});
            });

            $("#whiteBalance").change(function (event) {
                ptzCameraSettingsModule.toggleWhiteBalance($(this).val() == "manual");
                ptzCameraSettingsModule.ajustHeight();
                ptzCameraSettingsModule.setData({ whiteBalance: { mode: $(this).val(), red: $("#sliderWhiteBalanceRed").slider("getValue"), blue: $("#sliderWhiteBalanceBlue").slider("getValue") } });
            });

            if (customized == "HU03") {
                $("#autoExposureMode").on("focus", function () {
                    ptzCameraSettingsModule.autoPrevious = $(this).val();
                }).live("change", function (event) {
                    var flag = $(this).val();
                    switch (flag) {
                        case "auto":
                            ptzCameraSettingsModule.toggleAutoExposureMode(false, false, false, false);
                            break;
                        case "bright":
                            ptzCameraSettingsModule.toggleAutoExposureMode(true, false, false, false);
                            break;
                        case "shutter":
                            ptzCameraSettingsModule.toggleAutoExposureMode(false, true, false, false);
                            break;
                        case "iris":
                            ptzCameraSettingsModule.toggleAutoExposureMode(false, false, true, false);
                            break;
                        case "manual":
                            ptzCameraSettingsModule.toggleAutoExposureMode(false, true, true, true);
                            break;
                    }

                    ptzCameraSettingsModule.toggleManualExposureMode(flag);
                    ptzCameraSettingsModule.ajustHeight();
                    if (ptzCameraSettingsModule.autoPrevious == "auto") {
                        if (flag == "manual") {
                            ptzCameraSettingsModule.setData({ autoExposureMode: { mode: $(this).val(), autoBrightness: $("#sliderBrightness").slider("getValue"), autoShutter: $("#cobShutter").val(), autoIris: $("#cobAperture").val() } });
                            aa = true;
                        } else {
                            ptzCameraSettingsModule.setData({ autoExposureMode: { mode: $(this).val(), autoBrightness: $("#sliderBrightness").slider("getValue"), autoShutter: $("#cobShutter").val(), autoIris: $("#cobAperture").val() } });
                        }
                    } else {
                        ptzCameraSettingsModule.setData({ autoExposureMode: { mode: $(this).val(), autoBrightness: $("#sliderBrightness").slider("getValue"), autoShutter: $("#cobShutter").val(), autoIris: $("#cobAperture").val() } });
                    }
                });
            } else {
                $("#autoExposureMode").change(function (event) {
                    var flag = $(this).val();
                    switch (flag) {
                        case "auto":
                            ptzCameraSettingsModule.toggleAutoExposureMode(false, false, false, false);
                            break;
                        case "bright":
                            ptzCameraSettingsModule.toggleAutoExposureMode(true, false, false, false);
                            break;
                        case "shutter":
                            ptzCameraSettingsModule.toggleAutoExposureMode(false, true, false, false);
                            break;
                        case "iris":
                            ptzCameraSettingsModule.toggleAutoExposureMode(false, false, true, false);
                            break;
                        case "manual":
                            ptzCameraSettingsModule.toggleAutoExposureMode(false, true, true, true);
                            break;
                    }
                    ptzCameraSettingsModule.toggleManualExposureMode(flag);
                    ptzCameraSettingsModule.ajustHeight();
                    ptzCameraSettingsModule.setData({ autoExposureMode: { mode: $(this).val(), autoBrightness: $("#sliderBrightness").slider("getValue"), autoShutter: $("#sliderShutter").slider("getValue"), autoIris: $("#sliderAperture").slider("getValue") } });
                });
            }
            $("#cboDayNight").change(function () {
                ptzCameraSettingsModule.setData({ IRCutMode: $(this).val() });
                ptzCameraSettingsModule.toggleDayNight($(this).val() == "time");
                ptzCameraSettingsModule.ajustHeight();
            });
            $("#valueDayToNight").bind("blur", function () {
                ptzCameraSettingsModule.setData({ IRCutMode: { mode: $("#cboDayNight").val(), IRCutDayTime: $(this).val(), IRCutNightTime: $("#valueNightToDay").val() } });
            }).keydown(function (ev) {
                ev = ev || event;
                if (isEnter(ev))
                    ptzCameraSettingsModule.setData({ IRCutMode: { mode: $("#cboDayNight").val(), IRCutDayTime: $(this).val(), IRCutNightTime: $("#valueNightToDay").val() } });
            });
            $("#valueNightToDay").bind("blur", function () {
                ptzCameraSettingsModule.setData({ IRCutMode: { mode: $("#cboDayNight").val(), IRCutDayTime: $("#valueDayToNight").val(), IRCutNightTime: $(this).val() } });
            }).keydown(function (ev) {
                ev = ev || event;
                if (isEnter(ev))
                    ptzCameraSettingsModule.setData({ IRCutMode: { mode: $("#cboDayNight").val(), IRCutDayTime: $("#valueDayToNight").val(), IRCutNightTime: $(this).val() } });
            });

            $(":radio[name=\"backLight\"]").click(function () {
                ptzCameraSettingsModule.setData({ backLightSwitch: $(this).val() });
            });

            $(":radio[name=\"digitalDisplay\"]").click(function () {
                ptzCameraSettingsModule.setData({ digitalDisplay: $(this).val() });
            });

            $("#chkCameraInitial").click(function () {
                ptzCameraSettingsModule.setData({ cameraInitial: "true" });
            });

            $("#chkSetNorth").click(function () {
                ptzCameraSettingsModule.setData({ setNorth: "true" });
            });

            $("#btnToDefault").click(function () {
                ptzCameraSettingsModule.toDefault();
            });
            $("#btnReset").click(function () {
                ptzCameraSettingsModule.reset();
            });

            $("#onThreshold").click(function () {
                ptzCameraSettingsModule.setData({ infraSensitivity: { infraMode: $("#coInfraMode").val(), threshold: "true"} });
            });

            $("#offThreshold").click(function () {
                ptzCameraSettingsModule.setData({ infraSensitivity: { infraMode: $("#coInfraMode").val(), threshold: "false"} });
            });

            ptzCameraSettingsModule.setOCX();
        }
    },
    bindCameraSettingsData: function(){

        function setRange(slider, xmlPath) {
            var node = $(xmlPath, xmlDoc);
            if (node.size() == 0) {
                return;
            }
            var min = node.attr("min");
            var max = node.attr("max");
            var type = node.attr("type");
            var minValue = min * 1;
            var maxValue = max * 1;
            if (!min) {
                if (type == "uint8") {
                    minValue = 0;
                }
            }
            if (!max) {
                if (type == "uint8") {
                    maxValue = 255;
                }
            }
            slider.slider("setProperty", "minValue", minValue);
            slider.slider("setProperty", "maxValue", maxValue);
            initNumberInput(slider, { minValue: min, maxValue: max });
        }

        function setTextRange(slider, xmlPath) {
            var node = $(xmlPath, xmlDoc);
            if (node.size() == 0) {
                return;
            }
            var min = node.attr("min");
            var max = node.attr("max");
            var type = node.attr("type");
            var minValue = min * 1;
            var maxValue = max * 1;
            if (!min) {
                if (type == "uint8") {
                    minValue = 0;
                }
            }
            if (!max) {
                if (type == "uint8") {
                    maxValue = 255;
                }
            }
            initNumberInput(slider, { minValue: min, maxValue: max });
        }

        function getWhitebalanceMode(value) {
            switch (value) {
                case "auto":
                    return LangCtrl._L_("auto");
                default:
                    return LangCtrl._L_(value);
            }
        }

        ptzCameraSettingsModule.isLightInhibit = $("config>ptzCameraSetting>lightInhibit>switch", xmlDoc).size() > 0
            && $("config>ptzCameraSetting>lightInhibit>value", xmlDoc).size() > 0;
        $("#trLightInhibit")[ptzCameraSettingsModule.isLightInhibit ? "show" : "remove"]();
        ptzCameraSettingsModule.isBackLightSwitch = $("config>ptzCameraSetting>backLightSwitch", xmlDoc).size() > 0;
        $("#trBackLightSwitch")[ptzCameraSettingsModule.isBackLightSwitch ? "show" : "remove"]();
        ptzCameraSettingsModule.isColorLevel = $("config>ptzCameraSetting>colorLevel", xmlDoc).size() > 0;
        $("#trColorLevel")[ptzCameraSettingsModule.isColorLevel ? "show" : "remove"]();
        ptzCameraSettingsModule.isPtzSharpness = $("config>ptzCameraSetting>ptzSharpness>switch", xmlDoc).size() > 0
            && $("config>ptzCameraSetting>ptzSharpness>value", xmlDoc).size() > 0;
        $("#trPtzSharpness")[ptzCameraSettingsModule.isPtzSharpness ? "show" : "remove"]();
        ptzCameraSettingsModule.isWideDynamic = $("config>ptzCameraSetting>wideDynamic", xmlDoc).size() > 0;
        ptzCameraSettingsModule.isWideDynamicLev = $("config>ptzCameraSetting>wideDynamicLev", xmlDoc).size() > 0;
        $("#trWideDynamic")[ptzCameraSettingsModule.isWideDynamic && ptzCameraSettingsModule.isWideDynamicLev ? "show" : "remove"]();

        ptzCameraSettingsModule.isPtz3DNoiseReduce = $("config>ptzCameraSetting>ptz3DNoiseReduce", xmlDoc).size() > 0;
        $("#trPtz3DNoiseReduce")[ptzCameraSettingsModule.isPtz3DNoiseReduce ? "show" : "remove"]();
        ptzCameraSettingsModule.isGamma = $("config>ptzCameraSetting>gamma", xmlDoc).size() > 0;
        $("#trGamma")[ptzCameraSettingsModule.isGamma ? "show" : "remove"]();
        ptzCameraSettingsModule.isThroughFog = $("config>ptzCameraSetting>throughFog>switch", xmlDoc).size() > 0
            && $("config>ptzCameraSetting>throughFog>value", xmlDoc).size() > 0;
        $("#trThroughFog")[ptzCameraSettingsModule.isThroughFog ? "show" : "remove"]();
        ptzCameraSettingsModule.isBrightness = $("config>ptzCameraSetting>brightness", xmlDoc).size() > 0;
        $("#trBrightness1")[ptzCameraSettingsModule.isBrightness ? "show" : "remove"]();

        ptzCameraSettingsModule.isMinFocusDistance = $("config>ptzCameraSetting>minFocusDistance", xmlDoc).size() > 0;
        $("#trMinFocusDistance")[ptzCameraSettingsModule.isMinFocusDistance ? "show" : "remove"]();
        ptzCameraSettingsModule.isZoomDisplay = $("config>ptzCameraSetting>zoomDisplay", xmlDoc).size() > 0;
        ptzCameraSettingsModule.isZoomDisplaySpeed =  $("config>ptzCameraSetting>zoomDisplay>value", xmlDoc).size() > 0;
        $("#trZoomDisplay")[ptzCameraSettingsModule.isZoomDisplay ? "show" : "remove"]();
        $("#trZoomDisplaySpeed")[ptzCameraSettingsModule.isZoomDisplay ? "show" : "remove"]();
        ptzCameraSettingsModule.isScanSpeed = $("config>ptzCameraSetting>scanSpeed", xmlDoc).size() > 0;
        $("#trScanSpeed")[ptzCameraSettingsModule.isScanSpeed ? "show" : "remove"]();
        ptzCameraSettingsModule.isDigitalDisplay =  $("config>ptzCameraSetting>digitalDisplay", xmlDoc).size() > 0;
        $("#trDigitalDisplay")[ptzCameraSettingsModule.isDigitalDisplay ? "show" : "remove"]();

        ptzCameraSettingsModule.isAutoExposureMode =  $("config>ptzCameraSetting>autoExposureMode", xmlDoc).size() > 0;
        $("#trAutoExposureMode")[ptzCameraSettingsModule.isAutoExposureMode ? "show" : "remove"]();
        ptzCameraSettingsModule.isWhiteBalance =  $("config>ptzCameraSetting>whiteBalance", xmlDoc).size() > 0;
        $("#trWhiteBalance")[ptzCameraSettingsModule.isWhiteBalance ? "show" : "remove"]();
        ptzCameraSettingsModule.isAutomaticGain =  $("config>ptzCameraSetting>automaticGain", xmlDoc).size() > 0;
        $("#trAutomaticGain")[ptzCameraSettingsModule.isAutomaticGain ? "show" : "remove"]();
        ptzCameraSettingsModule.isImageFlip =  $("config>ptzCameraSetting>imageFlip", xmlDoc).size() > 0;
        $("#trImageFlip")[ptzCameraSettingsModule.isImageFlip ? "show" : "remove"]();

        ptzCameraSettingsModule.isIRCutMode =  $("config>ptzCameraSetting>IRCutMode", xmlDoc).size() > 0;
        $("#trDayNight")[ptzCameraSettingsModule.isIRCutMode ? "show" : "remove"]();
        ptzCameraSettingsModule.isInfraSensitivity =  $("config>ptzCameraSetting>infraSensitivity", xmlDoc).size() > 0;
        $("#trInfraMode")[ptzCameraSettingsModule.isInfraSensitivity ? "show" : "remove"]();

        ptzCameraSettingsModule.isFrequency =  $("config>ptzCameraSetting>frequency", xmlDoc).size() > 0;
        $("#trFrequency")[ptzCameraSettingsModule.isFrequency ? "show" : "remove"]();

        setRange($("#sliderAutomaticGain"), "config>ptzCameraSetting>automaticGain");
        setTextRange($("#valueAutomaticGain"), "config>ptzCameraSetting>automaticGain");
        setRange($("#sliderColorLevel"), "config>ptzCameraSetting>colorLevel");
        setTextRange($("#valueColorLevel"), "config>ptzCameraSetting>colorLevel");
        setRange($("#sliderPtzSharpness"), "config>ptzCameraSetting>ptzSharpness>value");
        setTextRange($("#valuePtzSharpness"), "config>ptzCameraSetting>ptzSharpness>value");
        setRange($("#sliderLightInhibit"), "config>ptzCameraSetting>sliderLightInhibit>value");
        setTextRange($("#valueLightInhibit"), "config>ptzCameraSetting>sliderLightInhibit>value");
        setRange($("#sliderZoomDisplay"), "config>ptzCameraSetting>zoomDisplay>value");
        setTextRange($("#valueZoomDisplay"), "config>ptzCameraSetting>zoomDisplay>value");
        setRange($("#sliderScanSpeed"), "config>ptzCameraSetting>scanSpeed");
        setTextRange($("#valueScanSpeed"), "config>ptzCameraSetting>scanSpeed");
        setRange($("#sliderBrightness"), "config>ptzCameraSetting>autoExposureMode>autoBrightness");
        setTextRange($("#valueBrightness"), "config>ptzCameraSetting>autoExposureMode>autoBrightness");
        if(customized == "HU03"){

        }else{
            setRange($("#sliderShutter"), "config>ptzCameraSetting>autoExposureMode>autoShutter");
            setTextRange($("#valueShutter"), "config>ptzCameraSetting>autoExposureMode>autoShutter");
            setRange($("#sliderAperture"), "config>ptzCameraSetting>autoExposureMode>autoIris");
            setTextRange($("#valueAperture"), "config>ptzCameraSetting>autoExposureMode>autoIris");
        }

        setRange($("#sliderAutoGain"), "config>ptzCameraSetting>autoExposureMode>autoGain");
        setTextRange($("#valueAutoGain"), "config>ptzCameraSetting>autoExposureMode>autoGain");
        setRange($("#sliderWhiteBalanceRed"), "config>ptzCameraSetting>whiteBalance>red");
        setTextRange($("#valueWhiteBalanceRed"), "config>ptzCameraSetting>whiteBalance>red");
        setRange($("#sliderWhiteBalanceBlue"), "config>ptzCameraSetting>whiteBalance>blue");
        setTextRange($("#valueWhiteBalanceBlue"), "config>ptzCameraSetting>whiteBalance>blue");
        setRange($("#sliderBrightness1"), "config>ptzCameraSetting>brightness");
        setTextRange($("#valueBrightness1"), "config>ptzCameraSetting>brightness");

        if(ptzCameraSettingsModule.isWhiteBalance){
            var cboWhiteBalance = $("#whiteBalance");
            cboWhiteBalance.empty();
            $("config>types>whitebalanceMode>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + getWhitebalanceMode($(ele).text()) + "</option>").appendTo(cboWhiteBalance);
            });
            cboWhiteBalance.val($("config>ptzCameraSetting>whiteBalance>mode",xmlDoc).text());

            ptzCameraSettingsModule.toggleWhiteBalance($(ptzCameraSettingsModule.mapping.cboWhiteBalance, xmlDoc).text() === "manual");
            $("#sliderWhiteBalanceRed").slider("setValue", $("config>ptzCameraSetting>whiteBalance>red",xmlDoc).text());
            $("#sliderWhiteBalanceBlue").slider("setValue", $("config>ptzCameraSetting>whiteBalance>blue",xmlDoc).text());
        }

        if(ptzCameraSettingsModule.isAutoExposureMode){
            var cboAutoExposureMode = $("#autoExposureMode");
            cboAutoExposureMode.empty();
            $("config>types>autoExposureMode>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + getWhitebalanceMode($(ele).text()) + "</option>").appendTo(cboAutoExposureMode);
            });
            cboAutoExposureMode.val($("config>ptzCameraSetting>autoExposureMode>mode",xmlDoc).text());
            var flag = $(ptzCameraSettingsModule.mapping.cboAutoExposureMode, xmlDoc).text();
            switch (flag){
                case "auto": ptzCameraSettingsModule.toggleAutoExposureMode(false,false,false,false);break;
                case "bright": ptzCameraSettingsModule.toggleAutoExposureMode(true,false,false,false);break;
                case "shutter": ptzCameraSettingsModule.toggleAutoExposureMode(false,true,false,false);break;
                case "iris": ptzCameraSettingsModule.toggleAutoExposureMode(false,false,true,false);break;
                case "manual": ptzCameraSettingsModule.toggleAutoExposureMode(false,true,true,true);break;
            }
            ptzCameraSettingsModule.toggleManualExposureMode(flag);
            $("#sliderBrightness").slider("setValue", $("config>ptzCameraSetting>autoExposureMode>autoBrightness",xmlDoc).text());
            $("#sliderAutoGain").slider("setValue", $("config>ptzCameraSetting>autoExposureMode>autoGain",xmlDoc).text());
            if(customized == "HU03"){

                var cobShutter = $("#cobShutter");
                cobShutter.empty();
                var cobShutterArr60HZ = ["1/1","1/2","1/4","1/8","1/15","1/30","1/60","1/90","1/100","1/125","1/180","1/250","1/350","1/500","1/725","1/1000","1/1500","1/2000","1/3000","1/4000","1/6000","1/10000"];
                var cobShutterArr50HZ = ["1/1","1/2","1/3","1/6","1/12","1/25","1/50","1/75","1/100","1/120","1/150","1/215","1/300","1/425","1/600","1/1000","1/1250","1/1750","1/2500","1/3500","1/6000","1/10000"];
                var cobShutterArr;
                if($("config>ptzCameraSetting>frequency", xmlDoc).text() == "50HZ"){
                    cobShutterArr = cobShutterArr50HZ;
                }else{
                    cobShutterArr = cobShutterArr60HZ;
                }
                for(var i= 0,len = cobShutterArr.length;i<len;i++){
                    var eleNum = cobShutterArr[i] ;
                    $("<option value=" + i + ">" + eleNum + "</option>").appendTo(cobShutter);
                }
                cobShutter.val($("config>ptzCameraSetting>autoExposureMode>autoShutter",xmlDoc).text());
                cobShutter.change(function(){
                    ptzCameraSettingsModule.setData({ autoExposureMode: { mode: $("#autoExposureMode").val(), autoShutter: $(this).val()} });
                });

                var cobAperture = $("#cobAperture");
                cobAperture.empty();
                var cobApertureArr = ["OFF", "F14", "F11", "F9.6", "F8", "F6.8", "F5.6", "F4.8", "F4", "F3.4", "F2.8", "F2.4", "F2", "F1.6"];
                for(var i= 0,len = cobApertureArr.length;i<len;i++){
                    var eleNum = cobApertureArr[i] ;
                    $("<option value=" + i + ">" + eleNum + "</option>").appendTo(cobAperture);
                }
                cobAperture.val($("config>ptzCameraSetting>autoExposureMode>autoIris",xmlDoc).text());
                cobAperture.change(function(){
                    ptzCameraSettingsModule.setData({ autoExposureMode: { mode: $("#autoExposureMode").val(), autoIris: $(this).val()} });
                });

            }else{
                $("#sliderShutter").slider("setValue", $("config>ptzCameraSetting>autoExposureMode>autoShutter",xmlDoc).text());
                $("#sliderAperture").slider("setValue", $("config>ptzCameraSetting>autoExposureMode>autoIris",xmlDoc).text());
            }
        }

        if(ptzCameraSettingsModule.isImageFlip ){
            var cboImgMirror = $("#imgMirror");
            cboImgMirror.empty();
            $("config>types>imageFlip>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + LangCtrl._L_($(ele).text()) + "</option>").appendTo(cboImgMirror);
            });
            cboImgMirror.val($("config>ptzCameraSetting>imageFlip",xmlDoc).text());
            cboImgMirror.change(function(){
                ptzCameraSettingsModule.setData({ imageFlip: $(this).val() });
            });
        }

        if(ptzCameraSettingsModule.isMinFocusDistance){
            var cboAutoMinFocusDistance = $("#autoMinFocusDistance");
            cboAutoMinFocusDistance.empty();
//            var minFocusDistanceArr = [30,100,150,200,300,500,1000];
//            for(var i= 0,len = minFocusDistanceArr.length;i<len;i++){
//                var eleNum = minFocusDistanceArr[i] ;
//                var str = eleNum< 100 ? eleNum+ "CM" : (eleNum/100) + "M";
//                $("<option value=" + eleNum + ">" + str + "</option>").appendTo(cboAutoMinFocusDistance);
//            }
            $("config>types>FocusLimit>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + LangCtrl._L_($(ele).text()) + "</option>").appendTo(cboAutoMinFocusDistance);
            });
            cboAutoMinFocusDistance.val($("config>ptzCameraSetting>minFocusDistance",xmlDoc).text());
            cboAutoMinFocusDistance.change(function(){
                ptzCameraSettingsModule.setData({ minFocusDistance: $(this).val() });
            });
        }

        if(ptzCameraSettingsModule.isPtz3DNoiseReduce){
            var cboPtz3DNoiseReduce = $("#ptz3DNoiseReduce");
            cboPtz3DNoiseReduce.empty();
            $("config>types>ptz3DNoiseReduce>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + LangCtrl._L_($(ele).text()) + "</option>").appendTo(cboPtz3DNoiseReduce);
            });
            cboPtz3DNoiseReduce.val($("config>ptzCameraSetting>ptz3DNoiseReduce",xmlDoc).text());
            cboPtz3DNoiseReduce.change(function(){
                ptzCameraSettingsModule.setData({ ptz3DNoiseReduce: $(this).val() });
            });
        }

        if(ptzCameraSettingsModule.isGamma){
            var cboGamma = $("#gamma");
            cboGamma.empty();
            $("config>types>gamma>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + LangCtrl._L_($(ele).text()) + "</option>").appendTo(cboGamma);
            });
            cboGamma.val($("config>ptzCameraSetting>gamma",xmlDoc).text());
            cboGamma.change(function(){
                ptzCameraSettingsModule.setData({ gamma: $(this).val() });
            });
        }

        if(ptzCameraSettingsModule.isWideDynamic && ptzCameraSettingsModule.isWideDynamicLev){
            function getLevelStr(lev){
                switch (lev){
                    case "off":
                        return LangCtrl._L_("close");
                    case "high":
                        return LangCtrl._L_("3");
                    case "mid":
                        return LangCtrl._L_("2");
                    case "low":
                        return LangCtrl._L_("1");
                    default :
                        return LangCtrl._L_(lev);
                }
            }
            function getLevel(lev){
                switch (lev){
                    case "off":
                        return "0";
                    case "high":
                        return "3";
                    case "mid":
                        return "2";
                    case "low":
                        return "1";
                    default :
                        return lev;
                }
            }
            var cboWideDynamic = $("#wideDynamic");
            cboWideDynamic.empty();
            $("<option value='false'>" + LangCtrl._L_("auto") + "</option>").appendTo(cboWideDynamic);

            $("config>types>wideDynamicLev>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + getLevel($(ele).text()) + ">" + getLevelStr($(ele).text()) + "</option>").appendTo(cboWideDynamic);
            });

            if($("config>ptzCameraSetting>wideDynamic",xmlDoc).text() == "false"){
                cboWideDynamic.val($("config>ptzCameraSetting>wideDynamic",xmlDoc).text());
            }else{
                cboWideDynamic.val($("config>ptzCameraSetting>wideDynamicLev",xmlDoc).text());
            }

            cboWideDynamic.change(function(){
                var flag = $(this).val() === "false" ? "false" : "true";
                var level = $(this).val() === "false" ? "0" : $(this).val();
                ptzCameraSettingsModule.setData({ wideDynamic:{flag: flag, level: level }});
            });
        }

        if(ptzCameraSettingsModule.isIRCutMode){
            function getIRCutModeText(type){
                switch (type) {
                    case "auto":
                        return LangCtrl._L_("auto");
                    case "day":
                        return LangCtrl._L_("daytime");
                    case "night":
                        return LangCtrl._L_("night");
                    case "time":
                        return LangCtrl._L_("schedule");
                    default :
                        return LangCtrl._L_(type);
                }
            }
            var cboDayNight = $("#cboDayNight");
            cboDayNight.empty();
            $("config>types>IRCutMode>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + getIRCutModeText($(ele).text()) + "</option>").appendTo(cboDayNight);
            });
            var IRCutMode = $("config>ptzCameraSetting>IRCutMode>mode",xmlDoc).text();
            cboDayNight.val(IRCutMode);
            if(IRCutMode === "time"){
                ptzCameraSettingsModule.toggleDayNight(true);
            }
            var IRCutDayTime = $("config>ptzCameraSetting>IRCutMode>IRCutDayTime", xmlDoc).text().split(":");
            var IRCutNightTime = $("config>ptzCameraSetting>IRCutMode>IRCutNightTime", xmlDoc).text().split(":");
            IRCutDayTime = [IRCutDayTime[0],IRCutDayTime[1]].join(":");
            IRCutNightTime = [IRCutNightTime[0],IRCutNightTime[1]].join(":");
//            var format = IRCutDayTime.split(":").length == 2 ? "hh:mm" : "hh:mm:ss";
//            $("#valueDayToNight,#valueNightToDay").timeInput({ format: format });
            $("#valueDayToNight").val(IRCutDayTime);
            $("#valueNightToDay").val(IRCutNightTime);
        }

        if(ptzCameraSettingsModule.isFrequency){
            var cboPNMode = $("#cboPNMode");
            cboPNMode.empty();
            $("config>types>frequency>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + LangCtrl._L_($(ele).text()) + "</option>").appendTo(cboPNMode);
            });
            cboPNMode.val($("config>ptzCameraSetting>frequency",xmlDoc).text());
            cboPNMode.on("focus",function(){
                ptzCameraSettingsModule.pnMode = $(this).val();
            }).change(function() {
                var $this = $(this);
                window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmReStartPtz"), function(flag) {
                    if (flag) {
                        ptzCameraSettingsModule.setData({ frequency: $this.val() });
                        window.top.showLoading(LangCtrl._L_("loadingTip"));
                        $(".loadingIndicator_tip",window.top.document).css({background:"#5A626B"});
                        $(".msg_border>.msg",window.top.document).css({color:"white"});
                        setTimeout("reconnect()", 10000);
                    }else{
                        $this.val(ptzCameraSettingsModule.pnMode);
                    }
                },400);
            });
        }
        XmlHttpClient.BindPageByXml(ptzCameraSettingsModule.mapping, xmlDoc);
        if(ptzCameraSettingsModule.isAutomaticGain){
            $("#sliderAutomaticGain").slider("setValue", $("config>ptzCameraSetting>automaticGain",xmlDoc).text());
        }
        if(ptzCameraSettingsModule.isZoomDisplaySpeed){
            $("#sliderZoomDisplay").slider("setValue", $("config>ptzCameraSetting>zoomDisplay>value",xmlDoc).text());
        }
        if(ptzCameraSettingsModule.isScanSpeed){
            $("#sliderScanSpeed").slider("setValue", $("config>ptzCameraSetting>scanSpeed",xmlDoc).text());
        }
        if (ptzCameraSettingsModule.isColorLevel) {
            $("#sliderColorLevel").slider("setValue", $("config>ptzCameraSetting>colorLevel",xmlDoc).text());
        }
        if (ptzCameraSettingsModule.isBrightness) {
            $("#sliderBrightness1").slider("setValue", $("config>ptzCameraSetting>brightness",xmlDoc).text());
        }
        if (ptzCameraSettingsModule.isLightInhibit) {
            ptzCameraSettingsModule.toggleLightInhibit($(ptzCameraSettingsModule.mapping.chkLightInhibit, xmlDoc).text() === "true");
            var lightInhibitNode = $("config>ptzCameraSetting>lightInhibit>value",xmlDoc);
            $("#sliderLightInhibit").slider("setValue", lightInhibitNode.text() ? lightInhibitNode.text() : lightInhibitNode.attr("default"));
        }
        if (ptzCameraSettingsModule.isPtzSharpness) {
            ptzCameraSettingsModule.togglePtzSharpness($(ptzCameraSettingsModule.mapping.chkPtzSharpness, xmlDoc).text() === "true");
            $("#sliderPtzSharpness").slider("setValue", $("config>ptzCameraSetting>ptzSharpness>value",xmlDoc).text());
        }
        if(ptzCameraSettingsModule.isThroughFog){
            ptzCameraSettingsModule.toggleThroughFog($(ptzCameraSettingsModule.mapping.chkThroughFog, xmlDoc).text() === "true");
            var throughFogValue = $("config>ptzCameraSetting>throughFog>value",xmlDoc);
            $("#sliderThroughFog").slider("setValue", throughFogValue.text() == 0 ? throughFogValue.attr("default"): throughFogValue.text());
        }

        if(ptzCameraSettingsModule.isInfraSensitivity){
            var coInfraMode = $("#coInfraMode");
            coInfraMode.empty();
            $("config>types>infraSensitivity>enum", xmlDoc).each(function(i, ele) {
                $("<option value=" + $(ele).text() + ">" + LangCtrl._L_("infra"+$(ele).text()) + "</option>").appendTo(coInfraMode);
            });
            coInfraMode.val($("config>ptzCameraSetting>infraSensitivity>infraMode",xmlDoc).text());
            var flag = $(ptzCameraSettingsModule.mapping.coInfraMode, xmlDoc).text() === "user";
            ptzCameraSettingsModule.toggleInfra(flag);

        }
//        setRange($("#sliderThroughFog"), "config>ptzCameraSetting>throughFog>value");
        if(ptzCameraSettingsModule.isDigitalDisplay){
            var digitalDisplay = $("config>ptzCameraSetting>digitalDisplay", xmlDoc).text();
            $(":radio[name=\"digitalDisplay\"]").each(function(index, element) {
                if (digitalDisplay == $(this).val()) {
                    $(this).attr("checked", true);
                    return false;
                }
            });
        }
        if(ptzCameraSettingsModule.isBackLightSwitch){
            var backLight = $("config>ptzCameraSetting>backLightSwitch", xmlDoc).text();
            $(":radio[name=\"backLight\"]").each(function(index, element) {
                if (backLight == $(this).val()) {
                    $(this).attr("checked", true);
                    return false;
                }
            });
        }
        ptzCameraSettingsModule.ajustHeight();
    },
    getPtzCameraSettingsData:function(){
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPtzCameraSetting" ,
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    xmlDocReset = result;
                    ptzCameraSettingsModule.bindCameraSettingsData();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function(mapping) {
        var xmlDoc = XMLStr2XMLDoc(xmlHeader + "<config><ptzCameraSetting></ptzCameraSetting></config>");
        var root = $("config>ptzCameraSetting", xmlDoc);
        var configs = ["backLightSwitch", "lightInhibit", "colorLevel", "ptzSharpness", "wideDynamic", "ptz3DNoiseReduce", "gamma"
            , "throughFog", "autoExposureMode", "whiteBalance", "automaticGain", "imageFlip", "minFocusDistance", "zoomDisplay"
            , "digitalDisplay", "cameraInitial", "setNorth", "IRCutMode", "infraSensitivity", "frequency","brightness","scanSpeed"];
        $.each(configs, function(index, element) {
            var key = element;
            if (mapping[key] !== undefined) {
                if (key == "lightInhibit" || key == "ptzSharpness"  || key == "zoomDisplay" || key == "throughFog" ) {
                    root.append(
                        $(xmlDoc.createElement(key)).append(
                            $(xmlDoc.createElement("switch")).append(
                                $(xmlDoc.createTextNode(mapping[key]["switch"]))
                            )
                        ).append(
                            $(xmlDoc.createElement("value")).append(
                                $(xmlDoc.createTextNode(mapping[key]["value"]))
                            )
                        )
                    );
                } else if (key == "whiteBalance") {
                    root.append(
                        $(xmlDoc.createElement(key)).append(
                            $(xmlDoc.createElement("mode")).append(
                                $(xmlDoc.createTextNode(mapping[key]["mode"]))
                            )
                        ).append(
                            $(xmlDoc.createElement("red")).append(
                                $(xmlDoc.createTextNode(mapping[key]["red"]))
                            )
                        ).append(
                            $(xmlDoc.createElement("blue")).append(
                                $(xmlDoc.createTextNode(mapping[key]["blue"]))
                            )
                        )
                    );
                } else if (key == "infraSensitivity" ) {
                    if( mapping[key]["threshold"] !==undefined){
                        root.append(
                            $(xmlDoc.createElement(key)).append(
                                $(xmlDoc.createElement("infraMode")).append(
                                    $(xmlDoc.createTextNode(mapping[key]["infraMode"]))
                                )
                            ).append(
                                $(xmlDoc.createElement("threshold")).append(
                                    $(xmlDoc.createTextNode(mapping[key]["threshold"]))
                                )
                            )
                        );
                    }else{
                        root.append(
                            $(xmlDoc.createElement(key)).append(
                                $(xmlDoc.createElement("infraMode")).append(
                                    $(xmlDoc.createTextNode(mapping[key]["infraMode"]))
                                )
                            )
                        );
                    }
                }
                else if (key == "autoExposureMode") {
                    root.append(
                        $(xmlDoc.createElement(key)).append(
                            $(xmlDoc.createElement("mode")).append(
                                $(xmlDoc.createTextNode(mapping[key]["mode"]))
                            )
                        ).append(
                            $(xmlDoc.createElement("autoBrightness")).append(
                                $(xmlDoc.createTextNode((mapping[key]["autoBrightness"] !== undefined)?mapping[key]["autoBrightness"]:""))
                            )
                        ).append(
                            $(xmlDoc.createElement("autoShutter")).append(
                                $(xmlDoc.createTextNode((mapping[key]["autoShutter"] !== undefined)?mapping[key]["autoShutter"]:""))
                            )
                        ).append(
                            $(xmlDoc.createElement("autoIris")).append(
                                $(xmlDoc.createTextNode((mapping[key]["autoIris"] !== undefined)?mapping[key]["autoIris"]:""))
                            )
                        ).append(
                            $(xmlDoc.createElement("autoGain")).append(
                                $(xmlDoc.createTextNode((mapping[key]["autoGain"] !== undefined)?mapping[key]["autoGain"]:""))
                            )
                        )
                    );
                }
                else if (key == "IRCutMode" ) {
                    if( mapping["IRCutMode"]["mode"] != undefined){
                        root.append(
                            $(xmlDoc.createElement(key)).append(
                                $(xmlDoc.createElement("mode")).append(
                                    $(xmlDoc.createTextNode(mapping["IRCutMode"]["mode"]))
                                )
                            ).append(
                                $(xmlDoc.createElement("IRCutDayTime")).append(
                                    $(xmlDoc.createTextNode(mapping["IRCutMode"]["IRCutDayTime"]))
                                )
                            ).append(
                                $(xmlDoc.createElement("IRCutNightTime")).append(
                                    $(xmlDoc.createTextNode(mapping["IRCutMode"]["IRCutNightTime"]))
                                )
                            )
                        );
                    }else{
                        root.append(
                            $(xmlDoc.createElement(key)).append(
                                $(xmlDoc.createElement("mode")).append(
                                    $(xmlDoc.createTextNode(mapping["IRCutMode"]))
                                )
                            )
                        )
                    }
                }
                else if(key == "wideDynamic"){
                    root.append($(xmlDoc.createElement(key)).append($(xmlDoc.createTextNode(mapping[key]["flag"]))));
                    root.append($(xmlDoc.createElement("wideDynamicLev")).append($(xmlDoc.createTextNode(mapping[key]["level"]))));
                }
                else {
                    root.append($(xmlDoc.createElement(key)).append($(xmlDoc.createTextNode(mapping[key]))));
                }
            }
        });

        return XMLDoc2XMLStr(xmlDoc);
    },
    setData: function(mapping) {
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetPtzCameraSetting/1",
                type: "POST",
                async: true,
                data: ptzCameraSettingsModule.getSaveData(mapping),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if($("config",result).attr("status") == "success"){
                        ShowFloatError($("#tip"), LangCtrl._L_("setSuccess"), { top: 10 },"success");
                    }else{
                        ShowFloatError($("#tip"), LangCtrl._L_("setFailed"), { top: 10 },"failed");
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    toDefault: function() {
        var defaultObj = {};

        if (ptzCameraSettingsModule.isLightInhibit) {
            defaultObj.lightInhibit = {};
            defaultObj.lightInhibit["switch"] = $(ptzCameraSettingsModule.mapping.chkLightInhibit, xmlDoc).attr("default");
            defaultObj.lightInhibit.value = $("config>ptzCameraSetting>lightInhibit>value", xmlDoc).attr("default");
            $("#sliderLightInhibit").slider("setValue", defaultObj.lightInhibit.value);
            $("#chkLightInhibit").attr("checked", defaultObj.lightInhibit["switch"] === "true");
            ptzCameraSettingsModule.toggleLightInhibit(defaultObj.lightInhibit["switch"] === "true");
        }
        if (ptzCameraSettingsModule.isBackLightSwitch) {
            defaultObj.backLightSwitch = $("config>ptzCameraSetting>backLightSwitch", xmlDoc).attr("default");
            $(":radio[name=\"backLight\"]").each(function(index, element) {
                if (defaultObj.backLightSwitch == $(this).val()) {
                    $(this).attr("checked", true);
                    return false;
                }
            });
        }
        if (ptzCameraSettingsModule.isColorLevel) {
            defaultObj.colorLevel = $("config>ptzCameraSetting>colorLevel", xmlDoc).attr("default");
            $("#sliderColorLevel").slider("setValue", defaultObj.colorLevel);
        }
        if (ptzCameraSettingsModule.isBrightness) {
            defaultObj.brightness = $("config>ptzCameraSetting>brightness", xmlDoc).attr("default");
            $("#sliderBrightness1").slider("setValue", defaultObj.brightness);
        }
        if (ptzCameraSettingsModule.isPtzSharpness) {
            defaultObj.ptzSharpness = {};
            defaultObj.ptzSharpness["switch"] = $(ptzCameraSettingsModule.mapping.chkPtzSharpness, xmlDoc).attr("default");
            defaultObj.ptzSharpness.value = $("config>ptzCameraSetting>ptzSharpness>value", xmlDoc).attr("default");
            $("#chkPtzSharpness").attr("checked", defaultObj.ptzSharpness["switch"] === "true");
            ptzCameraSettingsModule.togglePtzSharpness(defaultObj.ptzSharpness["switch"] === "true");
            $("#sliderPtzSharpness").slider("setValue", defaultObj.ptzSharpness.value);
        }
        if (ptzCameraSettingsModule.isWideDynamic && ptzCameraSettingsModule.isWideDynamicLev) {
            defaultObj.wideDynamic = {};
            defaultObj.wideDynamic.flag = $("config>ptzCameraSetting>wideDynamic", xmlDoc).attr("default");
            defaultObj.wideDynamic.level = $("config>ptzCameraSetting>wideDynamicLev", xmlDoc).attr("default");

            if(defaultObj.wideDynamic.flag == "false"){
                $("#wideDynamic").val(defaultObj.wideDynamic.flag);
            }else{
                $("#wideDynamic").val(defaultObj.wideDynamic.level);
            }
        }
        if (ptzCameraSettingsModule.isPtz3DNoiseReduce) {
            defaultObj.ptz3DNoiseReduce = $("config>ptzCameraSetting>ptz3DNoiseReduce", xmlDoc).attr("default");
            $("#ptz3DNoiseReduce").val(defaultObj.ptz3DNoiseReduce);
        }
        if (ptzCameraSettingsModule.isGamma) {
            defaultObj.gamma = $("config>ptzCameraSetting>gamma", xmlDoc).attr("default");
            $("#gamma").val(defaultObj.gamma);
        }
        if (ptzCameraSettingsModule.isThroughFog) {
            defaultObj.throughFog = {};
            defaultObj.throughFog["switch"] = $(ptzCameraSettingsModule.mapping.chkThroughFog, xmlDoc).attr("default");
            defaultObj.throughFog.value = $("config>ptzCameraSetting>throughFog>value", xmlDoc).attr("default");
            $("#chkThroughFog").attr("checked", defaultObj.throughFog["switch"] === "true");
            ptzCameraSettingsModule.toggleThroughFog(defaultObj.throughFog["switch"] === "true");
            $("#sliderThroughFog").slider("setValue", defaultObj.throughFog.value);
        }
        if (ptzCameraSettingsModule.isWhiteBalance) {
            defaultObj.whiteBalance = {};
            defaultObj.whiteBalance.mode = $(ptzCameraSettingsModule.mapping.cboWhiteBalance, xmlDoc).attr("default");
            defaultObj.whiteBalance.red = $("config>ptzCameraSetting>whiteBalance>red", xmlDoc).attr("default");
            defaultObj.whiteBalance.blue = $("config>ptzCameraSetting>whiteBalance>blue", xmlDoc).attr("default");
            $("#sliderWhiteBalanceRed").slider("setValue", defaultObj.whiteBalance.red);
            $("#sliderWhiteBalanceBlue").slider("setValue", defaultObj.whiteBalance.blue);
            $("#whiteBalance").val(defaultObj.whiteBalance.mode);
            ptzCameraSettingsModule.toggleWhiteBalance(defaultObj.whiteBalance.mode === "manual");
        }
        if (ptzCameraSettingsModule.isAutoExposureMode) {
            defaultObj.autoExposureMode = {};
            defaultObj.autoExposureMode.mode = $(ptzCameraSettingsModule.mapping.cboAutoExposureMode, xmlDoc).attr("default");
            defaultObj.autoExposureMode.autoBrightness = $("config>ptzCameraSetting>autoExposureMode>autoBrightness", xmlDoc).attr("default");
            defaultObj.autoExposureMode.autoShutter = $("config>ptzCameraSetting>autoExposureMode>autoShutter", xmlDoc).attr("default");
            defaultObj.autoExposureMode.autoIris = $("config>ptzCameraSetting>autoExposureMode>autoIris", xmlDoc).attr("default");
            defaultObj.autoExposureMode.autoGain = $("config>ptzCameraSetting>autoExposureMode>autoGain", xmlDoc).attr("default");
            $("#autoExposureMode").val(defaultObj.autoExposureMode.mode);
            $("#sliderBrightness").slider("setValue", defaultObj.autoExposureMode.autoBrightness);
            $("#sliderShutter").slider("setValue", defaultObj.autoExposureMode.autoShutter);
            $("#sliderAperture").slider("setValue", defaultObj.autoExposureMode.autoIris);
            $("#sliderAutoGain").slider("setValue", defaultObj.autoExposureMode.autoGain);
            ptzCameraSettingsModule.toggleAutoExposureMode(defaultObj.autoExposureMode.mode === "manual");
            ptzCameraSettingsModule.toggleManualExposureMode(defaultObj.autoExposureMode.mode);
        }
        if (ptzCameraSettingsModule.isIRCutMode) {
            defaultObj.IRCutMode = $(ptzCameraSettingsModule.mapping.cboDayNight, xmlDoc).attr("default");
            $("#cboDayNight").val(defaultObj.IRCutMode);
            ptzCameraSettingsModule.toggleDayNight(defaultObj.IRCutMode === "time");
        }

        if (ptzCameraSettingsModule.isImageFlip) {
            defaultObj.imageFlip = $("config>ptzCameraSetting>imageFlip", xmlDoc).attr("default");
            $("#imgMirror").val(defaultObj.imageFlip);
        }
        if (ptzCameraSettingsModule.isInfraSensitivity) {
            defaultObj.infraSensitivity = {};
            defaultObj.infraSensitivity.infraMode = $("config>ptzCameraSetting>infraSensitivity>infraMode", xmlDoc).attr("default");
            $("#coInfraMode").val(defaultObj.infraSensitivity.infraMode);
            var flag =  (defaultObj.infraSensitivity.infraMode === "user");
            ptzCameraSettingsModule.toggleInfra(flag);
        }

        if (ptzCameraSettingsModule.isMinFocusDistance) {
            defaultObj.minFocusDistance = $("config>ptzCameraSetting>minFocusDistance", xmlDoc).attr("default");
            $("#autoMinFocusDistance").val(defaultObj.minFocusDistance);
        }
        if (ptzCameraSettingsModule.isZoomDisplay) {
            defaultObj.zoomDisplay = {};
            defaultObj.zoomDisplay["switch"] = $("config>ptzCameraSetting>zoomDisplay>switch", xmlDoc).attr("default");
            $("#chkZoomDisplay").attr("checked",defaultObj.zoomDisplay["switch"] == "true" );
        }
        if (ptzCameraSettingsModule.isZoomDisplaySpeed) {
            defaultObj.zoomDisplay.value = $("config>ptzCameraSetting>zoomDisplay>value", xmlDoc).attr("default");
            $("#sliderZoomDisplay").slider("setValue", defaultObj.zoomDisplay.value);
        }

        if (ptzCameraSettingsModule.isScanSpeed) {
            defaultObj.scanSpeed = $("config>ptzCameraSetting>scanSpeed", xmlDoc).attr("default");
            $("#sliderScanSpeed").slider("setValue", defaultObj.scanSpeed);
        }

        if (ptzCameraSettingsModule.isDigitalDisplay) {
            defaultObj.digitalDisplay = $("config>ptzCameraSetting>digitalDisplay", xmlDoc).attr("default");
            $(":radio[name=\"digitalDisplay\"]").each(function(index, element) {
                if (defaultObj.digitalDisplay == $(this).val()) {
                    $(this).attr("checked", true);
                    return false;
                }
            });
        }
        if(ptzCameraSettingsModule.isAutomaticGain){
            defaultObj.automaticGain = $("config>ptzCameraSetting>automaticGain", xmlDoc).attr("default");
            $("#sliderAutomaticGain").slider("setValue",  defaultObj.automaticGain );
        }

        ptzCameraSettingsModule.setData(defaultObj,"default");
    },
    reset: function(){
        window.top.showLoading();
        try{
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetPtzCameraSetting/1",
                type: "POST",
                async: true,
                data: xmlDocReset,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    ptzCameraSettingsModule.getPtzCameraSettingsData();
                    window.top.hideLoading();
                }
            });
        }catch (e){
            alert(e);
        }
    },
    setOCX: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    netPort = $("config>port>netPort", result).text() * 1;
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");
                    if(NetLiveMonitor){
                        // 设置模式
                        var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    }

                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");

        // 设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var ip = serverIp;
        var port = netPort;
        var id = "";
        var sendXML = OCX_XML_SetLoginInfo(username, password, ip, port, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }

    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCX").css({width:"400px",height:"300px"});
        ptzCameraSettingsModule.getPtzCameraSettingsData();
    }

    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), ptzCameraSettingsModule.getPtzCameraSettingsData);
        }
    }

}

//检测重启
function reconnect() {
    XmlHttpClient.SendHttpRequest({
        url: serverBase + "/GetRebootStatus",
        type: "POST",
        async: true,
        data: "",
        timeout: 60000,
        beforeSend: XmlHttpClient.CommBeforeSend,
        callback: function(result) {
            if ($("rebootStatus", result).text() == "true") {
                $(".loadingIndicator_tip",window.top.document).css({background:"transparent"});
                $(".msg_border>.msg",window.top.document).css({color:"333"});
                window.top.hideLoading();
                $("#mainFrame", window.top.document).attr("src", MenuCtrl["menuList"]["live"]["url"]);
            }
            else {
                setTimeout("reconnect()", 5000);
            }
        },
        error: function() {
            setTimeout("reconnect()", 5000);
        }
    });
}