var xmlDoc;
var og_width = 1, og_height = 1; //原始大小
var isOg_WhLoaded = false; //原始大小是否已通知
var profiles; //码流
var rtspPort,netPort; //RTSP端口,数据端口
var NetLiveMonitor; //视频控件
var ogr_w = 0, ogr_h = 0; //原始比例
var asInterval = 3000; // 报警刷新间隔
var alarmStatusIcon = { width: 32, height: 32, xGap: 5, yGap: 5 };// 报警图标信息
var streamLoadComplete = false;
var systemInfoLoadComplete = false;
var netPortComplete = false;
var selectId = { presetSelectId : 1, cruiseSelectId: 1, traceSelectId : 1};  //用一个全局变量去保存几个变量，减少全局变量
var tabMapRS485Ptz,tabMapIntegratedPtz;
var customized;
var screenWidth1 = screen.width,screenHeight1=screen.height;

//云台
var PtzCtrl = {
    isShow: false,
    show: function() {
        PtzCtrl.isShow = true;
        $("#divHoulderControl").show();
        $("#divLeft").removeClass("hidePtz").addClass("showPtz");

        var playStatus = $("#btnLivePlay").attr("class");
        if (OCX_WH_Ctrl.wh != "1:1") {
            if(playStatus === "play"){
                positionStopTip();
            }else{
                OCX_WH_Ctrl.clearStyle();
            }

        }
        OCX_WH_Ctrl.changeWH(OCX_WH_Ctrl.wh);
    },
    hide: function() {
        PtzCtrl.isShow = false;
        $("#divHoulderControl").hide();
        $("#divLeft").removeClass("showPtz").addClass("hidePtz");
        var playStatus = $("#btnLivePlay").attr("class");
        if (OCX_WH_Ctrl.wh != "1:1") {
            if(playStatus === "play"){
                positionStopTip();
            }else{
                OCX_WH_Ctrl.clearStyle();
            }
        }
        OCX_WH_Ctrl.changeWH(OCX_WH_Ctrl.wh);
    },
    toggle: function() {
        if (PtzCtrl.isShow)
            PtzCtrl.hide();
        else
            PtzCtrl.show();
    }
};

//视频尺寸
var OCX_WH_Ctrl = {
    screenFlag: false,
    wh: "0:0", //"4:3","16:9","1:1","0:0"
    changeWH: function(wh) {
        // 设置最小宽度以适应
        var minW_content = PtzCtrl.isShow ? 1000 : 750;
//        $("#Content,#divCopyRight", window.top.document).css("min-width",minW_content + "px");
        $("#Content", window.top.document).css("min-width",minW_content + "px");
        $("#Content", window.top.document).css("min-height", "550px");
        switch (wh) {
            case "1:1A":

                var screenH = window.screen.height;
                $("#screen_x1_auto").addClass("selected");
                autoSize();
                $("#hack").html("1111");
                var w = $("#divLiveOCX").width();//og_width,og_height
                var h = w * og_height / og_width;

                if(h < screenH && OCX_WH_Ctrl.screenFlag){
                    OCX_WH_Ctrl.screenFlag = true;
                    $("#divLiveOCX").height(h);
                    $("#Content", window.top.document).css("min-height", (h + 109) + "px");
                    $("#divLeftBottom > div").css("margin-top", "0px");
                    $("#hack").html("1111");
                    var height = $("#divLeftCenter").height();
                    if (height > h) {
                        $("#divLiveOCX").css("margin-top", ((height - h) / 2) + "px");
                    }
                    else {
                        $("#divLiveOCX").css("margin-top", "0px");
                    }

                }else{
                    $("#hack").html("1111");
                    var h2 = $("#divLiveOCX").height();//og_width,og_height
                    var w2 = h2 * og_width / og_height;
                    $("#divLiveOCX").width(w2);

                    var minW;
                    if(PtzCtrl.isShow){
                        minW = w2 - $("#divHoulderControl").width() ;
                    }else{
                        if(w2 < window.screen.width){
                            minW = w2;
                        }else{
                            minW = window.screen.width;
                        }
                    }
                    $("#Content", window.top.document).css("min-width",minW  + "px");
                    $("#divLeftBottom > div").css("margin-top", "0px");

                    $("#hack").html("1111");
                    var divLeftCenterW = $("#divLeftCenter").width() * 1;
                    if (divLeftCenterW > $("#divLiveOCX").width()) {
                        $("#divLiveOCX").css("margin-left", ((divLeftCenterW - w2) / 2) + "px");
                    }
                    else {
                        $("#divLiveOCX").css("margin-left", "0px");
                        $("#divLiveOCX").width(divLeftCenterW);
                    }
                }
                break;
            case "1:1":
                $("#screen_x1").addClass("selected");
                autoSize();
                $("#hack").html("1111");
                $("#divLeftBottom > div").css("margin-top", "0px");
                var divLeftCenterW = $("#divLeftCenter").width();
                var divLeftCenterH = $("#divLeftCenter").height();

                var top = (divLeftCenterH - og_height)/2;
                var left = (divLeftCenterW - og_width)/2;
                var divLeftW = divLeftCenterW < og_width ? divLeftCenterW : og_width;
                var divLeftH = divLeftCenterH < og_height ? divLeftCenterH : og_height;
                var divMarginLeft,divMarginTop;
                if(left<0){
                    divMarginLeft = 0;
                    $("#divLiveOCX").width(divLeftW);
                }else{
                    $("#divLiveOCX").width(og_width);
                    divMarginLeft = left;
                }
                if(top<0){
                    divMarginTop = 0;
                    $("#divLiveOCX").height(divLeftH);
                }else{
                    $("#divLiveOCX").height(og_height);
                    divMarginTop = top;
                }
                $("#divLiveOCX").css({marginLeft:divMarginLeft + "px",marginTop:divMarginTop + "px"});
                break;
            case "0:0":
                $("#screen_auto").addClass("selected");
                autoSize();
                $("#divLeftBottom > div").css("margin-top", "0px");
                break;
        }

        // 不为自适应时加上横向滚动条高度
        if (PtzCtrl.isShow && wh != "1:1A" && window.top.document.documentElement.clientWidth < 1080) {
            //这里会导致XP下的IE8无限触发resize事件，注释掉
//            $("#Content", window.top.document).height($("#Content", window.top.document).height() + 17);
            // 自动滚动到最右边
            $(window.top.document.documentElement).add($(window.top.document.body)).scrollLeft(window.top.document.documentElement.scrollWidth);
        }

        // 调整报警区域宽度
        var containerWidth = $("#divLeftTop").width() - $("#divBalance").offset().left - $("#divBalance").width();
        $("#divAlarmStatus").width(containerWidth);
        $("#divAlarmStatus_bk").width(containerWidth - 4);

        // 是否显示报警弹出按钮和居中显示
        var elementCount = $(".sensorAlarm_normal, .sensorAlarm_alarm, #divMotionAlarmStatus, #divColorAbnmlAlarmStatus, #divClarityAbnmlAlarmStatus, #divSceneChgAlarmStatus").size();
        if (elementCount > 0) {
            var lineCount = getAlarmStatusLineCount();
            $("#divShowAlarmStatus")[elementCount == lineCount ? "hide" : "show"]();
            $("#divAlarmStatus").css("text-align", elementCount > lineCount ? "left" : "right");
        }

        if (NetLiveMonitor) {
            var sendXML = OCX_XML_SetViewRatio((wh == "16:9" || wh == "4:3" || wh == "1:1A") ? "0:0" : wh);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        }
        this.wh = wh;
    },
    init: function() {
        var whMode = $.cookie("whMode");
        if (whMode) {
            OCX_WH_Ctrl.wh = whMode;
        }

        $("#screen_x1").click(function() {
            if($(this).hasClass("disable")){return false;}
            $(window.top).unbind("resize", liveResize);
            OCX_WH_Ctrl.clearScreen();
            OCX_WH_Ctrl.clearStyle();
            if (!isOg_WhLoaded)
                return;
            OCX_WH_Ctrl.changeWH("1:1");
            $.cookie("whMode", "1:1");
            $(window.top).bind("resize", liveResize);
        });
        $("#screen_x1_auto").click(function() {
            if($(this).hasClass("disable")){return false;}
            $(window.top).unbind("resize", liveResize);
            OCX_WH_Ctrl.clearScreen();
            OCX_WH_Ctrl.clearStyle();
            if (ogr_w == 0)
                return;
            OCX_WH_Ctrl.changeWH("1:1A");
            $.cookie("whMode", "1:1A");
            $(window.top).bind("resize", liveResize);
        });
        $("#screen_auto").click(function() {
            if($(this).hasClass("disable")){return false;}
            $(window.top).unbind("resize", liveResize);
            OCX_WH_Ctrl.clearScreen();
            OCX_WH_Ctrl.clearStyle();
            OCX_WH_Ctrl.changeWH("0:0");
            $.cookie("whMode", "0:0");
            $(window.top).bind("resize", liveResize);
        });
    },
    clearStyle: function() {
        $("#divLiveOCX").removeAttr("style");
        $("#divLeft").removeAttr("style");
        $("#Content", window.top.document).removeAttr("style");
    },
    clearScreen: function() {
        $("#screen>div").removeClass("selected");
    }
};

//声音
var VoiceCtrl = {
    isOn: false,
    off: function() {
        var sendXML = OCX_XML_SetVolume("OFF");
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        VoiceCtrl.isOn = false;
        $("#btnVoice").removeClass("on").addClass("off").attr("title", LangCtrl._L_("voiceOn"));
        $(".voice_line").css("background-image","url(\"/Css/Pictures/Live/slider_line_off.png\")");
        $(".voice_thumb").css("background-image","url(\"/Css/Pictures/Live/voice_thumb_off.png\")");
        var line =  $(".voice_line").css("background-image");
        $("#voice_slider").slider("setProperty", "enable", false);
        $("#voiceBK, #voiceBK_bk").hide();
    },
    on: function() {
        var sendXML = OCX_XML_SetVolume($("#voice_slider").slider("getValue"));
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        VoiceCtrl.isOn = true;
        $("#btnVoice").removeClass("off").addClass("on").attr("title", LangCtrl._L_("voiceOff"));
        $(".voice_line").css("background-image","url(\"/Css/Pictures/Live/slider_line.png\")");
        $(".voice_thumb").css("background-image","url(\"/Css/Pictures/Live/thume.png\")");
        $("#voice_slider").slider("setProperty", "enable", true);
        $("#voiceBK, #voiceBK_bk").show();
    },
    disable:function(){
        $("#btnVoice").removeClass().addClass("disable").attr("title", LangCtrl._L_("voiceOn"));
        return false;
    },
    enable:function(){
        $("#btnVoice").removeClass("disable").attr("title", LangCtrl._L_("voiceOn"));
    },
    getVolume: function() {
        if (VoiceCtrl.isOn) {
            return $("#voice_slider").slider("getValue");
        }
        else
            return 0;
    },
    init: function() {
        $("#btnVoice").attr("title", LangCtrl._L_("voiceOff")).click(function() {
            if($(this).hasClass("disable"))
                return false;
            if (VoiceCtrl.isOn) {
                VoiceCtrl.off();
            }
            else {
                VoiceCtrl.on();
            }
        }).hover(function(event) {
            if($(this).hasClass("on")){
                $("#voiceBK, #voiceBK_bk").show();
            }
                }, function(event) {
                    var $target = $(event.relatedTarget);
                    if ($target.parents("#voiceBK").size() == 0 && $target.is(":not(#voiceBK)")) {
                        $("#voiceBK, #voiceBK_bk").hide();
                    }
                });
                $("#voiceBK").mouseleave(function(event) {
                    $("#voiceBK, #voiceBK_bk").hide();
                });
                $(document).click(function(event) {
                    var $target = $(event.target);
                    if ($target.parents("#voiceBK").size() == 0 && $target.is(":not(#voiceBK)") && $target.is(":not(#btnVoice)")) {
                        $("#voiceBK, #voiceBK_bk").hide();
                }
        });

        $("#voice_slider").slider({
            orientation: $.SLIDER_ORIENTATION_VERTICAL,
            minValue: 0,
            maxValue: 100,
            maxHeight: 155,
            vBorderCss: "voice_border",
            vLineCss: "voice_line",
            thumbCss: "voice_thumb",
            value: 50,
            enable:false,
            setValueCompleteEvent: function(value) {
                var sendXML = OCX_XML_SetVolume(value);
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
            }
        });

        $("#btnVoice").removeClass("on").addClass("off").attr("title", LangCtrl._L_("voiceOn"));
        $(".voice_line").css("background-image","url(\"/Css/Pictures/Live/slider_line_off.png\")");
        $(".voice_thumb").css("background-image","url(\"/Css/Pictures/Live/voice_thumb_off.png\")");
        var line =  $(".voice_line").css("background-image");
        $("#voice_slider").slider("setProperty", "enable", false);

    }
};

//对讲
var TakeCtrl = {
    status: "off", //"disable","on","off"
    setStatus: function(status) {
        $("#btnTalk").removeAttr("class");
        this.status = status;
        switch (status) {
            case "disable":
                $("#btnTalk").addClass("disable").attr("title", LangCtrl._L_("startTalk"));
                break;
            case "on":
                var sendXML = OCX_XML_TalkSwitch("ON");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnTalk").removeClass("off").addClass("on").attr("title", LangCtrl._L_("stopTalk"));
                //TODO OCX开始对讲
                break;
            case "off":
                var sendXML = OCX_XML_TalkSwitch("OFF");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnTalk").removeClass("on").addClass("off").attr("title", LangCtrl._L_("startTalk"));
                //TODO OCX结束对讲
                break;
        }

    },
    init: function(status) {
        if (status == "on"){
            TakeCtrl.setStatus("on");
            $("#btnTalk").removeClass("off").addClass("on").attr("title", LangCtrl._L_("stopTalk"));
        }
        else{
            TakeCtrl.setStatus("off");
            $("#btnTalk").removeClass("on").addClass("off").attr("title", LangCtrl._L_("startTalk"));
        }

        $("#btnTalk").attr("title", LangCtrl._L_("startTalk")).click(function() {
            if (TakeCtrl.status == "disable")
                return;
            if (TakeCtrl.status == "on") {
                TakeCtrl.setStatus("off");
            }
            else {
                TakeCtrl.setStatus("on");
            }
        });
    }
};

//录像
var RecCtrl = {
    status: "off", //"disable","on","off"
    setStatus: function(status) {
        $("#btnRec").removeAttr("class");
        this.status = status;
        switch (status) {
            case "disable":
                $("#btnRec").addClass("disable").attr("title", LangCtrl._L_("startRec"));
                break;
            case "on":
                var sendXML = OCX_XML_RecSwitch("ON");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnRec").removeClass("off").addClass("on").attr("title", LangCtrl._L_("stopRec"));
                break;
            case "off":
                var sendXML = OCX_XML_RecSwitch("OFF");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btnRec").removeClass("on").addClass("off").attr("title", LangCtrl._L_("startRec"));
                break;
        }
    },
    init: function(status) {
        if (status == "on"){
            RecCtrl.setStatus("on");
            $("#btnRec").removeClass("off").addClass("on").attr("title", LangCtrl._L_("stopRec"));
        }

        else{
            RecCtrl.setStatus("off");
            $("#btnRec").removeClass("on").addClass("off").attr("title", LangCtrl._L_("startRec"));
        }

        $("#btnRec").attr("title", LangCtrl._L_("startRec")).click(function() {
            if (RecCtrl.status == "disable")
                return;
            if (RecCtrl.status == "on") {
                RecCtrl.setStatus("off");
            }
            else {
                RecCtrl.setStatus("on");
            }
        });
    }
};

//自动扫描
var ScanCtrl = {
    status: "off", //"disabled","on","off"
    setStatus: function (status) {
        switch (status) {
            case "disabled":
                $("#scan").addClass("disabled");
                break;
            case "on":
                ScanCtrl.status = status;
                sendPtzCmdXml("PtzControl/1/ScanOn");
                $("#scan").addClass("on");
                break;
            case "off":
                ScanCtrl.status = status;
                sendPtzCmdXml("PtzControl/1/ScanOff");
                $("#scan").removeClass("on");
                break;
        }
    },
    init: function (status) {
        if (status == "on")
            $("#scan").addClass("on");
        else
            $("#scan").removeClass("on");
        $("#scan").click(function () {
            if ($(this).is(".disabled")) {
                return;
            }

            if (ScanCtrl.status == "disabled")
                return;
            if (ScanCtrl.status == "on") {
                ScanCtrl.setStatus("off");
            }
            else {
                ScanCtrl.setStatus("on");
            }
        });
    }
};

//雨刷
var WiperCtrl = {
    status: "off", //"disabled","on","off"
    setStatus: function (status) {
        switch (status) {
            case "disabled":
                $("#wiper").addClass("disabled");
                break;
            case "on":
                WiperCtrl.status = status;
                sendPtzCmdXml("PtzControl/1/WiperOn");
                $("#wiper").addClass("on");
                break;
            case "off":
                WiperCtrl.status = status;
                sendPtzCmdXml("PtzControl/1/WiperOff");
                $("#wiper").removeClass("on");
                break;
        }
    },
    init: function (status) {
        if (status == "on")
            $("#wiper").addClass("on");
        else
            $("#wiper").removeClass("on");
        $("#wiper").click(function () {
            if ($(this).is(".disabled")) {
                return;
            }

            if (WiperCtrl.status == "disabled")
                return;
            if (WiperCtrl.status == "on") {
                WiperCtrl.setStatus("off");
            }
            else {
                WiperCtrl.setStatus("on");
            }
        });
    }
};

//灯光
var LightCtrl = {
    status: "off", //"auto","on","off"
    setStatus: function (status) {
        switch (status) {
            case "disabled":
                $("#light").addClass("disabled");
                break;
            case "on":
                LightCtrl.status = status;
                sendPtzCmdXml("PtzControl/1/LightOn");
                ShowFloatError($("#showFloat"), LangCtrl._L_("successLightOn"),{},"success");
                $("#light").removeClass().addClass("on");
                break;
            case "off":
                LightCtrl.status = status;
                sendPtzCmdXml("PtzControl/1/LightOff");
                ShowFloatError($("#showFloat"), LangCtrl._L_("successLightOff"),{},"success");
                $("#light").removeClass().addClass("off");
                break;
            case "auto":
                LightCtrl.status = status;
                sendPtzCmdXml("PtzControl/1/LightAuto");
                ShowFloatError($("#showFloat"), LangCtrl._L_("successLightAuto"),{},"success");
                $("#light").removeClass().addClass("auto");
                break;
        }
    },
    init: function (status) {

        if (status == "on"){
            $("#light").removeClass().addClass("on");
        }
        else if(status == "off"){
            $("#light").removeClass().addClass("off");
        }else if(status == "auto"){
            $("#light").removeClass().addClass("auto");
        }
        $("#light").click(function () {
            if ($(this).is(".disabled")) {
                return;
            }

            if (LightCtrl.status == "disabled")
                return;
            if (LightCtrl.status == "on") {
                LightCtrl.setStatus("off");
            }else if(LightCtrl.status == "off"){
                LightCtrl.setStatus("auto");
            }
            else {
                LightCtrl.setStatus("on");
            }
        });
    }
};

//随机扫描
var RandomScanCtrl = {
    status: "off", //"disabled","on","off"
    setStatus: function (status) {
        switch (status) {
            case "disabled":
                $("#random").addClass("disabled");
                break;
            case "on":
                RandomScanCtrl.status = status;
                sendPtzCmdXml("PtzControl/1/RandomScanOn");
                $("#random").addClass("on");
                break;
            case "off":
                RandomScanCtrl.status = status;
                sendPtzCmdXml("PtzControl/1/RandomScanOff");
                $("#random").removeClass("on");
                break;
        }
    },
    init: function (status) {
        if (status == "on")
            $("#random").addClass("on");
        else
            $("#random").removeClass("on");
        $("#random").click(function () {
            if ($(this).is(".disabled")) {
                return;
            }

            if (RandomScanCtrl.status == "disabled")
                return;
            if (RandomScanCtrl.status == "on") {
                RandomScanCtrl.setStatus("off");
            }
            else {
                RandomScanCtrl.setStatus("on");
            }
        });
    }
};

//群组
var GroupCtrl = {
    status: "off", //"disabled","on","off"
    setStatus: function (status) {
        switch (status) {
            case "disabled":
                $("#group").addClass("disabled");
                break;
            case "on":
                GroupCtrl.status = status;
                sendPtzCmdXml("PtzControl/1/GroupRun");
                $("#group").addClass("on");
                break;
            case "off":
                GroupCtrl.status = status;
                sendPtzCmdXml("PtzControl/1/GroupStop");
                $("#group").removeClass("on");
                break;
        }
    },
    init: function (status) {
        if (status == "on")
            $("#group").addClass("on");
        else
            $("#group").removeClass("on");
        $("#group").click(function () {
            if ($(this).is(".disabled")) {
                return;
            }

            if (GroupCtrl.status == "disabled")
                return;
            if (GroupCtrl.status == "on") {
                GroupCtrl.setStatus("off");
            }
            else {
                GroupCtrl.setStatus("on");
            }
        });
    }
};

//3D定位
var Zoom3DCtrl = {
    status: "off", //"disable","on","off"
    setStatus: function(status) {
        $("#btn3D").removeAttr("class");
        this.status = status;
        switch (status) {
            case "disable":
                $("#btn3D").addClass("disable").attr("title", LangCtrl._L_("3dOn"));
                break;
            case "on":
                var sendXML = OCX_XML_3dSwitch("ON");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btn3D").removeClass("off").addClass("on").attr("title", LangCtrl._L_("3dOff"));
                break;
            case "off":
                var sendXML = OCX_XML_3dSwitch("OFF");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#btn3D").removeClass("on").addClass("off").attr("title", LangCtrl._L_("3dOn"));
                break;
        }
    },
    init: function(status) {
        if (status == "on")
            $("#btn3D").removeClass("off").addClass("on").attr("title", LangCtrl._L_("3dOff"));
        else
            $("#btn3D").removeClass("on").addClass("off").attr("title", LangCtrl._L_("3dOn"));
        $("#btn3D").attr("title", LangCtrl._L_("3dOn")).click(function() {
            if (Zoom3DCtrl.status == "disable")
                return;
            if (Zoom3DCtrl.status == "on") {
                Zoom3DCtrl.setStatus("off");
            }
            else {
                Zoom3DCtrl.setStatus("on");
            }
        });
    }
};

//电子放大缩小
var MagCtrl = {
    status: "disable",
    init:function(){
        $("#btnMagnify").click(function(){
            if(!$(this).hasClass("disable")){
                MagCtrl.magnifyImg();
            }
        });
        $("#btnMinify").click(function(){
            if(!$(this).hasClass("disable")){
                MagCtrl.minifyImg();
            }
        });
    },
    magnifyImg: function() {
        var sendXML = OCX_XML_MagnifyImg();
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    },
    minifyImg: function(status) {
        var sendXML = OCX_XML_MinifyImg();
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }
};

// 获取摄像机设置中的对焦模式
function GetPtzCameraSetting() {
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetPtzCameraSetting",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
                var focusMode = $("config>ptzCameraSetting>autoFocus>switch", result).text() == "true" ? "auto": "manual";
                FocusModeCtrl.init(focusMode);
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}
//对焦模式
var FocusModeCtrl = {
    status: "manual", //"disabled","auto","manual"
    setStatus: function (status) {
        switch (status) {
            case "disabled":
                $("#focusMode").addClass("disabled");
                break;
            case "auto":
                FocusModeCtrl.status = status;
                FocusModeCtrl.setData();
                break;
            case "manual":
                FocusModeCtrl.status = status;
                FocusModeCtrl.setData();
                break;
        }
    },
    setData: function(){
        var autoFocusSwitch = (FocusModeCtrl.status == "auto")? "true": "false";
        var sendXml = XMLStr2XMLDoc(xmlHeader + "<config><ptzCameraSetting></ptzCameraSetting></config>");
        var root = $("config>ptzCameraSetting", sendXml);
        root.append(
            $(sendXml.createElement("autoFocus")).append(
                $(sendXml.createElement("switch")).append(
                    $(sendXml.createTextNode(autoFocusSwitch))
                )
            )
        );
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetPtzCameraSetting/1",
                type: "POST",
                async: true,
                data: XMLDoc2XMLStr(sendXml),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {

                    if($("config",result).attr("status") == "success"){
                        if(FocusModeCtrl.status == "auto"){
                            $("#focusMode").removeClass("manual").addClass("auto");
                            $("#afMode").html("AF");
                            ShowFloatError($("#showFloat"), LangCtrl._L_("successAutoFocus"),{},"success");
                        }else{
                            $("#focusMode").removeClass("auto").addClass("manual");
                            $("#afMode").html("MF");
                            ShowFloatError($("#showFloat"), LangCtrl._L_("successManualFocus"),{},"success");
                        }
                    }else{
                        ShowFloatError($("#showFloat"), LangCtrl._L_("failedAutoFocus"),{},"success");
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    init: function (status) {
        FocusModeCtrl.status = status;
        if (status == "auto"){
            $("#focusMode").removeClass("manual").addClass("auto");
            $("#afMode").html("AF");
        }
        else{
            $("#focusMode").removeClass("auto").addClass("manual");
            $("#afMode").html("MF");
        }

        $("#focusMode").click(function () {
            if ($(this).is(".disabled")) {
                return;
            }

            if (FocusModeCtrl.status == "disabled")
                return;
            if (FocusModeCtrl.status == "auto") {
                FocusModeCtrl.setStatus("manual");
            }
            else {
                FocusModeCtrl.setStatus("auto");
            }

        });
    }
};

$(function() {
    window.top.showLoading();
    $("#Content", window.top.document).css({ "min-height": "600px" });
    screenHeight1 = screen.height;
    screenWidth1 = screen.width;
    liveResize();
    bindEvent();
    getDeviceInfo(function(result) {
        xmlDoc = result;

        $.cookie('userType', $("config > deviceInfo > userType",result).text());
        $("#btnTalk")[$("config>deviceInfo>audioInCount", xmlDoc).text() * 1 > 0
            && $("config>deviceInfo>audioOutCount", xmlDoc).text() * 1 > 0 ? "show" : "hide"]();
        $("#divPTZShow")[$("config>deviceInfo>integratedPtz", xmlDoc).text() === "true"
            || $("config>deviceInfo>supportRS485Ptz", xmlDoc).text() === "true" ? "show" : "hide"]();
//        $("#btn3D")[$("config>deviceInfo>integratedPtz", xmlDoc).text() === "true" ? "hide" : "hide"]();

        if($("config > deviceInfo > userType",result).text() === "normal"){
            $("#divPTZShow").hide();
        }

        if($("config>deviceInfo>integratedPtz", xmlDoc).text() === "true"){
            $("#btn3D")["show"]();
            $("#presetCruisePL").tab({map:tabMapIntegratedPtz});
        }else{
            $("#btn3D")["hide"]();
            $("#voiceBK,#voiceBK_bk").css("right","153px");
        }
        if($("config>deviceInfo>integratedPtz", xmlDoc).text() === "false" && $("config>deviceInfo>supportRS485Ptz", xmlDoc).text() === "true"){
            $("#presetCruisePL").tab({map:tabMapRS485Ptz});
            $("#scan,#wiper,#light,#random,#group").addClass("disabled");
            $("#liCruise,#liTrace").remove();
        }

        if($("config > deviceInfo > supportWiper ",result).text() == "false"){
            $("#wiper").addClass("disabled");
        }
        if($("config > deviceInfo > supportInfraredLamp",result).text() == "false"){
            $("#light").addClass("disabled");
        }

        if($("config>deviceInfo>integratedPtz", xmlDoc).text() === "true" || $("config>deviceInfo>supportRS485Ptz", xmlDoc).text() === "true"){
            getFreshList();
            getTraceList();
            getPresetList();
            getCruiseList();
        }
        systemInfoLoadComplete = true;

        if (systemInfoLoadComplete && streamLoadComplete && netPortComplete) {
            window.top.hideLoading();
            if(!NetLiveMonitor){
                NetLiveMonitor = LoadPlugin("divLiveOCX","NetLiveMonitor");
                InitLiveOCX();
            }
        }
        //定制需求
        customized = $("config>deviceInfo>Customized", xmlDoc).text();
        if(customized == "HU03"){
            $("#speedPL").empty().css({background:""});
            $("<div id='focusMode'><span id='afMode' class='afMode' lc='html' lk='afMode'></span></div>").appendTo($("#speedPL"));
            $("#speedPL").append(" <div id='btnSlow'></div>");
            $("<div id='speedPtz'></div>").css({position:"absolute",left:"50px",top:"0px", width: "180px",height: "30px",background: "url(../Css/Pictures/HoulderControl/SpeedLine1.png?v=2)"}).appendTo($("#speedPL"));
            $("<div id='sliderSpeed'></div>").css({position:"absolute",left:"25px",top:"0px", width: "130px",height: "30px"}).appendTo($("#speedPtz"));
            $("#btnSlow").css({left:"57px","z-index":"9999"});
            $("#speedPL").append(" <div id='btnQuick'></div>");
            $("#sliderSpeed_line").css({width:"120px"});
            GetPtzCameraSetting();
        }
        if(customized == "HU03"){
            $("#sliderSpeed").slider({
                value: 4,
                maxWidth: 110,
                buildTip: function(value) {
                    return LangCtrl._L_("ptzSpeed") + value;
                }
            });
        }else{
            $("#sliderSpeed").slider({
                value: 4,
                maxWidth: 155,
                buildTip: function(value) {
                    return LangCtrl._L_("ptzSpeed") + value;
                }
            });
        }


        $("#btnSlow").click(function() {
            var curSpeed = $("#sliderSpeed").slider("getValue");
            if (curSpeed <= 1)
                return;
            curSpeed = curSpeed - 1;
            $("#sliderSpeed").slider("setValue", curSpeed);
        });

        $("#btnQuick").click(function() {
            var curSpeed = $("#sliderSpeed").slider("getValue");
            if (curSpeed >= 8)
                return;
            curSpeed = curSpeed + 1;
            $("#sliderSpeed").slider("setValue", curSpeed);
        });
    });

    getNetPort();
    getStreamInfo();
    setInterval(getAlarmStatus, asInterval);
    closeStream();

});

function InitLiveOCX() {
    //NetLiveMonitor.AboutBox();
    //设置OCX模式
    try {
        var sendXML = OCX_XML_SetPreViewModel('Fixed');
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        is_NetLiveMonitor_init = true;
    }
    catch (ex) {
    }
}

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {

    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));
    //OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type='Login']", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie('auInfo'));
        var userInfoArr = userInfo.split(':');

        //设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var ip = serverIp;
        var port = netPort;

        var id = "";
        var sendXML = OCX_XML_SetLoginInfo(username, password, ip, port, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        var streamType = $.cookie('streamId');
        switch(streamType){
            case "1": $("#mainStream").click();break;
            case "2": $("#subStream").click();break;
            case "3": $("#thirdStream").click();break;
        }
        bindOcxEvent();

        var sendXML = OCX_XML_SetBufferTime(1);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

    }

    var orgWH = $("statenotify[type='GetOriginalWH']", $xmlDoc);
    if (orgWH.length > 0) {
        og_width = $(">width", orgWH).text() * 1;
        og_height = $(">height", orgWH).text() * 1;
        if (OCX_WH_Ctrl.wh == "1:1") {
            OCX_WH_Ctrl.changeWH("1:1");
        }
        isOg_WhLoaded = true;

        var whMode = $.cookie("whMode");
        var whModeMapping = {
            "1:1": "screen_x1",
            "1:1A": "screen_x1_auto",
            "0:0": "screen_auto"
        };
        if (!whMode) {
            whMode = "0:0";
        }
        $("#" + whModeMapping[whMode]).click();
    }
    var threeDArea = $("statenotify[type='3DAction']",$xmlDoc);
    if(threeDArea.length > 0){
        var X1 = $(">startPoint", threeDArea).attr("X") * 1;
        var Y1 = $(">startPoint", threeDArea).attr("Y") * 1;
        var X2 = $(">endPoint", threeDArea).attr("X") * 1;
        var Y2 = $(">endPoint", threeDArea).attr("Y") * 1;
        var X3 = $(">centerPoint", threeDArea).attr("X") * 1;
        var Y3 = $(">centerPoint", threeDArea).attr("Y") * 1;
        sendPtz3dZoomXml(X1,Y1,X2,Y2,X3,Y3);
    }
    var avdAnalysisResults = $("statenotify[type='AvdAnalysisResults']",$xmlDoc);
    if(avdAnalysisResults.length > 0){
        setSmartAlarm(avdAnalysisResults);
    }
    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var diskFull = $("statenotify[type='DiskFull']",$xmlDoc);
    if(diskFull.length > 0){
        if($(">status", diskFull).text() === "YES"){
            RecCtrl.setStatus("off");
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("DiskFull"), null);
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.hideLoading();
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), function(){window.top.hideLoading();});
        }
    }

}

function setSmartAlarm(avdAnalysisResults){
    var divAlarmStatus = $("#divAlarmStatus");
    var colorAbnmlAlarmStatus = $(">result>colorAbnmlAlarm", avdAnalysisResults).text();
    var divColorAbnmlAlarmStatus = $("#divColorAbnmlAlarmStatus");
    if (divColorAbnmlAlarmStatus.size() == 0) {
        divColorAbnmlAlarmStatus = $("<div id=\"divColorAbnmlAlarmStatus\" title=\"" + LangCtrl._L_("colorAbnml") + "\"></div>");
        divAlarmStatus.prepend(divColorAbnmlAlarmStatus);
    }
    divColorAbnmlAlarmStatus.removeClass().addClass(colorAbnmlAlarmStatus ? "colorAbnmlAlarm_alarm" : "colorAbnmlAlarm_normal");

    var clarityAbnmlAlarmStatus = $(">result>clarityAbnmlAlarm", avdAnalysisResults).text();
    var divClarityAbnmlAlarmStatus = $("#divClarityAbnmlAlarmStatus");
    if (divClarityAbnmlAlarmStatus.size() == 0) {
        divClarityAbnmlAlarmStatus = $("<div id=\"divClarityAbnmlAlarmStatus\" title=\"" + LangCtrl._L_("clarityAbnml") + "\"></div>");
        divAlarmStatus.prepend(divClarityAbnmlAlarmStatus);
    }
    divClarityAbnmlAlarmStatus.removeClass().addClass(clarityAbnmlAlarmStatus ? "clarityAbnmlAlarm_alarm" : "clarityAbnmlAlarm_normal");

    var sceneChgAlarmStatus = $(">result>sceneChgAlarm", avdAnalysisResults).text();
    var divSceneChgAlarmStatus = $("#divSceneChgAlarmStatus");
    if (divSceneChgAlarmStatus.size() == 0) {
        divSceneChgAlarmStatus = $("<div id=\"divSceneChgAlarmStatus\" title=\"" + LangCtrl._L_("sceneChg") + "\"></div>");
        divAlarmStatus.prepend(divSceneChgAlarmStatus);
    }
    divSceneChgAlarmStatus.removeClass().addClass(sceneChgAlarmStatus ? "sceneChgAlarm_alarm" : "sceneChgAlarm_normal");

    // 调整报警区域宽度
    var containerWidth = $("#stream").offset().left - $("#screen").offset().left - $("#screen").width();
    $("#divAlarmStatus, #divAlarmStatus_bk").width(containerWidth);

    // 是否显示报警弹出按钮和居中显示
    var elementCount = $(".sensorAlarm_normal, .sensorAlarm_alarm, #divMotionAlarmStatus, #divColorAbnmlAlarmStatus, #divClarityAbnmlAlarmStatus, #divSceneChgAlarmStatus").size();
    if (elementCount > 0) {
        var lineCount = getAlarmStatusLineCount();
        $("#divShowAlarmStatus")[elementCount == lineCount ? "hide" : "show"]();
        $("#divAlarmStatus").css("text-align", elementCount > lineCount ? "left" : "right");
    }
    setTimeout(setSmartAlarmFalse, asInterval);
}

function setSmartAlarmFalse(){
    var divColorAbnmlAlarmStatus = $("#divColorAbnmlAlarmStatus");
    divColorAbnmlAlarmStatus.removeClass("colorAbnmlAlarm_alarm").addClass("colorAbnmlAlarm_normal");

    var divClarityAbnmlAlarmStatus = $("#divClarityAbnmlAlarmStatus");
    divClarityAbnmlAlarmStatus.removeClass( "clarityAbnmlAlarm_alarm").addClass("clarityAbnmlAlarm_normal");

    var divSceneChgAlarmStatus = $("#divSceneChgAlarmStatus");
    divSceneChgAlarmStatus.removeClass( "sceneChgAlarm_alarm").addClass("sceneChgAlarm_normal");
}


//设置预览码流索引
function SetStreamType(index) {
    isOg_WhLoaded = false;
    var sendXML = OCX_XML_SetStreamType(index + 1);
    $.cookie('streamId',(index + 1));
    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    $("#btnLivePlay").removeClass("play").addClass("stop");
    if(RecCtrl.status == "on"){
        RecCtrl.setStatus("off");
        RecCtrl.setStatus("on");
    }else if(RecCtrl.status == "disable"){
        RecCtrl.setStatus("off");
    }
    TakeCtrl.setStatus("off");
    Zoom3DCtrl.setStatus("off");
    VoiceCtrl.enable();

    $("#screen_x1").removeClass("disable");
    $("#screen_x1_auto").removeClass("disable");
    $("#screen_auto").removeClass("disable");
    $("#fullScreen").removeClass("disable");
    $("#btnMagnify").removeClass("disable").addClass("off");
    $("#btnMinify").removeClass("disable").addClass("off");
    $("#btnTakePic").removeClass("disable");
}

//对预置点调用等按钮的悬浮、选中操作
function presetBtnOperate(itemData,aObj){
    if(!(aObj.children("#preset_save_"+itemData.id).size() > 0)){
        var btnSave = $("<div class=\"button preset_save\" id=\"preset_save_" + itemData.id + "\" title=\"" + LangCtrl._L_("savePosition") + "\" onfocus=\"this.blur();\"></div>");
        btnSave.click(function(event) {
            try {
                XmlHttpClient.SendHttpRequest({
                    url: serverBase + "/PtzModifyPresetPosition",
                    type: "POST",
                    async: true,
                    data: xmlHeader + "<presetInfo><id>" + itemData.id + "</id></presetInfo>",
                    beforeSend: XmlHttpClient.CommBeforeSend,
                    callback: function(result) {

                        if ($("config",result).attr("status") === "success"){
                            ShowFloatError($("#showFloat"), LangCtrl._L_("successSave"),{},"success");
                            itemData.savedPosition = true;
                            aObj.parent().find("span").removeClass("normalStyle").addClass("savedPosition");
                            $("#preset_call_"+itemData.id).removeClass("button preset_call_not").addClass("button preset_call").unbind().bind("click",function() {
                                callPreset(itemData.id,$("#showFloat"));
                                aObj.parent().parent().find("span").removeClass("callPosition");
                                aObj.parent().find("span").addClass("callPosition");
                                return false;
                            });

                            if((itemData.id >= 90 && itemData.id <= 109)){
//                                var btnDel = $("<div class=\"button preset_del_not\" id=\"preset_del_" + itemData.id + "\" title=\"" + LangCtrl._L_("delete") + "\" onfocus=\"this.blur();\"></div>");
//                                aObj.append(btnDel);
                            }else{
                                $("#preset_del_"+itemData.id).removeClass("button preset_del_not").addClass("button preset_del").unbind().bind("click",function(event) {
                                    window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmDeletePreset"), function(flag) {
                                        if (flag) {
                                            try {
                                                XmlHttpClient.SendHttpRequest({
                                                    url: serverBase + "/PtzDeletePreset",
                                                    type: "POST",
                                                    async: true,
                                                    data: xmlHeader + "<presetInfo><id>" + itemData.id + "</id></presetInfo>",
                                                    beforeSend: XmlHttpClient.CommBeforeSend,
                                                    callback: function(result) {
                                                        itemData.savedPosition = false;
                                                        aObj.parent().find("span").removeClass("savedPosition").addClass("normalStyle");
                                                        $("#preset_call_"+itemData.id).removeClass("button preset_call").addClass("button preset_call_not").unbind();
                                                        $("#preset_del_"+itemData.id).removeClass("button preset_del").addClass("button preset_del_not").unbind();
                                                        if ($("config",result).attr("status") === "success"){
                                                            ShowFloatError($("#showFloat"), LangCtrl._L_("successDel"),{},"success");
                                                        }else{
                                                            ShowFloatError($("#showFloat"), LangCtrl._L_("failedDel"),{},"failed");
                                                        }
                                                    }
                                                });
                                            }
                                            catch (ex) {
                                                alert(ex);
                                            }
                                        }
                                    });
                                });
                            }
                        }else{
                            ShowFloatError($("#showFloat"), LangCtrl._L_("failedSave"),{},"failed");
                        }

                    }
                });
            }
            catch (ex) {
                alert(ex);
            }
        });
        aObj.append(btnSave);
    }

    if (itemData.savedPosition) {

        if(!(aObj.children("#preset_call_"+itemData.id).size() > 0)){
            var editStr = "<div class='button preset_call' id='preset_call_" + itemData.id + "' title='" + LangCtrl._L_("call") + "' onfocus='this.blur();'></div>";
            aObj.append(editStr);
            var btnCall = $("#preset_call_" + itemData.id);
            if (btnCall) {
                btnCall.unbind().bind("click", function() {
                    aObj.parent().parent().find("span").removeClass("callPosition");
                    aObj.parent().find("span").removeClass().addClass("callPosition");
                    callPreset(itemData.id,$("#showFloat"));
                    return false;
                });
            }
        }

        if((itemData.id >= 90 && itemData.id <= 109)){
        if(!(aObj.children("#preset_del_"+itemData.id).size() > 0)){
            var btnDel = $("<div class=\"button preset_del_not\" id=\"preset_del_" + itemData.id + "\" title=\"" + LangCtrl._L_("delete") + "\" onfocus=\"this.blur();\"></div>");
            aObj.append(btnDel);
        }
        }else{
            if(!(aObj.children("#preset_del_"+itemData.id).size() > 0)){
                var btnDel = $("<div class=\"button preset_del\" id=\"preset_del_" + itemData.id + "\" title=\"" + LangCtrl._L_("delete") + "\" onfocus=\"this.blur();\"></div>");
                btnDel.click(function(event) {
                    window.top.MsgBoxHelper.Show("y/n", LangCtrl._L_("infoTip"), LangCtrl._L_("confirmDeletePreset"), function(flag) {
                        if (flag) {
                            try {
                                XmlHttpClient.SendHttpRequest({
                                    url: serverBase + "/PtzDeletePreset",
                                    type: "POST",
                                    async: true,
                                    data: xmlHeader + "<presetInfo><id>" + itemData.id + "</id></presetInfo>",
                                    beforeSend: XmlHttpClient.CommBeforeSend,
                                    callback: function(result) {
                                        itemData.savedPosition = false;
                                        aObj.parent().find("span").removeClass("savedPosition").addClass("normalStyle");
                                        $("#preset_call_"+itemData.id).removeClass("button preset_call").addClass("button preset_call_not").unbind();
                                        $("#preset_del_"+itemData.id).removeClass("button preset_del").addClass("button preset_del_not").unbind();
                                        if ($("config",result).attr("status") === "success"){
                                            ShowFloatError($("#showFloat"), LangCtrl._L_("successDel"),{},"success");
                                        }else{
                                            ShowFloatError($("#showFloat"), LangCtrl._L_("failedDel"),{},"failed");
                                        }
                                    }
                                });
                            }
                            catch (ex) {
                                alert(ex);
                            }
                        }
                    });
                })
                aObj.append(btnDel);
            }
        }




    }else{
        if(!(aObj.children("#preset_call_"+itemData.id).size() > 0)){
            var editStr = "<div class='button preset_call_not' id='preset_call_" + itemData.id + "' title='" + LangCtrl._L_("call") + "' onfocus='this.blur();'></div>";
            aObj.append(editStr);

        }
        if(!(aObj.children("#preset_del_"+itemData.id).size() > 0)){
            var btnDel = $("<div class=\"button preset_del_not\" id=\"preset_del_" + itemData.id + "\" title=\"" + LangCtrl._L_("delete") + "\" onfocus=\"this.blur();\"></div>");
            aObj.append(btnDel);
        }
    }
}

function getPresetList(callback) {
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/PtzGetPresets",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
                xmlDoc = result;
                var presetArr = [];
                var presetMap = {};

                var presetPre = LangCtrl._L_("preset");
                $("config>presetInfo>item", result).each(function(i, elem) {
                    presetMap["p_" + $(elem).attr("id")] = presetPre + $(elem).attr("id");
                });

                var maxId = $("config>presetInfo", result).attr("maxCount") * 1;
                for (var i = 1; i <= maxId; i++) {
                    if ("p_" + i in presetMap)
                        presetArr.push({ id: i, value: presetMap["p_" + i], savedPosition:true, normalStyle: false });
                    else if( i >= 90 && i<= 109)
                        presetArr.push({ id: i, value: presetPre + i, savedPosition:true, normalStyle: false });
                    else
                        presetArr.push({ id: i, value: presetPre + i, savedPosition:false, normalStyle: true });
                }

                $("#divPreset").listbox({
                    data: presetArr,
                    itemCustomMapping:{savedPosition:"savedPosition", normalStyle: "normalStyle"},
                    selectItem: function(){
                        var itemData = $(this).data("itemData");
                        var aObj = $(".btnDiv", this);
                        selectId.presetSelectId = itemData.id;
                        presetBtnOperate(itemData,aObj);
                    },
                    unSelectItem: function(){
                        var itemData = $(this).data("itemData");
                        $("#preset_call_" + itemData.id).unbind().remove();
                        $("#preset_save_" + itemData.id).unbind().remove();
                        $("#preset_del_" + itemData.id).unbind().remove();
                    },
                    mouse_enter: function(event){
                        var itemData = $(this).data("itemData");
                        var aObj = $(".btnDiv", this);
                        presetBtnOperate(itemData,aObj);
                    },
                    mouse_leave:function(){
                        var itemData = $(this).data("itemData");
                        var divPresetItems = $("#divPreset").listbox("getSeletedItems");
                        if(divPresetItems.length != 0){
                            selectId.presetSelectId = divPresetItems.data("itemData").id;
                            if(selectId.presetSelectId != itemData.id){
                                $("#preset_call_" + itemData.id).unbind().remove();
                                $("#preset_save_" + itemData.id).unbind().remove();
                                $("#preset_del_" + itemData.id).unbind().remove();
                            }
                        }

                    }
                });

                if (presetArr.length > 0) {
                    var divPreset = $("#divPreset");
                    divPreset.listbox("getItemByID", selectId.presetSelectId).click();
                }

                if (typeof callback == "function") {
                    callback();
                }
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

function getCruiseList() {
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/PtzGetCruises",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
                xmlDoc = result;
                var cruiseArr = [];
                var cruiseMap = {};

                $("config>cruiseInfo>item", result).each(function(i, elem) {
                    cruiseMap["p_" + $(elem).attr("id")] = $(elem).text();
                });

                var cruisePre = LangCtrl._L_("cruise");
                var maxId = $("config>cruiseInfo", result).attr("maxCount") * 1;
				var count = $("config>cruiseInfo>item", result).size() * 1;

                for (var i = 1; i <= maxId; i++) {
                    if ("p_" + i in cruiseMap)
                        cruiseArr.push({ id: i, value: cruisePre + i , set:true, normalStyle: false });
                    else
                        cruiseArr.push({ id: i, value: cruisePre + i, set:false, normalStyle: true });
                }
//                for (var i = 1; i <= maxId; i++) {
////                    if ("p_" + i in cruiseMap)
////                        cruiseArr.push({ id: i, value: cruiseMap["p_" + i] });
////                    else
//                    cruiseArr.push({ id: i, value: cruisePre + i });
//                }

                $("#cruiseList").listbox({
                    data: cruiseArr,
                    itemCustomMapping:{set:"set", normalStyle: "normalStyle"},
                    selectItem: function(){
                        var itemData = $(this).data("itemData");
                        selectId.cruiseSelectId = itemData.id;
                        if(itemData["set"]){
                            $("#cruise_play,#cruise_stop").removeClass("disabled").removeAttr("disabled");
                        }else{
                            $("#cruise_play,#cruise_stop").removeClass().addClass("disabled").attr("disabled","disabled");
                        }
                    },
                    unSelectItem:function(){}
//                    dbClickItem: function() {
//                        var itemData = $(this).data("itemData");
//                        startCruise(itemData.id,$("#showFloat"));
//                    }
                });

                if (cruiseArr.length > 0) {
                    $("#cruiseList").listbox("selectItem", selectId.cruiseSelectId);
                }

				 if(count === 0){
                    $("#cruise_play,#cruise_stop").removeClass().addClass("disabled").attr("disabled","disabled");
                }
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

function getTraceList() {
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/PtzGetTraces",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                xmlDoc = result;
                var traceArr = [];
                var traceMap = {};

                $("config>traceInfo>item", result).each(function(i, elem) {
                    traceMap["p_" + $(elem).attr("id")] = $(elem).text();
                });

                var tracePre = LangCtrl._L_("trace");
                var maxId = $("config>traceInfo", result).attr("maxCount") * 1;
				var count = $("config>traceInfo>item", result).size() * 1;

                for (var i = 1; i <= maxId; i++) {
                    if ("p_" + i in traceMap)
                        traceArr.push({ id: i, value: tracePre + i , set:true, normalStyle: false });
                    else
                        traceArr.push({ id: i, value: tracePre + i, set:false, normalStyle: true });
                }

                $("#traceList").listbox({
                    data: traceArr,
                    itemCustomMapping:{set:"set", normalStyle: "normalStyle"},
                    selectItem: function(){
                        var itemData = $(this).data("itemData");
                        selectId.traceSelectId = itemData.id;
                        if(itemData["set"]){
                            $("#trace_play,#trace_stop").removeClass("disabled").removeAttr("disabled");
                        }else{
                            $("#trace_play,#trace_stop").removeClass().addClass("disabled").attr("disabled","disabled");
                        }
                    },
                    unSelectItem:function(){}
//                    dbClickItem: function() {
//                        var itemData = $(this).data("itemData");
//                        startTrace(itemData.id, $("#showFloat"));
//                    }
                });

                if (traceArr.length > 0) {
                    $("#traceList").listbox("selectItem", selectId.traceSelectId);
                }
				 if(count === 0){
                    $("#trace_play,#trace_stop").removeClass().addClass("disabled").attr("disabled","disabled");
                }

//                var traceMaxCount = $("config>caps>traceMaxCount", result).text() * 1;
//                var traceArr = [];
//
//                var tracePre = LangCtrl._L_("trace");
//                for (var i = 1; i <= traceMaxCount; i++) {
//                    traceArr.push({ id: i, value: tracePre + i });
//                }
//
//                $("#traceList").listbox({
//                    data: traceArr,
//                    dbClickItem: function() {
//                        var itemData = $(this).data("itemData");
//                        startTrace(itemData.id, $("#showFloat"));
//                    }
//                });
//
//                if (traceArr.length > 0) {
//                    $("#traceList").listbox("selectItem", 1);
//                }
            }
        });
    } catch (ex) {
        alert(ex);
    }
}

function startTrace(id, obj) {
    var sendData = xmlHeader + "<traceInfo><id>" + id + "</id></traceInfo>";
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/PtzRunTrace",
            type: "POST",
            async: true,
            data: sendData,
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
                if(obj != null){
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError(obj, LangCtrl._L_("successRun"),{},"success");
                    }else{
                        ShowFloatError(obj, LangCtrl._L_("failedRun"),{},"failed");
                    }
                }
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

function stopTrace(obj) {
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/PtzStopTrace",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                if(obj != null){
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError(obj, LangCtrl._L_("successStop"),{},"success");
                    }else{
                        ShowFloatError(obj, LangCtrl._L_("failedStop"),{},"failed");
                    }
                }

            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

function bindEvent() {

    $("#balanceSub").click(function() {
        var selectorPosition = $(this).position();
        var $subStreamList = $("#subBalanceList");
        var bottomPosition = $("#divBalance").position();
        $subStreamList.css({ top: (bottomPosition.top + 22) + "px",
            left: (-10 - $(".balanceLabel").width()) + "px" })
            .show();

        var subStreamListOffset = $subStreamList.offset();

        $("#subBalanceList_bk").css({ top: subStreamListOffset.top + "px",
            left: subStreamListOffset.left  +"px" })
            .width($subStreamList.outerWidth())
            .height($subStreamList.outerHeight())
            .show();
        return false;
    });

    $("#subBalanceList > span").unbind().click(function(e){
        var text =this.innerHTML;
        $(".balanceLabel").html(text);

        if (NetLiveMonitor) {
            var value = $(this).attr("name");
            var sendXML = OCX_XML_SetBufferTime(value);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        }
        $("#subBalanceList").hide();
        $("#subBalanceList_bk").hide();
        e.stopPropagation();
    });

    $(window.top.document).click(function() {
        $("#subBalanceList").hide();
        $("#subBalanceList_bk").hide();
    });
    $(window.document).click(function() {
        $("#subBalanceList").hide();
        $("#subBalanceList_bk").hide();
    });

    $("#divPTZShow").click(PtzCtrl.toggle);
    $("#divShowAlarmStatus").mouseover(function(event) {
        var elementCount = $(".sensorAlarm_normal, .sensorAlarm_alarm, #divMotionAlarmStatus, #divColorAbnmlAlarmStatus, #divClarityAbnmlAlarmStatus, #divSceneChgAlarmStatus").size();
        var lineCount = getAlarmStatusLineCount();
        var containerHeight = (elementCount == lineCount ? 1 : Math.ceil(elementCount / lineCount)) * (alarmStatusIcon.height + alarmStatusIcon.yGap);
        $("#divAlarmStatus").height(containerHeight);
        $("#divAlarmStatus_bk").show().height(containerHeight-4);
    });

    $("#divShowAlarmStatus, #divAlarmStatus, #divAlarmStatus_bk").mouseleave(function(event) {
        if (event.relatedTarget && (event.relatedTarget.id == "divAlarmStatus"
            || event.relatedTarget.id == "divAlarmStatus_bk")) {
            return;
        }
        $("#divAlarmStatus").height(32);
        $("#divAlarmStatus_bk").hide();
    });

    var maxIndex = 1;
    tabMapRS485Ptz = [{ "tab": "liPreset", "content": "divPreset",init: function () {
        maxIndex++;
        $("#liPreset").css("z-index", maxIndex);
    }
    }];
    tabMapIntegratedPtz = [
        { "tab": "liPreset", "content": "divPreset",init: function () {
            maxIndex++;
            $("#liPreset").css("z-index", maxIndex);
        }
        },
        { "tab": "liCruise", "content": "divCruise", init: function () {
            maxIndex++;
            $("#liCruise").css("z-index", maxIndex);
        }
        },
        { "tab": "liTrace", "content": "divTrace", init: function () {
            maxIndex++;
            $("#liTrace").css("z-index", maxIndex);
        }
        }
    ];
//    $("#presetCruisePL").tab({
//        map: [{ "tab": "liPreset", "content": "divPreset",init: function () {
//                maxIndex++;
//                $("#liPreset").css("z-index", maxIndex);
//            }
//            },
//            { "tab": "liCruise", "content": "divCruise", init: function () {
//                maxIndex++;
//                $("#liCruise").css("z-index", maxIndex);
//            }
//            },
//            { "tab": "liTrace", "content": "divTrace", init: function () {
//                maxIndex++;
//                $("#liTrace").css("z-index", maxIndex);
//            }
//            }]
//    });

    $("#btnLivePlay").attr("title", LangCtrl._L_("liveStop")).click(function() {
        var $this = $(this);
        if ($this.hasClass("stop")) {
            var sendXML = OCX_XML_LiveSwitch("OFF");
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
            $this.removeClass("stop").addClass("play");
            $("#btnLivePlay").attr("title", LangCtrl._L_("liveStart"));
            VoiceCtrl.disable();
            TakeCtrl.setStatus("disable");
            RecCtrl.setStatus("disable");
            Zoom3DCtrl.setStatus("disable");
            $("#btnMagnify").removeClass("off").addClass("disable");
            $("#btnMinify").removeClass("off").addClass("disable");

            $("#screen_x1").addClass("disable");
            $("#screen_x1_auto").addClass("disable");
            $("#screen_auto").addClass("disable");
            $("#fullScreen").addClass("disable");

            $("#btnTakePic").addClass("disable");
            positionStopTip();
            $("#stopOCXTip").show();
            $(window.top).bind("resize", positionStopTip);
        }
        else {
            var sendXML = OCX_XML_LiveSwitch("ON");
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
            $this.removeClass("play").addClass("stop");
            TakeCtrl.setStatus("off");
            RecCtrl.setStatus("off");
            Zoom3DCtrl.setStatus("off");
            VoiceCtrl.enable();
            $("#btnTakePic").removeClass("disable");
            $("#btnMagnify").removeClass("disable").addClass("off");
            $("#btnMinify").removeClass("disable").addClass("off");
            $("#screen_x1").removeClass("disable");
            $("#screen_x1_auto").removeClass("disable");
            $("#screen_auto").removeClass("disable");
            $("#fullScreen").removeClass("disable");
            VoiceCtrl.off();
            $("#btnLivePlay").attr("title", LangCtrl._L_("liveStop"));
            $("#stopOCXTip").hide();
            $(window.top).unbind("resize", positionStopTip);
            $("#stopOCXTip").unbind("click");
        }
    });

    OCX_WH_Ctrl.init();
    bindPtzEvent();
}

function bindOcxEvent() {
    VoiceCtrl.init();
    TakeCtrl.init("off");
    RecCtrl.init("off");
    Zoom3DCtrl.init("off");
    MagCtrl.init();

    ScanCtrl.init();
    WiperCtrl.init();
    LightCtrl.init();
    RandomScanCtrl.init();
    GroupCtrl.init();

    $("#btnTakePic").click(function() {
        if ($(this).hasClass("disable")) {
            return;
        }
        var sendXML = OCX_XML_IpcTakePhoto();
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        $(this).addClass("disable");
        setTimeout(function () { $("#btnTakePic").removeClass("disable") }, 1000);

    });

    $("#fullScreen").click(function() {
        if($(this).hasClass("disable")){return false;}
        var sendXML = OCX_XML_FullScreen();
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    });

    function sendOcxActionXml(url) {
        var speed = $("#sliderSpeed").slider("getValue");
        var sendData = xmlHeader + "<actionInfo><speed type=\"uint32\" default=\"4\" min=\"1\" max=\"8\">" + speed + "</speed><actionInfo>";
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/" + url,
                type: "POST",
                async: true,
                data: sendData,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }

    $("#cruise_play").click(function() {
        var selectItem = $("#cruiseList").listbox("getSeletedItems");
        if (selectItem && selectItem.length > 0) {
            startCruise(selectItem.data("itemData").id,$("#showFloat"));
        }
    });

    $("#cruise_stop").click(function(){
        stopCruise($("#showFloat"));
    });

    $("#trace_play").click(function() {
        var selectItem = $("#traceList").listbox("getSeletedItems");
        if (selectItem && selectItem.length > 0) {
            startTrace(selectItem.data("itemData").id, $("#showFloat"));
        }
    });

    $("#trace_stop").click(function(){
        stopTrace($("#showFloat"));
    });
}

// 获取私有协议数据端口
function getNetPort() {
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetPortConfig",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
                netPort = $("config>port>netPort", result).text() * 1;
                netPortComplete = true;
                if (systemInfoLoadComplete && streamLoadComplete && netPortComplete) {
                    window.top.hideLoading();
                    if(!NetLiveMonitor){
                        NetLiveMonitor = LoadPlugin("divLiveOCX","NetLiveMonitor");
                        InitLiveOCX();
                    }
                }
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

// 获取码流信息
function getStreamInfo() {
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetProfileInfo",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
                profiles = $("config>profile>porfileNameList>item", result);
                rtspPort = $("config>profile>rtspPort", result).text() * 1;
                ogr_w = $("config>profile>originalRation>W", result).text() * 1;
                ogr_h = $("config>profile>originalRation>H", result).text() * 1;
                $.cookie('profile_count', profiles.length);
                if (profiles.length == 0) {
                    $("#subStream,#thirdStream").removeClass("hasMore").addClass("noMore");
                    $("#mainStream,#subStream,#thirdStream").hide();
                    return;
                }
                else if (profiles.length == 1) {
                    $("#subStream,#thirdStream").removeClass("hasMore").addClass("noMore");
                    $("#subStream,#thirdStream").hide();
                    $("#mainStream").addClass("selected");
                    $("#mainStream").nextAll().hide();
                    $("#mainStream").click(function() { SetStreamType(0); });
                }
                else if (profiles.length == 2) {
                    $("#subStream,#thirdStream").removeClass("hasMore").addClass("noMore");
                    $("#thirdStream").hide();
                    $("#mainStream").click(function() {
                        SetStreamType(0);
                        $("#subStream").removeClass("selected");
                        $(this).addClass("selected");
                    });
                    $("#subStream").click(function() {
                        SetStreamType(1);
                        $("#mainStream").removeClass("selected");
                        $(this).addClass("selected");
                    });
                }
                else{
                    $("#subStream,#thirdStream").removeClass("hasMore").addClass("noMore");
                    $("#mainStream").click(function() {
                        SetStreamType(0);
                        $("#subStream,#thirdStream").removeClass("selected");
                        $(this).addClass("selected");
                    });
                    $("#subStream").click(function() {
                        SetStreamType(1);
                        $("#mainStream,#thirdStream").removeClass("selected");
                        $(this).addClass("selected");
                    });
                    $("#thirdStream").click(function() {
                        SetStreamType(2);
                        $("#mainStream,#subStream").removeClass("selected");
                        $(this).addClass("selected");
                    });
                }
                streamLoadComplete = true;
                if (systemInfoLoadComplete && streamLoadComplete && netPortComplete) {
                    window.top.hideLoading();
                    if(!NetLiveMonitor){
                        NetLiveMonitor = LoadPlugin("divLiveOCX","NetLiveMonitor");
                        InitLiveOCX();
                    }
                }
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

//预置点、巡航线、轨迹与osd操作后状态同步的定时查询请求
function getFreshList(){
    try{
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetFreshList",
            type: "POST",
            timeout:5000,
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback:function(result){
                $("config >freshListInfo> item",result).each(function(index,element){
                    var ele = $(element).text();
//                    ele === "preset" ? getPresetList() : ele === "cruise" ? getCruiseList() : ele === "trace" ? getTraceList() : rebootStatus();
                    if(ele === "preset"){
                        getPresetList()
                    }else if( ele === "cruise" ){
                        getCruiseList();
                    }else if(ele === "trace"){
                        getTraceList();
                    }else if(ele === "reboot"){
                        $("#divLiveOCX").css({height:"0px",width:"0px"});
                        window.top.showLoading(LangCtrl._L_("loadingTip"));
                        $(".loadingIndicator_tip",window.top.document).css({background:"#5A626B"});
                        $(".msg_border>.msg",window.top.document).css({color:"white"});
                        rebootStatus();
                    }
                });
                setTimeout(getFreshList,3000);
            }
        })
    }catch (exception){
        alert(exception);
    }
}

function rebootStatus(){
    setTimeout("reconnectForLive()", 10000);
}

//检测重启
function reconnectForLive() {
    XmlHttpClient.SendHttpRequest({
        url: serverBase + "/GetRebootStatus",
        type: "POST",
        async: true,
        data: "",
        timeout: 60000,
        beforeSend: XmlHttpClient.CommBeforeSend,
        callback: function(result) {
            if ($("rebootStatus", result).text() == "true") {
                $(".loadingIndicator_tip",window.top.document).css({background:"transparent"});
                $(".msg_border>.msg",window.top.document).css({color:"333"});
                window.top.hideLoading();
                $("#mainFrame", window.top.document).attr("src", MenuCtrl["menuList"]["live"]["url"]);
            }
            else {
                setTimeout("reconnectForLive()", 5000);
            }

        },
        error: function() {
            setTimeout("reconnectForLive()", 5000);
        }
    });
}


function getAlarmStatus() {
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetAlarmStatus",
            type: "POST",
            timeout:5000,
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
                var divAlarmStatus = $("#divAlarmStatus");
                $("config>alarmStatusInfo>sensorAlarmIn>item", result).each(function(index, element) {
                    var sensorId = $(this).attr("id");
                    var sensorAlarmStatus = $(this).text() === "true";
                    var divSensorAlarmStatus = $("#divSensorAlarmStatus" + sensorId);
                    if (divSensorAlarmStatus.size() == 0) {
                        divSensorAlarmStatus = $("<div id=\"divSensorAlarmStatus" + sensorId + "\" title=\"" + LangCtrl._L_("alarmIn") + sensorId + "\"></div>");
                        divAlarmStatus.append(divSensorAlarmStatus);
                    }
                    divSensorAlarmStatus.removeClass().addClass(sensorAlarmStatus ? "sensorAlarm_alarm" : "sensorAlarm_normal");
                });
                var motionAlarmStatus = $("config>alarmStatusInfo>motionAlarm", result).text() === "true";
                var divMotionAlarmStatus = $("#divMotionAlarmStatus");
                if (divMotionAlarmStatus.size() == 0) {
                    divMotionAlarmStatus = $("<div id=\"divMotionAlarmStatus\" title=\"" + LangCtrl._L_("motion") + "\"></div>");
                    divAlarmStatus.append(divMotionAlarmStatus);
                }
                divMotionAlarmStatus.removeClass().addClass(motionAlarmStatus ? "motionAlarm_alarm" : "motionAlarm_normal");

                // 调整报警区域宽度
                var containerWidth = $("#divLeftTop").width() - $("#divBalance").offset().left - $("#divBalance").width();
                $("#divAlarmStatus,#divAlarmStatus_bk").width(containerWidth);

                // 是否显示报警弹出按钮和居中显示
                var elementCount = $(".sensorAlarm_normal, .sensorAlarm_alarm, #divMotionAlarmStatus, #divColorAbnmlAlarmStatus, #divClarityAbnmlAlarmStatus, #divSceneChgAlarmStatus").size();
                if (elementCount > 0) {
                    var lineCount = getAlarmStatusLineCount();
                    $("#divShowAlarmStatus")[elementCount == lineCount ? "hide" : "show"]();
                    $("#divAlarmStatus").css("text-align", elementCount > lineCount ? "left" : "right");
                }
            }
        });
    } catch (ex) {
        alert(ex);
    }
}

// 获取报警图标一行的个数
function getAlarmStatusLineCount() {
    var containerWidth = $("#divAlarmStatus").width();
    var elementCount = $(".sensorAlarm_normal, .sensorAlarm_alarm, #divMotionAlarmStatus, #divColorAbnmlAlarmStatus, #divClarityAbnmlAlarmStatus, #divSceneChgAlarmStatus").size();
    var currentWidth = 0;
    var lineCount = 0;
    for (; currentWidth - alarmStatusIcon.xGap < containerWidth && lineCount < elementCount; lineCount++) {
        currentWidth += alarmStatusIcon.width + alarmStatusIcon.xGap;
    }
    return currentWidth < containerWidth && elementCount == lineCount ? elementCount : lineCount - 1;
}

function liveResize() {
    if(screenHeight1 != screen.height && screenWidth1 !=screen.width){
        window.top.location.reload();
        screenHeight1 = screen.height;
        screenWidth1 = screen.width;
    }
    OCX_WH_Ctrl.changeWH(OCX_WH_Ctrl.wh);
}

var positionStopTip = function(){
    $("#hack").html("1111");
    $("#divLiveOCX").css({height:"0px",width:"0px"});
    var cWidth = $("#divLeftCenter").width();
    var cHeight = $("#divLeftCenter").height();
    var sWidth = $("#stopOCXTip").width();
    var sHeight = $("#stopOCXTip").height();
    var left = (cWidth - sWidth) / 2;
    var top = (cHeight - sHeight) / 2;
    $("#stopOCXTip").css({left:left+"px",top:top+"px",cursor:"pointer"}).unbind("click").bind("click",function(){
        var sendXML = OCX_XML_LiveSwitch("ON");
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        $("#btnLivePlay").removeClass("play").addClass("stop");
        $("#btnLivePlay").attr("title", LangCtrl._L_("liveStop"));
        TakeCtrl.setStatus("off");
        RecCtrl.setStatus("off");
        Zoom3DCtrl.setStatus("off");
        $("#btnTakePic").removeClass("disable");
        $("#btnMagnify").removeClass("disable").addClass("off");
        $("#btnMinify").removeClass("disable").addClass("off");
        $("#screen_x1").removeClass("disable");
        $("#screen_x1_auto").removeClass("disable");
        $("#screen_auto").removeClass("disable");
        $("#fullScreen").removeClass("disable");
        VoiceCtrl.enable();
        VoiceCtrl.off();
        $("#stopOCXTip").hide();
        $(window.top).unbind("resize", positionStopTip);
    });
};

$(window.top).resize(liveResize);