﻿function bindPtzEvent() {
    $("#Ptz_U").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/Up");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#Ptz_RU").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/RightUp");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#Ptz_R").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/Right");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#Ptz_RD").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/RigthDown");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#Ptz_D").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/Down");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#Ptz_LD").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/LeftDown");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#Ptz_L").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/Left");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#Ptz_LU").bind("mousedown", function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/LeftUp");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#Ptz_Stop").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        stopCruise();
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
    });

    $("#zoomIn").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/ZoomIn");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#zoomOut").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/ZoomOut");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#focusIn").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/Far");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#focusOut").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/Near");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#irisIn").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/IrisOpen");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#irisOut").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendPtzCmdXml("PtzControl/1/IrisClose");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendPtzCmdXml("PtzControl/1/Stop");
    });

    $("#zoomInAZ").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendAZCmdXml("AZControl/1/ZoomIn");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendAZCmdXml("AZControl/1/Stop");
    });

    $("#zoomOutAZ").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendAZCmdXml("AZControl/1/ZoomOut");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendAZCmdXml("AZControl/1/Stop");
    });

    $("#focusInAZ").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendAZCmdXml("AZControl/1/Far");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendAZCmdXml("AZControl/1/Stop");
    });

    $("#focusOutAZ").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendAZCmdXml("AZControl/1/Near");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendAZCmdXml("AZControl/1/Stop");
    });

    $("#oneKeyFocus").mousedown(function() {
        $(this).addClass("active");
        DragSetCapture(this);
        sendAZCmdXml("AZControl/1/OneKeyFocus");
    }).bind("mouseup", function() {
        $(this).removeClass("active");
        DragReleaseCapture(this);
        sendAZCmdXml("AZControl/1/Stop");
    });

}

function sendPtzCmdXml(url) {
    var speed = $("#sliderSpeed").slider("getValue");
    var sendData = xmlHeader + "<actionInfo><speed>" + speed + "</speed></actionInfo>";
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/" + url,
            type: "POST",
            async: true,
            data: sendData,
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}
function sendAZCmdXml(url) {
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/" + url,
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

function callPreset(id,obj) {
    var sendData = xmlHeader + "<presetInfo><id>" + id + "</id></presetInfo>";
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/PtzGotoPreset",
            type: "POST",
            async: true,
            data: sendData,
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                if(obj != null){
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError(obj, LangCtrl._L_("successCall"),{},"success");
                    }else{
                        ShowFloatError(obj, LangCtrl._L_("failedCall"),{},"failed");
                    }
                }

            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

function startCruise(id,obj) {
    var sendData = xmlHeader + "<cruiseInfo><id>" + id + "</id></cruiseInfo>";
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/PtzRunCruise",
            type: "POST",
            async: true,
            data: sendData,
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                if(obj != null){
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError(obj, LangCtrl._L_("successRun"),{},"success");
                    }else{
                        ShowFloatError(obj, LangCtrl._L_("failedRun"),{},"failed");
                    }
                }

            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

function stopCruise(obj) {
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/PtzStopCruise",
            type: "POST",
            async: true,
            data: "",
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {

                if(obj != null){
                    if ($("config",result).attr("status") === "success"){
                        ShowFloatError(obj, LangCtrl._L_("successStop"),{},"success");
                    }else{
                        ShowFloatError(obj, LangCtrl._L_("failedStop"),{},"failed");
                    }
                }

            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

function sendPtz3dZoomXml(x1,y1,x2,y2,x3,y3) {
    var url = "Ptz3DZoom";
    var sendData = xmlHeader + "<actionInfo>"
                    + "<startPoint>"
                    + "<X type=\"uint32\">" + x1 + "</X>"
                    + "<Y type=\"uint32\">" + y1 + "</Y>"
                    +"</startPoint>"
                    + "<endPoint>"
                    + "<X type=\"uint32\">" + x2 + "</X>"
                    + "<Y type=\"uint32\">" + y2 + "</Y>"
                    +"</endPoint>"
                    + "<centerPoint>"
                    + "<X type=\"uint32\">" + x3 + "</X>"
                    + "<Y type=\"uint32\">" + y3 + "</Y>"
                    +"</centerPoint>"
                    +"</actionInfo>";
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/" + url,
            type: "POST",
            async: true,
            data: sendData,
            beforeSend: XmlHttpClient.CommBeforeSend,
            callback: function(result) {
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}