var xmlDoc;
var timeInterval = 1000;
var NetLiveMonitor;
var initVoiceFlag = false,initWatermarkFlag = false;


var ogr_w = 2000, ogr_h = 1000; //原始尺寸
var maxZIndex = 1;  //操作面板的宽，高
var imgSelectArr = [];
var imgObject = {};
var slideImg = [];

$(function(){

    getDeviceInfo(function(result) {
        if ($("config>deviceInfo>supportSDCard ", result).text() == "false") {
            $("#liPicSearch,#sdRec").hide();
            $("#divParent").tab({
                map: [
                    { "tab": "liRecPlay", "content": "divRecPlay", init: commonRecModule.init }
                ]
            });
        }else{
            $("#divParent").tab({
                map: [{ "tab": "liPicSearch", "content": "divPicSearch", init: imgMgrModule.init },
                    { "tab": "liRecPlay", "content": "divRecPlay", init: commonRecModule.init }
                ]
            });
        }

        if ($("config>deviceInfo>alarmInCount", result).text()*1 < 1) {
            $("#divRecSensor").hide();
        }

        if ($("config>deviceInfo>supportWatermark", result).text() == "false") {
            $("#watermark").hide();
        }

    });
    $(window.top).resize(autoSize);
    $("#divParent").tab("selectLastTab");
//    if($.cookie('tab') != undefined){
//        $("#divParent").tab("selectTab","$.cookie('tab')");
//    }

});

var commonRecModule = {
    rowData:[],
    doResize: function(){
        var height = $(".third1").height();
        if(0 == height) {
            setTimeout("commonRecModule.doResize()", 20);
            return;
        }
        $("#recGrid").wbGrid("setHeight",height -40);
    },
    initComponent: function(){
        $("#recCalendar").wbDatePicker({
            displayMode: $.DATEPICKER_DISPLAY_MODE_INNER,
            highlightWeekEnd: false,
            lang: LangCtrl.getLang(),
            skin: {
                containerCss: "calendar_container",
                readonlyCss: "calendar_readonly",
                dateContainerCss: "calendar_date_container",
                dateHeaderCss: "calendar_date_header",
                dateRowOddCss: "calendar_date_row_odd",
                dateRowEvenCss: "calendar_date_row_even",
                dateCellCss: "calendar_date_cell",
                dateCellSelectedCss: "calendar_date_cell_selected",
                dateOtherMonthCss: "calendar_date_other_month"
            },
            callback:{
                onMonthChanged: function(datePicker, oldValue, newValue) {
//                    localRecModule.getDatesCondition();
                },
                onYearChanged: function(datePicker, oldValue, newValue) {
//                    localRecModule.getDatesCondition();
                }
            }
        });
    },

    init:function(){
        commonRecModule.initComponent();
        localRecModule.initCtrl();
        $(":radio[name=\"playRec\"]").unbind().click(function() {

            if($(this).val() == "local"){
                localRecModule.initCtrl();
                $(".divSDEventType,#download").hide();
                var sendXML = OCX_XML_SetPlayStatus("STOP");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
            }else{
                SDRecModule.initCtrl();
                $(".divSDEventType,#download").show();
                SDRecModule.getSdCardStatus();
                SDRecModule.GetDatesExistRecord();
                var sendXML = OCX_XML_SetPlayStatus("STOP");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
            }

            $("#fwPlay,#fwPause,#recStop,#bkSpeed,#fwSpeed,#lastFile,#nextFile").addClass("disabled");
            $("#Audio").removeClass("off").removeClass("on").addClass("disabled");
            $("#watermark").removeClass("off on").addClass("disabled");
            if(initVoiceFlag){$("#AudioBar").slider("setProperty","enable", false);}
            RecModule.setPlayStatusTip("");
            $("#playStatusIcon").removeAttr("class");
        });
        $(":radio[name=\"playRec\"][value=\"local\"]").attr("checked","checked");
        if($(":radio[name=\"playRec\"]").val() == "local"){
            $(".divSDEventType,#download").hide();
        }
        $(":radio[name=\"snap\"][value=\"local\"]").attr("checked","checked");
        if($(":radio[name=\"snap\"]").val() == "local"){
            $(".divEventType2").hide();
        }
        $(window.top).resize(recResize);
    },
    getRowData:function(pageIndex, pageDataCount) {
        var dataList = [];
        var index = (pageIndex-1) * pageDataCount;
        if(commonRecModule.rowData.length < index){
            index = (commonRecModule.rowData.length / pageDataCount - 1) * pageDataCount
        }

        for(var i=0; i<pageDataCount; i++) {
            if(index + i > commonRecModule.rowData.length - 1)
                break;
            dataList.push(commonRecModule.rowData[index + i]);
        }
        return dataList;
    },
    queryPageRecs:function(pageIndex,pageDataCount) {
        $("#download").addClass("disabled");
        $('#recGrid').wbGrid("load", commonRecModule.getRowData(pageIndex,pageDataCount));
        $("#recGridPage").wbPager("setDataCount", commonRecModule.rowData.length, false);
    }
};

var localRecModule = {
    maxSize:20,
    initCtrl: function(){
        $(".total > div").addClass("disabled");
        var format =  "hh:mm:ss";
        $("#recStartTime").timeInput({ format: format });
        $("#recEndTime").timeInput({ format: format,defaultValue:"23:59:59"});

        $('#recGrid').wbGrid({
            data: {
                colNames: ["id",LangCtrl._L_("recName"), LangCtrl._L_("time"), LangCtrl._L_("duration"),"imgUrl"],
                colModel: [
                    { name: 'imgId', index: 'imgId',width: 80, align: "center",hidden:true, sortable: false },
                    { name: 'recName', index: 'recName',width: 80, align: "center", sortable: false },
                    { name: 'time', index: 'time',width: 80, align: "center", sortable: false },
                    { name: 'duration', index: 'duration',width: 80, align: "center", sortable: false },
                    { name: 'imgUrl', index: 'imgUrl',width: 80, align: "center",hidden:true, sortable: false }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            },
            callback: {
                onlClickRow: function (e, gridId, rowIndex, rowData) {
                    $("#fwPlay,#full_screen").removeClass("disabled");
                },
                onDblClickRow: function (e, gridId, rowIndex, rowData) {
                    var recName =  rowData["recName"];
                    var sendXML = xmlHeader+"<cmd  type=\"LocalPlay\">";
                    sendXML += "<ip>" + serverIp + "</ip>" + "<fileName>" + recName + "</fileName>";
                    sendXML = sendXML + "</cmd>";
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

                    RecModule.setPlayStatusTip("");
                    PlaySpeedCtrl.value = 1;
                    if(!initVoiceFlag){
                        RecVoiceCtrl.init();
                    }

                    if(!initWatermarkFlag){
                        WatermarkCtrl.init("off");
                    }
                    WatermarkCtrl.setStatus("off");

                    RecVoiceCtrl.on();
                    RecPlayStatusCtrl.setStatus("PLAY", false);

                    $("#full_screen").removeClass("disabled");
                }
            }
        });

        $("#recGridPage").wbPager({
            pageIndex: 1,
            pageDataCount: 10,
            dataCount: 0,
            lang: LangCtrl.getLang(),
            pageDataCountItems: [5,10],
            onPage: function (pagerId, pageIndex, pageDataCount) {
                localRecModule.queryPageRecs(pageIndex,pageDataCount);
            }
        });

        commonRecModule.initComponent();
        commonRecModule.doResize();
        if(!NetLiveMonitor){
            localRecModule.setOCX();
        }else{
            localRecModule.getRecDates();
            RecModule.bindOCXCtrlEvent();
        }

        $("#searchRec").unbind().click(localRecModule.getData);
        //防止拖动image打开新浏览器窗口
        $("body").bind("dragstart",function(){return false});
        $("#Content",window.top.document).css({"min-width":"1342px","min-height":"600px"});
        $(window.top).resize(recResize);
    },
    getRecDates: function(){
        var sendXML = xmlHeader+"<request type=\"GetRecDates\">";
        sendXML += "<ip>" + serverIp + "</ip>";
        sendXML = sendXML + "</request>";
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var $xmlDoc = $(XMLStr2XMLDoc(result));

        var periods =[];
        $("response>dates>item", $xmlDoc).each(function(i,ele){
            var value = $(ele).text();
            periods.push({start:value,end:value});
        });

//        var periods = [{start:"2015-07-06",end:"2015-07-06"},{start:"2015-07-08",end:"2015-07-09"}];

        $("#recCalendar").wbDatePicker("setProperty",{
            specialPeriods: [
                {
                    skin: {
                        dateCellCss: "specialDays", // 特殊日期单元格样式
                        dateCellHoverCss: "", // 特殊日期单元格悬停样式
                        dateCellSelectedCss: "selectDay" // 特殊日期单元格选中样式
                    },
                    periods: periods
                }
            ]
        });

    },
    getLocalRecCon: function(){
        var date = $("#recCalendar").wbDatePicker("getWithFormat");
        var hour1 = $("#recStartTime").val();
        var hour2 = $("#recEndTime").val();
        var startTime = date + " " + hour1;
        var endTime = date + " " + hour2;
        if(Date.parse(startTime) > Date.parse(endTime)){
            ShowFloatError($("#searchRec"), LangCtrl._L_("tip"));
            return false;
        }
        var condition = xmlHeader+"<request type=\"GetRecCondition\">";
        condition += "<ip>" + serverIp + "</ip>"+
            "<startTime>"  + startTime + "</startTime>"+
            "<endTime>"  + endTime + "</endTime>";
        condition = condition + "</request>";
        return condition;
    },
    getData: function(){
        /*window.top.showLoading();*/
        var sendXML = localRecModule.getLocalRecCon();
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
        var $xmlDoc = $(XMLStr2XMLDoc(result));

        localRecModule.rowData = [];
        $("response>recList>item", $xmlDoc).each(function(i,ele){
            var id = i;
            var recName = $(">recName",ele).text();
            var time =  $(">time",ele).text();
            var duration = $(">duration",ele).text();
//            var recUrl = "../Css/Pictures/Snap/" + recName;
            var objectRec = {recId:id,recName:recName,time:time,duration:duration};
            localRecModule.rowData.push(objectRec);
        });

        localRecModule.rowData.sort(function(a,b){
            return a.time < b.time ? 1 : a.time == b.time ? 0 : -1;
        });

        $('#recGrid').wbGrid("load", localRecModule.getRowData(1,$("#recGridPage").wbPager("getPageDataCount")));
//        $('#recGrid').wbGrid("load", localRecModule.getRowData(1,10));
        $("#recGridPage").wbPager("setPageIndex", 1, false);
        $("#recGridPage").wbPager("setDataCount", localRecModule.rowData.length, false);

        $("#fwPlay,#fwPause,#recStop,#bkSpeed,#fwSpeed,#nextFile,#lastFile,#full_screen").addClass("disabled");
        var sendXML = OCX_XML_SetPlayStatus("STOP");
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        $("#watermark").removeClass("on off").addClass("disabled");
        window.top.hideLoading();
//        WatermarkCtrl.setStatus("off");
    },
    setOCX: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    netPort = $("config>port>netPort", result).text() * 1;
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");
                    if(NetLiveMonitor){
                        // 设置模式
                        var sendXML = OCX_XML_SetPreViewModel("Fixed");
                        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    }
                    localRecModule.getRecDates();
                    RecModule.bindOCXCtrlEvent();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getRowData:function(pageIndex, pageDataCount) {
        var dataList = [];
        var index = (pageIndex-1) * pageDataCount;
        if(localRecModule.rowData.length < index){
            index = (localRecModule.rowData.length / pageDataCount - 1) * pageDataCount
        }

        for(var i=0; i<pageDataCount; i++) {
            if(index + i > localRecModule.rowData.length - 1)
                break;
            dataList.push(localRecModule.rowData[index + i]);
        }
        return dataList;
    },
    queryPageRecs:function(pageIndex,pageDataCount) {
        $('#recGrid').wbGrid("load", localRecModule.getRowData(pageIndex,pageDataCount));
        $("#recGridPage").wbPager("setDataCount", localRecModule.rowData.length, false);
    }
};

var RecModule = {
    bindOCXCtrlEvent : function(){

        PlaySpeedCtrl.init();
        RecPlayStatusCtrl.init();
        filePreNextCtrl.init();

        $("#full_screen").unbind().click(function () {
            if ($(this).hasClass("disabled"))
                return false;
            var sendXML = OCX_XML_FullScreen();
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        });

//        $("#stop").click(function () {
//            if ($(this).hasClass("disabled"))
//                return false;
//            var sendXML = OCX_XML_StopPreview("ALL");
//            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
//        });
    },
    setPlayStatusTip: function(speed){
        if (!speed)
            $("#playStatusTip").html("");
        else {
            var speedShow = speed;
            if (speedShow < 0) {
                speedShow = "1/" + speedShow * (-1);
            }
            $("#playStatusTip").html("X" + speedShow);
        }
    }
};

PlaySpeedCtrl = {
    init: function () {
        $("#bkSpeed").unbind().click(function () {
            if ($(this).hasClass("disabled"))
                return false;
            var index = PlaySpeedCtrl.valueIndex[PlaySpeedCtrl.value.toString()];
            if (index > 0) {
                index--;
                PlaySpeedCtrl.setSpeed(PlaySpeedCtrl.speedValues[index], true);
            }
        });
        $("#fwSpeed").unbind().click(function () {
            if ($(this).hasClass("disabled"))
                return false;
            var index = PlaySpeedCtrl.valueIndex[PlaySpeedCtrl.value.toString()];
            if (index < 2) {
                index++;
                PlaySpeedCtrl.setSpeed(PlaySpeedCtrl.speedValues[index], true);
            }
        });
//        PlaySpeedCtrl.setEnable(false);
    },
    valueIndex: { "1": 0, "2": 1, "4":2},
    speedValues: [ "1", "2", "4"],
//    valueIndex: { "-32": 0, "-16": 1, "-8": 2, "-4": 3, "-2": 4, "1": 5, "2": 6, "4": 7, "8": 8, "16": 9, "32": 10 },
//    speedValues: ["-32", "-16", "-8", "-4", "-2", "1", "2", "4", "8", "16", "32"],
    value: 1,
    enable: false,
    setSpeed: function (speed, isSendCmd) {
//        if (!PlaySpeedCtrl.enable)
//            return;

        PlaySpeedCtrl.value = speed * 1;
        if (NetLiveMonitor && isSendCmd) {
            var sendXML = OCX_XML_SetPlaySpeed(this.value);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        }
//        if (this.value == 1 && RecPlayStatusCtrl.status != "STOP" && RecPlayStatusCtrl.status != "READAY") {
//            $("#skip30s,#bk30s,#fw30s").removeClass("disabled");
//        }
//        else {
//            $("#skip30s,#bk30s,#fw30s").addClass("disabled");
//        }

        if (PlaySpeedCtrl.value == 1) {
            RecModule.setPlayStatusTip("");
        }
        else {
            RecModule.setPlayStatusTip(PlaySpeedCtrl.value);
        }

//        PlaySpeedCtrl.setEnable(true);

    },
    setEnable: function (enable) {
        PlaySpeedCtrl.enable = enable;
        if (enable) {
            if (PlaySpeedCtrl.value == 4) {
                $("#bkSpeed").addClass("disabled");
            }
            else if (PlaySpeedCtrl.value == 1) {
                $("#fwSpeed").addClass("disabled");
            }
            else {
                $("#bkSpeed,#fwSpeed").removeClass("disabled");
            }
        }
        else {
//            PlaySpeedCtrl.setSpeed(1, true);
            $("#bkSpeed,#fwSpeed").addClass("disabled");
        }
    }
};

RecPlayStatusCtrl = {
    enableBackForwards: true,
    playOrder: "PLAY", //BACKWARDS
    status: "STOP", //PLAY/PAUSE/STOP
    setStatus: function (status, isSendCmd) {
        RecPlayStatusCtrl.status = status;
        if (RecPlayStatusCtrl.status == "STOP") {
//            $("#bkPlay,#fwPlay").removeClass("pause");
            WatermarkCtrl.setStatus("off");
            $("#fwPause,#recStop,#fwPlay").addClass("disabled");
            $("#Audio").removeClass("off").removeClass("on").addClass("disabled");
            $("#Audio>b").removeClass("off").removeClass("on").addClass("disable");
            $(".sound_line").removeClass("off").addClass("disabled");
            $(".sound_thumb").removeClass("off").addClass("disabled");
            $("#watermark").removeClass("off").removeClass("on").addClass("disabled");
            $("#AudioBar").slider("setProperty","enable", false);
            $("#playStatusIcon").removeAttr("class");
            RecModule.setPlayStatusTip("");
            PlaySpeedCtrl.setEnable(false);
        }
        else {
            $("#divRecCtrl_Center .ctrl_2").removeClass("disabled");
//            PlaySpeedCtrl.setEnable(true);
            if (!RecPlayStatusCtrl.enableBackForwards) {
                $("#bkPlay").addClass("disabled");
            }
            if (RecPlayStatusCtrl.status == "PAUSE") {
                $("#fwPlay").removeClass("disabled");
                $("#fwPause").addClass("disabled");
                $("#playStatusIcon").attr("class", "bkPlay");
                if (PlaySpeedCtrl.value == 1) {
                    RecModule.setPlayStatusTip("");
                }
                else {
                    RecModule.setPlayStatusTip(PlaySpeedCtrl.value);
                }
            }
            else if (RecPlayStatusCtrl.status == "PLAY") {
                $("#fwPlay").addClass("disabled");
                $("#playStatusIcon").attr("class", "fwPlay");
                if (PlaySpeedCtrl.value == 1) {
                    RecModule.setPlayStatusTip("");
                }
                else {
                    RecModule.setPlayStatusTip(PlaySpeedCtrl.value);
                }
            }
        }
        if (isSendCmd) {
            var sendXML = OCX_XML_SetPlayStatus(RecPlayStatusCtrl.status);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        }
    },
    init: function () {
//        $("#divRecCtrl_Center .ctrl_2,#skip30s,#bk30s,#fw30s,#nextFrame,#preFrame").addClass("disabled");
        $("#bkPlay").unbind().click(function () {
            if ($(this).hasClass("disabled"))
                return false;
            RecPlayStatusCtrl.playOrder = "PLAY";
            if (RecPlayStatusCtrl.status == "PLAY") {
                RecPlayStatusCtrl.setStatus("PAUSE", true);
            }
            else {
                RecPlayStatusCtrl.setStatus("PLAY", true);
            }
        });
        $("#fwPlay").unbind().click(function () {
            if ($(this).hasClass("disabled"))
                return false;

            if(RecPlayStatusCtrl.status == "PAUSE"){
                RecModule.setPlayStatusTip("");
//            PlaySpeedCtrl.value = 1;
//            PlaySpeedCtrl.setSpeed(1, true);
//            RecVoiceCtrl.on();
                RecPlayStatusCtrl.playOrder = "PLAY";
                RecPlayStatusCtrl.setStatus("PLAY", true);
            }else if(RecPlayStatusCtrl.status == "STOP"){
                var datas = $("#recGrid").wbGrid("getSelectRowDatas");
                if(datas == null){
                    ShowFloatError($("#fwPlay"), LangCtrl._L_("selectRec"));
                    return false;
                }
                if($(":radio[name=\"playRec\"]:checked").val() == "local"){
                    var recName =  datas["recName"];
                    var sendXML = xmlHeader+"<cmd  type=\"LocalPlay\">";
                    sendXML += "<ip>" + serverIp + "</ip>" + "<fileName>" + recName + "</fileName>";
                    sendXML = sendXML + "</cmd>";
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                }else{
                    var sendXML = xmlHeader+"<cmd  type=\"SDRecPlay\">";
                    sendXML += "<recType>" + datas["recType"] + "</recType>" + "<startSecond>" + datas["startNum"] + "</startSecond>" + "<endSecond>" + datas["endNum"] + "</endSecond>";
                    sendXML = sendXML + "</cmd>";
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                }

                RecModule.setPlayStatusTip("");
                PlaySpeedCtrl.value = 1;
                if(!initVoiceFlag){
                    RecVoiceCtrl.init();
                }
                if(!initWatermarkFlag){
                    WatermarkCtrl.init("off");
                }
                WatermarkCtrl.setStatus("off");
                RecVoiceCtrl.on();
                RecPlayStatusCtrl.setStatus("PLAY", false);
                $("#full_screen").removeClass("disabled");
            }

        });
        $("#fwPause").unbind().click(function () {
            if ($(this).hasClass("disabled"))
                return false;
            RecPlayStatusCtrl.playOrder = "PAUSE";
            RecPlayStatusCtrl.setStatus("PAUSE", true);
        });
        $("#recStop").unbind().click(function () {
            if ($(this).hasClass("disabled"))
                return false;
            var sendXML = OCX_XML_SetPlayStatus("STOP");
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
            RecPlayStatusCtrl.setStatus("STOP");
            $("#fwPlay").removeClass("disabled");
            $("#full_screen").addClass("disabled");
        });

//        RecPlayStatusCtrl.setStatus("FORWARDS", true);
    },
    resetPositon: function () {
        var w = $("#divRecCtrl").width() - $("#divRecCtrl_Left").width() - $("#divRecCtrl_Right").width();
        $("#divRecCtrl_Center").css("left", (w - $("#divRecCtrl_Center").width()) / 2 + $("#divRecCtrl_Left").width() + "px");
    }
};

//声音
RecVoiceCtrl = {
    isOn: false,
    off: function () {
        var sendXML = OCX_XML_SetRecVolume(0);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        RecVoiceCtrl.isOn = false;
        $("#Audio").removeClass("disabled").addClass("on").addClass("off").children("b").attr("title", LangCtrl._L_("voiceOn"));
        $("#AudioBar").slider("setProperty", "enable", false);
    },
    on: function () {
        $("#AudioBar").slider("setValue",50);
//            var sendXML = OCX_XML_SetRecVolume(RecVoiceCtrl.getVolume());
//            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        RecVoiceCtrl.isOn = true;
        $("#Audio").removeClass("disabled").removeClass("off").addClass("on").children("b").attr("title", LangCtrl._L_("voiceOff"));
        $(".sound_line").removeClass("disabled").removeClass("off");
        $(".sound_thumb").removeClass("disabled").removeClass("off");
        $("#AudioBar").slider("setProperty", "enable", true);
    },
    getVolume: function () {
        return $("#AudioValue").html() * 1;
    },
    //只设置状态，不发命令
    setStatusNoCmd: function (status) {
        RecVoiceCtrl.isOn = status;
        switch (status) {
            case true:
                $("#Audio").removeClass("off").children("b").attr("title", LangCtrl._L_("voiceOff"));
                $("#Audio>b").removeClass("off");
                $(".sound_line").removeClass("off");
                $(".sound_thumb").removeClass("off");
                $("#AudioBar").slider("setProperty", "enable", true);
                break;
            case false:
                $("#Audio").addClass("off").children("b").attr("title", LangCtrl._L_("voiceOn"));
                $("#Audio>b").addClass("off");
                $(".sound_line").removeClass("off");
                $(".sound_thumb").removeClass("off");
                $("#AudioBar").slider("setProperty", "enable", false);
                break;
        }
    },
    init: function () {
        initVoiceFlag = true;
        $("#Audio").attr("title", LangCtrl._L_("voiceOn")).find("b").click(function () {
            if ($("#Audio").hasClass("disabled"))
                return;
            if (RecVoiceCtrl.isOn) {
                RecVoiceCtrl.off();
            }
            else {
                RecVoiceCtrl.on();
            }
        });

        $("#AudioValue").html("50");
        $("#AudioBar").slider({
            value: 50,
            maxWidth: 134, //滑动宽度
            minValue: 0, //最小值
            maxValue: 100, //最大值
            borderCss: 'sound_border',
            lineCss: 'sound_line',
            thumbCss: 'sound_thumb',
            enable: false,
            valueChangeEvent: function (value) {
                $("#AudioValue").html(value);
                if (NetLiveMonitor) {
                    var sendXML = OCX_XML_SetRecVolume(value);
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                }
            }
        });
        $("#Audio").removeClass("off").removeClass("on").addClass("disabled");
        $("#Audio>b").removeClass("off").removeClass("on").addClass("disable");
        $(".sound_line").removeClass("off").addClass("disabled");
        $(".sound_thumb").removeClass("off").addClass("disabled");
        $("#AudioBar").slider("setProperty","enable",false);
    }
};

//水印
var WatermarkCtrl = {
    status: "off", //"disable","on","off"
    setStatus: function(status) {
        $("#watermark").removeAttr("class");
        this.status = status;
        switch (status) {
            case "disable":
                $("#watermark").addClass("disable").attr("title", LangCtrl._L_("waterOn"));
                break;
            case "on":
                var sendXML = OCX_XML_Watermark("Open");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#watermark").removeClass("off disabled").addClass("ctrl_2 on").attr("title", LangCtrl._L_("waterOff"));
                break;
            case "off":
                var sendXML = OCX_XML_Watermark("Close");
                NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                $("#watermark").removeClass("on disabled").addClass("ctrl_2 off").attr("title", LangCtrl._L_("waterOn"));
                break;
        }
    },
    init: function(status) {
        initWatermarkFlag = true;
        if (status == "on")
            $("#watermark").removeClass("off").addClass("on").attr("title", LangCtrl._L_("waterOff"));
        else if(status == "off"){
            $("#watermark").removeClass("on").addClass("off").attr("title", LangCtrl._L_("waterOn"));
        }else{
            return;
        }

        $("#watermark").attr("title", LangCtrl._L_("waterOn")).unbind().click(function() {
            if($(this).hasClass("disabled")){
                return false;
            }
            if (WatermarkCtrl.status == "on") {
                WatermarkCtrl.setStatus("off");
            }else {
                WatermarkCtrl.setStatus("on");
            }
        });
    }
};

var filePreNextCtrl = {
    currentIndex: 0,
    init: function(){
        $("#lastFile").unbind().click(function(){
            filePreNextCtrl.previousFile();
        });
        $("#nextFile").unbind().click(function(){
            filePreNextCtrl.nextFile();
        });
    },
    previousFile: function(){
        var recGrid = $('#recGrid');
        var selectRow = recGrid.wbGrid("getSelectRows");
        filePreNextCtrl.currentIndex = selectRow.index;
        if(filePreNextCtrl.currentIndex < 1){
            recGrid.wbGrid("selectRowByIndex",filePreNextCtrl.currentIndex);
        }else{
            filePreNextCtrl.currentIndex = filePreNextCtrl.currentIndex - 1;
            recGrid.wbGrid("selectRowByIndex",filePreNextCtrl.currentIndex);
        }

        if($(":radio[name=\"playRec\"]:checked").val() == "local"){
            var recName =  recGrid.wbGrid("getRowByIndex",filePreNextCtrl.currentIndex)["data"]["recName"];
            var sendXML = xmlHeader+"<cmd  type=\"LocalPlay\">";
            sendXML += "<ip>" + serverIp + "</ip>" + "<fileName>" + recName + "</fileName>";
            sendXML = sendXML + "</cmd>";
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        }else{
            var recType =  recGrid.wbGrid("getRowByIndex",filePreNextCtrl.currentIndex)["data"]["recType"];
            var startNum =  recGrid.wbGrid("getRowByIndex",filePreNextCtrl.currentIndex)["data"]["startNum"];
            var endNum =  recGrid.wbGrid("getRowByIndex",filePreNextCtrl.currentIndex)["data"]["endNum"];

            var sendXML = xmlHeader+"<cmd  type=\"SDRecPlay\">";
            sendXML += "<recType>" + recType + "</recType>" + "<startSecond>" + startNum + "</startSecond>" + "<endSecond>" + endNum + "</endSecond>";
            sendXML = sendXML + "</cmd>";
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        }

        RecModule.setPlayStatusTip("");
        PlaySpeedCtrl.value = 1;
        if(!initVoiceFlag){
            RecVoiceCtrl.init();
        }
        RecVoiceCtrl.on();
        if(!initWatermarkFlag){
            WatermarkCtrl.init("off");
        }
        WatermarkCtrl.setStatus("off");
        RecPlayStatusCtrl.setStatus("PLAY", false);
        $("#full_screen").removeClass("disabled");

    },
    nextFile: function(){
        var recGrid = $('#recGrid');
        var selectRow = recGrid.wbGrid("getSelectRows");

        if(selectRow != null){
            filePreNextCtrl.currentIndex = selectRow.index + 1;
            if(recGrid.wbGrid("getRowByIndex",filePreNextCtrl.currentIndex) == null){
                recGrid.wbGrid("selectRowByIndex",filePreNextCtrl.currentIndex -1);
            }else{
                recGrid.wbGrid("selectRowByIndex",filePreNextCtrl.currentIndex);
                if($(":radio[name=\"playRec\"]:checked").val() == "local"){
                    var recName =  recGrid.wbGrid("getRowByIndex",filePreNextCtrl.currentIndex)["data"]["recName"];
                    var sendXML = xmlHeader+"<cmd  type=\"LocalPlay\">";
                    sendXML += "<ip>" + serverIp + "</ip>" + "<fileName>" + recName + "</fileName>";
                    sendXML = sendXML + "</cmd>";
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                }else{
                    var recType =  recGrid.wbGrid("getRowByIndex",filePreNextCtrl.currentIndex)["data"]["recType"];
                    var startNum =  recGrid.wbGrid("getRowByIndex",filePreNextCtrl.currentIndex)["data"]["startNum"];
                    var endNum =  recGrid.wbGrid("getRowByIndex",filePreNextCtrl.currentIndex)["data"]["endNum"];

                    var sendXML = xmlHeader+"<cmd  type=\"SDRecPlay\">";
                    sendXML += "<recType>" + recType + "</recType>" + "<startSecond>" + startNum + "</startSecond>" + "<endSecond>" + endNum + "</endSecond>";
                    sendXML = sendXML + "</cmd>";
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                }

                RecModule.setPlayStatusTip("");
                PlaySpeedCtrl.value = 1;
                if(!initVoiceFlag){
                    RecVoiceCtrl.init();
                }
                RecVoiceCtrl.on();
                if(!initWatermarkFlag){
                    WatermarkCtrl.init("off");
                }
                WatermarkCtrl.setStatus("off");
                RecPlayStatusCtrl.setStatus("PLAY", false);
                $("#full_screen").removeClass("disabled");
            }
        }else{
            recGrid.wbGrid("selectRowByIndex",filePreNextCtrl.currentIndex);
        }

    }
};

var SDRecModule = {
    getSdCardStatus: function() {
        /*window.top.showLoading();*/
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetSdCardStatus",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                   /* window.top.hideLoading();*/
                    var status = $("config>sdCardInfo>status",result).text();
                    if(status === "no card"){
                        $("#searchRec").addClass("disabled").attr("disabled","disabled");
                        window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("noCard"), null);
                    }else if(status === "formatting"){
                        $("#searchRec").addClass("disabled").attr("disabled","disabled");
                        window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("formatting"), null);
                    }else if(status === "popup"){
                        $("#searchRec").addClass("disabled").attr("disabled","disabled");
                        window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("popup"), null);
                    }else if(status === "normal"){
                        var year = $("#recCalendar").wbDatePicker("get","yyyy");
                        var month = ($("#recCalendar").wbDatePicker("get","M")*1 +1) > 9 ? ($("#recCalendar").wbDatePicker("get","M")*1 +1) : ("0" +($("#recCalendar").wbDatePicker("get","M")*1 +1));
                        SDRecModule.getDatesCondition(year,month);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    initComponent:function(status){
        $("#recCalendar").wbDatePicker({
            displayMode: $.DATEPICKER_DISPLAY_MODE_INNER,
            highlightWeekEnd: false,
            lang: LangCtrl.getLang(),
            skin: {
                containerCss: "calendar_container",
                readonlyCss: "calendar_readonly",
                dateContainerCss: "calendar_date_container",
                dateHeaderCss: "calendar_date_header",
                dateRowOddCss: "calendar_date_row_odd",
                dateRowEvenCss: "calendar_date_row_even",
                dateCellCss: "calendar_date_cell",
                dateCellSelectedCss: "calendar_date_cell_selected",
                dateOtherMonthCss: "calendar_date_other_month"
            },
            callback: {
                onMonthChanged: function (datePicker, oldValue, newValue, year) {
                    var year = $("#calendar").wbDatePicker("get", "yyyy");
                    var month = ($("#calendar").wbDatePicker("get", "M") + 1) > 9 ? ($("#calendar").wbDatePicker("get", "M") + 1) : ("0" + ($("#calendar").wbDatePicker("get", "M") + 1));
                    SDRecModule.getDatesCondition(year, month);
                },
                onYearChanged: function (datePicker, oldValue, newValue) {
                    var month = ($("#calendar").wbDatePicker("get", "M") + 1);
                    var month = ($("#calendar").wbDatePicker("get", "M") + 1) > 9 ? ($("#calendar").wbDatePicker("get", "M") + 1) : ("0" + ($("#calendar").wbDatePicker("get", "M") + 1));
                    SDRecModule.getDatesCondition(newValue, month);
                }
            }
        });
        if(status === "no card"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("noCard"), null);
        }else if(status === "formatting"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("formatting"), null);
        }else if(status === "popup"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("popup"), null);
        }else if(status === "normal"){
            var year = $("#calendar").wbDatePicker("get","yyyy");
            var month = ($("#calendar").wbDatePicker("get","M")*1 +1) > 9 ? ($("#calendar").wbDatePicker("get","M")*1 +1) : ("0" +($("#calendar").wbDatePicker("get","M")*1 +1));
            SDRecModule.getDatesCondition(year,month);
        }
    },
    getDatesCondition:function(year,month){
        var month = [year,month].join("-");
        var condition = xmlHeader+"<queryCondition>";
        condition += "<condition><month type=\"string\">" + month + "</month ></condition></queryCondition>";
        SDRecModule.GetDatesExistRecord(condition);
    },
    GetDatesExistRecord: function(condition){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetDatesExistRecord",
                type: "POST",
                async: true,
                data: condition,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    var periods =[];
                    localRecModule.maxSize =  $("config>maxSize",result).text();
                    $("config>date>item",result).each(function(index,ele){
                        var value = $(ele).text();
                        periods.push({start:value,end:value});
                    });
                    $("#recCalendar").wbDatePicker("setProperty",{
                        specialPeriods: [
                            {
                                skin: {
                                    dateCellCss: "specialDays", // 特殊日期单元格样式
                                    dateCellHoverCss: "", // 特殊日期单元格悬停样式
                                    dateCellSelectedCss: "selectDay" // 特殊日期单元格选中样式
                                },
                                periods: periods
                            }
                        ]
                    });
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    initCtrl: function(){
        $(".total > div").addClass("disabled");
        var format =  "hh:mm:ss";
        $("#startTime").timeInput({ format: format });
        $("#endTime").timeInput({ format: format,defaultValue:"23:59:59"});

        $('#recGrid').wbGrid({
            data: {
                colNames: ["id",LangCtrl._L_("recType"), LangCtrl._L_("startTime"), LangCtrl._L_("endTime"),"startNum","endNum"],
                colModel: [
                    { name: 'imgId', index: 'imgId',width: 80, align: "center",hidden:true, sortable: false },
                    { name: 'recType', index: 'recType',width: 80, align: "center", sortable: false },
                    { name: 'startTime', index: 'startTime',width: 80, align: "center", sortable: false },
                    { name: 'endTime', index: 'endTime',width: 80, align: "center", sortable: false },
                    { name: 'startNum', index: 'startNum',width: 80, align: "center",hidden:true, sortable: false },
                    { name: 'endNum', index: 'endNum',width: 80, align: "center", hidden:true , sortable: false }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            },
            callback: {
                onDblClickRow: function (e, gridId, rowIndex, rowData) {
                    var sendXML = xmlHeader+"<cmd  type=\"SDRecPlay\">";
                    sendXML += "<recType>" + rowData["recType"] + "</recType>" + "<startSecond>" + rowData["startNum"] + "</startSecond>" + "<endSecond>" + rowData["endNum"] + "</endSecond>";
                    sendXML = sendXML + "</cmd>";
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    RecModule.setPlayStatusTip("");
                    PlaySpeedCtrl.value = 1;
                    if(!initVoiceFlag){
                        RecVoiceCtrl.init();
                    }
                    if(!initWatermarkFlag){
                        WatermarkCtrl.init("off");
                    }
                    WatermarkCtrl.setStatus("off");
                    $("#full_screen").removeClass("disabled");
                    RecVoiceCtrl.on();
                    RecPlayStatusCtrl.setStatus("PLAY", false);
                }
            }
        });
        $("#recGridPage").wbPager({
            pageIndex: 1,
            pageDataCount: 10,
            dataCount: 0,
            lang: LangCtrl.getLang(),
            pageDataCountItems: [5,10],
            onPage: function (pagerId, pageIndex, pageDataCount) {
                commonRecModule.queryPageRecs(pageIndex,pageDataCount);
            }
        });

        commonRecModule.rowData = [];
        commonRecModule.doResize();
        $("#searchRec").unbind().click(SDRecModule.getData);
    },
    getSDRecData: function(){
        var date = $("#recCalendar").wbDatePicker("getWithFormat");
        var hour1 = $("#recStartTime").val();
        var hour2 = $("#recEndTime").val();
        var startTime = date + " " + hour1;
        var endTime = date + " " + hour2;

        if(Date.parse(startTime) > Date.parse(endTime)){
            ShowFloatError($("#showFloat"), LangCtrl._L_("tip"));
            return false;
        }
        var condition = xmlHeader+"<queryCondition>";
        condition += "<types><recType><enum>motion</enum><enum>sensor</enum><enum>off-line</enum></recType></types>";
        condition += "<condition>" +
        "<startTime type=\"string\">" + startTime + "</startTime>"+
        "<endTime type=\"string\">"  + endTime + "</endTime>"+
        "<recType type=\"recType\">";

        if($("#motion1").attr("checked") == "checked"){
            condition += "<item>motion</item>";
        }
        if($("#sensor1").attr("checked") == "checked"){
            condition += "<item>sensor</item>";
        }

        if($("#offLine").attr("checked") == "checked"){
            condition += "<item>off-line</item>";
        }
        if($("#tripwire").attr("checked") == "checked"){
            condition += "<item>tripwire</item>";
        }
        if($("#perimeter").attr("checked") == "checked"){
            condition += "<item>perimeter</item>";
        }
        if($("#osc").attr("checked") == "checked"){
            condition += "<item>osc</item>";
        }
        if($("#avd").attr("checked") == "checked"){
            condition += "<item>avd</item>";
        }

        condition = condition + "</recType>" + "</condition>" + "</queryCondition>";
        return condition;
    },
    getData: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetRecordInfo",
                type: "POST",
                async: true,
                data: SDRecModule.getSDRecData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    commonRecModule.rowData = [];
                    $("config > record > item", result).each(function(index,element){
                        var id = index;
                        var recType = LangCtrl._L_($(">recType",element).text());
                        var startTime =  $(">starttime",element).text().split(" ");
                        var endTime = $(">endtime",element).text().split(" ");
                        var startNum =  startTime[2];
                        var endNum = endTime[2];
                        var objectRec = {recId:id,recType:recType,startTime:[startTime[0],startTime[1]].join(" "),endTime:[endTime[0],endTime[1]].join(" "),startNum:startNum,endNum:endNum};
                        commonRecModule.rowData.push(objectRec);
                    });
                    $("#download").addClass("disabled");
                    $('#recGrid').wbGrid("load", commonRecModule.getRowData(1, $("#recGridPage").wbPager("getPageDataCount")));
                    $("#recGridPage").wbPager("setPageIndex", 1, false);
                    $("#recGridPage").wbPager("setDataCount", commonRecModule.rowData.length, false);

                    $("#fwPlay,#fwPause,#recStop,#bkSpeed,#fwSpeed,#nextFile,#lastFile,#full_screen").addClass("disabled");
                    $("#Audio").removeClass("off").removeClass("on").addClass("disabled");
                    $("#Audio>b").removeClass("off").removeClass("on").addClass("disable");
                    $(".sound_line").removeClass("off").addClass("disabled");
                    $(".sound_thumb").removeClass("off").addClass("disabled");
                    $("#watermark").removeClass("on off").addClass("disabled");
                    if(initVoiceFlag){
                        $("#AudioBar").slider("setProperty","enable",false);
                    }
                    try{
                        var sendXML = OCX_XML_SetPlayStatus("STOP");
                        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    }catch (e){}
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    queryPageImages: function(pageIndex,pageSize){
        localRecModule.emptyList();
        $("#bigImg").hide();
        var condition = xmlHeader+"<queryCondition>";
        condition += "<condition>" +
            "<pageIndex>" + pageIndex  + "</pageIndex>" +
            "<pageSize>" + pageSize  + "</pageSize>" +
            "</condition>" + "</queryCondition>";

        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetImagesPage",
                type: "POST",
                async: true,
                data: condition,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    var rowData = [];
                    $("config > images > item", result).each(function(index,element){
                        var id = index;
                        var eventType = $(">imgType",element).text() === "sensor" ? LangCtrl._L_("sensor") : LangCtrl._L_("motion");
                        var imgTime = $(">time",element).text();
                        var fileName = $(">fileName",element).text();
                        var imgUrl = "../Css/Pictures/Snap/" + fileName;
                        var objectImage = {imgId:id,eventType:eventType,imgTime:imgTime,fileName:fileName,imgUrl:imgUrl};
                        rowData.push(objectImage);
                    });
                    $('#imgGrid').wbGrid("load",rowData);
                    $("#imgGridPage").wbPager("setDataCount", $("config>images",result).attr("total") * 1, false);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    queryOneImage: function(pageIndex,imageIndex,pageSize,imgObject){
        var condition = xmlHeader+"<queryCondition>";
        condition += "<condition>" +
            "<pageIndex>" + pageIndex  + "</pageIndex>" +
            "<imageIndex>" + imageIndex  + "</imageIndex>" +
            "<pageSize>" + pageSize  + "</pageSize>" +
            "</condition>" + "</queryCondition>";

        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetOneImage",
                type: "POST",
                async: true,
                data: condition,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        localRecModule.appendImgList(imgObject.id,imgObject.url,imgObject.name);
                    }else{
                        ShowFloatError($("#searchPhoto"), LangCtrl._L_("failedLoad"), { left: 15 });
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));
    if ($("statenotify[type=\"RecPlayEnd\"]", $xmlDoc).length > 0 || $("statenotify[type=\"FileIsBad\"]", $xmlDoc).length > 0) {
        $("#fwPlay,#fwPause,#recStop,#bkSpeed,#fwSpeed,#full_screen").addClass("disabled");
        $("#Audio").removeClass("off").removeClass("on").addClass("disabled");
        $("#watermark").removeClass("off on").addClass("disabled");
        $("#AudioBar").slider("setProperty","enable", false);
        RecModule.setPlayStatusTip("");
        $("#playStatusIcon").removeAttr("class");
//        $("#fwPlay").removeClass("disabled");
    }
    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        //设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var id = "";
        // 设置模式
        var sendXML = OCX_XML_SetPreViewModel("Fixed");
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        var sendXML = OCX_XML_SetRecLoginInfo(username, password, serverIp, netPort, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }
}

function recResize() {
    commonRecModule.doResize();
}

//图片搜索代码
var imgPublicMethod = {
    accAdd : function(arg1,arg2){//浮点加减运算
        var r1,r2,m;
        try{r1=arg1.toString().split(".")[1].length}catch(e){r1=0}
        try{r2=arg2.toString().split(".")[1].length}catch(e){r2=0}
        m=Math.pow(10,Math.max(r1,r2));
        return (arg1*m+arg2*m)/m;
    },
    IsContain:function(arr,value){ //判断数组里有没有包含已经存在id一样的对象
        for(var i= 0,len = arr.length;i< len;i++)
        {
            var id1 = arr[i]["id"],id2 = value["id"];
            if(id1 == id2)
                return true;
        }
        return false;
    },
    removeImgObject: function(arr,id){ //对元数组根据对象id移除对象
        for(var i= 0,len = arr.length;i< len;i++)
        {
            var id1 = arr[i]["id"];
            if(id1 == id){
                arr.splice(i,1);
                return true;
            }
        }
        return false;
    },
    slideImgArr: function(arr,id){ //重新返回一个轮询的图片数组
        for(var i= 0,len = arr.length;i< len;i++){
            var startId = arr[i]["id"];
            if(startId == id){
                return arr.slice(i);
            }
        }
    }
};

var photoCloseCtrl = {
    init: function(){
        $("#close").click(function(){
            if($(this).hasClass("disabled")){
                return false;
            }
            photoCloseCtrl.closeShow();
        });
        $("#closeAll").click(function(){
            if($(this).hasClass("disabled")){
                return false;
            }
            photoCloseCtrl.closeAll();
        });
    },
    closeShow: function(){
        zoomSize = 1;
        var that  = $("#imgList > div.selected");
        if(that.hasClass("selected")){
            var id = that[0]["id"].split("_")[1];
            imgPublicMethod.removeImgObject(imgSelectArr,id);
            that.remove();
        }
        $("#bigImg").hide();
        if(imgSelectArr.length == 0){
            $("#close,#closeAll,#save,#saveAll,#actualSize,#properSize,#zoomIn,#zoomOut,#slideShow,#stop").addClass("disabled");
        }else{
            $("#close,#save,#actualSize,#properSize,#zoomIn,#zoomOut,#slideShow,#stop").addClass("disabled");
        }

        $("#showSpeedSlider").slider("setProperty", "enable", false);
    },
    closeAll: function(){
        zoomSize = 1;
        $("#imgList > div").remove();
        $(".total > div").addClass("disabled");
        $("#showSpeedSlider").slider("setProperty", "enable", false);
        $("#bigImg").hide();
        imgSelectArr = [];
    }
};

var photoSaveCtrl = {
    init : function(){
        $("#save").click(function(){
            if($(this).hasClass("disabled")){
                return false;
            }
            photoSaveCtrl.saveImg();
        });
        $("#saveAll").click(function(){
            if($(this).hasClass("disabled")){
                return false;
            }
            photoSaveCtrl.saveAll();
        });
    },
    saveImg: function(){
        var that  = $("#imgList > div.selected");
        var fileName = "";
        if(that.hasClass("selected")){
            fileName =  $(that).attr("title").split(".")[0];
            $("#img").attr("value",fileName);
        }
        //fileName = fileName + "\0";
        $("#downImage").attr("action",serverBase + "/DownloadImage/");
        $("#downImage").submit();
    },
    saveAll: function(){
        var fileName = "";
        if(imgSelectArr.length > 1){
            for(var i= 0,len = imgSelectArr.length; i< len; i++ ) {
                fileName = fileName + imgSelectArr[i]["name"].split(".")[0] + "$";
            }
        }else{
            fileName =  fileName + imgSelectArr[0]["name"].split(".")[0];
        }
        //fileName = fileName + "\0";
        $("#img").attr("value",fileName);
        $("#downImage").attr("action",serverBase + "/DownloadImage/");
        $("#downImage").submit();
    }
};

var timeoutId;
var slideShowImgCtrl = {
    curIndex:0,
    init: function(){
        $("#slideShow").click(function(){
            if($(this).hasClass("disabled")){
                return false;
            }
            $("#close,#closeAll,#save,#saveAll,#actualSize,#properSize,#zoomIn,#zoomOut,#slideShow").addClass("disabled");
            $("#stop").removeClass("disabled");
            slideShowImgCtrl.slideShow();
        });
        $("#stop").click(function(){
            if($(this).hasClass("disabled")){
                return false;
            }
            $("#stop").addClass("disabled");
            $("#close,#closeAll,#save,#saveAll,#actualSize,#properSize,#zoomIn,#zoomOut,#slideShow").removeClass("disabled");
            slideShowImgCtrl.stopSlideShow();
        });
    },
    changeImg: function(){
        if (slideShowImgCtrl.curIndex == slideImg.length-1) {
            slideShowImgCtrl.curIndex = 0;
            clearTimeout(timeoutId);
            $("#stop").addClass("disabled");
            $("#close,#closeAll,#save,#saveAll,#actualSize,#properSize,#zoomIn,#zoomOut,#slideShow").removeClass("disabled");
        } else {
            slideShowImgCtrl.curIndex += 1;
            $("#bigImg").attr("src",slideImg[slideShowImgCtrl.curIndex]["url"]).show();
            $("#imgList > div").removeClass("selected");
            $("#img_" + slideImg[slideShowImgCtrl.curIndex]["id"]).addClass("selected");
            timeoutId = setTimeout(slideShowImgCtrl.changeImg,timeInterval);
        }
    },
    slideShow: function(){
        zoomSize = 1;
        var that  = $("#imgList > div.selected");
        if(that.hasClass("selected")){
            var id = that[0]["id"].split("_")[1];
            slideImg = imgPublicMethod.slideImgArr(imgSelectArr,id);
        }
        timeoutId = setTimeout(slideShowImgCtrl.changeImg,timeInterval);
    },
    stopSlideShow: function(){
        zoomSize = 1;
        slideShowImgCtrl.curIndex = 0;
        clearTimeout(timeoutId);
    }
};

var photoSizeCtrl = {
    wh: "0:0",
    changeWH: function(wh) {
        autoSize();
        $("#hack").html("1111");
        var divBigImg_w = $("#divBigImg").width();
        var divBigImg_h = $("#divBigImg").height();
        switch (wh) {
            case "1:1A":

                if(ogr_w/ogr_h >=divBigImg_w/divBigImg_h){
                    var w = divBigImg_w;
                    var h = divBigImg_w*ogr_h/ogr_w;
                    var top = (divBigImg_h - h)/2;
                    var left = 0;
                    $("#divImg").css({
                        top:top + "px",
                        left:left + "px",
                        width:w+"px",
                        height:h+"px"
                    });
                    $("#bigImg").css({top:"0px",left:"0px",height:h+"px",width:w+"px"});
                }
                else{
                    var h = divBigImg_h - 40;
                    var w = divBigImg_h * ogr_w /ogr_h;
                    var top = 20;
                    var left = (divBigImg_w - w)/2;
                    $("#divImg").css({
                        top:top + "px",
                        left:left + "px",
                        width:w+"px",
                        height:h+"px"
                    });
                    $("#bigImg").css({top:"0px",left:"0px",height:h+"px",width:w+"px"});
                }
                break;

            case "1:1":
                var top = (divBigImg_h - ogr_h)/2;
                var left = (divBigImg_w - ogr_w)/2;
                var divImgW = divBigImg_w < ogr_w ? divBigImg_w : ogr_w;
                var divImgLeft,bigImgLeft;
                if(left<0){
                    divImgLeft = 0;
                    bigImgLeft = left;
                }else{
                    divImgLeft = left;
                    bigImgLeft = 0;
                }
                if(top < 0){
                    top = $("#divImg").height()/2 - $("#bigImg").height() /2;
                    $("#divImg").css({
                        position:"absolute",
                        top:"0px",
                        left:divImgLeft + "px",
                        width:divImgW+"px",
                        height:divBigImg_h+"px"
                    });
                    $("#bigImg").css({
                        position:"absolute",
                        top:top + "px",
                        left:bigImgLeft+"px",
                        cursor:"move"
                    });
                }else{
                    $("#divImg").css({
                        position:"absolute",
                        top:top + "px",
                        left:divImgLeft + "px",
                        width:divImgW+"px",
                        height:ogr_h+"px"
                    });
                    $("#bigImg").css({ top: "0px",  left:"0px",cursor:"default"});
                }
                break;
        }
        this.wh = wh;
    },
    init: function() {
        $("#properSize").click(function() {
            if($(this).hasClass("disabled")){
                return false;
            }
            zoomSize = 1;

            var omg = new Image();
            omg.src =  $("#bigImg").attr("src");
            ogr_w = omg.width;
            ogr_h = omg.height;

            $(window.top).unbind("resize", photoResize);
            $("#bigImg").css({
                position:"absolute",
                width:"100%",
                height:"100%"
            });
            photoSizeCtrl.changeWH("1:1A");
            $(window.top).bind("resize", photoResize);
        });
        $("#actualSize").click(function() {
            if($(this).hasClass("disabled")){
                return false;
            }
            zoomSize = 1;
            $(window.top).unbind("resize", photoResize);

            var omg = new Image();
            omg.src =  $("#bigImg").attr("src");
            ogr_w = omg.width;
            ogr_h = omg.height;

            $("#bigImg").css({
                position:"absolute",
                width:ogr_w+"px",
                height:ogr_h+"px"
            });
            photoSizeCtrl.changeWH("1:1");
            $(window.top).bind("resize", photoResize);

        });
    },
    dragStart: function (e, mPostion, dragObj, helper) {
        $(helper.parent()).css("z-index", maxZIndex++);
        $("body").disableSelection();
    },
    dragStop: function (e, mPostion, dragObj) {
        $(dragObj).css("z-index", maxZIndex++);
        $("body").enableSelection();
    },
    dragging: function (e, mPostion, dragObj, helper) {
        var helperBorder = helper.parent();
        var $layoutBorder = $("#divImg");
        var pos = helperBorder.position();
        var bw = $layoutBorder.width();
        var bh = $layoutBorder.height();
        var w = helper.width(), h = helper.height();
        //越界判断
        if(pos.left <= 0 && (pos.left + w) >= bw){
            helperBorder.css({ "left":  pos.left + "px"});
        }else if(pos.left > 0){
            helperBorder.css({ "left": "0px" });
        }else if((pos.left + w) < bw){
            helperBorder.css({ "left": (bw-w) + "px" });
        }
        if(pos.top <= 0 && (pos.top + h) >= bh  ){
            helperBorder.css({ "top":  pos.top + "px"});
        }else if(pos.top > 0){
            helperBorder.css({ "top": "0px" });
        }else if((pos.top + h) < bh){
            helperBorder.css({ "top": (bh-h) + "px" });
        }
    }
};

var zoomSize = 1;      //图片长宽比,放大倍数
var photoZoomCtrl = {
    init: function(){
        $("#zoomOut").click(function(){
            if($(this).hasClass("disabled")){
                return false;
            }
            photoZoomCtrl.zoomOut();
        });
        $("#zoomIn").click(function(){
            if($(this).hasClass("disabled")){
                return false;
            }
            photoZoomCtrl.zoomIn();
        });
    },
    zoomOut: function(){
        var bigImg = $("#bigImg");
        if(zoomSize < 1 || zoomSize >=2) return false;
        zoomSize = imgPublicMethod.accAdd(zoomSize,0.1);
        var centerX = $("#divImg").width()/2 , centerY = $("#divImg").height()/2;
        var top = Math.round(centerY - bigImg.height() * zoomSize /2);
        var left = Math.round(centerX - bigImg.width() * zoomSize /2);
        var bigImgW = bigImg.width() * zoomSize;
        var bigImgH = bigImg.height() * zoomSize;
        bigImg.css({top:top+"px",left:left+"px",width:Math.round(bigImgW) +"px",height:Math.round(bigImgH) + "px"});
    },
    zoomIn:function(){
        var bigImg = $("#bigImg");
        var centerX = $("#divImg").width()/2 , centerY = $("#divImg").height()/2;

        var top = Math.round(centerY -  bigImg.height() / (zoomSize * 2) );
        var left = Math.round(centerX -  bigImg.width() / (zoomSize * 2));
        var bigImgW = bigImg.width() / zoomSize;
        var bigImgH = bigImg.height() / zoomSize;

        $("#bigImg").css({top:top+"px",left:left+"px",width:Math.round(bigImgW) +"px",height:Math.round(bigImgH) + "px"});
        if(zoomSize <= 1) return false;
        zoomSize = imgPublicMethod.accAdd(zoomSize,-0.1);
    }
};

var imgMgrModule = {
    sdCardStatus:"",
    maxSize:20,
    init: function(){

        if(NetLiveMonitor != undefined){
            var sendXML = OCX_XML_SetPlayStatus("STOP");
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        }

        $("#fwPlay,#fwPause,#recStop,#bkSpeed,#fwSpeed,#lastFile,#nextFile,#full_screen").addClass("disabled");
        $("#Audio").removeClass("off").removeClass("on").addClass("disabled");
        $("#watermark").removeClass("off").removeClass("on").addClass("disabled");
        $("#playStatusIcon").removeAttr("class");
        RecModule.setPlayStatusTip("");
        PlaySpeedCtrl.setEnable(false);
        imgMgrModule.initCtrl();
        imgMgrModule.initComponent();

        //判断显示图片搜索功能
        getDeviceInfo(function(result){
            if ($("config>deviceInfo>supportPea", result).text() == "false") {
                $("#eventTripwire").hide();
                $("#eventPerimeter").hide();
            }
            if ($("config>deviceInfo>supportOsc", result).text() == "false") {
                $("#eventOsc").hide();
            }
            if ($("config>deviceInfo>supportAvd", result).text() == "false") {
                $("#eventAvd").hide();
                $("#eventVloss").hide();
            }
            if ($("config>deviceInfo>supportVfd ", result).text() == "false") {
//            $("#mu_imgMgr").hide();
            }
            if ($("config>deviceInfo>alarmInCount", result).text()*1 < 1) {
                $("#divSensor").hide();
            }
        });



        imgMgrModule.getSdCardStatus();
        imgMgrModule.doResize();

        //防止拖动image打开新浏览器窗口
        $("body").bind("dragstart",function(){return false});
        photoCloseCtrl.init();
        photoSaveCtrl.init();
        photoSizeCtrl.init();
        photoZoomCtrl.init();
        slideShowImgCtrl.init();
        $("#Content",window.top.document).css({"min-width":"1442px","min-height":"600px"});
        $(window.top).resize(photoResize);
    },
    doResize: function(){
        var height = $(".third").height();
        if(0 == height) {
            setTimeout("imgMgrModule.doResize()", 20);
            return;
        }
        $("#imgGrid").wbGrid("setHeight",height -40);
//        $(window.top).resize(function () {
//            $("#imgGrid").wbGrid("setHeight", height -40);
//        });
    },
    getSdCardStatus: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetSdCardStatus",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
					imgMgrModule.sdCardStatus = $("config>sdCardInfo>status",result).text();
                    if(imgMgrModule.sdCardStatus === "no card"){
                        $("#searchPhoto").addClass("disabled").attr("disabled","disabled");
                        window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("noCard"), null);
                    }else if(imgMgrModule.sdCardStatus === "formatting"){
                        $("#searchPhoto").addClass("disabled").attr("disabled","disabled");
                        window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("formatting"), null);
                    }else if(imgMgrModule.sdCardStatus === "popup"){
                        $("#searchPhoto").addClass("disabled").attr("disabled","disabled");
                        window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("popup"), null);
                    }else if(imgMgrModule.sdCardStatus === "normal"){
                        var year = $("#calendar").wbDatePicker("get","yyyy");
                        var month = ($("#calendar").wbDatePicker("get","M")*1 +1) > 9 ? ($("#calendar").wbDatePicker("get","M")*1 +1) : ("0" +($("#calendar").wbDatePicker("get","M")*1 +1));
                        imgMgrModule.getDatesCondition(year,month);
                    }
                    imgMgrModule.initComponent();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    initComponent:function(){
        $("#calendar").wbDatePicker({
            displayMode: $.DATEPICKER_DISPLAY_MODE_INNER,
            highlightWeekEnd: false,
            lang: LangCtrl.getLang(),
            skin: {
                containerCss: "calendar_container",
                readonlyCss: "calendar_readonly",
                dateContainerCss: "calendar_date_container",
                dateHeaderCss: "calendar_date_header",
                dateRowOddCss: "calendar_date_row_odd",
                dateRowEvenCss: "calendar_date_row_even",
                dateCellCss: "calendar_date_cell",
                dateCellSelectedCss: "calendar_date_cell_selected",
                dateOtherMonthCss: "calendar_date_other_month"
            },
            callback:{
                onMonthChanged: function(datePicker, oldValue, newValue,year) {
                    var year = $("#calendar").wbDatePicker("get","yyyy");
                    var month = ($("#calendar").wbDatePicker("get","M") +1) > 9 ? ($("#calendar").wbDatePicker("get","M") +1) : ("0" +($("#calendar").wbDatePicker("get","M") +1));
                    imgMgrModule.getDatesCondition(year,month);
                },
                onYearChanged: function(datePicker, oldValue, newValue) {
                    var month = ($("#calendar").wbDatePicker("get","M") +1);
                    var month = ($("#calendar").wbDatePicker("get","M") +1) > 9 ? ($("#calendar").wbDatePicker("get","M") +1) : ("0" +($("#calendar").wbDatePicker("get","M") +1));
                    imgMgrModule.getDatesCondition(newValue,month);
                },
//                onPicked: function(datePicker, oldValue, newValue){
//                    imgMgrModule.getDatesCondition();
//                }
                onTodayClicked: function(datePicker) {
                    var year = $("#calendar").wbDatePicker("get","yyyy");
                    var month = ($("#calendar").wbDatePicker("get","M")*1 +1) > 9 ? ($("#calendar").wbDatePicker("get","M")*1 +1) : ("0" +($("#calendar").wbDatePicker("get","M")*1 +1));
                    imgMgrModule.getDatesCondition(year,month);
                }
            }
        });
    },
    getDatesCondition:function(year,month){
		var month = [year,month].join("-");
        var condition = xmlHeader+"<queryCondition>";
        condition += "<condition><month type=\"string\">" + month + "</month ></condition></queryCondition>";
        imgMgrModule.getDatesExistImage(condition);
    },
    getDatesExistImage: function(condition){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetDatesExistImage",
                type: "POST",
                async: true,
                data: condition,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    var periods =[];
                    imgMgrModule.maxSize =  $("config>maxSize",result).text();
                    $("config>date>item",result).each(function(index,ele){
                        var value = $(ele).text();
                        periods.push({start:value,end:value});
                    });

                    $("#calendar").wbDatePicker("setProperty",{
                        specialPeriods: [
                            {
                                skin: {
                                    dateCellCss: "specialDays", // 特殊日期单元格样式
                                    dateCellHoverCss: "", // 特殊日期单元格悬停样式
                                    dateCellSelectedCss: "selectDay" // 特殊日期单元格选中样式
                                },
                                periods: periods
                            }
                        ]
                    });

                    window.top.hideLoading();
                }
            });

        }
        catch (ex) {
            alert(ex);
        }
    },
    initCtrl: function(){
        $(".total > div").addClass("disabled");
        var format =  "hh:mm:ss";
        $("#startTime").timeInput({ format: format });
        $("#endTime").timeInput({ format: format,defaultValue:"23:59:59"});

        $('#imgGrid').wbGrid({
            data: {
                colNames: ["id",LangCtrl._L_("eventType"), LangCtrl._L_("imgTime"), LangCtrl._L_("fileName"),"imgUrl"],
                colModel: [
                    { name: 'imgId', index: 'imgId',width: 80, align: "center",hidden:true, sortable: false },
                    { name: 'eventType', index: 'eventType',width: 80, align: "center", sortable: false },
                    { name: 'imgTime', index: 'imgTime',width: 80, align: "center", sortable: false },
                    { name: 'fileName', index: 'fileName',width: 80, align: "center", sortable: false },
                    { name: 'imgUrl', index: 'imgUrl',width: 80, align: "center",hidden:true, sortable: false }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            },
            callback: {
                onClickRow: function (e, gridId, rowIndex, rowData) {
                    var imgId =  rowData["imgId"];
                    var url = rowData["imgUrl"];
                    var imgName = rowData["fileName"];

                    var pagesImg = $("#imgGridPage");
                    var pageIndex = pagesImg.wbPager("getPageIndex");
                    var pageSize = pagesImg.wbPager("getPageDataCount");

                    imgObject = {"id":imgId,"url": url,"name": imgName};
                    if(!imgPublicMethod.IsContain(imgSelectArr,imgObject)){
                        imgMgrModule.queryOneImage(pageIndex,imgId,pageSize,imgObject);
                    }else{
                        $("#imgList > div").removeClass("selected");
                        $("#img_"+imgId).addClass("selected");
                        $("#bigImg").attr({src:url}).show();
                    }
                    $("#close,#closeAll,#save,#saveAll,#actualSize,#properSize,#zoomIn,#zoomOut,#slideShow").removeClass("disabled");
                    $("#showSpeedSlider").slider("setProperty", "enable", true);
                    photoSizeCtrl.changeWH("1:1A");
                    zoomSize = 1;
                }
            }
        });

        $("#imgGridPage").wbPager({
            pageIndex: 1,
            pageDataCount: 10,
            dataCount: 0,
            lang: LangCtrl.getLang(),
            pageDataCountItems: [5,10],
            onPage: function (pagerId, pageIndex, pageDataCount) {
                $("#close,#closeAll,#save,#saveAll,#actualSize,#properSize,#zoomIn,#zoomOut,#slideShow").addClass("disabled");
                if($('#imgGrid').wbGrid("getRowDatas").length > 1){
                    imgMgrModule.queryPageImages(pageIndex,pageDataCount);
                }
            }
        });

        $("#showSpeedSlider").slider({
            minValue: 1,
            maxValue: 11,
            maxWidth: 100,
            enable:false,
            thumbCss: "slider_thumb_1",
            valueChangeEvent: function(value) {
                timeInterval = (value/2) * 1000;
                $("#valueShow").val(value/2+"S");
            },
            buildTip:function(value){
                return value/2 + "s";
            }
        });

        $("#bigImg").wbDragable({
            appendTo: "parent",
            dragThumb: '',
            helperOpacity: false,
            dragStart: photoSizeCtrl.dragStart,
            dragStop: photoSizeCtrl.dragStop,
            draging: photoSizeCtrl.dragging
        });

        $("#searchPhoto").unbind().click(imgMgrModule.getData);

    },
    appendImgList:function(imgId,url,imgName){
        imgObject = {"id":imgId,"url": url,"name": imgName};

        var d = document.getElementById('dvCompute');
        d.innerHTML = imgName;
        var  averageLen = d.offsetWidth / (imgName.length);
        var indexStr = Math.floor(70 / averageLen);
        var imageName =  d.offsetWidth > 75 ? (imgName.substr(0, indexStr) + "...") : imgName;

        if(imgSelectArr.length != 0){
            if(!imgPublicMethod.IsContain(imgSelectArr,imgObject)){
                imgSelectArr.push(imgObject);
                var imgDiv = $("<div id=\"img_" + imgId + "\" class=\"img\"  style='display: inline-block' title=\"" + imgName + "\">" +
                    "<img class='showImg' src=\"" + url + "\">" +
                    "<div class='imgName' style='width: 75px;font-size: 14px'>" + imageName + "</div>" +
                    "</div>").bind("click",function(){
                    zoomSize = 1;
                    $("#imgList > div").removeClass("selected");
                    $(this).addClass("selected");
                    $("#close,#closeAll,#save,#saveAll,#actualSize,#properSize,#zoomIn,#zoomOut,#slideShow").removeClass("disabled");
                    $("#showSpeedSlider").slider("setProperty", "enable", true);
                    photoSizeCtrl.changeWH("1:1A");
                    $("#bigImg").attr({src:url}).show();
                });

                $("#imgList > div").removeClass("selected");
                imgDiv.addClass("selected").appendTo($("#imgList"));
                $("#imgList").scrollLeft(imgDiv.width() * imgSelectArr.length);

                $("#bigImg").attr({src:url}).show();
            }else{
                $("#imgList > div").removeClass("selected");
                $("#img_" + imgId).addClass("selected");
                $("#bigImg").attr({src:url}).show();
            }
        }else{
            imgSelectArr.push(imgObject);
            var imgDiv = $("<div id=\"img_" + imgId + "\" class=\"img\"  style='display: inline-block' title=\"" + imgName + "\">" +
                "<img class='showImg' src=\"" + url + "\">" +
                "<div class='imgName'  style='width: 75px;font-size: 14px'>" + imageName + "</div>" +
                "</div>").bind("click",function(){
                zoomSize = 1;
                $("#imgList > div").removeClass("selected");
                $(this).addClass("selected");
                $("#close,#closeAll,#save,#saveAll,#actualSize,#properSize,#zoomIn,#zoomOut,#slideShow").removeClass("disabled");
                $("#showSpeedSlider").slider("setProperty", "enable", true);
                photoSizeCtrl.changeWH("1:1A");
                $("#bigImg").attr({src:url}).show();
            });

            $("#imgList > div").removeClass("selected");
            imgDiv.addClass("selected").appendTo($("#imgList"));
            imgDiv.appendTo($("#imgList"));

            $("#bigImg").attr({src:url}).show();
        }
    },
    emptyList: function(){
        $("#imgList").empty();
        imgSelectArr = [];
    },
    GetImagesData: function(){
        var date = $("#calendar").wbDatePicker("getWithFormat");
        var hour1 = $("#startTime").val();
        var hour2 = $("#endTime").val();
        var startTime = date + " " + hour1;
        var endTime = date + " " + hour2;

        if(Date.parse(startTime) > Date.parse(endTime)){
            ShowFloatError($("#showImgFloat"), LangCtrl._L_("tip"));
            return false;
        }
        var pagesImg = $("#imgGridPage");
        var pageSize = pagesImg.wbPager("getPageDataCount");
        var condition = xmlHeader+"<queryCondition>";
        condition += "<types><imgType><enum>motion</enum><enum>sensor</enum></imgType></types>";
        condition += "<condition>" +
            "<startTime type=\"string\">" + startTime + "</startTime>"+
            "<endTime type=\"string\">"  + endTime + "</endTime>"+
            "<pageIndex>1</pageIndex>" +
            "<pageSize>" + pageSize  + "</pageSize>" +
            "<imgTypes type=\"imgType\">";

        if($("#motion").attr("checked") == "checked"){
            condition += "<item>motion</item>";
        }
        if($("#sensor").attr("checked") == "checked"){
            condition += "<item>sensor</item>";
        }

        if($("#vloss").attr("checked") == "checked"){
            condition += "<item>vloss</item>";
        }
        if($("#tripwire").attr("checked") == "checked"){
            condition += "<item>tripwire</item>";
        }
        if($("#perimeter").attr("checked") == "checked"){
            condition += "<item>perimeter</item>";
        }
        if($("#osc").attr("checked") == "checked"){
            condition += "<item>osc</item>";
        }
        if($("#avd").attr("checked") == "checked"){
            condition += "<item>avd</item>";
        }

        condition = condition + "</imgTypes>" + "</condition>" + "</queryCondition>";
        return condition;
    },
    getData: function(){
        imgMgrModule.emptyList();
        $("#bigImg").hide();
        $("#close,#closeAll,#save,#saveAll,#actualSize,#properSize,#zoomIn,#zoomOut,#slideShow").addClass("disabled");
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetImages",
                type: "POST",
                async: true,
                data: imgMgrModule.GetImagesData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {

                    if( $("config", result).attr("status") === "failed"){
                        if(imgMgrModule.sdCardStatus === "no card"){
                            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("noCard"), null);
                        }else{
                            window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("searchFailed"), null);
                        }
                    }else{
                        var rowData = [];
                        $("config > images > item", result).each(function(index,element){
                            var id = index;
                            var imageType = $(">imgType",element).text();
                            var eventType = imageType === "sensor" ? LangCtrl._L_("sensor") : imageType === "motion" ? LangCtrl._L_("motion") : imageType === "vloss" ? LangCtrl._L_("vloss") :  imageType === "tripwire" ?  LangCtrl._L_("tripwire") : imageType === "perimeter" ?  LangCtrl._L_("perimeter") : imageType === "osc" ?  LangCtrl._L_("osc") :  LangCtrl._L_("avd");
                            var imgTime = $(">time",element).text();
                            var fileName = $(">fileName",element).text();
                            var imgUrl = "../Css/Pictures/Snap/" + fileName;
                            var objectImage = {imgId:id,eventType:eventType,imgTime:imgTime,fileName:fileName,imgUrl:imgUrl};
                            rowData.push(objectImage);
                        });
                        $('#imgGrid').wbGrid("load",rowData);
                        $("#imgGridPage").wbPager("setPageIndex", 1, false);
                        $("#imgGridPage").wbPager("setDataCount", $("config>images",result).attr("total") * 1, false);
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    queryPageImages: function(pageIndex,pageSize){
        ClearFloatError();
        imgMgrModule.emptyList();
        $("#bigImg").hide();
        var condition = xmlHeader+"<queryCondition>";
        condition += "<condition>" +
            "<pageIndex>" + pageIndex  + "</pageIndex>" +
            "<pageSize>" + pageSize  + "</pageSize>" +
            "</condition>" + "</queryCondition>";

        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetImagesPage",
                type: "POST",
                async: true,
                data: condition,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    var rowData = [];
                    $("config > images > item", result).each(function(index,element){
                        var id = index;
                        var eventType = $(">imgType",element).text() === "sensor" ? LangCtrl._L_("sensor") : LangCtrl._L_("motion");
                        var imgTime = $(">time",element).text();
                        var fileName = $(">fileName",element).text();
                        var imgUrl = "../Css/Pictures/Snap/" + fileName;
                        var objectImage = {imgId:id,eventType:eventType,imgTime:imgTime,fileName:fileName,imgUrl:imgUrl};
                        rowData.push(objectImage);
                    });
                    $('#imgGrid').wbGrid("load",rowData);
                    $("#imgGridPage").wbPager("setDataCount", $("config>images",result).attr("total") * 1, false);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    queryOneImage: function(pageIndex,imageIndex,pageSize,imgObject){
        var condition = xmlHeader+"<queryCondition>";
        condition += "<condition>" +
            "<pageIndex>" + pageIndex  + "</pageIndex>" +
            "<imageIndex>" + imageIndex  + "</imageIndex>" +
            "<pageSize>" + pageSize  + "</pageSize>" +
            "</condition>" + "</queryCondition>";

        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetOneImage",
                type: "POST",
                async: true,
                data: condition,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        imgMgrModule.appendImgList(imgObject.id,imgObject.url,imgObject.name);
                    }else{
                        ShowFloatError($("#searchPhoto"), LangCtrl._L_("failedLoad"), { left: 15 });
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

function photoResize() {
    imgMgrModule.doResize();
    photoSizeCtrl.changeWH(photoSizeCtrl.wh);
}

$(window.top).resize(autoSize);

