//Windows插件
var ClientPluVer = "1,1,5,7";
var ClientPluMimeType = "application/np-ipcamera-plugin";
var ClientPluDownLoadPath = webBase + "OCX/NetIPCamera.exe";
var ClientPluClassId = "2CC323D2-B580-4543-B2CB-C3B08C90D848";

//MAC插件
var ClientPluVer_MAC = "1,0,5,1";
var ClientPluMimeType_MAC = "application/x-ipcamera";
var ClientPluDownLoadPath_MAC = webBase + "OCX/ipcamera.pkg";


/**
* 
*/
var OCX_XML_Header = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>";

//获取“设置OCX模式”的XML命令字符串
//para: Interactive(交互模式)/ReadOnly(只读模式)
function OCX_XML_SetPreViewModel(model) {
    var result = OCX_XML_Header + "<cmd type=\"SetPreViewModel\">";
    result += model;
    result += "</cmd>";
    return result;
}

//获取“设置OCX模式”的XML命令字符串
//para: Interactive(交互模式)/Fixed
function OCX_XML_SetRecModel(model) {
    var result = OCX_XML_Header + "<cmd type=\"SetRecModel\">";
    result += model;
    result += "</cmd>";
    return result;
}

//获取“设置登录信息”的XML命令字符串
function OCX_XML_SetLoginInfo(username, pwd, ip, port, id) {
    var result = OCX_XML_Header + "<cmd type=\"SetLoginInfo\">";
    result += "<username>" + username + "</username>";
    result += "<password>" + pwd + "</password>";
    result += "<ip>" + ip + "</ip>";
    result += "<port>" + port + "</port>";
    result += "<id>" + id + "</id>";
    result += "</cmd>";
    return result;
}

//获取“设置登录信息”的XML命令字符串
function OCX_XML_SetUpgradeLoginInfo(username, pwd, ip, port, id) {
    var result = OCX_XML_Header + "<cmd type=\"SetUpgradeLoginInfo\">";
    result += "<username>" + username + "</username>";
    result += "<password>" + pwd + "</password>";
    result += "<ip>" + ip + "</ip>";
    result += "<port>" + port + "</port>";
    result += "<id>" + id + "</id>";
    result += "</cmd>";
    return result;
}


//获取“设置登录信息”的XML命令字符串
function OCX_XML_SetRecLoginInfo(username, pwd, ip, port, id) {
    var result = OCX_XML_Header + "<cmd type=\"SetRecLoginInfo\">";
    result += "<username>" + username + "</username>";
    result += "<password>" + pwd + "</password>";
    result += "<ip>" + ip + "</ip>";
    result += "<port>" + port + "</port>";
    result += "<id>" + id + "</id>";
    result += "</cmd>";
    return result;
}

//获取“设置当前选中通道ID”的XML命令字符串
function OCX_XML_SetViewChannelID(chlId) {
    var result = OCX_XML_Header + "<cmd type=\"SetViewChannelId\">";
    result += "<item>" + chlId + "</item>";
    result += "</cmd>";
    return result;
}

//获取“设置当前选中设备ID”的XML命令字符串
function OCX_XML_SetViewEquipmentID(chlId) {
    var result = OCX_XML_Header + "<cmd type=\"SetViewEquipmentId\">";
    result += "<item>" + chlId + "</item>";
    result += "</cmd>";
    return result;
}

//退出OCX
function OCX_XML_Leave() {
    return OCX_XML_Header + "<cmd type=\"Leave\"/>";
}

//请求巡航线预置点的命令
function OCX_XML_RequestPresetCruise(chlId) {
    var result = OCX_XML_Header + "<cmd type=\"RequestPresetCruise\">";
    result += "<item>" + chlId + "</item>";
    result += "</cmd>";
    return result;
}

//获取“云台控制”的XML命令字符串
function OCX_XML_PTZ_Control(action, speed, chlID) {
    var result = OCX_XML_Header + "<cmd type=\"PtzCtrl\">";
    /*
    * action可选值：ECMS_PTZ_LEFT_UP，ECMS_PTZ_UP，ECMS_PTZ_RIGHT_UP
    * ，ECMS_PTZ_LEFT，ECMS_PTZ_STOP_CRUISE，ECMS_PTZ_RIGHT，ECMS_PTZ_LEFT_DOWN
    * ，ECMS_PTZ_RIGHT，ECMS_PTZ_LEFT_DOWN，ECMS_PTZ_DOWN，ECMS_PTZ_RIGHT_DOWN
    * ，ECMS_PTZ_FOCUS_NEAR，ECMS_PTZ_FOCUS_FAR，ECMS_PTZ_ZOOM_IN，ECMS_PTZ_ZOOM_OUT
    * ，ECMS_PTZ_IRIS_CLOSE，ECMS_PTZ_IRIS_OPEN，ECMS_PTZ_STOP_MOVE
    */
    result += "<action>" + action + "</action>";
    result += "<speed>" + speed + "</speed>";
    result += "<chlId>" + chlID + "</chlId>";
    result += "</cmd>";
    return result;
}

//获取“预置点调用，保存位置”的XML命令字符串
function OCX_XML_Preset_Control(preset_index, action, speed, chlID) {
    var result = OCX_XML_Header + "<cmd type=\"PtzPreset\">";
    result += "<presetIndex>" + preset_index + "</presetIndex>";
    result += "<speed>" + speed + "</speed>";
    result += "<chlId>" + chlID + "</chlId>";
    /*
    * action可选值：ECMS_PTZ_CONTROL_PRESETGO，ECMS_PTZ_CONTROL_PRESETSET
    */
    result += "<action>" + action + "</action>";
    result += "</cmd>";
    return result;
}

//获取“巡航线调用，巡航线停止”的XML命令字符串
function OCX_XML_Cruise_Control(cruise_index, action, speed, chlID) {
    var result = OCX_XML_Header + "<cmd type=\"PtzCruise\">";
    result += "<cruiseIndex>" + cruise_index + "</cruiseIndex>";
    result += "<speed>" + speed + "</speed>";
    result += "<chlId>" + chlID + "</chlId>";
    /*
    * action可选值：ECMS_PTZ_CONTROL_PRESETGO，ECMS_PTZ_CONTROL_PRESETSET
    */
    result += "<action>" + action + "</action>";
    result += "</cmd>";
    return result;
}

//获取“设置移动侦测区域操作类型”的XML命令字符串
function OCX_XML_SetMotionAreaAction(action) {
    var result = OCX_XML_Header + "<cmd type=\"SetMotionAreaAction\">";
    /*
    * action可选值：ADD，DEL,ALL,NONE,INVERSE
    */
    result += action;
    result += "</cmd>";
    return result;
}

//获取“查询选中的移动侦测区域”的XML命令字符串
function OCX_XML_GetMotionArea() {
    var result = OCX_XML_Header + "<request type=\"GetMotionArea\"/>";
    return result;
}

//获取“预置点调用，保存位置”的XML命令字符串
function OCX_XML_SetImage(chlID, brightness, contrast, saturation, hue) {
    var result = OCX_XML_Header + "<cmd type=\"SetImage\">";
    result += "<chlId>" + chlID + "</chlId>";
    if (brightness != -1)
        result += "<brightness>" + brightness + "</brightness>";
    if (contrast != -1)
        result += "<contrast>" + contrast + "</contrast>";
    if (saturation != -1)
        result += "<saturation>" + saturation + "</saturation>";
    if (hue != -1)
        result += "<hue>" + hue + "</hue>";
    result += "</cmd>";
    return result;
}

//获取“设置码流模式”的XML命令字符串
function OCX_XML_SetStreamType(index) {
    var result = OCX_XML_Header + "<cmd type=\"SetStreamType\">";
    result += index;
    result += "</cmd>";
    return result;
}

function OCX_XML_LiveSwitch(status) {
    var result = OCX_XML_Header + "<cmd type=\"LiveSwitch\">";
    result += status;
    result += "</cmd>";
    return result;
}

function OCX_XML_TalkSwitch(status) {
    var result = OCX_XML_Header + "<cmd type=\"TalkSwitch\">";
    result += status;
    result += "</cmd>";
    return result;
}

function OCX_XML_RecSwitch(status) {
    var result = OCX_XML_Header + "<cmd type=\"RecSwitch\">";
    result += status;
    result += "</cmd>";
    return result;
}

function OCX_XML_3dSwitch(status) {
    var result = OCX_XML_Header + "<cmd type=\"3dSwitch\">";
    result += status;
    result += "</cmd>";
    return result;
}

function OCX_XML_Watermark(status) {
    var result = OCX_XML_Header + "<cmd type=\"Watermark\">";
    result += status;
    result += "</cmd>";
    return result;
}

function OCX_XML_MagnifyImg() {
    var result = OCX_XML_Header + "<cmd type=\"MagnifyImg\"></cmd>";
    return result;
}

function OCX_XML_MinifyImg() {
    var result = OCX_XML_Header + "<cmd type=\"MinifyImg\"></cmd>";
    return result;
}

function OCX_XML_SetVolume(value) {
    var result = OCX_XML_Header + "<cmd type=\"SetVolume\">";
    result += value;
    result += "</cmd>";
    return result;
}

function OCX_XML_SetRecVolume(value) {
    var result = OCX_XML_Header + "<cmd type=\"SetRecVolume\">";
    result += value;
    result += "</cmd>";
    return result;
}

function OCX_XML_IpcTakePhoto() {
    var result = OCX_XML_Header + "<cmd type=\"IpcTakePhoto\"></cmd>";
    return result;
}

//获取“查询OCX版本号”的XML命令字符串
function OCX_XML_GetOcxVersion() {
    var result = OCX_XML_Header + "<request type=\"GetOcxVersion\"/>";
    return result;
}

function OCX_XML_FullScreen() {
    var result = OCX_XML_Header + "<cmd type=\"FullScreen\">";
    result += "</cmd>";
    return result;
}

//获取“设置视频显示比例”的XML命令字符串
function OCX_XML_SetViewRatio(value) {
    var result = OCX_XML_Header + "<cmd type=\"SetViewRatio\">";
    result += value;
    result += "</cmd>";
    return result;
}

function OCX_XML_SetLang(value) {
    var result = OCX_XML_Header + "<cmd type=\"SetLang\">";
    result += value;
    result += "</cmd>";
    return result;
}

//打开文件选择窗口
function OCX_XML_OpenFileBrowser(mode) {
    var result = OCX_XML_Header + "<request type=\"OpenFileBrowser\">";
    result += mode;
    result += "</request>";
    return result;
}

//解析文件路径
function OCX_XML_OpenFileBrowser_getpath(xmlStr) {
    var $xmlDoc = $(XMLStr2XMLDoc(xmlStr));
    return $("response[type='OpenFileBrowser']", $xmlDoc).text();
}

//获取“查询本地配置”的XML命令字符串
function OCX_XML_GetLocalCfg() {
    var result = OCX_XML_Header + "<request type=\"GetLocalCfg\"/>";
    return result;
}

//获取“查询本地路径权限”的XML命令字符串
function OCX_XML_GetLocalPathLimit(url1,url2) {
    var result = OCX_XML_Header + "<request type=\"GetLocalPathLimit\">";
    result += "  <liveSnapSavePath><![CDATA[" + url1 + "]]></liveSnapSavePath>";
    result += "  <recSavePath><![CDATA[" + url2 + "]]></recSavePath>";
    result += "</request>";
    return result;
}

//获取“设置本地配置”的XML命令字符串
function OCX_XML_SetLocalCfg(livePerformance,recVolume, liveSnapSavePath, recSavePath) {
    var result = OCX_XML_Header + "<cmd type=\"SetLocalCfg\">";
    result += "  <livePerformance>" + livePerformance + "</livePerformance>";
    result += "  <recVolume>" + recVolume + "</recVolume>";
    result += "  <liveSnapSavePath><![CDATA[" + liveSnapSavePath + "]]></liveSnapSavePath>";
    result += "  <recSavePath><![CDATA[" + recSavePath + "]]></recSavePath>";
    result += "</cmd>";
    return result;
}

//设置视频遮挡区域
function OCX_XML_SetMaskArea(masks) {
    var result = OCX_XML_Header + "<cmd type=\"SetMaskArea\" singleton=\"true\">";
    for (var i = 0, len = masks.length; i < len; i++) {
        result += "<item id=\"" + masks[i]["id"] + "\"  X1=\"" + masks[i]["rectangle"]["X1"] + "\" Y1=\"" + masks[i]["rectangle"]["Y1"] + "\" X2=\"" + masks[i]["rectangle"]["X2"] + "\" Y2=\"" + masks[i]["rectangle"]["Y2"] + "\">";
        result += "</item>";
    }
    result += "</cmd>";
    return result;
}

//设置ROI区域
function OCX_XML_SetROIArea(element){
    var result = OCX_XML_Header + "<cmd type=\"SetROIArea\">";
    for (var i = 0, len = element.length; i < len; i++) {
        result += "<item id=\"" + element[i]["id"] + "\"  X1=\"" + element[i]["rectangle"]["X1"] + "\" Y1=\"" + element[i]["rectangle"]["Y1"] + "\" X2=\"" + element[i]["rectangle"]["X2"] + "\" Y2=\"" + element[i]["rectangle"]["Y2"] + "\">";
        result += "</item>";
    }
    result += "</cmd>";
    return result;
}

//设置视频遮挡区域的动作（EDIT_ON,EDIT_OFF,NONE）
function OCX_XML_SetMaskAreaAction(action) {
    var result = OCX_XML_Header + "<cmd type=\"SetMaskAreaAction\">";
    result += action;
    result += "</cmd>";
    return result;
}

//设置ROI区域的动作（EDIT_ON,EDIT_OFF,NONE）
function OCX_XML_SetROIAreaAction(action) {
    var result = OCX_XML_Header + "<cmd type=\"SetROIAreaAction\">";
    result += action;
    result += "</cmd>";
    return result;
}

//获取活动的视频遮挡区域
function OCX_XML_GetMaskArea() {
    var result = OCX_XML_Header + "<request type=\"GetMaskArea\"/>";
    return result;
}

//获取ROI区域
function OCX_XML_GetROIArea() {
    var result = OCX_XML_Header + "<request type=\"GetROIArea\"/>";
    return result;
}

//获取OSD显示信息
function OCX_XML_GetOSDInfo(osd) {
    var result = OCX_XML_Header + "<request type=\"GetOSDInfo\"/>";
    return result;
}

//设置OSD显示信息
function OCX_XML_SetOSDInfo(osd) {
    var result = OCX_XML_Header + "<cmd type=\"SetOSDInfo\">";
    if (osd["timeStamp"]) {
        result += "<timeStamp>";
        for (var key in osd["timeStamp"]) {
            result += "<" + key + ">" + osd["timeStamp"][key] + "</" + key + ">";
        }
        result += "</timeStamp>";
    }
    if (osd["deviceName"]) {
        result += "<deviceName>";
        for (var key in osd["deviceName"]) {
            result += "<" + key + ">" + osd["deviceName"][key] + "</" + key + ">";
        }
        result += "</deviceName>";
    }
    if (osd["textOverlay"] && osd["textOverlay"].length > 0) {
        result += "<textOverlay>";
        for (var i = 0, len = osd["textOverlay"].length; i < len; i++) {
            result += "<item id=\"" + osd["textOverlay"][i]["id"] + "\">";
            for (var key in osd["textOverlay"][i]) {
                if (key != "id") {
                    result += "<" + key + ">" + osd["textOverlay"][i][key] + "</" + key + ">";
                }
            }
            result += "</item>";
        }
        result += "</textOverlay>";
    }
    result += "</cmd>";
    return result;
}

//设置移动侦测区域的动作
function OCX_XML_SetMotionAreaAction(action) {
    var result = OCX_XML_Header + "<cmd type=\"SetMotionAreaAction\">";
    result += action;
    result += "</cmd>";
    return result;
}

//设置移动侦测区域
function OCX_XML_SetMotionArea(motion) {
    var result = OCX_XML_Header + "<cmd type=\"SetMotionArea\">";
    result += "<column>" + motion["column"] + "</column>";
    result += "<row>" + motion["row"] + "</row>";
    result += "<areaInfo>";
    for (var i = 0, len = motion["areaInfo"].length; i < len; i++) {
        result += "<item>" + motion["areaInfo"][i] + "</item>";
    }
    result += "</areaInfo>";
    result += "</cmd>";
    return result;
}

//获取移动侦测区域
function OCX_XML_GetMotionArea(motion) {
    var result = OCX_XML_Header + "<request type=\"GetMotionArea\"/>";
    return result;
}

function getChromeNPAPIDisableNotice(downLoadUrl) {
    var pluginNotice = "<div style=\"padding:10px 0px 0px 10px; color:#fff;\">";
    if (LangCtrl.getLang() == "zh-cn") {
        pluginNotice += "NPAPI插件已禁用，请进行如下设置来启用：" +
            "<ul>" +
            "    <li>1.在地址栏输入\"chrome://flags/#enable-npapi\"；</li>" +
            "    <li>2.点击“启用NPAPI”下的启用按钮；</li>" +
            "    <li>3.关闭所有Chrome；</li>" +
            "    <li>4.重新打开Chrome并访问本系统，插件即可使用。</li>" +
            "</ul>" +
            "或者插件没有安装，请点击<a href='" + downLoadUrl + "'>这里</a>下载并安装插件。 安装时请关闭浏览器！";
    }
    else {
        pluginNotice += "NPAPI Support is currently disabled. Please follow the instructions below to enable it:" +
            "<ul>" +
            "    <li>1.Input \"chrome://flags/#enable-npapi\" into address bar;</li>" +
            "    <li>2.Click 'Enable' under the 'Enable Npapi';</li>" +
            "    <li>3.Close the Chrome browser completely;</li>" +
            "    <li>4.Reopen the Chrome and navigate to the system, the plugin is available.</li>" +
            "</ul>" +
            "Or the plugin is not installed, please click <a href='" + downLoadUrl + "'>Here</a> to download and install. Before installation, please close your browser.";
    }
    pluginNotice += "</div>";
    return pluginNotice;
}

function getPluginNotice(downLoadUrl) {
    var pluginNotice = "<div class='pluginNotic'>";
    if (LangCtrl.getLang() == "zh-cn") {
        pluginNotice += "插件没有安装，请点击<a href='" + downLoadUrl + "'>这里</a>下载并安装插件。 安装时请关闭浏览器！";
    }
    else {
        pluginNotice += "The plugin is not installed, please click <a href='" + downLoadUrl + "'>Here</a> to download and install. Before installation, please close your browser.";
    }
    pluginNotice += "</div>";
    return pluginNotice;
}

function getSafariPluginNotice(downLoadUrl) {
    var pluginNotice = "<div class='pluginNotic'>";
    if (LangCtrl.getLang() == "zh-cn") {
        pluginNotice += "插件没有安装，请点击<a href='" + downLoadUrl + "'>这里</a>下载并安装插件。 安装时请关闭浏览器！";
        pluginNotice += "<br/>如果您已安装了插件，请在“Safari->偏好设置->安全性”检查插件是否被禁用。";
    }
    else {
        pluginNotice += "The plugin is not installed, please click <a href='" + downLoadUrl + "'>Here</a> to download and install. Before installation, please close your browser.";
        pluginNotice += "<br/>If you have installed plugin, please check if the plugin is disabled at \"Safari->Preferences->Security\".";
    }
    pluginNotice += "</div>";
    return pluginNotice;
}

/*
 *	加载OCX
 contentId：控件容器ID
 objectId：控件ID
 */
function LoadPlugin(contentId,objectId) {
    var $content = $("#" + contentId);
    var ocx = null;
    var osType = detectOS();
    switch (osType) {
        case "Windows":
            ocx = LoadWinPlugin($content, objectId, ClientPluMimeType, ClientPluVer, ClientPluClassId, ClientPluDownLoadPath);
            break;
        case "Mac":
            ocx = LoadMacPlugin($content, objectId, ClientPluMimeType_MAC, ClientPluVer_MAC, ClientPluDownLoadPath_MAC);
            break;
        default:
            alert("The plugin don't support current operating system!");
    }
    return ocx;
}

/*
加载OCX
contentId：OCX容器Id
return：OCX对象
*/
function LoadWinPlugin($content, objectId, mimeTypeString, newPluginVer, classid, downLoadUrl) {
    var ocx = null;
    var browserType = detectBrowser();

    if (browserType == "IE") {// IE
        var needUpate = true;

        try{
            ocx = window.document.createElement("object");
            ocx.classid = "CLSID:" + classid;
            ocx.id = objectId;
            ocx.width = "100%";
            ocx.height = "100%";
        }catch(e){
        }
        if ("QueryInfo" in ocx) {
            var sendXML = OCX_XML_GetOcxVersion();
            var returnXML = "";
            try{
                returnXML = ocx.QueryInfo(sendXML, sendXML.length);
            }
            catch(e){

            }
            var $xmlDoc = $("response[type='GetOcxVersion']", $(XMLStr2XMLDoc(returnXML)));
            if ($xmlDoc.length > 0) {
                var intCurVer = $xmlDoc.text();
                if (compareOcxVersion(intCurVer, newPluginVer) >= 0) {
                    needUpate = false;
                }
            }
        }

        if (needUpate) {
            if ($(".pluginNotic", $content).length == 0) {
                $content.html(getPluginNotice(downLoadUrl));
                $(".pluginNotic").css("padding-top", (($content.height() - $(".pluginNotic").height()) / 2) + "px");
            }
            return;
        }
        else {
            $content.append(ocx);
            $("#divLoginOCX").width(0).height(0);
        }
    }
    else {// 非IE
        var needUpate = true;
        var mimetype = navigator.mimeTypes[mimeTypeString];
        if (mimetype) {
            $content.html("<object id='NetLiveMonitor' type='application/np-ipcamera-plugin' style='width: 100%;height: 100%;'></object>");
            ocx = document.getElementById(objectId);
            var intCurVer = ocx.version;
            if (compareOcxVersion(intCurVer, newPluginVer) >= 0) {
                needUpate = false;
            }
        }else{
            //Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/42.0.2311.135 Safari/537.36
            if (browserType == "Chrome") {
                var versionParts = navigator.userAgent.toLowerCase().match(/\schrome\/(.+)\s/i);
                if (versionParts && versionParts.length > 1) {
                    var versionArr = versionParts[1].split(".");
                    if (versionArr[0] >= 42) {//chrome 42版本以上默认屏蔽NPAPI插件
                        $content.html(getChromeNPAPIDisableNotice(downLoadUrl));
                        $(".pluginNotic", $content).css("padding-top", "10px");
                        return;
                    }
                }
            }
        }

        if (needUpate) {
            if ($(".pluginNotic", $content).length == 0) {
                $content.html(getPluginNotice(downLoadUrl));
                $(".pluginNotic").css("padding-top", (($content.height() - $(".pluginNotic").height()) / 2) + "px");
            }
            return;
        }
    }
    $.cookie("ocxVersion",newPluginVer);
    $("#divLoginOCX").width(0).height(0);
    return ocx;
}

//加载MAC平台的插件
function LoadMacPlugin($content, objectId, mimeTypeString, newPluginVer, downLoadUrl) {
    var ocx = null;
    var browserType = detectBrowser();
    if (browserType == "safari") {// safari
        var needUpate = true;
        $content.html("<embed id='" + objectId + "' style='width: 0;height: 100%;' type='" + mimeTypeString + "'></embed>");
        ocx = document.getElementById(objectId);
        if ("QueryInfo" in ocx) {
            var sendXML = OCX_XML_GetOcxVersion();
            var returnXML = ocx.QueryInfo(sendXML, sendXML.length);
            var $xmlDoc = $("response[type='GetOcxVersion']", $(XMLStr2XMLDoc(returnXML)));
            if ($xmlDoc.length > 0) {
                var intCurVer = $xmlDoc.text();
                if (compareOcxVersion(intCurVer, newPluginVer) >= 0) {
                    needUpate = false;
                    $(ocx).width('100%');
                }
            }
        }

        if (needUpate) {
            if ($(".pluginNotic", $content).length == 0) {
                $(ocx).hide();
                $content.append($(getSafariPluginNotice(downLoadUrl)));
                $(".pluginNotic", $content).css("padding-top", (($content.height() - $(".pluginNotic").height()) / 2) + "px");
            }
            return;
        }
    }
    else {
        alert("The plugin don't support current browser!");
    }
    return ocx;
}

function compareOcxVersion(ver1, ver2) {
    var var1Arr = ver1.split(',');
    var var2Arr = ver2.split(',');
    for (var i = 0; i < var1Arr.length; i++) {
        if (var1Arr[i] * 1 > var2Arr[i] * 1) {
            return 1;
        }
        else if (var1Arr[i] * 1 == var2Arr[i] * 1) {
            continue;
        }
        else {
            return -1;
        }
    }
    return 0;
}

//轨迹
function OCX_XML_TraceSwitch(status) {
    var result = OCX_XML_Header + "<cmd type=\"TraceSwitch\">";
    result += status;
    result += "</cmd>";
    return result;
}

//自动扫描
function OCX_XML_ScanSwitch(status) {
    var result = OCX_XML_Header + "<cmd type=\"ScanSwitch\">";
    result += status;
    result += "</cmd>";
    return result;
}

//雨刷
function OCX_XML_WiperSwitch(status) {
    var result = OCX_XML_Header + "<cmd type=\"WiperSwitch\">";
    result += status;
    result += "</cmd>";
    return result;
}

//灯光
function OCX_XML_LightSwitch(status) {
    var result = OCX_XML_Header + "<cmd type=\"LightSwitch\">";
    result += status;
    result += "</cmd>";
    return result;
}


//获取物品看护
function OCX_XML_GetOscArea() {
    var result = OCX_XML_Header + "<request type=\"GetOscArea\"/>";
    return result;
}

//获取区域入侵
function OCX_XML_GetPeaArea() {
    var result = OCX_XML_Header + "<request type=\"GetPeaArea\"/>";
    return result;
}

//获取越界侦测
function OCX_XML_GetTripwireLine() {
    var result = OCX_XML_Header + "<request type=\"GetTripwireLine\"/>";
    return result;
}

//获取人脸检测
function OCX_XML_GetVfd() {
    var result = OCX_XML_Header + "<request type=\"GetVfd\"/>";
    return result;
}

//物品看护
function OCX_XML_SetOscArea(array) {
    var result = OCX_XML_Header + "<cmd type=\"SetOscArea\">";
    result += "<points>";
    for (var i = 0, len = array.length; i < len; i++) {
        result += "<item X=\"" + array[i]["X"] + "\" Y=\"" + array[i]["Y"] + "\"/>";
    }
    result += "</points>";
    result += "</cmd>";
    return result;
}

//区域入侵检测
function OCX_XML_SetPeaArea(array) {
    var result = OCX_XML_Header + "<cmd type=\"SetPeaArea\">";
    result += "<points>";
    for (var i = 0, len = array.length; i < len; i++) {
        result += "<item X=\"" + array[i]["X"] + "\" Y=\"" + array[i]["Y"] + "\"/>";
    }
    result += "</points>";
    result += "</cmd>";
    return result;
}

//越界检测
function OCX_XML_SetTripwireArea(array) {
    var result = OCX_XML_Header + "<cmd type=\"SetTripwireLine\">";
    result += "<points>";
    for (var i = 0, len = array.length; i < len; i++) {
        result += "<item X=\"" + array[i]["X"] + "\" Y=\"" + array[i]["Y"] + "\"/>";
    }
    result += "</points>";
    result += "</cmd>";
    return result;
}

//人脸检测
function OCX_XML_SetVfdArea(array) {
    var result = OCX_XML_Header + "<cmd type=\"SetVfd\">";
    result += "<points>";
    for (var i = 0, len = array.length; i < len; i++) {
        result += "<item X=\"" + array[i]["X"] + "\" Y=\"" + array[i]["Y"] + "\"/>";
    }
    result += "</points>";
    result += "</cmd>";
    return result;
}

//清除OCX上的数据(type:SetOscAreaAction/SetPeaAreaAction/SetTripwireLineAction
// action:EDIT_ON,EDIT_OFF,NONE)
function OCX_XML_SetAreaAction(type,action) {
    var result = OCX_XML_Header + "<cmd type=\"" + type + "\">";
    result += action;
    result += "</cmd>";
    return result;
}

//设置预览缓存值
function OCX_XML_SetBufferTime(value){
    var result = OCX_XML_Header + "<cmd type=\"SetBufferTime\">" + value + "</cmd>";
    return result;
}

//播放下一帧
function OCX_XML_PlayNextFrame() {
    return OCX_XML_Header + "<cmd type=\"RecNextFrame\"/>";
}

//播放上一帧
function OCX_XML_RecPreFrame() {
    return OCX_XML_Header + "<cmd type=\"RecPreFrame\"/>";
}

//获取“停止预览”的XML命令字符串
//ALL/CURRENT/int<!--窗口编号-->
function OCX_XML_StopPreview(screenIndex) {
    var result = OCX_XML_Header + "<cmd type=\"StopPreview\">";
    result += screenIndex;
    result += "</cmd>";
    return result;
}

//设置播放状态
function OCX_XML_SetPlayStatus(status) {
    var result = OCX_XML_Header + "<cmd type=\"RecPlayStatus\">";
    result += status;
    result += "</cmd>";
    return result;
}
//设置播放倍速
function OCX_XML_SetPlaySpeed(speed) {
    var result = OCX_XML_Header + "<cmd type=\"RecPlaySpeed\">";
    result += speed;
    result += "</cmd>";
    return result;
}
//获取PC的MAC地址
function OCX_XML_GetMac(ip,port) {
    var result = OCX_XML_Header + "<request type=\"GetMac\">";
    result += "  <ip><![CDATA[" + ip + "]]></ip>";
    result += "  <port><![CDATA[" + port + "]]></port>";
    result += "</request>";
    return result;
}

//设置升级文件
function OCX_XML_SetUpgradePath(url) {
    var result = OCX_XML_Header + "<cmd type=\"SetUpgradePath\">";
    result += "  <upgradePath><![CDATA[" + url + "]]></upgradePath>";
    result += "</cmd>";
    return result;
}