var xmlDoc;
var dialogAddFtp;
var ftpXmlDoc;

$(function() {
    initControl();
    $("#divParent").tab({
        map: [{ "tab": "liPort", "content": "divPort", init: initPort },
			{ "tab": "liActiveConn", "content": "divActiveConn", init: initActiveConn },
			{ "tab": "liDDNS", "content": "divDDNS", init: initDDNS },
			{ "tab": "liSNMP", "content": "divSNMP", init: initSNMP },
			{ "tab": "liIEEE", "content": "divIEEE", init: initIEEE },
			{ "tab": "liRTSP", "content": "divRTSP", init: initRTSP },
			{ "tab": "liUPNP", "content": "divUPNP", init: initUPNP },
			{ "tab": "liEmail", "content": "divEmail", init: initEmail },
			{ "tab": "liFTP", "content": "divFTP", init: initFTP },
            { "tab": "liSpvmn", "content": "divSpvmn", init: initSpvmn },
        //			{ "tab": "liOnvif", "content": "divOnvif", init: initOnvif },
			{"tab": "liCloudStorage", "content": "divCloudStorage", init: initCloudStorage}]
    });
    getDeviceInfo(function(result) {
        xmlDoc = result;
        if($("config > deviceInfo > supportSpvmn ",result).text() != "true"){
            $("#liSpvmn").hide();
        }
    });

    $("#divParent").tab("selectLastTab");
    $("#Content",window.top.document).css({"min-width":"1050px"});
});

function initPort() {
    SNMPModule.modifyFlag1 = false;
    SNMPModule.modifyFlag2 = false;
    SNMPModule.modifyFlag3 = false;
    SNMPModule.modifyFlag4 = false;
    EmailModule.modifyFlag = false;
    DDNSModule.modifyFlag = false;
    $("#txtEmailPassword").unbind();
    window.parent.setConfigMiniHeight(0);
    $(".cfgfooter").css("width","320px");
    clearTab($("#divPort"));
    PortModule.getData();
}

function initActiveConn() {
    SNMPModule.modifyFlag1 = false;
    SNMPModule.modifyFlag2 = false;
    SNMPModule.modifyFlag3 = false;
    SNMPModule.modifyFlag4 = false;
    EmailModule.modifyFlag = false;
    DDNSModule.modifyFlag = false;
    $("#txtEmailPassword").unbind();
    window.parent.setConfigMiniHeight(0);
    $(".cfgfooter").css("width","360px");
    clearTab($("#divActiveConn"));
    ActiveConnModule.getData();
}

function initDDNS() {
    SNMPModule.modifyFlag1 = false;
    SNMPModule.modifyFlag2 = false;
    SNMPModule.modifyFlag3 = false;
    SNMPModule.modifyFlag4 = false;
    EmailModule.modifyFlag = false;
    $("#txtEmailPassword").unbind();
    window.parent.setConfigMiniHeight(0);
    $(".cfgfooter").css("width","350px");
    clearTab($("#divDDNS"));
    DDNSModule.getData();
}

function initSNMP() {
    EmailModule.modifyFlag = false;
    DDNSModule.modifyFlag = false;
    $("#txtEmailPassword").unbind();
    window.parent.setConfigMiniHeight(1150);
    $(".cfgfooter").css("width","400px");
    clearTab($("#divSNMP"));
    SNMPModule.getData();
}

function initIEEE() {
    SNMPModule.modifyFlag1 = false;
    SNMPModule.modifyFlag2 = false;
    SNMPModule.modifyFlag3 = false;
    SNMPModule.modifyFlag4 = false;
    EmailModule.modifyFlag = false;
    DDNSModule.modifyFlag = false;
    $("#txtEmailPassword").unbind();
    window.parent.setConfigMiniHeight(0);
    $(".cfgfooter").css("width","350px");
    clearTab($("#divIEEE"));
    IeeeModule.getData();
}

function initRTSP() {
    SNMPModule.modifyFlag1 = false;
    SNMPModule.modifyFlag2 = false;
    SNMPModule.modifyFlag3 = false;
    SNMPModule.modifyFlag4 = false;
    EmailModule.modifyFlag = false;
    DDNSModule.modifyFlag = false;
    $("#txtEmailPassword").unbind();
    window.parent.setConfigMiniHeight(0);
    $(".cfgfooter").css("width","380px");
    clearTab($("#divRTSP"));
    RTSPModule.getData();
}

function initUPNP() {
    SNMPModule.modifyFlag1 = false;
    SNMPModule.modifyFlag2 = false;
    SNMPModule.modifyFlag3 = false;
    SNMPModule.modifyFlag4 = false;
    EmailModule.modifyFlag = false;
    DDNSModule.modifyFlag = false;
    $("#txtEmailPassword").unbind();
    window.parent.setConfigMiniHeight(0);
    $(".cfgfooter").css("width","320px");
    clearTab($("#divUPNP"));
    UPnPModule.getData();
}

function initEmail() {
    SNMPModule.modifyFlag1 = false;
    SNMPModule.modifyFlag2 = false;
    SNMPModule.modifyFlag3 = false;
    SNMPModule.modifyFlag4 = false;
    DDNSModule.modifyFlag = false;
    window.parent.setConfigMiniHeight(800);
    $(".clearBtn").css({top:$(".cfgfooter").position().top + 15 + "px"})
    $(".cfgfooter").css("width","370px");
    clearTab($("#divEmail"));
    EmailModule.getData();
}

function initFTP() {
    SNMPModule.modifyFlag1 = false;
    SNMPModule.modifyFlag2 = false;
    SNMPModule.modifyFlag3 = false;
    SNMPModule.modifyFlag4 = false;
    EmailModule.modifyFlag = false;
    DDNSModule.modifyFlag = false;
    $("#txtEmailPassword").unbind();
    window.parent.setConfigMiniHeight(0);
    $(".cfgfooter").css("width","758px");
    clearTab($("#divFTP"));
    FTPModule.getData();
}

function initOnvif() {
    SNMPModule.modifyFlag1 = false;
    SNMPModule.modifyFlag2 = false;
    SNMPModule.modifyFlag3 = false;
    SNMPModule.modifyFlag4 = false;
    EmailModule.modifyFlag = false;
    DDNSModule.modifyFlag = false;
    window.parent.setConfigMiniHeight(0);
    clearTab($("#divOnvif"));
    OnvifModule.getData();
}

function initCloudStorage() {
    SNMPModule.modifyFlag1 = false;
    SNMPModule.modifyFlag2 = false;
    SNMPModule.modifyFlag3 = false;
    SNMPModule.modifyFlag4 = false;
    EmailModule.modifyFlag = false;
    DDNSModule.modifyFlag = false;
    window.parent.setConfigMiniHeight(0);
    $(".cfgfooter").css("width","340px");
    clearTab($("#divCloudStorage"));
    CloudStorageModule.getData();
}

function initSpvmn() {
    SNMPModule.modifyFlag1 = false;
    SNMPModule.modifyFlag2 = false;
    SNMPModule.modifyFlag3 = false;
    SNMPModule.modifyFlag4 = false;
    EmailModule.modifyFlag = false;
    DDNSModule.modifyFlag = false;
    window.parent.setConfigMiniHeight(0);
    $(".cfgfooter").css("width","320px");
    clearTab($("#divSpvmn"));
    SpvmnModule.initCtrl();
    SpvmnModule.getData();
}

var PortModule = {
    mapping: {
        txtHttpPort: "config>port>httpPort",
        txtDataPort: "config>port>netPort",
        txtRtspPort: "config>port>rtspPort"
    },
    initCtrl: function() {
        initNumberInput($("#txtHttpPort"), { minValue: 10, maxValue: 65535 });
        initNumberInput($("#txtDataPort"), { minValue: 10, maxValue: 65535 });
        initNumberInput($("#txtRtspPort"), { minValue: 10, maxValue: 65535 });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    XmlHttpClient.BindPageByXml(PortModule.mapping, xmlDoc);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    verification: function() {

        var httpPort = $("#txtHttpPort").val(), dataPort =  $("#txtDataPort").val(), rtspPort =  $("#txtRtspPort").val();
        if( httpPort * 1 == dataPort * 1 || httpPort * 1 == rtspPort * 1 || dataPort * 1 == rtspPort * 1){
            ShowFloatError($("#txtPortSame"), LangCtrl._L_("portSameResult"));
            return false;
        }

        if (XmlHttpClient.Verification("txtHttpPort", PortModule.mapping["txtHttpPort"], xmlDoc, LangCtrl._L_("portLimit"))) {
            return false;
        }
        if (XmlHttpClient.Verification("txtDataPort", PortModule.mapping["txtDataPort"], xmlDoc, LangCtrl._L_("portLimit"))) {
            return false;
        }
        if (XmlHttpClient.Verification("txtRtspPort", PortModule.mapping["txtRtspPort"], xmlDoc, LangCtrl._L_("portLimit"))) {
            return false;
        }
        return true;
    },
    setData: function() {
        if (!PortModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        var httpPort = $("#txtHttpPort").val(),xmlPort = $("config>port>httpPort",xmlDoc).text();
        if(httpPort === xmlPort){
            PortModule.msg = "";
            window.top.showLoading();
        }else{
            PortModule.msg = "changeHttpPortTip";
            window.top.showLoading(window.top.LangCtrl._L_(PortModule.msg));
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetPortConfig",
                type: "POST",
                async: true,
                data: XmlHttpClient.GetXmlByPage(PortModule.mapping, xmlDoc),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if($("config",result).attr("status") == "success"){
                        if(httpPort === xmlPort){
                            window.top.hideLoading();
                            window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("saveSuccess"), null);
                        }else{
                            PortModule.msg = "changeHttpPortTip";
                            window.top.showLoading(window.top.LangCtrl._L_(PortModule.msg));
                            window.top.location.href = "http://" + serverIp + ":"+httpPort;
                        }
                    }else{
                        window.top.hideLoading();
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("saveFailed"), null);
                    }

                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var SpvmnModule = {
    modifyFlag:false,
    mapping: {
        txtWSipserverPort: "config>spvmn>wSipserverPort",
        txtSipServerDomain: "config>spvmn>SipServerDomain",
        txtSipServerId: "config>spvmn>SipServerId",
        txtRegisterPasswd: "config>spvmn>RegisterPasswd",
        txtWSipIpcPort: "config>spvmn>wSipIpcPort",
        txtIpcId: "config>spvmn>IpcId",
        txtDeviceOwner: "config>spvmn>DeviceOwner",
        txtCivilCode: "config>spvmn>CivilCode",
        txtInstallAddress: "config>spvmn>InstallAddress"

    },
    toggle: function(disabled) {
        $("#txtDwServerIp").ipInput("setEnable", !disabled);
        $("#txtWSipserverPort").attr("disabled", disabled);
        $("#txtSipServerDomain").attr("disabled", disabled);
        $("#txtSipServerId").attr("disabled", disabled);
        $("#txtRegisterPasswd").attr("disabled", disabled);
        $("#txtWSipIpcPort").attr("disabled", disabled);
        $("#txtIpcId").attr("disabled", disabled);
        $("#txtDeviceOwner").attr("disabled", disabled);
        $("#txtCivilCode").attr("disabled", disabled);
        $("#txtInstallAddress").attr("disabled", disabled);
    },
    initCtrl: function() {
        $("#chkSpvmn").unbind().click(function() {
            var disabled = true;
            if ($("#chkSpvmn").attr("checked") == "checked") {
                disabled = false;
            }
            SpvmnModule.toggle(disabled);
        });
        initNumberInput($("#txtWSipserverPort"), { minValue: 10, maxValue: 65535 });
        initNumberInput($("#txtWSipIpcPort"), { minValue: 10, maxValue: 65535 });
        $("#txtDwServerIp").empty();
        $("#txtDwServerIp").ipInput();

        $("#txtRegisterPasswd").keydown(function(event){
            $(this).unbind();
            SpvmnModule.modifyFlag = true;
            $(this).val("");
            if(event.keyCode == 8){
                return false;
            }
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetSpvmnConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    XmlHttpClient.BindPageByXml(SpvmnModule.mapping, xmlDoc);
                    $("#chkSpvmn").attr("checked",$("config>spvmn>EnableSpvmn",xmlDoc).text()=="true" ? "checked":false);
                    $("#txtDwServerIp").ipInput("setValue",$("config>spvmn>dwServerIp", xmlDoc).text());
                    $("#txtRegisterPasswd").val("$#@$#@");
                    var activeConnEnabled = ($("config>spvmn>EnableSpvmn",xmlDoc).text().toLowerCase() === "false");
                    SpvmnModule.toggle(activeConnEnabled);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    verification: function() {
        var txtServerIp = $("#txtDwServerIp");
        var txtSipServerDomain = $("#txtSipServerDomain");
        var txtSipServerId = $("#txtSipServerId");
        var txtRegisterPasswd = $("#txtRegisterPasswd");
        var txtIpcId = $("#txtIpcId");
        var txtDeviceOwner = $("#txtDeviceOwner");
        var txtCivilCode = $("#txtCivilCode");
        var txtInstallAddress = $("#txtInstallAddress");

        // 第一段 1到223
        // 其余段 0到254
        var serverIp = txtServerIp.ipInput("getValue").split(".");
        if(serverIp[0]*1 < 1 || serverIp[0]*1 > 223){
            ShowFloatError(txtServerIp, LangCtrl._L_("ipValidChar"));
            return false;
        }
        if(serverIp[1]*1 <= 0 || serverIp[1]*1 > 254){
            ShowFloatError(txtServerIp, LangCtrl._L_("ipValidChar"));
            return false;
        }
        if(serverIp[2]*1 <= 0 || serverIp[2]*1 > 254){
            ShowFloatError(txtServerIp, LangCtrl._L_("ipValidChar"));
            return false;
        }
        if(serverIp[3]*1 <= 0 || serverIp[3]*1 > 254){
            ShowFloatError(txtServerIp, LangCtrl._L_("ipValidChar"));
            return false;
        }

        if(/^.*[\u4e00-\u9fa5]+.*$/g.test(txtServerIp.val())){
            ShowFloatError(txtServerIp, LangCtrl._L_("invalidChar"));
            return false;
        }
        if(/^[\u4e00-\u9fa5]+$/g.test(txtSipServerDomain.val())){
            ShowFloatError(txtSipServerDomain, LangCtrl._L_("invalidChar"));
            return false;
        }
        if(/^.*[\u4e00-\u9fa5]+.*$/g.test(txtSipServerId.val())){
            ShowFloatError(txtSipServerId, LangCtrl._L_("invalidChar"));
            return false;
        }
        if(/^.*[\u4e00-\u9fa5]+.*$/g.test(txtRegisterPasswd.val())){
            ShowFloatError(txtRegisterPasswd, LangCtrl._L_("invalidChar"));
            return false;
        }
        if(/^.*[\u4e00-\u9fa5]+.*$/g.test(txtIpcId.val())){
            ShowFloatError(txtIpcId, LangCtrl._L_("invalidChar"));
            return false;
        }
        if(/^.*[\u4e00-\u9fa5]+.*$/g.test(txtDeviceOwner.val())){
            ShowFloatError(txtDeviceOwner, LangCtrl._L_("invalidChar"));
            return false;
        }
        if(/^.*[\u4e00-\u9fa5]+.*$/g.test(txtCivilCode.val())){
            ShowFloatError(txtCivilCode, LangCtrl._L_("invalidChar"));
            return false;
        }
        if(/^.*[\u4e00-\u9fa5]+.*$/g.test(txtInstallAddress.val())){
            ShowFloatError(txtInstallAddress, LangCtrl._L_("invalidChar"));
            return false;
        }
        return true;
    },
    getSaveData: function(){

        $("config>spvmn>EnableSpvmn", xmlDoc).text($("#chkSpvmn").attr("checked") == "checked"?"true":"false");
        $("config>spvmn>dwServerIp", xmlDoc).empty().append($(xmlDoc.createCDATASection($("#txtDwServerIp").ipInput("getValue"))));
        var pwd = $("#txtRegisterPasswd").val();
        var pwdNode = $("config>spvmn>RegisterPasswd", xmlDoc);
        if (pwd == "" || !SpvmnModule.modifyFlag) {
            pwdNode.remove();
        } else {
            if (pwdNode.size() == 0) {
                var selectorParts = /^((\w+>?)+)>(\w+)$/.exec("config>spvmn>RegisterPasswd");
                if (selectorParts) {
                    pwdNode = $(xmlDoc.createElement(selectorParts[3]));
                    $(selectorParts[1], xmlDoc).append(pwdNode);
                }
            }
            pwdNode.empty().append($(xmlDoc.createCDATASection(PrivEncrypt([pwd],23784501))));
        }
        return XmlHttpClient.GetXmlByPage(SpvmnModule.mapping, xmlDoc);
    },
    setData: function() {
        if (!SpvmnModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetSpvmnConfig",
                type: "POST",
                async: true,
                data: SpvmnModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var ActiveConnModule = {
    mapping: {
        chkActiveConn: "config>ecms>switch",
        txtServicePort: "config>ecms>port",
        txtServiceAddress: "config>ecms>server",
        txtDevId: "config>ecms>id"
    },
    toggle: function(enabled) {
        $("#txtServicePort").attr("disabled", !enabled);
        $("#txtServiceAddress").attr("disabled", !enabled);
        $("#txtDevId").attr("disabled", !enabled);
        if (!enabled) {
            XmlHttpClient.BindPageByXml({
                txtServicePort: "config>ecms>port",
                txtServiceAddress: "config>ecms>server",
                txtDevId: "config>ecms>id"
            }, xmlDoc);
        }
    },
    initCtrl: function() {
        initNumberInput($("#txtServicePort"), { minValue: 10, maxValue: 65535 });
        $("#chkActiveConn").click(function(event) {
            ActiveConnModule.toggle($(this).attr("checked") == "checked");
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetServerConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    var activeConnEnabled = ($(ActiveConnModule.mapping.chkActiveConn, xmlDoc).text().toLowerCase() === "true");
                    XmlHttpClient.BindPageByXml(ActiveConnModule.mapping, xmlDoc);
                    ActiveConnModule.toggle(activeConnEnabled);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    verification: function() {
        if (XmlHttpClient.Verification("txtServicePort", ActiveConnModule.mapping["txtServicePort"], xmlDoc, LangCtrl._L_("portLimit"))) {
            return false;
        }
        if (XmlHttpClient.Verification("txtDevId", ActiveConnModule.mapping["txtDevId"], xmlDoc, LangCtrl._L_("idLimit"))) {
            return false;
        }
        return true;
    },
    setData: function() {
        window.top.showLoading();
        if (!ActiveConnModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetServerConfig",
                type: "POST",
                async: true,
                data: XmlHttpClient.GetXmlByPage(ActiveConnModule.mapping, xmlDoc),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var SNMPModule = {
    modifyFlag1:false,
    modifyFlag2:false,
    modifyFlag3:false,
    modifyFlag4:false,
    mapping: {
        txtWriteSNMPComm: "config>snmp>rwCommunity",
        txtReadSNMPComm: "config>snmp>roCommunity",
//        txtTrapAddress: "config>snmp>trapIp",
        txtTrapPort: "config>snmp>trapPort",
        txtTrapComm: "config>snmp>trapCommunity",
        txtReadUserName: "config>snmp>readUserName",
        drpSecurityLevel_r: "config>snmp>readSecLevel",
//        txtAuthPwd_r: "config>snmp>readAuthPass",
//        txtPrivateKeyPwd_r: "config>snmp>readPrivPass",
        txtWriteUserName: "config>snmp>writeUserName",
        drpSecurityLevel_w: "config>snmp>writeSecLevel",
//        txtAuthPwd_w: "config>snmp>writeAuthPass",
//        txtPrivateKeyPwd: "config>snmp>writePrivPass",
        txtSnmpPort: "config>snmp>snmpPort"
    },
    toggleV1V2: function(disabled) {
        $("#txtWriteSNMPComm").attr("disabled", disabled);
        $("#txtReadSNMPComm").attr("disabled", disabled);
        $("#txtTrapAddress").ipInput("setEnable", !disabled);
        $("#txtTrapPort").attr("disabled", disabled);
        $("#txtTrapComm").attr("disabled", disabled);
    },
    toggleV3: function(disabled) {
        $("#txtReadUserName").attr("disabled", disabled);
        $("#drpSecurityLevel_r").attr("disabled", disabled);
        $("input[name='authAlgorithm_r']").attr("disabled", disabled);
        $("#txtAuthPwd_r").attr("disabled", disabled);
        $("input[name='privateKeyAlgorithm_r']").attr("disabled", disabled);
        $("#txtPrivateKeyPwd_r").attr("disabled", disabled);

        $("#txtWriteUserName").attr("disabled", disabled);
        $("#drpSecurityLevel_w").attr("disabled", disabled);
        $("input[name='authAlgorithm_w']").attr("disabled", disabled);
        $("#txtAuthPwd_w").attr("disabled", disabled);
        $("input[name='privateKeyAlgorithm_w']").attr("disabled", disabled);
        $("#txtPrivateKeyPwd").attr("disabled", disabled);
    },
    bindChange: function(){
        $("#txtAuthPwd_r").keydown(function(event){
            $(this).unbind();
            SNMPModule.modifyFlag1 = true;
            $(this).val("");
            if(event.keyCode == 8){
                return false;
            }
        });
        $("#txtPrivateKeyPwd_r").keydown(function(event){
            $(this).unbind();
            SNMPModule.modifyFlag2 = true;
            $(this).val("");
            if(event.keyCode == 8){
                return false;
            }
        });
        $("#txtAuthPwd_w").keydown(function(event){
            $(this).unbind();
            SNMPModule.modifyFlag3 = true;
            $(this).val("");
            if(event.keyCode == 8){
                return false;
            }
        });
        $("#txtAuthPwd_w").keydown(function(event){
            $(this).unbind();
            SNMPModule.modifyFlag4 = true;
            $(this).val("");
            if(event.keyCode == 8){
                return false;
            }
        });
    },
    resetPass: function(){
        $("#txtAuthPwd_r,#txtPrivateKeyPwd_r,#txtAuthPwd_w,#txtPrivateKeyPwd").unbind().val("89898989");
        SNMPModule.modifyFlag1 = false;
        SNMPModule.modifyFlag2 = false;
        SNMPModule.modifyFlag3 = false;
        SNMPModule.modifyFlag4 = false;
    },
    initCtrl: function() {

        initNumberInput($("#txtTrapPort"), { minValue: 1, maxValue: 65535 });
        initNumberInput($("#txtSnmpPort"), { minValue: 1, maxValue: 65535 });
        $("#chkEnableSNMPv1,#chkEnableSNMPv2").click(function() {
            var disabled = true;
            if ($("#chkEnableSNMPv1").attr("checked") == "checked" || $("#chkEnableSNMPv2").attr("checked") == "checked") {
                disabled = false;
            }
            SNMPModule.toggleV1V2(disabled);
            if (!disabled) {
                $("#chkEnableSNMPv3").removeAttr("checked");
                SNMPModule.toggleV3(true);
            }
        });
        $("#chkEnableSNMPv3").unbind().click(function() {
            var disabled = !($("#chkEnableSNMPv3").attr("checked") == "checked");
            SNMPModule.toggleV3(disabled);
            if (!disabled) {
                $("#chkEnableSNMPv1").removeAttr("checked");
                $("#chkEnableSNMPv2").removeAttr("checked");
                SNMPModule.toggleV1V2(true);
                SNMPModule.bindChange();
            }else{
                SNMPModule.resetPass();
            }
        });
        $("#txtTrapAddress").ipInput();
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetSnmpConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    xmlDoc = result;
                    SNMPModule.bindCtrlData();
                    XmlHttpClient.BindPageByXml(SNMPModule.mapping, xmlDoc);
                    $("#txtTrapAddress").ipInput("setValue",$("config>snmp>trapIp", xmlDoc).text());
                    var vension = $("config>snmp>supportVersion", xmlDoc).text();
                    switch (vension) {
                        case "NONE":
                            SNMPModule.toggleV1V2(true);
                            SNMPModule.toggleV3(true);
                            break;
                        case "V1":
                            $("#chkEnableSNMPv1").attr("checked", "checked");
                            SNMPModule.toggleV1V2(false);
                            SNMPModule.toggleV3(true);
                            break;
                        case "V2":
                            $("#chkEnableSNMPv2").attr("checked", "checked");
                            SNMPModule.toggleV1V2(false);
                            SNMPModule.toggleV3(true);
                            break;
                        case "V1ANDV2":
                            $("#chkEnableSNMPv1").attr("checked", "checked");
                            $("#chkEnableSNMPv2").attr("checked", "checked");
                            SNMPModule.toggleV1V2(false);
                            SNMPModule.toggleV3(true);
                            break;
                        case "V3":
                            $("#chkEnableSNMPv3").attr("checked", "checked");
                            SNMPModule.toggleV1V2(true);
                            SNMPModule.toggleV3(false);
                            SNMPModule.bindChange();
                            break;
                    }
                    $("[name='authAlgorithm_r'][value='" + $("config>snmp>readAuth", xmlDoc).text() + "']").attr("checked", "checked");
                    $("[name='privateKeyAlgorithm_r'][value='" + $("config>snmp>readPriv", xmlDoc).text() + "']").attr("checked", "checked");
                    $("[name='authAlgorithm_w'][value='" + $("config>snmp>writeAuth", xmlDoc).text() + "']").attr("checked", "checked");
                    $("[name='privateKeyAlgorithm_w'][value='" + $("config>snmp>writePriv", xmlDoc).text() + "']").attr("checked", "checked");
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        var $drpSecurityLevel_r = $("#drpSecurityLevel_r");
        var $drpSecurityLevel_w = $("#drpSecurityLevel_w");
        $drpSecurityLevel_r.empty();
        $drpSecurityLevel_w.empty();
        $("config>types>readSecLevel>enum", xmlDoc).each(function(i, ele) {
            $("<option value=" + $(ele).text() + ">" + $(ele).attr("display") + "</option>").appendTo($drpSecurityLevel_r);
            $("<option value=" + $(ele).text() + ">" + $(ele).attr("display") + "</option>").appendTo($drpSecurityLevel_w);
        });

        $drpSecurityLevel_r.change(function(){
            if($drpSecurityLevel_r.val() === "auth_priv"){
                $("#authAlgorithm_r,#authPwd_r,#privateKeyAlgorithm_r,#privateKeyPwd_r").show();
            }else if($drpSecurityLevel_r.val() === "auth_noPriv"){
                $("#authAlgorithm_r,#authPwd_r").show();
                $("#privateKeyAlgorithm_r,#privateKeyPwd_r").hide();
            }else{
                $("#authAlgorithm_r,#authPwd_r,#privateKeyAlgorithm_r,#privateKeyPwd_r").hide();
            }
        });
        $drpSecurityLevel_w.change(function(){
            if($drpSecurityLevel_w.val() === "auth_priv"){
                $("#authAlgorithm,#authPwd,#privateKeyAlgorithm,#privateKeyPwd").show();
            }else if($drpSecurityLevel_w.val() === "auth_noPriv"){
                $("#authAlgorithm,#authPwd").show();
                $("#privateKeyAlgorithm,#privateKeyPwd").hide();
            }else{
                $("#privateKeyAlgorithm,#authAlgorithm,#authPwd,#privateKeyPwd").hide();
            }
        });

        var $tdAuthAlgorithm_r = $("#tdAuthAlgorithm_r");
        var $tdAuthAlgorithm_w = $("#tdAuthAlgorithm_w");
        $tdAuthAlgorithm_r.empty();
        $tdAuthAlgorithm_w.empty();
        $("config>types>readAuth>enum", xmlDoc).each(function(i, ele) {
            var value = $(ele).text();
            $("<input id=\"authAlgorithm_r_" + value + "\" type=\"radio\" name=\"authAlgorithm_r\" value=\"" + value + "\" /><label for=\"authAlgorithm_r_" + value + "\">" + value + "</label>").appendTo($tdAuthAlgorithm_r);
            $("<input id=\"authAlgorithm_w_" + value + "\" type=\"radio\" name=\"authAlgorithm_w\" value=\"" + value + "\" /><label for=\"authAlgorithm_w_" + value + "\">" + value + "</label>").appendTo($tdAuthAlgorithm_w);
        });

        var $tdPrivateKeyAlgorithm_r = $("#tdPrivateKeyAlgorithm_r");
        var $tdPrivateKeyAlgorithm_w = $("#tdPrivateKeyAlgorithm_w");
        $tdPrivateKeyAlgorithm_r.empty();
        $tdPrivateKeyAlgorithm_w.empty();
        $("config>types>readPriv>enum", xmlDoc).each(function(i, ele) {
            var value = $(ele).text();
            $("<input id=\"privateKeyAlgorithm_r_" + value + "\" type=\"radio\" name=\"privateKeyAlgorithm_r\" value=\"" + value + "\" /><label for=\"privateKeyAlgorithm_r_" + value + "\">" + value + "</label>").appendTo($tdPrivateKeyAlgorithm_r);
            $("<input id=\"privateKeyAlgorithm_w_" + value + "\" type=\"radio\" name=\"privateKeyAlgorithm_w\" value=\"" + value + "\" /><label for=\"privateKeyAlgorithm_w_" + value + "\">" + value + "</label>").appendTo($tdPrivateKeyAlgorithm_w);
        });

        var readSecLevel = $("config>snmp>readSecLevel",xmlDoc).text();
        if(readSecLevel === "auth_priv"){
            $("#authAlgorithm_r,#authPwd_r,#privateKeyAlgorithm_r,#privateKeyPwd_r").show();
        }else if(readSecLevel === "auth_noPriv"){
            $("#authAlgorithm_r,#authPwd_r").show();
            $("#privateKeyAlgorithm_r,#privateKeyPwd_r").hide();
        }else{
            $("#authAlgorithm_r,#authPwd_r,#privateKeyAlgorithm_r,#privateKeyPwd_r").hide();
        }
        var writeSecLevel  = $("config>snmp>writeSecLevel",xmlDoc).text();
        if(writeSecLevel === "auth_priv"){
            $("#authAlgorithm,#authPwd,#privateKeyAlgorithm,#privateKeyPwd").show();
        }else if(writeSecLevel === "auth_noPriv"){
            $("#authAlgorithm,#authPwd").show();
            $("#privateKeyAlgorithm,#privateKeyPwd").hide();
        }else{
            $("#privateKeyAlgorithm,#authAlgorithm,#authPwd,#privateKeyPwd").hide();
        }

    },
    verification: function() {
        var txtServerIp = $("#txtTrapAddress");
        var serverIp = txtServerIp.ipInput("getValue").split(".");
        // 第一段 1到223
        // 其余段 0到254
        var serverIp = txtServerIp.ipInput("getValue").split(".");
        if(serverIp[0]*1 < 1 || serverIp[0]*1 > 223){
            ShowFloatError(txtServerIp, LangCtrl._L_("ipValidChar"));
            return false;
        }
        if(serverIp[1]*1 <= 0 || serverIp[1]*1 > 254){
            ShowFloatError(txtServerIp, LangCtrl._L_("ipValidChar"));
            return false;
        }
        if(serverIp[2]*1 <= 0 || serverIp[2]*1 > 254){
            ShowFloatError(txtServerIp, LangCtrl._L_("ipValidChar"));
            return false;
        }
        if(serverIp[3]*1 <= 0 || serverIp[3]*1 > 254){
            ShowFloatError(txtServerIp, LangCtrl._L_("ipValidChar"));
            return false;
        }

        if(serverIp[0]*1 == 127 && serverIp[1]*1 == 0 && serverIp[2]*1 == 0 && serverIp[3]*1 == 0){
            ShowFloatError(txtServerIp, LangCtrl._L_("ipValidChar"));
            return false;
        }

        if ($("#chkEnableSNMPv1").attr("checked") == "checked" || $("#chkEnableSNMPv2").attr("checked") == "checked") {
            if($("#txtReadSNMPComm").val() == ""){
                ShowFloatError($("#txtReadSNMPComm"), LangCtrl._L_("notEmptyTip"));
                return false;
            }
            if($("#txtWriteSNMPComm").val() == ""){
                ShowFloatError($("#txtWriteSNMPComm"), LangCtrl._L_("notEmptyTip"));
                return false;
            }
            if($("#txtTrapComm").val() == ""){
                ShowFloatError($("#txtTrapComm"), LangCtrl._L_("notEmptyTip"));
                return false;
            }
        }

        var chk3 = $("#chkEnableSNMPv3").attr("checked") == "checked";
        if (chk3) {
            if(!$("#txtAuthPwd_r").is(":hidden") && !chkSafeChar($("#txtAuthPwd_r").val())){
                ShowFloatError($("#txtAuthPwd_r"), LangCtrl._L_("invalidChar"));
                return false;
            }
            var reg = /^\w{8,119}$/;
            if(!$("#txtAuthPwd_r").is(":hidden") && !reg.test($("#txtAuthPwd_r").val())){
                ShowFloatError($("#txtAuthPwd_r"), LangCtrl._L_("passwordLimit"));
                return false;
            }

            if(!$("#txtPrivateKeyPwd_r").is(":hidden") && !chkSafeChar($("#txtPrivateKeyPwd_r").val())){
                ShowFloatError($("#txtPrivateKeyPwd_r"), LangCtrl._L_("invalidChar"));
                return false;
            }
            if(!$("#txtPrivateKeyPwd_r").is(":hidden") && !reg.test($("#txtPrivateKeyPwd_r").val())){
                ShowFloatError($("#txtPrivateKeyPwd_r"), LangCtrl._L_("passwordLimit"));
                return false;
            }

            if(!$("#txtAuthPwd_w").is(":hidden") && !chkSafeChar($("#txtAuthPwd_w").val())){
                ShowFloatError($("#txtAuthPwd_w"), LangCtrl._L_("invalidChar"));
                return false;
            }
            if(!$("#txtAuthPwd_w").is(":hidden") && !reg.test($("#txtAuthPwd_w").val())){
                ShowFloatError($("#txtAuthPwd_w"), LangCtrl._L_("passwordLimit"));
                return false;
            }

            if(!$("#txtPrivateKeyPwd").is(":hidden") && !chkSafeChar($("#txtPrivateKeyPwd").val())){
                ShowFloatError($("#txtPrivateKeyPwd"), LangCtrl._L_("invalidChar"));
                return false;
            }
            if(!$("#txtPrivateKeyPwd").is(":hidden") && !reg.test($("#txtPrivateKeyPwd").val())){
                ShowFloatError($("#txtPrivateKeyPwd"), LangCtrl._L_("passwordLimit"));
                return false;
            }
            if($("#txtReadUserName").val() == ""){
                ShowFloatError($("#txtReadUserName"), LangCtrl._L_("notEmptyTip"));
                return false;
            }
            if($("#txtWriteUserName").val() == ""){
                ShowFloatError($("#txtWriteUserName"), LangCtrl._L_("notEmptyTip"));
                return false;
            }
        }

        if (XmlHttpClient.Verification("txtTrapPort", SNMPModule.mapping["txtTrapPort"], xmlDoc, LangCtrl._L_("portLimit"))) {
            return false;
        }
        if (XmlHttpClient.Verification("txtSnmpPort", SNMPModule.mapping["txtSnmpPort"], xmlDoc, LangCtrl._L_("portLimit"))) {
            return false;
        }
        return true;
    },
    getSaveData: function() {
        var chk1 = $("#chkEnableSNMPv1").attr("checked") == "checked";
        var chk2 = $("#chkEnableSNMPv2").attr("checked") == "checked";
        var chk3 = $("#chkEnableSNMPv3").attr("checked") == "checked";
        if (chk1 || chk2 || chk3) {
            if (chk1 && chk2) {
                $("config>snmp>supportVersion", xmlDoc).text("V1ANDV2");
            }
            else if (chk1) {
                $("config>snmp>supportVersion", xmlDoc).text("V1");
            }
            else if (chk2) {
                $("config>snmp>supportVersion", xmlDoc).text("V2");
            }
            if (chk3) {
                $("config>snmp>supportVersion", xmlDoc).text("V3");
            }
        }
        else {
            $("config>snmp>supportVersion", xmlDoc).text("NONE");
        }

        $("config>snmp>readAuth", xmlDoc).text($("[name='authAlgorithm_r']:checked").val());
        $("config>snmp>readPriv", xmlDoc).text($("[name='privateKeyAlgorithm_r']:checked").val());
        $("config>snmp>writeAuth", xmlDoc).text($("[name='authAlgorithm_w']:checked").val());
        $("config>snmp>writePriv", xmlDoc).text($("[name='privateKeyAlgorithm_w']:checked").val());
        $("config>snmp>trapIp", xmlDoc).empty().append($(xmlDoc.createCDATASection($("#txtTrapAddress").ipInput("getValue"))));

        var txtAuthPwd_r = $.trim($("#txtAuthPwd_r").val());
        var pwdNode1 = $("config>snmp>readAuthPass", xmlDoc);
        if (txtAuthPwd_r == "" || !SNMPModule.modifyFlag1) {
            pwdNode1.remove();
        } else {
            if (pwdNode1.size() == 0) {
                var selectorParts = /^((\w+>?)+)>(\w+)$/.exec("config>snmp>readAuthPass");
                if (selectorParts) {
                    pwdNode1 = $(xmlDoc.createElement(selectorParts[3]));
                    $(selectorParts[1], xmlDoc).append(pwdNode1);
                }
            }
            pwdNode1.empty().append($(xmlDoc.createCDATASection(PrivEncrypt([txtAuthPwd_r],23784501))));
        }
        var txtPrivateKeyPwd_r = $.trim($("#txtPrivateKeyPwd_r").val());
        var pwdNode2 = $("config>snmp>readPrivPass", xmlDoc);
        if (txtPrivateKeyPwd_r == "" || !SNMPModule.modifyFlag2) {
            pwdNode2.remove();
        } else {
            if (pwdNode2.size() == 0) {
                var selectorParts = /^((\w+>?)+)>(\w+)$/.exec("config>snmp>readPrivPass");
                if (selectorParts) {
                    pwdNode2 = $(xmlDoc.createElement(selectorParts[3]));
                    $(selectorParts[1], xmlDoc).append(pwdNode2);
                }
            }
            pwdNode2.empty().append($(xmlDoc.createCDATASection(PrivEncrypt([txtPrivateKeyPwd_r],23784501))));
        }
        var txtAuthPwd_w = $.trim($("#txtAuthPwd_w").val());
        var pwdNode3 = $("config>snmp>writeAuthPass", xmlDoc);
        if (txtAuthPwd_w == "" || !SNMPModule.modifyFlag3) {
            pwdNode3.remove();
        } else {
            if (pwdNode3.size() == 0) {
                var selectorParts = /^((\w+>?)+)>(\w+)$/.exec("config>snmp>writeAuthPass");
                if (selectorParts) {
                    pwdNode3 = $(xmlDoc.createElement(selectorParts[3]));
                    $(selectorParts[1], xmlDoc).append(pwdNode3);
                }
            }
            pwdNode3.empty().append($(xmlDoc.createCDATASection(PrivEncrypt([txtAuthPwd_w],23784501))));
        }
        var txtPrivateKeyPwd = $.trim($("#txtPrivateKeyPwd").val());
        var pwdNode4 = $("config>snmp>writePrivPass", xmlDoc);
        if (txtPrivateKeyPwd == "" || !SNMPModule.modifyFlag4) {
            pwdNode4.remove();
        } else {
            if (pwdNode4.size() == 0) {
                var selectorParts = /^((\w+>?)+)>(\w+)$/.exec("config>snmp>writePrivPass");
                if (selectorParts) {
                    pwdNode4 = $(xmlDoc.createElement(selectorParts[3]));
                    $(selectorParts[1], xmlDoc).append(pwdNode4);
                }
            }
            pwdNode4.empty().append($(xmlDoc.createCDATASection(PrivEncrypt([txtPrivateKeyPwd],23784501))));
        }

        return XmlHttpClient.GetXmlByPage(SNMPModule.mapping, xmlDoc);

    },
    setData: function() {
        window.top.showLoading();
        if (!SNMPModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetSnmpConfig",
                type: "POST",
                async: true,
                data: SNMPModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    SNMPModule.getData();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var IeeeModule = {
    mapping: {
        chkUseIEEE: "config>ieee802>switch",
        cboEncodeType: "config>ieee802>encodeType",
        cboIeeVersion: "config>ieee802>version",
        txtIEEEUserName: "config>ieee802>userName",
        txtIEEEPassword: "config>ieee802>password",
        txtIEEEConfirmPassword: "config>ieee802>password"
    },
    toggle: function(enabled) {
        $("#cboEncodeType").attr("disabled", !enabled);
        $("#cboIeeVersion").attr("disabled", !enabled);
        $("#txtIEEEUserName").attr("disabled", !enabled);
        $("#txtIEEEPassword").attr("disabled", !enabled);
        $("#txtIEEEConfirmPassword").attr("disabled", !enabled);
        if (!enabled) {
            XmlHttpClient.BindPageByXml({
                cboEncodeType: "config>ieee802>encodeType",
                cboIeeVersion: "config>ieee802>version",
                txtIEEEUserName: "config>ieee802>userName",
                txtIEEEPassword: "config>ieee802>password",
                txtIEEEConfirmPassword: "config>ieee802>password"
            }, xmlDoc);
        }
    },
    initCtrl: function() {
        $("#chkUseIEEE").click(function(event) {
            IeeeModule.toggle($(this).attr("checked") == "checked");
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetIeee802Config",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    var ieeeEnabled = ($(IeeeModule.mapping.chkUseIEEE, xmlDoc).text().toLowerCase() === "true");
                    IeeeModule.bindCtrlData();
                    XmlHttpClient.BindPageByXml(IeeeModule.mapping, xmlDoc);
                    IeeeModule.toggle(ieeeEnabled);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        function getEncodeModeName(value) {
            switch (value) {
                default:
                    return value;
            }
        }
        $("#cboEncodeType").empty();
        $("config>types>ieee802EncodeType>enum", xmlDoc).each(function(i, ele) {
            $("<option value=" + $(ele).text() + ">" + getEncodeModeName($(ele).text()) + "</option>").appendTo($("#cboEncodeType"));
        });
        $("#cboIeeVersion").empty();
        $("config>types>ieee802VersionType>enum", xmlDoc).each(function(i, ele) {
            $("<option value=" + $(ele).text() + ">" + $(ele).text() + "</option>").appendTo($("#cboIeeVersion"));
        });
    },
    verification: function() {
        ClearFloatError();
        if ($("#txtIEEEPassword").val() != $("#txtIEEEConfirmPassword").val()) {
            ShowFloatError($("#txtIEEEConfirmPassword"), LangCtrl._L_("passwordNotEqualTip"));
            return false;
        }
        return true;
    },
    setData: function() {
        window.top.showLoading();
        if (!IeeeModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetIeee802Config",
                type: "POST",
                async: true,
                data: XmlHttpClient.GetXmlByPage(IeeeModule.mapping, xmlDoc),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var RTSPModule = {
    mapping: {
        chkUseRTSP: "config>rtsp>switch",
        txtRTSPPort: "config>rtsp>port",
        chkAnonymous: "config>rtsp>anonymitySwitch"
    },
    toggle: function(enabled) {
        $("#txtRTSPPort").attr("disabled", !enabled);
        $("#chkAnonymous").attr("disabled", !enabled);
        $("#lblAnonymous").attr("disabled", !enabled);
        if (!enabled) {
            XmlHttpClient.BindPageByXml({
                txtRTSPPort: "config>rtsp>port",
                chkAnonymous: "config>rtsp>anonymitySwitch"
            }, xmlDoc);
        }
    },
    initCtrl: function() {
        initNumberInput($("#txtRTSPPort"), { minValue: 10, maxValue: 65535 });
        $("#chkUseRTSP").click(function(event) {
            RTSPModule.toggle($(this).attr("checked") == "checked");
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetRtspConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    var rtspEnabled = ($(RTSPModule.mapping.chkUseRTSP, xmlDoc).text().toLowerCase() === "true");
                    RTSPModule.bindCtrlData();
                    XmlHttpClient.BindPageByXml(RTSPModule.mapping, xmlDoc);
                    RTSPModule.toggle(rtspEnabled);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        function genProfileList(profileName, profileCount, table) {
            var tbody = $("<tbody></tbody>");
            table.find("tr").remove();
            table.append(tbody);
            for (var i = 0; i < profileCount; i++) {
                var tr = $("<tr></tr>");
                if (i % 2 != 0) {
                    tr.attr("class", "alter");
                }
                tbody.append(tr);
                var td = $("<td>&nbsp;</td>");
                if (i == 0) {
                    td.css("width", "100px");
                    td.html(LangCtrl._L_("RTSPAddress"));
                }
                tr.append(td);
                td = $("<td></td>");
                tr.append(td);
                var txt = $("<input type=\"text\" disabled=\"disabled\" style=\"width: 260px;\"/>");
                txt.val("rtsp://IP or domain name:port/" + profileName + (i + 1));
                txt.attr("title", "rtsp://IP or domain name:port/" + profileName + (i + 1));
                td.append(txt);
            }
        }

        var profileCount = $.cookie("profile_count");
        if (profileCount) {
            genProfileList($("config>rtsp>streamName", xmlDoc).text(), profileCount, $("#tbProfile"));
        }
    },
    verification: function() {
        if (XmlHttpClient.Verification("txtRTSPPort", RTSPModule.mapping["txtRTSPPort"], xmlDoc, LangCtrl._L_("portLimit"))) {
            return false;
        }
        return true;
    },
    setData: function() {
        window.top.showLoading();
        if (!RTSPModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetRtspConfig",
                type: "POST",
                async: true,
                data: XmlHttpClient.GetXmlByPage(RTSPModule.mapping, xmlDoc),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var UPnPModule = {
    mapping: {
        chkUseUPnP: "config>upnp>switch",
        txtUPnPName: "config>upnp>friendlyName"
    },
    toggle: function(enabled) {
        $("#txtUPnPName").attr("disabled", !enabled);
        if (!enabled) {
            XmlHttpClient.BindPageByXml({
                txtUPnPName: "config>upnp>friendlyName"
            }, xmlDoc);
        }
    },
    initCtrl: function() {
        $("#chkUseUPnP").click(function(event) {
            UPnPModule.toggle($(this).attr("checked") == "checked");
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetUpnpConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    var upnpEnabled = ($(UPnPModule.mapping.chkUseUPnP, xmlDoc).text().toLowerCase() === "true");
                    XmlHttpClient.BindPageByXml(UPnPModule.mapping, xmlDoc);
                    UPnPModule.toggle(upnpEnabled);

                    UPnPModule.friendlyNameMaxLen = $("config>upnp>friendlyName",xmlDoc).attr("maxLen")*1;
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    setData: function() {

        if($("#txtUPnPName").val().getBytesLength() > UPnPModule.friendlyNameMaxLen){
            ShowFloatError($("#txtUPnPName"), LangCtrl._L_("friendlyNameTooLong"));
            return false;
        }

        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetUpnpConfig",
                type: "POST",
                async: true,
                data: XmlHttpClient.GetXmlByPage(UPnPModule.mapping, xmlDoc),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var EmailModule = {
    maxAddValue:0,
    modifyFlag: false,
    mapping: {
        txtFromEmail: "config>mail>srcMail",
        txtEmailUserName: "config>mail>userName",
//        txtEmailPassword: "config>mail>passwd",
        txtEmailServiceAddress: "config>mail>server",
        choSafeLink: "config>mail>securityMethod",
        txtSMTPPort: "config>mail>port",
        chkEmailIntervalTime: "config>mail>intervalTime>switch",
        txtEmailIntervalTime:"config>mail>intervalTime>value",
        chkEmailSendPicSwitch: "config>mail>sendPicSwitch"
    },
    initCtrl: function() {
        initNumberInput($("#txtSMTPPort"), { minValue: 10, maxValue: 65535 });
        function addEmail() {
            var txtReceiveEmail = $("#txtReceiveEmail");
            var emailStr = txtReceiveEmail.val();
            var cboEmailList = $("#cboEmailList");
            ClearFloatError();
            if (EmailModule.emailMaxCount && cboEmailList.find("option").size() >= EmailModule.emailMaxCount) {
                ShowFloatError(txtReceiveEmail, LangCtrl._L_("emailMaxCount").format(EmailModule.emailMaxCount));
                return;
            }
            if (emailStr == "" || !CheckEmail(emailStr)) {
                ShowFloatError(txtReceiveEmail, LangCtrl._L_("invalidEmailTip"));
                return;
            }
            ++EmailModule.maxAddValue;
            var breakFlag = false;
            cboEmailList.find("option").each(function(i,ele){
                if($(ele).text() == emailStr ){
                    ShowFloatError(txtReceiveEmail, LangCtrl._L_("notUniqueEmailTip"));
                    breakFlag = true;
                }
                if(breakFlag){
                    return false;
                }
            });
            if(breakFlag){
                return ;
            }
//            if (cboEmailList.find("option[value=\"" + EmailModule.maxAddValue + "\"]").size() > 0) {
//                ShowFloatError(txtReceiveEmail, LangCtrl._L_("notUniqueEmailTip"));
//                return;
//            }
            cboEmailList.append("<option value=\"" + EmailModule.maxAddValue  + "\">" + emailStr + "</option>");

            cboEmailList.find("option:not(:last)").attr("selected", false);
            cboEmailList.find("option:last").attr("selected", true);
            txtReceiveEmail.val("");
        }

        $("#btnUseDefault").click(function(event) {
            $("#txtSMTPPort").val("25");
        });

        $("#txtReceiveEmail").keydown(function(event) {
            if (isEnter(event)) {
                addEmail();
            }
        });
        $("#btnTestAccountSet").click(function(event) {

            if (!EmailModule.verificationTestAccountSet()) {
                window.top.hideLoading();
                return false;
            }
           dialog_addTestReceive = new DialogHelper({
                title: LangCtrl._L_("addTestReceive"),
                content: "testEmail.htm",
                width: 410,
                height: 200,
                contentType: "url",
                loadCallBack: testEmailModule.initCtrl
            });
        });

        $("#btnEmailAdd").click(function(event) {
            addEmail();
        });

        $("#btnEmailDel").click(function(event) {
            var cboEmailList = $("#cboEmailList");
            var selectedEmail = cboEmailList.find("option:selected");
            ClearFloatError();
            if (selectedEmail.size() == 0) {
                ShowFloatError($("#txtReceiveEmail"), LangCtrl._L_("noEmailSelectedTip"));
                return;
            }
            selectedEmail.remove();
            cboEmailList.find("option:last").attr("selected", true);
        });

        $("#btnClearRecieve").click(function(){
            var $FromEmail = $("#txtFromEmail");
            var $UserName =  $("#txtEmailUserName");
            var $PassWord =  $("#txtEmailPassword");
            var $serviceAddress = $("#txtEmailServiceAddress");
            if ($.trim($FromEmail.val()).length != 0) {
                $FromEmail.val("");
            }
            if ($.trim($UserName.val()).length != 0) {
                $UserName.val("");
            }
            if ($.trim($PassWord.val()).length != 0) {
                $PassWord.val("");
            }
            if ($.trim($serviceAddress.val()).length != 0) {
                $serviceAddress.val("");
            }
        });
//        $("#clearBtn").click(function(){
//            var $cboEmailList = $("#cboEmailList");
//            var cboEmailList = $("#cboEmailList");
//            var selectedEmail = cboEmailList.find("option");
//            if (selectedEmail.size() != 0) {
//                selectedEmail.remove();
//            }
//        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetMailConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    EmailModule.bindCtrlData();
                    XmlHttpClient.BindPageByXml(EmailModule.mapping, xmlDoc);

                    if(!($("config > mail >intervalTime",result).size() > 0)){
                        $("#intervalTime").hide();
                    }

                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        function getSecurityMethodName(value) {
            switch (value) {
                case "no":
                    return LangCtrl._L_("notNecessary");
                default:
                    return value;
            }
        }
        var choSafeLink = $("#choSafeLink");
        choSafeLink.empty();
        $("config>types>securityMethod>enum", xmlDoc).each(function(i, ele) {
            $("<option value=" + $(ele).text() + ">" + getSecurityMethodName($(ele).text()) + "</option>").appendTo(choSafeLink);
        });

        if($("config>mail>srcMail",xmlDoc).text() != "" && $("config>mail>userName",xmlDoc).text() != "" && $("config>mail>server",xmlDoc).text() != ""){
            $("#txtEmailPassword").val("$#@$#@");
            $("#txtEmailPassword").keydown(function(event){
                $(this).unbind();
                EmailModule.modifyFlag = true;
                $(this).val("");
                if(event.keyCode == 8){
                    return false;
                }
            });
//            $("#txtEmailPassword").bind("propertychange input",function(){
//                $(this).unbind();
//                $(this).val("");
//                EmailModule.modifyFlag = true;
//            });
        }else{
            EmailModule.modifyFlag = true;
        }

        var cboEmailList = $("#cboEmailList");
        cboEmailList.empty();
        $("config>mail>recvMail>item", xmlDoc).each(function(i, ele) {
            $("<option value=" + (i+1) + ">" + $(ele).text() + "</option>").appendTo(cboEmailList);
        });
        cboEmailList.find("option:last").attr("selected", true);
        $("#txtReceiveEmail").attr("maxlength", $("config>mail>recvMail>itemType", xmlDoc).attr("maxLen"));

        var intervalTime = $("config>mail>intervalTime>value", xmlDoc).text();
        var minValue = $("config>mail>intervalTime>value", xmlDoc).attr("min");
        var maxValue = $("config>mail>intervalTime>value", xmlDoc).attr("max");
        initNumberInput($("#txtEmailIntervalTime"), { minValue: minValue , maxValue: maxValue });
        $("#txtEmailIntervalTime").val(intervalTime);
        $("#txtTip").html("("+minValue+"-"+maxValue+")");
        EmailModule.maxAddValue = $("config>mail>recvMail>item",xmlDoc).length;
        EmailModule.emailMaxCount = $("config>mail>recvMail", xmlDoc).attr("maxCount") * 1;
    },
    verification: function() {
        if (XmlHttpClient.Verification("txtSMTPPort", EmailModule.mapping["txtSMTPPort"], xmlDoc, LangCtrl._L_("portLimit"))) {
            return false;
        }
        ClearFloatError();
        var $FromEmail = $("#txtFromEmail");
        var $UserName =  $("#txtEmailUserName");
        var $PassWord =  $("#txtEmailPassword");
        var $cboEmailList = $("#cboEmailList");
        var $serviceAddress = $("#txtEmailServiceAddress");
        if($.trim($FromEmail.val()).length != 0 || $.trim($UserName.val()).length != 0 || $.trim($PassWord.val()).length != 0 || $.trim($serviceAddress.val()).length != 0 || $cboEmailList.find("option").size() != 0){
            if ($.trim($FromEmail.val()).length == 0) {
                ShowFloatError($FromEmail, LangCtrl._L_("emailNotEmptyTip"));
                return false;
            }
            if ( !CheckEmail($.trim($FromEmail.val()))) {
                ShowFloatError($FromEmail, LangCtrl._L_("invalidEmailTip"));
                return false;
            }

            if ($.trim($UserName.val()).length == 0) {
                ShowFloatError($UserName, LangCtrl._L_("userNameNotEmptyTip"));
                return false;
            }
            if ($.trim($PassWord.val()).length == 0) {
                ShowFloatError($PassWord, LangCtrl._L_("passwordNotEmptyTip"));
                return false;
            }
            if(!chkSafeChar($PassWord.val())){
                ShowFloatError($PassWord, LangCtrl._L_("invalidChar"));
                return false;
            }
            if ($.trim($serviceAddress.val()).length == 0) {
                ShowFloatError($serviceAddress, LangCtrl._L_("serviceAddressNotEmptyTip"));
                return false;
            }
            if(/^.*[\u4e00-\u9fa5]+.*$/i.test($serviceAddress.val())){
                ShowFloatError($serviceAddress, LangCtrl._L_("invalidChar"));
                return false;
            }
//            if ($cboEmailList.find("option").size() == 0) {
//                ShowFloatError($cboEmailList, LangCtrl._L_("receiveNotEmptyTip"));
//                return false;
//            }
        }
        return true;
    },
    verificationTestAccountSet: function() {
        if (XmlHttpClient.Verification("txtSMTPPort", EmailModule.mapping["txtSMTPPort"], xmlDoc, LangCtrl._L_("portLimit"))) {
            return false;
        };
        ClearFloatError();
        var $FromEmail = $("#txtFromEmail");
        var $UserName =  $("#txtEmailUserName");
        var $PassWord =  $("#txtEmailPassword");
        if($.trim($FromEmail.val()).length != 0 || $.trim($UserName.val()).length != 0 || $.trim($PassWord.val()).length != 0){
            if ($.trim($FromEmail.val()).length == 0) {
                ShowFloatError($FromEmail, LangCtrl._L_("emailNotEmptyTip"));
                return false;
            }
            if ($.trim($UserName.val()).length == 0) {
                ShowFloatError($UserName, LangCtrl._L_("userNameNotEmptyTip"));
                return false;
            }
            if ($.trim($PassWord.val()).length == 0) {
                ShowFloatError($PassWord, LangCtrl._L_("passwordNotEmptyTip"));
                return false;
            }
        }
        return true;
    },
    getSaveData: function() {
        var recvMail = $("config>mail>recvMail", xmlDoc);
        $("config>mail>recvMail>item", xmlDoc).remove();
        $("#cboEmailList>option").each(function(i, ele) {
            recvMail.append($(xmlDoc.createElement("item")).attr("id",($(ele).val())).append(xmlDoc.createCDATASection($(ele).text())));
        });

        var pwd = $("#txtEmailPassword").val();
        var pwdNode = $("config>mail>passwd", xmlDoc);
        if (pwd == "" || !EmailModule.modifyFlag) {
            pwdNode.remove();
        } else {
            if (pwdNode.size() == 0) {
                var selectorParts = /^((\w+>?)+)>(\w+)$/.exec("config>mail>passwd");
                if (selectorParts) {
                    pwdNode = $(xmlDoc.createElement(selectorParts[3]));
                    $(selectorParts[1], xmlDoc).append(pwdNode);
                }
            }
            pwdNode.empty().append($(xmlDoc.createCDATASection(PrivEncrypt([pwd],23784501))));
        }
        return XmlHttpClient.GetXmlByPage(EmailModule.mapping, xmlDoc);
    },
    setData: function() {
        window.top.showLoading();
        if (!EmailModule.verification()) {
            window.top.hideLoading();
            return false;
        }
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetMailConfig",
                type: "POST",
                async: true,
                data: EmailModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var FTPGrid;
var FTPModule = {
    maxAddValue:0,
    initCtrl: function() {

        $("#FTPGrid").wbGrid({
            data: {
                colNames: ["id",LangCtrl._L_("serverName"),LangCtrl._L_("serverAddress"),LangCtrl._L_("port"),LangCtrl._L_("userName"),"password","changeFlag","anonymousName",LangCtrl._L_("uploadPath")],
                colModel: [
                    { name: "id", index: "id", width: 100, align: "center", hidden:true, sortable: false },
                    { name: "serverName", index: "serverName", key: true,width: 70, align:"center"},
                    { name: "serverAddress", index: "serverAddress",width: 70, align: "center",sortable: false},
                    { name: "port", index: "port", width: 40, align: "center", sortable: false },
                    { name: "userName", index: "userName", width: 70, align: "center", sortable: false },
                    { name: "password", index: "password", width: 50, align: "center", hidden:true, sortable: false },
                    { name: "changeFlag", index: "changeFlag", width: 50, align: "center", hidden:true, sortable: false },
                    { name: "anonymousName", index: "anonymousName", width: 50, align: "center", hidden:true, sortable: false },
                    { name: "uploadPath", index: "uploadPath", width: 50, align: "center", sortable: false }
                ],
                rowList: []
            },
            view: {
                selectRow : true
            }
        });
        $("#btnNewFTP").unbind().click(function(){
            FTPModule.addFtp();
        });
        $("#btnAlterFTP").unbind().click(function(){
            FTPModule.toEditFtp();
        });
        $("#btnDeleteFTP").unbind().click(function(){
            FTPModule.deleteFtp();
        });
        FTPGrid = $("#FTPGrid");
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetFtpConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    ftpXmlDoc = result;
                    var rowData = [];
                    FTPModule.maxAddValue = $("config>ftp>item",ftpXmlDoc).length;
                    $("config>ftp>item",ftpXmlDoc).each(function(i,ele){
                        var userName = $(">anonymousSwitch",ele).text() === "true" ? "anonymous" : $(">userName",ele).text();
                        rowData.push({
                            "id":$(ele).attr("id"),
                            "serverName":$(">serverName",ele).text(),
                            "serverAddress":$(">serverAddr",ele).text(),
                            "port":$(">port",ele).text(),
                            "userName":userName,
                            "password": "898989",
                            "changeFlag":"false",
                            "anonymousSwitch":  $(">anonymousSwitch",ele).text(),
                            "uploadPath":$(">path",ele).text()
                        });
                    });
                    $("#FTPGrid").wbGrid("load", rowData);
                    FTPModule.ftpList = rowData;

                    if (rowData.length != 0) {
                        $("#FTPGrid").wbGrid("selectRowByIndex",0);
                        $("#btnAlterFTP,#btnDeleteFTP,#btnTestFTP").removeAttr("disabled").removeClass("disabled");
                    }
                    else {
                        $("#btnAlterFTP,#btnDeleteFTP,#btnTestFTP").attr("disabled", "disabled").addClass("disabled");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function() {
        $("config >ftp >item", ftpXmlDoc).remove();
        $.each(FTPModule.ftpList, function(index, element) {
            var itemFtp =  $(ftpXmlDoc.createElement("item")).attr("id",element.id)
                .append(
                $(ftpXmlDoc.createElement("serverName")).attr("type","string").attr("maxLen","31").append(
                    $(ftpXmlDoc.createCDATASection(element.serverName))
                )
            ).append(
                $(ftpXmlDoc.createElement("serverAddr")).attr("type","string").attr("maxLen","131").append(
                    $(ftpXmlDoc.createCDATASection(element.serverAddress))
                )
            ).append(
                $(ftpXmlDoc.createElement("port")).attr("type","uint16").append(
                    element["port"]
                )
            ).append(
                $(ftpXmlDoc.createElement("path")).attr("type","string").attr("maxLen","131").append(
                    $(ftpXmlDoc.createCDATASection(element.uploadPath))
                )
            ).append(
                $(ftpXmlDoc.createElement("anonymousSwitch")).attr("type","boolean").append(
                        element.anonymousSwitch+""
                )
            ).append(
                $(ftpXmlDoc.createElement("userName")).attr("type","string").attr("maxLen","67").append(
                    $(ftpXmlDoc.createCDATASection(element.userName))
                )
            );
            if(element["changeFlag"] == "true"){
                itemFtp.append(
                    $(ftpXmlDoc.createElement("passwd")).attr("type","string").attr("maxLen","67").append(
                        $(ftpXmlDoc.createCDATASection(PrivEncrypt([element["password"]],23784501)))
                    )
                )
            }
            $("ftp", ftpXmlDoc).append(itemFtp);
        });
        return XMLDoc2XMLStr(ftpXmlDoc);
    },
    setData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetFtpConfig",
                type: "POST",
                async: true,
                data: FTPModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    AddFtpModule.modifyFlag = false;
                    FTPModule.getData();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    addFtp: function(){
        FTPModule.editIndex = -1;
        dialogAddFtp = new DialogHelper({
            title: LangCtrl._L_("addFtp"),
            content: "addFtpDialog.htm",
            width:  530,
            height: 330,
            contentType: "url",
            loadCallBack: AddFtpModule.initCtrl
        });
    },
    toEditFtp: function() {
        FTPModule.editIndex = FTPGrid.wbGrid("getSelectRows").index;
        AddFtpModule.modifyFlag = false;
        dialogAddFtp = new DialogHelper({
            title: LangCtrl._L_("editFtp"),
            content: "editFtpDialog.htm",
            width:  530,
            height: 330,
            zIndex: 302,
            contentType: "url",
            beforCloseEvent: function () {
                if (dialogAddFtp) {
                    DisplayOCX(document, false);
                }
            },
            loadCallBack: AddFtpModule.initCtrl
        });
    },
    deleteFtp: function() {
        FTPModule.ftpList.splice(FTPGrid.wbGrid("getSelectRows").index, 1);
        AddFtpModule.setFtpList();
        if (FTPModule.ftpList.length != 0) {
            FTPGrid.wbGrid("selectRowByIndex",0);
            $("#btnAlterFTP,#btnDeleteFTP,#btnTestFTP").removeAttr("disabled").removeClass("disabled");
        }
        else {
            $("#btnAlterFTP,#btnDeleteFTP,#btnTestFTP").attr("disabled", "disabled").addClass("disabled");
        }
    },
    setFtpList: function() {
        var xmlDoc = XMLStr2XMLDoc(xmlHeader + "<config version=\"" + apiVersion + "\" xmlns=\"" + defaultNS + "\"><presetInfo></presetInfo></config>");
        var rowData = [];
        $.each( FTPModule.ftpList, function(index, element) {
            rowData.push({
                "id": element.id,
                "serverName": element.serverName,
                "serverAddress": element.serverAddress,
                "port":  element.port,
                "userName": element.userName,
                "password": element["password"],
                "changeFlag":element.changeFlag,
                "anonymousSwitch": element.anonymousSwitch,
                "uploadPath": element.uploadPath
            });
            $("config >ftp >item", ftpXmlDoc).remove();
            $.each(FTPModule.ftpList, function(index, element) {
                $("ftp", ftpXmlDoc).append(
                    $(ftpXmlDoc.createElement("item")).attr("id",element.id)
                        .append(
                        $(ftpXmlDoc.createElement("serverName")).attr("type","string").attr("maxLen","31").append(
                            $(ftpXmlDoc.createCDATASection(element.serverName))
                        )
                    ).append(
                        $(ftpXmlDoc.createElement("serverAddr")).attr("type","string").attr("maxLen","131").append(
                            $(ftpXmlDoc.createCDATASection(element.serverAddress))
                        )
                    ).append(
                        $(ftpXmlDoc.createElement("port")).attr("type","uint16").append(
                            element["port"]
                        )
                    ).append(
                        $(ftpXmlDoc.createElement("path")).attr("type","string").attr("maxLen","131").append(
                            $(ftpXmlDoc.createCDATASection(element.uploadPath))
                        )
                    ).append(
                        $(ftpXmlDoc.createElement("anonymousSwitch")).attr("type","boolean").append(
                                element.anonymousSwitch+""
                        )
                    ).append(
                        $(ftpXmlDoc.createElement("userName")).attr("type","string").attr("maxLen","67").append(
                            $(ftpXmlDoc.createCDATASection(element.userName))
                        )
                    ).append(
                        $(ftpXmlDoc.createElement("passwd")).attr("type","string").attr("maxLen","67").append(
                            $(ftpXmlDoc.createCDATASection(element["password"]))
                        )
                    )
                );
            });
        });
        FTPGrid.wbGrid("load", rowData);

        if (rowData.length != 0) {
            FTPGrid.wbGrid("selectRowByIndex",0);
            $("#btnAlterFTP,#btnDeleteFTP,#btnTestFTP").removeAttr("disabled").removeClass("disabled");
        }
        else {
            $("#btnAlterFTP,#btnDeleteFTP,#btnTestFTP").attr("disabled", "disabled").addClass("disabled");
        }
    },
    getSaveTestData: function(){
        var testData = FTPGrid.wbGrid("getSelectRows")["data"];
        var index = FTPGrid.wbGrid("getSelectRows")["data"]["id"];
        var serverName = testData["serverName"];
        var serverAddr = testData["serverAddress"];
        var port = testData["port"];
        var userName = testData["userName"];
        var passwd = testData["password"];
        var path = testData["uploadPath"];
        var anonymousSwitch = testData["anonymousSwitch"];
        var testFtpXml = xmlHeader + "<config><ftp id=\""+index+"\">" + "<serverName type=\"string\" maxLen=\"31\"><![CDATA[" + serverName + "]]></serverName>" +
            "<serverAddr type=\"string\" maxLen=\"131\"><![CDATA[" + serverAddr + "]]></serverAddr>" +
            "<port type=\"uint16\">" + port + "</port>" +
            "<anonymousSwitch type=\"boolean\">" + anonymousSwitch + "</anonymousSwitch>" +
            "<userName type=\"string\" maxLen=\"67\"><![CDATA[" + userName + "]]></userName>";

        if(testData["changeFlag"] == "true"){
            testFtpXml += "<passwd type=\"string\" maxLen=\"67\"><![CDATA[" + PrivEncrypt([passwd],23784501) + "]]></passwd>";
        }

        testFtpXml += "<path type=\"string\" maxLen=\"131\"><![CDATA[" + path + "]]></path>" +
            "</ftp></config>";

        return testFtpXml;
    },
    setTestData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/FtpTest",
                type: "POST",
                async: true,
                data: FTPModule.getSaveTestData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    if ($("config", result).attr("status") == "success") {
                        window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("successTestTip"), null);
                    }
                    else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("errorTestTip"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var OnvifModule = {
    mapping: {
        cboOnvifClientType: "config>onvifClientType"
    },
    initCtrl: function() {
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetOnvifConfigInfo",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    OnvifModule.bindCtrlData();
                    XmlHttpClient.BindPageByXml(OnvifModule.mapping, xmlDoc);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        function getOnvifClientType(value) {
            switch (value) {
                case "0":
                    return LangCtrl._L_("noconfig");
                case "1":
                    return "Axxon";
                case "2":
                    return "Milestone";
                case "3":
                    return "Nuuo";
                case "4":
                    return "Hikvision";
                case "5":
                    return "DaHua";
            }
        }

        var cboOnvifClientType = $("#cboOnvifClientType");
        cboOnvifClientType.empty();
        $("config>types>onvifClientType>enum", xmlDoc).each(function(i, ele) {
            $("<option value=" + $(ele).text() + ">" + getOnvifClientType($(ele).text()) + "</option>").appendTo(cboOnvifClientType);
        });
    },
    setData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetOnvifConfigInfo",
                type: "POST",
                async: true,
                data: XmlHttpClient.GetXmlByPage(OnvifModule.mapping, xmlDoc),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var DDNSModule = {
    modifyFlag: false,
    mapping: {
        chkUseDDNS: "config>ddns>switch",
        drpDDNSServerType: "config>ddns>servertype",
        txtDDNSServerAddr: "config>ddns>serverName",
        txtDDNSUserName: "config>ddns>userName",
//        txtDDNSPwd: "config>ddns>password",
        txtDDNSDomain: "config>ddns>domainName"
    },
    toggle: function(disabled) {
        $("#drpDDNSServerType").attr("disabled", disabled);
        $("#txtDDNSServerAddr").attr("disabled", disabled);
        $("#txtDDNSUserName").attr("disabled", disabled);
        $("#txtDDNSPwd").attr("disabled", disabled);
        $("#txtDDNSDomain").attr("disabled", disabled);
        if (disabled) {
            XmlHttpClient.BindPageByXml({
                drpDDNSServerType: "config>ddns>servertype",
                txtDDNSServerAddr: "config>ddns>serverName",
                txtDDNSUserName: "config>ddns>userName",
//                txtDDNSPwd: "config>ddns>password",
                txtDDNSDomain: "config>ddns>domainName"
            }, xmlDoc);
        } else {
            $("#txtDDNSPwd").keydown(function(event){
                $(this).unbind();
                DDNSModule.modifyFlag = true;
                $(this).val("");
                if(event.keyCode == 8){
                    return false;
                }
            });
            var requireFields = $("config>types>ddnsServerType>enum:contains(\"" + $("#drpDDNSServerType").val() + "\")", xmlDoc).attr("requireParameters").split(/,\s*/);
            var fieldMapping = {
                txtDDNSUserName: "userName",
                txtDDNSPwd: "password",
                txtDDNSDomain: "domainName",
                txtDDNSServerAddr: "serverName"
            };
            $.each(["txtDDNSUserName", "txtDDNSPwd", "txtDDNSDomain", "txtDDNSServerAddr"], function(index, element) {
                if(!($.inArray(fieldMapping[element], requireFields) == -1)){
                    $("#" + fieldMapping[element]).show();
                }else{
                    $("#" + fieldMapping[element]).hide();
                }

            });
        }
    },
    initCtrl: function() {
        $("#chkUseDDNS").click(function(event) {
            DDNSModule.toggle(!($(this).attr("checked") == "checked"));
        });

        $("#txtDDNSPwd").keydown(function(event){
            $(this).unbind();
            DDNSModule.modifyFlag = true;
            $(this).val("");
            if(event.keyCode == 8){
                return false;
            }
        });
    },
    bindCtrlData: function() {
        function getDDNSServerType(value) {
            switch (value) {
                default:
                    return value;
            }
        }
        $("#drpDDNSServerType").empty().change(function(event) {
            var requireFields = $("config>types>ddnsServerType>enum:contains(\"" + $(this).val() + "\")", xmlDoc).attr("requireParameters").split(/,\s*/);
            var fieldMapping = {
                txtDDNSUserName: "userName",
                txtDDNSPwd: "password",
                txtDDNSDomain: "domainName",
                txtDDNSServerAddr: "serverName"
            };
            $.each(["txtDDNSUserName", "txtDDNSPwd", "txtDDNSDomain", "txtDDNSServerAddr"], function(index, element) {
                if(!($.inArray(fieldMapping[element], requireFields) == -1)){
                    $("#" + fieldMapping[element]).show();
                }else{
                    $("#" + fieldMapping[element]).hide();
                }

//                $("#" + element).attr("disabled", $.inArray(fieldMapping[element], requireFields) == -1).val("");
            });
            if ($(this).val() == $("config>ddns>servertype", xmlDoc).text()) {
                $.each(["txtDDNSUserName", "txtDDNSDomain", "txtDDNSServerAddr"], function(index, element) {
                    $("#" + element).val($(DDNSModule.mapping[element], xmlDoc).text());
                });
            }

        });
        $("config>types>ddnsServerType>enum", xmlDoc).each(function(i, ele) {
            $("<option value=" + $(ele).text() + ">" + getDDNSServerType($(ele).text()) + "</option>").appendTo($("#drpDDNSServerType"));
        });
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetDdnsConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    var ddnsDisabled = ($(DDNSModule.mapping.chkUseDDNS, xmlDoc).text().toLowerCase() === "false");
                    DDNSModule.bindCtrlData();
                    XmlHttpClient.BindPageByXml(DDNSModule.mapping, xmlDoc);
                    DDNSModule.toggle(ddnsDisabled);
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function(){

        XmlHttpClient.GetXmlByPage(DDNSModule.mapping, xmlDoc);
        var pwd = $("#txtDDNSPwd").val();
        var pwdNode = $("config>ddns>password",xmlDoc);
        if (pwd == "" || !DDNSModule.modifyFlag) {
            pwdNode.remove();
        } else {
            if (pwdNode.size() == 0) {
                var selectorParts = /^((\w+>?)+)>(\w+)$/.exec("onfig>ddns>password");
                if (selectorParts) {
                    pwdNode = $(xmlDoc.createElement(selectorParts[3]));
                    $(selectorParts[1], xmlDoc).append(pwdNode);
                }
            }
            pwdNode.empty().append($(xmlDoc.createCDATASection(PrivEncrypt([pwd],23784501))));
        }
        var result = XMLDoc2XMLStr(xmlDoc);
        return  XmlHttpClient.GetXmlByPage(DDNSModule.mapping, xmlDoc);
    },
    setData: function() {
        if(!chkSafeChar($("#txtDDNSPwd").val())){
            ShowFloatError($("#txtDDNSPwd"), LangCtrl._L_("invalidChar"));
            return false;
        }
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetDdnsConfig",
                type: "POST",
                async: true,
                data: DDNSModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
//                    $("#txtDDNSPwd").val(PrivEncrypt([pwd],23784501));
                    commSaveResponseHadler(result);
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

var CloudStorageModule = {
    mapping: {
        cboServerType: "config>netDisk>type",
        hidDiskTotalSize: "config>netDisk>totalSize",
        hidDiskUsedSize: "config>netDisk>totalUsed",
        txtIpcTotalSize: "config>netDisk>ipcAllowedSize",
        hidIpcTotalSize: "config>netDisk>ipcAllowedSize",
        hidIpcUsedSize: "config>netDisk>ipcUsed"
    },
    toggle: function(hasToken) {
        $("#cboServerType").attr("disabled", hasToken);
        $("#tbHasToken")[hasToken ? "show" : "hide"]();
        $("#tbNoToken")[hasToken ? "hide" : "show"]();
    },
    initCtrl: function() {
        ToNumOnlyTxt($("#txtIpcTotalSize"));
        $("#btnDestroy").click(function() {
            try {
                XmlHttpClient.SendHttpRequest({
                    url: serverBase + "/LogoutCloudStore",
                    type: "POST",
                    async: true,
                    data: "",
                    beforeSend: XmlHttpClient.CommBeforeSend,
                    callback: function(result) {
                        window.top.hideLoading();
                        if ($("config", result).attr("status") == "success") {
                            window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("logoutSuccess"), null);
                        }
                        else {
                            window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("logoutFailed"), null);
                        }
                        CloudStorageModule.getData();
                    }
                });
            }
            catch (ex) {
                alert(ex);
            }
        });
    },
    //以最小单位为M来表示存储容量
    convertSize: function(value) {
        if (value < 1024)
            return { size: value, unit: "MB" };
        else if (value < 1024 * 1024)
            return { size: (value / 1024).toFixed(2), unit: "GB" };
        else
            return { size: (value / (1024 * 1024)).toFixed(2), unit: "TB" };
    },
    bindSize: function() {
        var ipcTotalSize = $("#txtIpcTotalSize").val() * 1;
        var ipcUsedSize = $("#hidIpcUsedSize").val() * 1;
        var diskUsedSize = $("#hidDiskUsedSize").val() * 1;
        var ipcAvailableSize = ipcTotalSize - ipcUsedSize;
        s = CloudStorageModule.convertSize(ipcTotalSize);
        $("#spanIpcTotalSize").html(s.size + "&nbsp;" + s.unit);
        s = CloudStorageModule.convertSize(ipcAvailableSize);
        $("#spanIpcAvailableSize").html(s.size + "&nbsp;" + s.unit);
        s = CloudStorageModule.convertSize(ipcUsedSize);
        $("#spanIpcUsedSize").html(s.size + "&nbsp;" + s.unit);
        $("#imgIpcUsedSize").width(400 * ipcUsedSize / ipcTotalSize);
    },
    goToAuth: function() {
        // 百度
        if ($("#cboServerType").val() == "baiduYun") {
            var client_id = $.trim($("#hidBaiduClientId").val());
            var redirect_uri = "oob";
            var authUrl = "https://openapi.baidu.com/oauth/2.0/authorize?response_type=code&client_id=" + $("#cboServerType>option[value='baiduYun']").attr("cid") + "&redirect_uri=" + redirect_uri + "&scope=netdisk";
            authUrl = encodeURI(authUrl);
            window.open(authUrl);
        } // 微软
        else if ($("#cboServerType").val() == "microsoft") {
            alert('not complete!')
        }
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetCloudStoreConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    CloudStorageModule.bindCtrlData();
                    XmlHttpClient.BindPageByXml(CloudStorageModule.mapping, xmlDoc);
                    var userName = $.trim($("config>netDisk>username", xmlDoc).text());
                    $("#txtUserName").html(userName);
                    CloudStorageModule.toggle(userName != "");
                    //                    $("#hidDiskTotalSize").val(5120);
                    //                    $("#hidDiskUsedSize").val(1560);
                    var diskTotalSize = $("#hidDiskTotalSize").val() * 1;
                    var diskUsedSize = $("#hidDiskUsedSize").val() * 1;
                    var s = CloudStorageModule.convertSize($("#hidDiskTotalSize").val() * 1);
                    $("#spanDiskTotalSize").html(s.size + "&nbsp;" + s.unit);
                    s = CloudStorageModule.convertSize($("#hidDiskUsedSize").val() * 1);
                    $("#spanDiskUsedSize").html(s.size + "&nbsp;" + s.unit);
                    var diskAvailableSize = diskTotalSize - diskUsedSize;
                    s = CloudStorageModule.convertSize(diskAvailableSize * 1);
                    $("#spanDiskAvailableSize").html(s.size + "&nbsp;" + s.unit);
                    $("#imgDiskUsedSize").width(400 * diskUsedSize / diskTotalSize);

                    //                    $("#txtIpcTotalSize").val(3072);
                    //                    $("#hidIpcTotalSize").val(3072);
                    //                    $("#hidIpcUsedSize").val(89);

                    CloudStorageModule.bindSize();

                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        function getServerTypeName(value) {
            switch (value) {
                case "baiduYun":
                    return LangCtrl._L_("baidu");
                    break;
                case "microsoft":
                    return LangCtrl._L_("microsoft");
                    break;
            }
        }
        $("#cboServerType").empty();
        $("config>types>netDiskType>enum", xmlDoc).each(function(i, ele) {
            var $ele = $(ele);
            $("<option value=\"" + $ele.text() + "\" cid=\"" + $ele.attr("id") + "\" secret=\"" + $ele.attr("secret") + "\">" + getServerTypeName($(ele).text()) + "</option>").appendTo($("#cboServerType"));
        });
    },
    setData: function() {
        window.top.showLoading();
        ClearFloatError();
        //授权
        if ($("#txtUserName").text() == "") {
            var code = $.trim($("#txtAuthorizationCode").val());
            if (code == "") {
                window.top.hideLoading();
                ShowFloatError($("#txtAuthorizationCode"), LangCtrl._L_("authCodeLimit"));
                return;
            }
            else {
                var sendXml = xmlHeader + "<config version=\"" + apiVersion + "\" xmlns=\"" + defaultNS + "\"><netDisk><type type=\"netDiskType\">" + $("#cboServerType").val() + "</type><authorizationCode><![CDATA[" + code + "]]></authorizationCode></netDisk></config>";
                try {
                    XmlHttpClient.SendHttpRequest({
                        url: serverBase + "/AuthorizeCloudStore",
                        type: "POST",
                        async: true,
                        data: sendXml,
                        beforeSend: XmlHttpClient.CommBeforeSend,
                        callback: function(result) {
                            window.top.hideLoading();
                            if ($("config", result).attr("status") == "success") {
                                window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("authSuccess"), null);
                            }
                            else {
                                window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("authFailed"), null);
                            }
                            CloudStorageModule.getData();
                        }
                    });
                }
                catch (ex) {
                    alert(ex);
                }
            }
        }
        //设置容量
        else {
            var ipcTotalSize = $("#txtIpcTotalSize").val() * 1;
            var min = $("#hidIpcUsedSize").val() * 1;
            var max = $("#hidDiskTotalSize").val() * 1;
            if (isNaN(ipcTotalSize) || ipcTotalSize < min || ipcTotalSize > max) {
                ShowFloatError($("#txtIpcTotalSize"), LangCtrl._L_('ipcTotalSizeLimit').format(min, max));
                return;
            }
            else {
                $("#hidIpcTotalSize").val($("#txtIpcTotalSize").val());
                var sendXml = xmlHeader + "<config version=\"" + apiVersion + "\" xmlns=\"" + defaultNS + "\"><netDisk><ipcAllowedSize type=\"uint32\">" + $("#hidIpcTotalSize").val() + "</ipcAllowedSize ></netDisk></config>";
                try {
                    XmlHttpClient.SendHttpRequest({
                        url: serverBase + "/SetCloudStoreConfig",
                        type: "POST",
                        async: true,
                        data: sendXml,
                        beforeSend: XmlHttpClient.CommBeforeSend,
                        callback: function(result) {
                            window.top.hideLoading();
                            commSaveResponseHadler(result);
                            CloudStorageModule.getData();
                        }
                    });
                }
                catch (ex) {
                    alert(ex);
                }
            }
        }
    }
};


function initControl() {
    PortModule.initCtrl();
    ActiveConnModule.initCtrl();
    DDNSModule.initCtrl();
    SNMPModule.initCtrl();
    IeeeModule.initCtrl();
    RTSPModule.initCtrl();
    UPnPModule.initCtrl();
    EmailModule.initCtrl();
    FTPModule.initCtrl();
    //    OnvifModule.initCtrl();
    CloudStorageModule.initCtrl();

    $("#btnTestFTP").click(function(){
        ClearFloatError();
        FTPModule.setTestData();
    });


    $("#btnSave").click(function() {
        ClearFloatError();
        var curTab = $.cookie('tab');
        if (!curTab) {
            curTab = "liPort";
        }
        switch (curTab) {
            case "liPort":
                PortModule.setData();
                break;
            case "liActiveConn":
                ActiveConnModule.setData();
                break;
            case "liDDNS":
                DDNSModule.setData();
                break;
            case "liSNMP":
                SNMPModule.setData();
                break;
            case "liIEEE":
                IeeeModule.setData();
                break;
            case "liRTSP":
                RTSPModule.setData();
                break;
            case "liUPNP":
                UPnPModule.setData();
                break;
            case "liEmail":
                EmailModule.setData();
                break;
            case "liFTP":
                FTPModule.setData();
                break;
            //            case "liOnvif":          
            //                OnvifModule.setData();          
            //                break;          
            case "liCloudStorage":
                CloudStorageModule.setData();
                break;
            case "liSpvmn":
                SpvmnModule.setData();
                break;
        }
    });
}

function clearTab(parent) {
    $("input[type='text']", parent).val("");
    $("input[type='checkbox']", parent).removeAttr("checked");
    $("select", parent).empty();
}