﻿var context;
var AddPresetModule = {
    initCtrl: function(c) {
        context = c;
        XmlHttpClient.BindPageByXml({ txtName: "config>presetInfo>" + (ptzPresetModule.editIndex == -1 ? "itemType" : "item:eq(" + ptzPresetModule.editIndex + ")") }, autoPresetXmlDoc, null, context);
        var maxLen = $("config>presetInfo>itemType",autoPresetXmlDoc).attr("maxLen");
        $("#txtName", context).attr("maxLength",maxLen);
        initNumberInput($("#txtID",context), { minValue: 1, maxValue: 255 });
        $("#txtName", context).select();
        ptzPresetModule.editIndex == -1 ? $("#presetId",context).show() : $("#presetId",context).hide();
        $("#btnOK", context).click(function() {
            AddPresetModule[ptzPresetModule.editIndex == -1 ? "addData" : "setData"]();

        });
        $("#btnCancel", context).click(function() {
            AddPresetModule.close();
        });
        LangCtrl.translate($("#tbAddPreset", context));

        if(ptzPresetModule.editIndex == -1){
            $("#txtID",context).val(1);
            $("#txtName",context).val("PRESET001");
        }

    },
    verifyId: function(){
        var id = $("#txtID",context).val()*1;
        var presetData = ptzPresetModule.presetData;
        for(var i = 0,len = presetData.length-1;i<=len;i++){
            if(presetData[i]["@id"]*1 == id){
                ShowFloatError($("#txtID",context), LangCtrl._L_("presetIdExist"));
                if (dialogAddPreset) {
                    DisplayOCX(document, false);
                }
                return false;
            }
        }
        return true;
    },
    getAddData: function() {
        return xmlHeader + "<presetInfo><id>" + $("#txtID",context).val() + "</id><name>" + $("#txtName", context).val() + "</name></presetInfo>";
    },
    addData: function() {
        if (!AddPresetModule.verifyId()) {
            return false;
        }
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzAddPreset",
                type: "POST",
                async: true,
                data: AddPresetModule.getAddData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    AddPresetModule.close();
                    ptzPresetModule.getData();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    getSaveData: function() {
        return xmlHeader + "<presetInfo><id>" + $("config>presetInfo>item:eq(" + ptzPresetModule.editIndex + ")", autoPresetXmlDoc).attr("id") + "</id><name>" + $("#txtName", context).val() + "</name></presetInfo>";
    },
    setData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/PtzModifyPresetName",
                type: "POST",
                async: true,
                data: AddPresetModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    AddPresetModule.close();
                    ptzPresetModule.getData();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    close: function() {
        dialogAddPreset.CloseDialog();
    }
};