var context;

var AddSubTaskModule = {
    initCtrl: function(c) {
        context = c;

        $("#btnSubTaskOK", context).click(function() {
            AddSubTaskModule.setData();
            AddSubTaskModule.close();
        });

        $("#btnSubTaskCancel", context).click(function() {
            AddSubTaskModule.close();
        });


        LangCtrl.translate($("#tbSubTask", context));

        AddSubTaskModule.bindCtrlData();

        if (ptzTaskModule.editIndex != -1) {
            var format = "hh:mm";
            $("#txtSubStartTime", context).timeInput({ format: format,defaultValue:AddTaskModule.subTaskList[ptzTaskModule.editIndex]["startTime"] });
            $("#txtSubEndTime", context).timeInput({ format: format,defaultValue:AddTaskModule.subTaskList[ptzTaskModule.editIndex]["endTime"] });

            var functionMode = AddTaskModule.subTaskList[ptzTaskModule.editIndex]["function"];
            $("#subFunctionMode", context).val(functionMode);
            $("#subNumber", context).val(AddTaskModule.subTaskList[ptzTaskModule.editIndex]["number"]);
            AddSubTaskModule.changeMode();
        }
    },
    bindCtrlData: function() {
        var subFunctionMode = $("#subFunctionMode", context);
        subFunctionMode.empty();
        $("config>types>function>enum",autoTaskXmlDoc).each(function(i,ele){
            $("<option value=\""+ $(ele).text() +"\">"+ LangCtrl._L_($(ele).text()) +"</option>").appendTo(subFunctionMode);
        });
        subFunctionMode.change(AddSubTaskModule.changeMode);
    },
    changeMode:function(){
        var minValue,maxValue=0;
        var numberFunc = $("#subNumber", context);
        switch($("#subFunctionMode", context).val()){
            case "RSC" : minValue = 0;maxValue=0; numberFunc.val(0);initNumberInput(numberFunc, { minValue: 0, maxValue: 0 });break;
            case "ASC" : minValue = 0;maxValue=0; numberFunc.val(0);initNumberInput(numberFunc, { minValue: 0, maxValue: 0 });break;
            case "NON" : minValue = 0;maxValue=0; numberFunc.val(0);initNumberInput(numberFunc, { minValue: 0, maxValue: 0 });break;
            case "PRE" : minValue = $("config>types>pre",autoTaskXmlDoc).attr("min");maxValue=$("config>types>pre",autoTaskXmlDoc).attr("max");numberFunc.val(1);initNumberInput(numberFunc, { minValue: minValue, maxValue: maxValue });break;
            case "CRU" : minValue = $("config>types>cru",autoTaskXmlDoc).attr("min");maxValue=$("config>types>cru",autoTaskXmlDoc).attr("max");numberFunc.val(1);initNumberInput(numberFunc, { minValue: minValue, maxValue: maxValue });break;
            case "TRA" : minValue = $("config>types>tra",autoTaskXmlDoc).attr("min");maxValue=$("config>types>tra",autoTaskXmlDoc).attr("max");numberFunc.val(1);initNumberInput(numberFunc, { minValue: minValue, maxValue: maxValue });break;
        }
    },
    setData: function() {
        var objTask = {
            "id": (ptzTaskModule.editIndex+1),
            "startTime": $("#txtSubStartTime", context).val(),
            "endTime": $("#txtSubEndTime", context).val(),
            "function":  $("#subFunctionMode", context).val(),
            "number":  $("#subNumber", context).val()
        };

        if (ptzTaskModule.editIndex == -1) {
            AddTaskModule.subTaskList.push(objTask);
        } else {
            AddTaskModule.subTaskList[ptzTaskModule.editIndex] = objTask;
        }
        AddTaskModule.setTaskList();
    },
    close: function() {
        dialogEditTask.CloseDialog();
    }
};