var context;

var EditPrivateModule = {
    initCtrl: function(c) {
        context = c;

        $("#btnAlarmOK", context).click(function() {
            EditPrivateModule.setData();
            EditPrivateModule.close();
        });

        $("#btnAlarmCancel", context).click(function() {
            EditPrivateModule.close();
        });

        LangCtrl.translate($("#tbSubTask", context));

        EditPrivateModule.bindCtrlData();

        if (ptzPrivacyZoneModule.editIndex != -1) {
            $("#privateColor", context).val(ptzPrivacyZoneModule.privateArr[ptzPrivacyZoneModule.editIndex]["color"]);
            $("#privateShow", context).val(ptzPrivacyZoneModule.privateArr[ptzPrivacyZoneModule.editIndex]["show"]);
        }
    },
    bindCtrlData: function() {
        var privateColor = $("#privateColor", context);
        privateColor.empty();
        $("config>types>color>enum",alarmXmlDoc).each(function(i,ele){
            $("<option value=\""+ $(ele).text() +"\">"+ LangCtrl._L_($(ele).text()) +"</option>").appendTo(privateColor);
        });
        var privateShow = $("#privateShow", context);
        privateShow.empty();
        $("config>types>show>enum",alarmXmlDoc).each(function(i,ele){
            $("<option value=\""+ $(ele).text() +"\">"+ LangCtrl._L_($(ele).text()) +"</option>").appendTo(privateShow);
        });

    },
    getSavePtzPrivateInData: function(){
        var sendData = xmlHeader +  "<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\"><alarmIn><item id=\"" + (ptzPrivacyZoneModule.editIndex+1) + "\"><color>" + $("#privateColor", context).val() +"</color>" + "<show>" + $("#privateShow", context).val() +"</show>"  +"</item></alarmIn></config>";
        return sendData;
    },
    setData: function(c) {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetPtzAlarmIn",
                type: "POST",
                async: true,
                data: EditPrivateModule.getSavePtzPrivateInData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    if ($("config",result).attr("status") === "success"){
                        ptzPrivacyZoneModule.getPtzPrivateInfo();
                        ShowFloatError($("#taskTip",c), LangCtrl._L_("deleteTaskSuccess"),{},"success");
                    }else{
                        ShowFloatError($("#taskTip",c), LangCtrl._L_("deleteTaskFailed"),{},"failed");
                    }
                    window.top.hideLoading();
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    },
    close: function() {
        dialogEditAlarm.CloseDialog();
    }
};