﻿var xmlDoc;
$(function() {
    PtzInfoShowModule.initCtrl();
});

var PtzInfoShowModule = {
    showArr:[],
    initCtrl: function(){
        $("#btnSave").click(function(){
            PtzInfoShowModule.setPtzInfoShowData();
        });
        PtzInfoShowModule.getPtzInfoShowData();
    },
   getPtzInfoShowData: function(){
       window.top.showLoading();
       try {
           XmlHttpClient.SendHttpRequest({
               url: serverBase + "/GetPtzInfoShow" ,
               type: "POST",
               async: true,
               data: "",
               beforeSend: XmlHttpClient.CommBeforeSend,
               callback: function(result) {
                    xmlDoc = result;
                   $("config > ptzInfoShow",xmlDoc).each(function(index,element){
                       if($(">ptzTitle",element).size() > 0){
                           PtzInfoShowModule.isSupportPtzTitle = true;
                           PtzInfoShowModule.showArr.push("ptzTitle");
                       }else{
                           PtzInfoShowModule.isSupportPtzTitle = false;
                       }
                       if($(">ptzTime",element).size() > 0){
                           PtzInfoShowModule.isSupportPtzTime = true;
                           PtzInfoShowModule.showArr.push("ptzTime");
                       }else{
                           PtzInfoShowModule.isSupportPtzTime = false;
                       }
                       if($(">ptzTemperature",element).size() > 0){
                           PtzInfoShowModule.isSupportPtzTemperature = true;
                           PtzInfoShowModule.showArr.push("ptzTemperature");
                       }else{
                           PtzInfoShowModule.isSupportPtzTemperature = false;
                       }
                       if($(">ptzAngle",element).size() > 0){
                           PtzInfoShowModule.isSupportPtzAngle = true;
                           PtzInfoShowModule.showArr.push("ptzAngle");
                       }else{
                           PtzInfoShowModule.isSupportPtzAngle = false;
                       }
                       if($(">presetTitle",element).size() > 0){
                           PtzInfoShowModule.isSupportPresetTitle = true;
                           PtzInfoShowModule.showArr.push("presetTitle");
                       }else{
                           PtzInfoShowModule.isSupportPresetTitle = false;
                       }
                       if($(">runInfo",element).size() > 0){
                           PtzInfoShowModule.isSupportRunInfo = true;
                           PtzInfoShowModule.showArr.push("runInfo");
                       }else{
                           PtzInfoShowModule.isSupportRunInfo = false;
                       }

                   });

                   $("#trPtzTitle")[PtzInfoShowModule.isSupportPtzTitle ? "show" : "remove"]();
                   $("#trPtzTime")[PtzInfoShowModule.isSupportPtzTime ? "show" : "remove"]();
                   $("#trPtzTemperature")[PtzInfoShowModule.isSupportPtzTemperature ? "show" : "remove"]();
                   $("#trPtzAngle")[PtzInfoShowModule.isSupportPtzAngle ? "show" : "remove"]();
                   $("#trPresetTitle")[PtzInfoShowModule.isSupportPresetTitle ? "show" : "remove"]();
                   $("#trRunInfo")[PtzInfoShowModule.isSupportRunInfo ? "show" : "remove"]();

                   var arrShow =PtzInfoShowModule.showArr;
                   for(var i= 0,len=arrShow.length;i<len;i++){
                       $("config > types > switch > enum",xmlDoc).each(function(index,element){
                           var comb = "#"+ arrShow[i];
                           var flag =  $(element).text();
                           $("<option value=" + flag + ">" +  LangCtrl._L_(flag) + "</option>").appendTo($(comb));
                       });
                   }
                   XmlHttpClient.BindPageByXml({
                       ptzTitle: "config > ptzInfoShow > ptzTitle",
                       ptzTime: "config > ptzInfoShow > ptzTime",
                       ptzTemperature: "config > ptzInfoShow > ptzTemperature",
                       ptzAngle: "config > ptzInfoShow > ptzAngle",
                       presetTitle: "config > ptzInfoShow > presetTitle",
                       runInfo: "config > ptzInfoShow > runInfo"
                   }, xmlDoc);


                   $(".contentTable").find("tr:odd").addClass("oddRow");
                   window.top.hideLoading();
               }
           });
       }
       catch (ex) {
           alert(ex);
       }
   },
    getSaveData: function(){
        $("config >  ptzInfoShow > ptzTitle",xmlDoc).text($("#ptzTitle").val());
        $("config > ptzInfoShow > ptzTime",xmlDoc).text($("#ptzTime").val());
        $("config > ptzInfoShow > ptzTemperature",xmlDoc).text($("#ptzTemperature").val());
        $("config > ptzInfoShow > ptzAngle",xmlDoc).text($("#ptzAngle").val());
        $("config > ptzInfoShow > presetTitle",xmlDoc).text($("#presetTitle").val());
        $("config > ptzInfoShow > runInfo",xmlDoc).text($("#runInfo").val());

        return XMLDoc2XMLStr(xmlDoc);
    },
    setPtzInfoShowData: function(){
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetPtzInfoShow",
                type: "POST",
                async: true,
                data: PtzInfoShowModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        } catch (ex) {
            alert(ex);
        }
    }

};