﻿var context;
var ptzPasswordModule = {
    initCtrl: function (c) {
        context = c;
        $("#ptzPwd",context).unbind().keydown(function(event){
            var keyCode = GetKeyCode(event);
            if( !(keyCode >= 48 && keyCode <= 57 ||  keyCode == 8 ) ){
                return false;
            }
        });
        $("#btnOK",context).click(function () {
            ptzPasswordModule.setData();
        });
        $("#btnCancel",context).click(function () {
            dialogPtzPassword.CloseDialog();
        });
        LangCtrl.translate($("#tbContent_addRecEmail", context));
    },
    setData: function () {
        var condition = xmlHeader+"<config version=\"1.0\" xmlns=\"http://www.ipc.com/ver10\">";
        condition += "<ptzPassword><password type=\"string\"><![CDATA[" + PrivEncrypt([$("#ptzPwd",context).val()],23784501) + "]]></password ></ptzPassword></config>";
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/VerifyPtzPwd",
                type: "POST",
                async: true,
                data: condition,
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function (result) {
                    window.top.hideLoading();
                    dialogPtzPassword.CloseDialog();
                    if ($("config", result).attr("status") == "success") {
                        $("#mainFrame", window.top.document).attr("src", MenuCtrl["menuList"]["configMgr"]["url"]);
                        return false;
                    } else {
                        var $txtEmailName = $("#ptzPwd",context);
//                        ShowFloatError($txtEmailName, LangCtrl._L_("passwordError"));
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("passwordError"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};