﻿var ChangePasswordModule = {
    initCtrl: function () {
        $("#btnOK").click(function () {
            ChangePasswordModule.setData();
        });

        $("#btnCancel").click(function () {
            dialogChangePassword.CloseDialog();
        });

        $("#txtPassword,#txtNewPassword,#txtConfirmPassword").attr("maxlength", 19);

        LangCtrl.translate();
    },
    verification: function () {
        ClearFloatError();
        if ($("#txtNewPassword").val() != $("#txtConfirmPassword").val()) {
            ShowFloatError($("#txtConfirmPassword"), LangCtrl._L_("passwordNotEqualTip"));
            return false;
        }
        return true;
    },
    getSaveData: function () {
        var sendXml = xmlHeader + "<config version=\"" + apiVersion + "\" xmlns=\"" + defaultNS + "\"><userPassword><oldPassword><![CDATA[" + Encryption($("#txtPassword").val()) + "]]></oldPassword><password><![CDATA[" + Encryption($("#txtNewPassword").val()) + "]]></password></userPassword></config>";
        return sendXml;

        //        $("config>userPassword>userName", xmlDoc).append($(xmlDoc.createCDATASection(Decryption($.cookie("userInfo")).split(":")[0])));
        //        $("config>userPassword>oldPassword", xmlDoc).append($(xmlDoc.createCDATASection($("#txtPassword").val())));
        //        $("config>userPassword>password", xmlDoc).append($(xmlDoc.createCDATASection($("#txtNewPassword").val())));
        //        return XMLDoc2XMLStr(xmlDoc);
    },
    setData: function () {
        if (!ChangePasswordModule.verification()) {
            return false;
        }
        window.top.showLoading();
        var auInfo = zhBase64Encode(Decryption($.cookie("auInfo")).split(":")[0] + ":" + $.trim($("#txtNewPassword").val()));
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/ModifyPassword",
                type: "POST",
                async: true,
                data: ChangePasswordModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function (result) {
                    window.top.hideLoading();
                    dialogChangePassword.CloseDialog();
                    if ($("config", result).attr("status") == "success") {
                        $.cookie('auInfo', auInfo);
                        window.top.MsgBoxHelper.Show("success", LangCtrl._L_("successTip"), LangCtrl._L_("saveSuccess"), null);
//                        window.top.logout();
//                        $("#mainFrame", window.top.document).attr("src", MenuCtrl["menuList"]["live"]["url"]);
                    } else {
                        window.top.MsgBoxHelper.Show("error", LangCtrl._L_("errorTip"), LangCtrl._L_("saveFailed"), null);
                    }
                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};