var xmlDoc;

$(function(){
    onlineUserModule.initCtrl();
    onlineUserModule.getData();
});

var onlineUserModule = {

    initCtrl: function() {
        $('#divOnlineUser').wbGrid({
            data: {
                colNames: ["id",LangCtrl._L_("server"), LangCtrl._L_("port"), LangCtrl._L_("userName"),LangCtrl._L_("userType")],
                colModel: [
                    { name: '@id', index: '@id',width: 80, align: "center", hidden:true, sortable: false },
                    { name: 'ip', index: 'ip',width: 140, align: "center", sortable: false },
                    { name: 'port', index: 'port',width: 80, align: "center", sortable: false },
                    { name: 'userName', index: 'userName',width: 80, align: "center", sortable: false },
                    { name: 'userType', index: 'userType',width: 80, align: "center", sortable: false }
                ],
                rowList: []
            },
            view: {
                selectRow : true,
                rownumbers: true,
                lang: LangCtrl.getLang()
            },
            callback: {
//                onClickRow: function (e, gridId, rowIndex, rowData) {
//                    if(rowIndex == 0){
//                        $("#btnDelete").attr({disabled:true});
//                    }else{
//                        $("#btnDelete").attr("disabled", false);
//                    }
//                }
            }
        });
//        $("#divOnlineUser").wbGrid("setHeight", 480);

    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetVideoOnlineUser",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;
                    var rowData = xml2json(xmlDoc, "config>videoOnlineUser>item")["item"];
                    if (!rowData)
                        rowData = [];
                    if (!(rowData instanceof Array)) {
                        rowData = [rowData];
                    }
                    $.each( rowData, function(i, n){

                        switch (n["userType"]){
                            case 'administrator':
                                n["userType"] = LangCtrl._L_("administrator");
                                break;
                            case 'advance':
                                n["userType"] = LangCtrl._L_("advanceUser");
                                break;
                            default :
                                n["userType"] = LangCtrl._L_("normalUser");
                        }

                    });
                    $("#divOnlineUser").wbGrid("load", rowData);
                    window.top.hideLoading();
                }
            });

        }
        catch (ex) {
            alert(ex);
        }
    }
};
