﻿var xmlDoc;
var rtspPort,netPort;// RTSP端口
var NetLiveMonitor;// 视频控件
var AuthorizationBasic;// 验证字符串

$(function() {
    OSDModule.initCtrl();
    closeStream();
    $("#Content",window.top.document).css({"min-width":"1300px"});
});

var OSDModule = {
    mapping: {
        cboTimeStampFormat: "config>imageOsd>time>dateFormat",
        chkShowTimestamp: "config>imageOsd>time>switch",
        txtDevName: "config>imageOsd>channelName>name",
        chkShowDevName: "config>imageOsd>channelName>switch"
    },
    adjustFooter:function(){
        $(".cfgfooter").css("top",$("#timeTable").height() + 10);
    },
    createTextOverLayItem:function(item,osd){
        $( "<tr class='" + (parseInt(item.id, 10)%2===0?"":"odd") + "'>" +
            "<td style='width: 120px;'><input type='checkbox' id='chkShowTextOverLay_" + item.id +"'/> <label for='chkShowTextOverLay_" + item.id +"'  >" + LangCtrl._L_("textOverLay") + item.id + "</label></td>" +
            "<td style='width: 230px;'><input type='text' id='textOverLay_" + item.id + "' style='width: 193px;' ></input></td>" +
            "<td style='width: 150px;'><input type='checkbox' id='chkAddLine_" + item.id +"' style='display: none;'/> <label for='chkAddLine_" + item.id +"' style='display: none;'>" + LangCtrl._L_("addLine") + "</label></td>" +
            "</tr>" +
            "<tr id='overLayAdd_" + item.id + "' style='display:none;'>" +
            "<td></td>" +
            "<td><input type='text' id='textOverLayAdd_" + item.id + "' style='width: 193px;'/></td>" +
            "<td></td>" +
            "</tr>").appendTo($(".contentTable"));

        if(item.value.indexOf("\n") > 0){
            var textOverLay = item.value.split("\n");
            $("#textOverLay_" + item.id).val(textOverLay[0]);
            $("#textOverLayAdd_" + item.id).val(textOverLay[1]);
            $("#chkAddLine_" + item.id).attr("checked", true);
            $("#overLayAdd_" + item.id).toggle();
        }else{
            $("#textOverLay_" + item.id).val( item.value);
        }
        $("#textOverLayAdd_" + item.id).attr("maxLength", item.valueLen>16?item.valueLen/2:item.valueLen);
        $("#textOverLay_" + item.id).attr("maxLength", item.valueLen>16?item.valueLen/2:item.valueLen);
        $("#chkShowTextOverLay_" + item.id).attr("checked", item["switch"] === "true");
        OSDModule.toggleTextOverLay(item.id,item["switch"] === "true");
//        OSDModule.setTextOverLayToOcx(item);

        $("#chkShowTextOverLay_"+ item.id).click(function(event) {
            var itemId = $(this).attr("id").split("_")[1]*1;
            OSDModule.toggleTextOverLay(itemId,$(this).attr("checked") === "checked");
            OSDModule.setTextOverLaySwitch(item,$(this).attr("checked") === "checked" ? "true" : "false");
        });
        $("#chkAddLine_"+item.id).click(function(event){
            $("#overLayAdd_" + item.id).toggle();
            changeOverLayText($(this).attr("id").split("_")[1]*1);
            OSDModule.adjustFooter();
        });
        $("#textOverLay_" + item.id + ",#textOverLayAdd_" + item.id).bind("propertychange input", function(event) {
            changeOverLayText($(this).attr("id").split("_")[1]*1);
        });
        OSDModule.adjustFooter();
        function changeOverLayText(itemId){
            var osd = {};
            osd.textOverlay = [];
            var objOverlay = {};
            objOverlay.id = itemId;
            objOverlay["value"] = $("#textOverLay_" + itemId).val() + ($("#chkAddLine_"+itemId).attr("checked") === "checked"?"\n"+$("#textOverLayAdd_" + itemId).val():"");
            osd.textOverlay.push(objOverlay);
            var sendXML = OCX_XML_SetOSDInfo(osd);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        }
    },
    toggleTimeStamp: function(enabled) {
        $("#cboTimeStampFormat").attr("disabled", !enabled);
        if (!enabled) {
            XmlHttpClient.BindPageByXml({
                cboTimeStampFormat: "config>imageOsd>time>dateFormat"
            }, xmlDoc);
        }
    },
    toggleDeviceName: function(enabled) {
        $("#txtDevName").attr("disabled", !enabled);
        if (!enabled) {
            XmlHttpClient.BindPageByXml({
                txtDevName: "config>imageOsd>channelName>name"
            }, xmlDoc);
        }
    },
    toggleTextOverLay:function(itemId,enabled){
        $("#textOverLay_"+itemId).attr("disabled", !enabled);
        $("#textOverLayAdd_"+itemId).attr("disabled", !enabled);
        $("#chkAddLine_"+itemId).attr("disabled", !enabled);
    },
    setTextOverLaySwitch:function(param,flag){
        var osd = {};
        osd.textOverlay = [];
        var item = {};
        item.id = param.id;
//        item["value"] = param.value;
        arguments.length == 1 ? item["switch"] = param["switch"] : item["switch"] = flag;
//        item["X"] = param.X;
//        item["Y"] = param.Y;
        osd.textOverlay.push(item);
        var sendXML = OCX_XML_SetOSDInfo(osd);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    },
    setTextOverLayToOcx:function(param,flag){
        var osd = {};
        osd.textOverlay = [];
        var item = {};
        item.id = param.id;
        item["value"] = param.value;
        arguments.length == 1 ? item["switch"] = param["switch"] : item["switch"] = flag;
        item["X"] = param.X;
        item["Y"] = param.Y;
        osd.textOverlay.push(item);
        var sendXML = OCX_XML_SetOSDInfo(osd);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    },
    initCtrl: function() {
        $("#btnSave").click(function(event) {
            OSDModule.setData();
        });

        $("#cboTimeStampFormat").change(function(event) {
            var osd = {};
            osd.timeStamp = {};
            osd.timeStamp.format = $(this).val();

            var sendXML = OCX_XML_SetOSDInfo(osd);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        });

        $("#chkShowTimestamp").click(function(event) {
            OSDModule.toggleTimeStamp($(this).attr("checked"));

            var osd = {};
            osd.timeStamp = {};
            osd.timeStamp["switch"] = $(this).attr("checked") == "checked" ? "true" : "false";

            var sendXML = OCX_XML_SetOSDInfo(osd);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        });

        $("#chkShowDevName").click(function(event) {
            OSDModule.toggleDeviceName($(this).attr("checked"));
            var osd = {};
            osd.deviceName = {};
            osd.deviceName["switch"] = $(this).attr("checked") == "checked" ? "true" : "false";

            var sendXML = OCX_XML_SetOSDInfo(osd);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        });

        $("#txtDevName").attr("disabled", true);
        $("#txtDevName").bind("propertychange input", function(event) {
            var osd = {};
            osd.deviceName = {};
            osd.deviceName["value"] = $(this).val();
            var sendXML = OCX_XML_SetOSDInfo(osd);
            NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
        });

        OSDModule.setOCX();
    },
    getData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetImageOsdConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    xmlDoc = result;

                    OSDModule.bindCtrlData();
                    XmlHttpClient.BindPageByXml(OSDModule.mapping, xmlDoc);

                    OSDModule.toggleTimeStamp($(OSDModule.mapping.chkShowTimestamp, xmlDoc).text() === "true");
                    OSDModule.toggleDeviceName($(OSDModule.mapping.chkShowDevName, xmlDoc).text() === "true");

                    var osd = {};
                    osd.timeStamp = {};
                    osd.timeStamp["switch"] = $("config>imageOsd>time>switch", xmlDoc).text();
                    osd.timeStamp.X = $("config>imageOsd>time>X", xmlDoc).text();
                    osd.timeStamp.Y = $("config>imageOsd>time>Y", xmlDoc).text();
                    osd.timeStamp.format = $("config>imageOsd>time>dateFormat", xmlDoc).text();

                    osd.deviceName = {};
                    osd.deviceName.value = $("config>imageOsd>channelName>name", xmlDoc).text();
                    osd.deviceName["switch"] = $("config>imageOsd>channelName>switch", xmlDoc).text();
                    osd.deviceName.X = $("config>imageOsd>channelName>X", xmlDoc).text();
                    osd.deviceName.Y = $("config>imageOsd>channelName>Y", xmlDoc).text();

                    osd.textOverlay = [];
                    $("config>imageOsd>textOverLay>item", xmlDoc).each(function(index, element) {
                        var item = {};
                        item.id = (index+1);
                        item.value = $(this).find("value").text();
                        item["switch"] = $(this).find("switch").text();
                        item.valueLen = $(this).find("value").attr("maxLen");
                        item.X = $(this).find("X").text();
                        item.Y = $(this).find("Y").text();
                        osd.textOverlay.push(item);
                        if($("#textOverLay_" + item.id).length < 1){
                            OSDModule.createTextOverLayItem(item);
                        }
                    });

                    var sendXML = OCX_XML_SetOSDInfo(osd);
                    NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

                    window.top.hideLoading();
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    bindCtrlData: function() {
        function getTimeStampFormatMode(value) {
            switch (value) {
                case "year-month-day":
                    return "YYYY/MM/DD";
                case "month-day-year":
                    return "MM/DD/YYYY";
                case "day-month-year":
                    return "DD/MM/YYYY";
            }
        }
        $("#cboTimeStampFormat").empty();
        $("config>types>dateFormat>enum", xmlDoc).each(function(i, ele) {
            $("<option value=" + $(ele).text() + ">" + getTimeStampFormatMode($(ele).text()) + "</option>").appendTo($("#cboTimeStampFormat"));
        });
    },
    getSaveData: function() {
        var sendXML = OCX_XML_GetOSDInfo();
        var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);

        var $xmlDoc = $(XMLStr2XMLDoc(result));

        $("config>imageOsd>time>switch", xmlDoc).text($("response>timeStamp>switch", $xmlDoc).text());
        $("config>imageOsd>time>X", xmlDoc).text($("response>timeStamp>X", $xmlDoc).text());
        $("config>imageOsd>time>Y", xmlDoc).text($("response>timeStamp>Y", $xmlDoc).text());
        $("config>imageOsd>time>dateFormat", xmlDoc).text($("response>timeStamp>format", $xmlDoc).text());
        $("config>imageOsd>channelName>switch", xmlDoc).text($("response>deviceName>switch", $xmlDoc).text());
//        if($("#txtDevName").val() == ""){
//            $("config>imageOsd>channelName>name", xmlDoc).empty().append(xmlDoc.createCDATASection(""));
//        }else{
//            $("config>imageOsd>channelName>name", xmlDoc).empty().append(xmlDoc.createCDATASection($("response>deviceName>value", $xmlDoc).text()));
//        }

        $("config>imageOsd>channelName>name", xmlDoc).empty().append(xmlDoc.createCDATASection($("#txtDevName").val()));
        $("config>imageOsd>channelName>X", xmlDoc).text($("response>deviceName>X", $xmlDoc).text());
        $("config>imageOsd>channelName>Y", xmlDoc).text($("response>deviceName>Y", $xmlDoc).text());

        $("config>imageOsd>textOverlay>item", xmlDoc).each(function(index, element) {
            $(">value",element).empty().append(xmlDoc.createCDATASection( $("#textOverLay_"+(index+1)).val() + ($("#chkAddLine_"+(index+1)).attr("checked") === "checked"?"\n"+$("#textOverLayAdd_" + (index+1)).val():"")));
            if($("#chkAddLine_"+(index+1)).attr("checked") === "checked"){
                $(">value",element).attr("maxLen", $(">value",element).attr("maxLen") * 2 + 2);
            }
            $(">switch",element).text($("#chkShowTextOverLay_"+(index+1)).attr("checked") === "checked" ? "true" : "false");
            $(">X",element).text($("response>textOverlay>item>X:eq(" + index + ")", $xmlDoc).text());
            $(">Y",element).text($("response>textOverlay>item>Y:eq(" + index + ")", $xmlDoc).text());
        });

        return XMLDoc2XMLStr(xmlDoc);
    },
    setData: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/SetImageOsdConfig",
                type: "POST",
                async: true,
                data: OSDModule.getSaveData(),
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    commSaveResponseHadler(result);
                }
            });
        } catch (ex) {
            alert(ex);
        }
    },
    setOCX: function() {
        window.top.showLoading();
        try {
            XmlHttpClient.SendHttpRequest({
                url: serverBase + "/GetPortConfig",
                type: "POST",
                async: true,
                data: "",
                beforeSend: XmlHttpClient.CommBeforeSend,
                callback: function(result) {
                    window.top.hideLoading();
                    netPort = $("config>port>netPort", result).text() * 1;
                    NetLiveMonitor = LoadPlugin("divOCX","NetLiveMonitor");

                    if(NetLiveMonitor){
                        // 设置模式
                        var sendXML = OCX_XML_SetPreViewModel("ReadOnly");
                        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
                    }

                }
            });
        }
        catch (ex) {
            alert(ex);
        }
    }
};

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));

    // OCX已创建好窗口，通知可以登录了
    if ($("statenotify[type=\"Login\"]", $xmlDoc).length > 0) {
        var userInfo = Decryption($.cookie("auInfo"));
        var userInfoArr = userInfo.split(":");
        // 设置登录信息
        var username = userInfoArr[0];
        var password = userInfoArr[1];
        var ip = serverIp;
        var port = netPort;
        var id = "";
        var sendXML = OCX_XML_SetLoginInfo(username, password, ip, port, id);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);

        // 设置预览码流索引
        var sendXML = OCX_XML_SetStreamType(2);
        NetLiveMonitor.ExecuteCmd(sendXML, sendXML.length);
    }

    if ($("statenotify[type=\"GetOriginalWH\"]", $xmlDoc).length > 0) {
        $("#divOCX").css({width:"400px",height:"300px"});
        OSDModule.getData();
    }

    var connectstate = $("statenotify[type='connectstate']",$xmlDoc);
    if(connectstate.length > 0){
        if($(">status", connectstate).text() === "success"){
            window.top.hideLoading();
        }else{
            window.top.showLoading(window.top.LangCtrl._L_("connectError"));
        }
    }

    var Connect  = $("statenotify[type='Connect']",$xmlDoc);
    if(Connect.length > 0){
        if($(">status", Connect).text() === "limit"){
            window.top.MsgBoxHelper.Show("info", LangCtrl._L_("infoTip"), LangCtrl._L_("limit"), OSDModule.getData);
        }
    }
}