﻿var dialogPtzPassword;
$(function() {
//    window.top.showLoading();

//    document.getElementById("configRightFrame").onload = function(){
//        $("#configRightFrame").show();
//        window.top.hideLoading();
//    };

    goLastPage();
    $("[menu_id]").click(function(e) {
        e.stopPropagation();
        var menuID = $(this).attr("menu_id");
        $.cookie('menu_2', menuID);
        window.top.showLoading();
        $("#mainFrame", window.top.document).attr("src", MenuCtrl["menuList"]["configMgr"]["url"]);
        return false;
    });
    $("a[tabid]").click(function() {
        window.top.showLoading();
        $.cookie('menu_2', "netAdvance");
        $.cookie('tab', $(this).attr("tabid"));
        $("#configRightFrame").attr("src", MenuCtrl["menuList"]["netAdvance"]["url"]);
        return false;
    });

    getDeviceInfo(function(result) {
        if ($("config>deviceInfo>userType", result).text() != "administrator") {
            $("a[menu_id=\"user\"]").hide();
            $("a[menu_id=\"user\"] + a").hide();
        }
        if ($("config>deviceInfo>supportPrivateZone", result).text() !== "true") {
            $("a[menu_id=\"videoMask\"]").hide();
            $("a[menu_id=\"videoMask\"]").prev().hide();
        }
        if ($("config>deviceInfo>integratedPtz", result).text() === "true") {
            $("a[menu_id=\"camera\"]").hide();
            $("a[menu_id=\"camera\"] + a").hide();

            try {
                XmlHttpClient.SendHttpRequest({
                    url: serverBase + "/GetPtzInfoShow" ,
                    type: "POST",
                    async: true,
                    data: "",
                    beforeSend: XmlHttpClient.CommBeforeSend,
                    callback: function(result) {
                        if($("config > ptzInfoShow", result).children().length > 0){
                            $("a[menu_id=\"ptzInfoShow\"]").show();
                            $("a[menu_id=\"ptzInfoShow\"]").prev().show();
                        }
                    }
                });
            }
            catch (ex) {
                alert(ex);
            }
        }else{
            $("[menu_id=\"ptzProtocol\"]").nextAll().hide();
            $("a[menu_id=\"ptzCameraSettings\"]").prev().hide();
            $("a[menu_id=\"ptzCameraSettings\"]").hide();
        }

        if ($("config>deviceInfo>supportRS485Ptz", result).text() != "true") {
            $("a[menu_id=\"ptzProtocol\"]").hide();
            $("a[menu_id=\"ptzProtocol\"] + a").hide();
        }
        if ($("config>deviceInfo>supportSDCard", result).text() != "true") {
            $("a[menu_id=\"sdCfg\"]").hide();
            $("a[menu_id=\"sdCfg\"]").prev().hide();
        }
        if ($("config>deviceInfo>integratedPtz", result).text() != "true"
			&& $("config>deviceInfo>supportRS485Ptz", result).text() != "true") {
            $("[menu_id=\"ptz\"]").hide();
        }
        if ($("config>deviceInfo>alarmInCount", result).text() == "0") {
            $("a[menu_id=\"alarmIn\"]").hide();
            $("a[menu_id=\"alarmIn\"]").prev().hide();
        }
        if ($("config>deviceInfo>alarmOutCount", result).text() == "0") {
            $("a[menu_id=\"alarmOut\"]").hide();
            $("a[menu_id=\"alarmOut\"]").prev().hide();
        }
        if($("config>deviceInfo>supportPea", result).text() == "false" && $("config>deviceInfo>supportOsc", result).text() == "false" && $("config>deviceInfo>supportAvd", result).text() == "false"){
            $("[menu_id=\"event\"]").hide();
        }
        if ($("config>deviceInfo>supportPea", result).text() == "false") {
            $("a[menu_id=\"regionIntrusion\"]").hide();
            $("a[menu_id=\"regionIntrusion\"]").prev().hide();
            $("a[menu_id=\"crossBorder\"]").hide();
            $("a[menu_id=\"crossBorder\"]").prev().hide();
        }
        if ($("config>deviceInfo>supportOsc", result).text() == "false") {
            $("a[menu_id=\"itemsCare\"]").hide();
            $("a[menu_id=\"itemsCare\"] + a").hide();
        }
        if ($("config>deviceInfo>supportAvd", result).text() == "false") {
            $("a[menu_id=\"anomaly\"]").hide();
            $("a[menu_id=\"anomaly\"]").prev().hide();
        }
        if ($("config>deviceInfo>supportAZ", result).text() == "false") {
            $("a[menu_id=\"AZConfig\"]").hide();
            $("a[menu_id=\"AZConfig\"]").prev().hide();
        }
        if ($("config>deviceInfo>supportROI", result).text() == "false") {
            $("a[menu_id=\"ROIConfig\"]").hide();
            $("a[menu_id=\"ROIConfig\"]").prev().hide();
        }

        $("#config_left>div:visible").each(function(i, elem) {
            if (i % 2 != 0) {
                $(elem).addClass("alter");
            }
        });
        doResize();
//        window.top.hideLoading();
    });

});


function goLastPage() {
    var menu_2 = $.cookie('menu_2');
    if (menu_2 != null && menu_2 != "cfgHome") {
        $("#configRightFrame").attr("src", MenuCtrl["menuList"][menu_2]["url"]);
    }
    else {
        $("#mainFrame", window.top.document).attr("src", MenuCtrl["menuList"]["cfgHome"]["url"]);
    }
}



function doResize() {
    autoSize();
    $(window.top).resize(function() {
        autoSize();
    })
}

function selectModel(menuId) {
    setConfigMiniHeight(0);
    var mainMenuId = "system";
    switch (menuId) {
        case "basicInfo":
        case "timeSet":
        case "localCfg":
        case "sdCfg":
            mainMenuId = "system";
            break;
        case "video":
        case "camera":
        case "subSp":
        case "stream":
        case "timeStamp":
        case "videoMask":
        case "ROIConfig":
        case "AZConfig":
        case "ptzCameraSettings":
            mainMenuId = "video";
            break;
        case "ptz":
        case "ptzProtocol":
        case "ptzInfo":
        case "ptzSettings":
        case "ptzAutomaticFeatures":
        case "ptzInfoShow":
        case "ptzRestoreSetting":
            mainMenuId = "ptz";
            break;
        case "alarm":
        case "motion":
        case "alarmIn":
        case "alarmOut":
            mainMenuId = "alarm";
            break;
        case "event":
        case "itemsCare":
        case "anomaly":
        case "crossBorder":
        case "regionIntrusion":
        case "faceRecognition":
            mainMenuId = "event";
            break;
        case "net":
        case "netBase":
        case "netAdvance":
            mainMenuId = "net";
            break;
        case "secure":
        case "user":
        case "onlineUser":
        case "filterRules":
            mainMenuId = "secure";
            break;
        case "sysMaintenance":
        case "backupRestore":
        case "reboot":
        case "upgrade":
        case "operationLog":
        case "runLog":
            mainMenuId = "sysMaintenance";
            break;
    }
    $("#config_menu>div[menu_id=\"" + mainMenuId + "\"]").addClass("selected").siblings().removeClass("selected");
}

//设置最小高度
function  setConfigMiniHeight (h) {
    cfgMinHeight = $("#config_menu").height();
    $("#Content", window.top.document).css("min-height", (cfgMinHeight > h ? cfgMinHeight : h) + heightFix + "px");
}