var NetLiveMonitor;
var netPort;
var defaultLanguage;
$(function () {
    $("#selectSub").click(function() {
        $("#placeList").toggle();
        $("#LangList").hide();
        return false;
    });

    $("#LangSub").click(function() {
        $("#LangList").toggle();
        $("#placeList").hide();
        return false;
    });
    if ($.cookie('logout')) {
        $.cookie('logout', null);
        $.cookie('auInfo', null);
        //会删除所有域名下的认证缓存，导致IE不同同时登录不同的IPC客户端
//        document.execCommand('ClearAuthenticationCache', false);    /* For IE logout */
    }
    if($.cookie("rememberPWD") == "true"){
        $("#rememberPWD").attr("checked","checked");
        var userInfo = Decryption($.cookie("userInfo"));
        var userName = userInfo.split(":")[0];
        var userPWD = userInfo.split(":")[1];
        $("#txtUserName").val(userName);
        $("#txtPassword").val(userPWD);
    }else{
        $("#rememberPWD").attr("checked",false);
    }
    GetLoadInfo();
    //$("#LangList").empty();
    //if(!$.cookie("lang_type")){
    //    $.cookie("lang_type", getSystemLanguage(), {expires:45});
    //}
    //
    //for(var key in langArr){
    //    $("<span name=" + key + ">" + langArr[key] + "</span>").unbind().click(function(){
    //        var langType = $(this).attr("name");
    //        $.cookie("lang_type",langType,{expires:45});
    //        LangCtrl.changLang(langType);
    //    }).appendTo($("#LangList"));
    //}
    //LangCtrl.setLang($("#beSelectedL"),langArr);

    $("#btnLogin").click(funLogin);
    $("#txtUserName,#txtPassword").keydown(function (ev) {
        ev = ev || event;
        if (isEnter(ev)) funLogin(ev);
    });

    $(window.top.document).click(function() {
        $("#placeList,#LangList").hide();
    });
    $(window.document).click(function() {
        $("#placeList,#LangList").hide();
    });

    $(window.document).bind("keydown",function(ev){
        ev = ev || event;
        if (isEnter(ev)) funLogin(ev);
    });

    $("#btnLogin").focus();
});

function funLogin(e) {
//    document.execCommand('ClearAuthenticationCache', false);    /* For IE logout */

    if($(".pluginNotic", $("#divLoginOCX")).length == 1){
        $("#ErrorMsg").html(LangCtrl._L_("installTip"));
        return false;
    }

    $("#btnLogin").attr("disabled", true).addClass("disabled");
    $("#ErrorMsg").html("");
    if (e && e.stopPropagation)
        e.stopPropagation();
    if (!funVerify()) {
        $("#btnLogin").attr("disabled", false).removeClass("disabled");
        return;
    }

    var auInfo = zhBase64Encode($.trim($("#txtUserName").val()) + ":" + $.trim($("#txtPassword").val()));
    $.cookie("userInfo",auInfo,{expires:45});
    if($("#rememberPWD").attr("checked") == "checked"){
        $.cookie("rememberPWD","true",{expires:45});
    }else{
        $.cookie("rememberPWD","false",{expires:45});
    }
    var sendXML = OCX_XML_GetMac(serverIp,netPort);
    var result = NetLiveMonitor.QueryInfo(sendXML, sendXML.length);
    var $xmlDoc = $(XMLStr2XMLDoc(result));
    var sendData = xmlHeader + "<macInfo><address type=\"string\"><![CDATA[" + zhBase64Encode($("response>mac", $xmlDoc).text()) + "]]></address></macInfo>";
    var userMac = zhBase64Encode($("response>mac", $xmlDoc).text());
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/DoLogin",
            type: "POST",
            async: true,
            data: sendData,
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + auInfo);
                return true;
            },
            callback: function (result) {
                if ($("config", result).attr("status") === "success") {
                    $.cookie('auInfo', auInfo);
                    $.cookie('userType', $("config",result).attr("userType"));
                    $.cookie("userMac",userMac);
                    window.location.href = "main.htm";
                } else {
                    $("#txtPassword").val("");
                    var errorCode = $("config", result).attr("errorCode");
                    if (errorCode) {
                        switch (errorCode) {
                            case "pwdError":
                                $("#ErrorMsg").html(LangCtrl._L_("pwdError"));
                                break;
                            case "limitedError":
                                $("#ErrorMsg").html(LangCtrl._L_("limitedError"));
                                break;
                            default:
                                $("#ErrorMsg").html(LangCtrl._L_("unknownError") + errorCode);
                        }
                    } else {
                        $("#ErrorMsg").html(LangCtrl._L_("loginFailed"));
                    }
                    $("#btnLogin").attr("disabled", false).removeClass("disabled");
                }
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

//获取码流信息
function GetLoadInfo(){
    try {
        XmlHttpClient.SendHttpRequest({
            url: serverBase + "/GetLoadInfo",
            type: "POST",
            async: true,
            data: "",
            callback: function(result) {
                var option = "";
                $("#placeList").empty();
                $("config>loadInfo>streamInfo>item",result).each(function(index,ele){
                    var streamId = $(ele).attr("id");
                    option =  $(">resolution",ele).text() + " " + $(">frameRate",ele).text() + "fps";
                    if(index === 0){
                        $("#beSelectedP").html(option);
                        $.cookie('streamId',streamId);
                    }
                    $("<span name=" + streamId + ">" + option + "</span>").unbind().click(function(){
                        $.cookie('streamId', $(this).attr("name"));
                        var text =this.innerHTML;
                        $("#beSelectedP").html(text);
                    }).appendTo($("#placeList"));
                });
                netPort =  $("config>loadInfo>netPort",result).text();

                var langList = new Array;
                $("#LangList").empty();
                if($("config>loadInfo>languageInfo",result).length > 0){
                    $("config>loadInfo>languageInfo>support>item",result).each(function(index,ele){
                        langList.push($(ele).text());
                        $("<span name=" + $(ele).text() + ">" + langArr[$(ele).text()] + "</span>").unbind().click(function(){
                            var langType = $(this).attr("name");
                            LangCtrl.changLang(langType);
                        }).appendTo($("#LangList"));
                    });
                }else{
                    for(var key in langArr){
                        langList.push(key);
                        $("<span name=" + key + ">" + langArr[key] + "</span>").unbind().click(function(){
                            var langType = $(this).attr("name");
                            LangCtrl.changLang(langType);
                        }).appendTo($("#LangList"));
                    }
                }

                defaultLanguage = getDefaultLang(langList);

                if(!$.cookie("use_lang")){
                    $.cookie("use_lang",defaultLanguage, {expires:45});
                }

                LangCtrl.setLang($("#beSelectedL"),langArr);
                LangCtrl.translate();

                $("#txtUserName").watermark(LangCtrl._L_("inputUserName"));
                $("#txtPassword").watermark(LangCtrl._L_("inputPassword"));

                //检测是否有登录会话，如果有，直接进入系统
                var auInfo = $.cookie('auInfo');
                if (auInfo) {
                    window.location.href = "main.htm";
                    return;
                }

                $("#LangList").css("height",langList.length*28+"px");

                if ($.cookie("rememberPWD") !== "true") {
                    $("#txtUserName").val($("config>loadInfo>defautUser",result).text());
                }

                NetLiveMonitor = LoadPlugin("divLoginOCX","NetLiveMonitor");
            }
        });
    }
    catch (ex) {
        alert(ex);
    }
}

function getDefaultLang(list){
    if(list.length === 0){
        throw new Error("Language List is empty!");
    }

    if($.cookie("use_lang") !== null && $.inArray($.cookie("use_lang"), list) !== -1){
        return $.cookie("use_lang");
    }else{
        $.cookie("use_lang", null);
    }

    var systemLang = getSystemLanguage();
    if($.inArray(systemLang, list) !== -1){
        return systemLang;
    }else if($.inArray("en-us", list) !== -1){
        return "en-us";
    }else{
        return list[0];
    }
}

function funVerify() {
    var userName = $("#txtUserName").val();
    var password = $("#txtPassword").val();
    if (!$.trim(userName)) {
        $("#txtUserName").focus();
        $("#ErrorMsg").html(LangCtrl._L_("needUseName"));
        return false;
    }
    if (checkUserName(userName)) {
        $("#txtUserName").focus();
        $("#ErrorMsg").html(LangCtrl._L_("invalidCharU"));
        return false;
    }
    if (checkUserName(password)) {
        $("#txtPassword").focus();
        $("#ErrorMsg").html(LangCtrl._L_("invalidCharP"));
        return false;
    }
    return true;
}

//OCX调用js方法
function NotifyResultToJs(strXMLFormat, lStrLen) {
    var $xmlDoc = $(XMLStr2XMLDoc(strXMLFormat));
}